/*->c.infopal */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "akbd.h"
#include "transform.h"
#include "colour.h"

#include "err.h"
#include "task.h"
#include "xext.h"
#include "poll.h"
#include "temp.h"
#include "alloc.h"
#include "fsx.h"
#include "dbhi.h"
#include "trans.h"
#include "xmath.h"
#include "etc.h"
#include "drag.h"
#include "key.h"
#include "pane.h"
#include "xhelp.h"
#include "deb.h"
#include "osunits.h"
#include "tooltips.h"


#include "str.h"
#include "constants.h"
#include "reslink.h"
#include "file.h"
#include "page.h"
#include "mhi.h"

#include "caret.h"
#include "viewo.h"
#include "view.h"

#include "toolstr.h"
#include "tools.h"
#include "infopal.h"
#include "dbmore.h"



int infopalattached;
int infopaloffscreen;
int infopalposnx;
int infopalposny;


/*
   int infoxshift;
   int infoyshift;
   int infowheight;
*/

static viewstr * infoview;


/***************************************************************************/


os_error * updateinfopal(viewstr * view,int dpg)
{
 pagestr    * pagep;
 sectionstr * sectionp;
 int          dble;
 int          chapter;

 if(dpg!=view->dpage)
 {
  if(view->info && view->data.infopal && view->dsection) 
  {
   sectionp=(sectionstr*)fob_find(view->dsection,view->file);

   dble=sectionp->data.dble;
   chapter=sectionp->data.number;

   pagep=(pagestr*)fob_find(view->dpage,view->file);
   if(view->branch)
   {
    if(dble) writeiconf(view->info,11,"%d.%c",
                                         chapter,pagep->data.number?'R':'L');
    else     writeiconf(view->info,11,"%d",chapter);
   }
   else      writeiconf(view->info,11,"%d.%d",chapter,pagep->data.number);
  }

  event(EVENT_CURRPAGE,view,0);
 }
 return(NULL);
}


os_error * infopalfile(filestr * file,int branch)
{
 os_error * err;
 viewstr  * view;

 err=NULL;

 view=file->view;
 while(view)
 {
  if(view->branch==branch) err=updateinfopal(view,!view->dpage);
  if(err) break;
  view=view->next;
 }

 return(err);
}


/***************************************************************************/

static os_error * infokey(int handle,int userhandle,int icon,int * key)
{
 os_error      * err;
 int             i;
 ipstr         * p;
 viewstr       * view;
 toolboxstr    * toolbox;
 filestr       * file;
 int             chandle;
 int             cicon;

 err=NULL;

// possibly keypresses go to the main info pal passed
// back from the panes

 findcaret(&chandle,&cicon);

 menuview=view=(viewstr*)userhandle;
 menufile=file=view->file;
 toolbox=file->toolbox;

 for(i=0;i<IPMAXPANES;i++)
 {
  if((p=toolbox->ipx[i])!=NULL)
  {
   if(toolbox->iphandle[i]==chandle)
   {
    if(p->key)
    {
     err=p->key(chandle,userhandle,cicon,key);
    }
    break;
   }
  }
 }

 if(!err && *key!=-1 && !(key[KEYFLAGS] & KEYSUB)) 
     err=keyhandler(handle,userhandle,icon,key);

 return(err);
}


static os_error * infoclick(int handle,int userhandle,wimp_mousestr * m)
{
 os_error      * err;
 int             i;
 ipstr         * p;
 viewstr       * view;
 toolboxstr    * toolbox;
 filestr       * file;
 wimp_mousestr   mx;

 err=NULL;

 menuview=view=(viewstr*)userhandle; /* because menus can be launched */
 menufile=file=view->file;
 toolbox=file->toolbox;

 for(i=0;i<IPMAXPANES;i++)
 {
  if((p=toolbox->ipx[i])!=NULL)
  {
   if(toolbox->iphandle[i]==handle)
   {
    if(m->bbits==0x40 && (m->i==-1 || isshift))
    {
//     cprintf("info click handle %x",view->info);
     mx=*m;
     mx.w=view->info;
     err=dragawindow(&mx);
     break;
    }

    if(p->click)
    {
     err=p->click(handle,userhandle,m);
    }
    break;
   }
  }
 }

 return(err);
}





static os_error * infoclickmain(int handle,int userhandle,wimp_mousestr * m)
{
 os_error      * err;

 err=NULL;

// cprintf("info click main %x handle %x",m->bbits,m->w);

 if(m->bbits==0x40 && isshift)
 {
  err=dragawindow(m);
 }
 return(err);

 USE(userhandle);
 USE(handle);
}







static os_error * infohelp(int handle,int userhandle,int icon,char ** p)
{
 viewstr    * view;
 filestr    * file;
 toolboxstr * toolbox;
 int          i;

 cprintf("info help %d",icon);

 view=(viewstr*)userhandle;

 if(handle==view->info)  /* take out own icons */
 {
  *p=helpfindtagstring(TIPAL,icon);
 }
 else
 {
  file=view->file;
  toolbox=file->toolbox;

  for(i=0;i<IPMAXPANES;i++)
  {
   if(toolbox->ipx[i]!=NULL)
   {
    if(toolbox->iphandle[i]==handle)
    {
     *p=helpfindtagstring((toolbox->ipx[i])->htemplate,icon);
					cprintf("help string %s",*p);
     break;
    }
   }
  }
 }
          
 return(NULL);

 USE(handle);
}






static os_error * inforedraw(int handle,int userhandle)
{
 os_error       * err;
 viewstr        * view;
 filestr        * file;
 toolboxstr     * toolbox;
 int              i;
 ipstr          * p;
 wimp_redrawstr   redrawstr;
 int              more;

 err=NULL;

 view=(viewstr*)userhandle;
 file=view->file;
 toolbox=file->toolbox;

 for(i=0;i<IPMAXPANES;i++)
 {
  if((p=toolbox->ipx[i])!=NULL)
  {
   if(toolbox->iphandle[i]==handle)
   {
    redrawstr.w=handle;
    err=wimp_redraw_wind(&redrawstr,&more);
    if(!err)
    {
     while(more)
     {
      if(p->redraw) err=p->redraw(view,handle,&redrawstr);
      wimp_get_rectangle(&redrawstr,&more);
     }
    }
    break;
   }
  }
 }

 return(err);
}






/* find pane template, go through it, creating icons at shifts  */
/* meanwhile, look at icon map and fill in any numbers you meet */


static os_error * createpane1(viewstr * view,int handle,toolboxstr * toolbox,int pane,int * x,windowstr * infow)
{
 os_error   * err;
 ipstr      * p;
 iconmap    * map;
 wimp_w       phandle;
 wimp_wstate  wst;
 int          shift;
	wimp_w       tipshandle;
	char       * t;

 err=NULL;


 p=toolbox->ipx[pane];
 map=p->map;

 if(p->htemplate)
 {
  if(toolbox->ipchange[pane]==-1)
  {
   toolbox->ipchange[pane]=0;
  
   err=createwindowparent(p->htemplate,&toolbox->iphandle[pane],handle);
			if(!err)
			{
    phandle=toolbox->iphandle[pane];

 //   cprintf("create pane1 %x",phandle);

				if(ihelp)
    {
     tooltipstart(phandle,-1,&tipshandle,TTIPADDSUBCLASS);
				}
				else
				{
					tipshandle=NULL;
				}

    if(map)
    {

     while(1)
     {
      if(map->originalicon==0) break;
      map->realicon=map->originalicon;
      if(map->flags & IP_FSUB)
      {
       addkeyeventicon(phandle,map->originalicon);
      }

//      *p=helpfindtagstring((toolbox->ipx[i])->htemplate,icon);

      if((map->flags & IP_TIPS) && ihelp)
      {
							t=helpfindtagstring((toolbox->ipx[pane])->htemplate,map->originalicon+1000);
       if(t) tooltipaddicon(phandle,map->originalicon,t,tipshandle);
      }

      map++;
     }
    }

    addkeyevent(infokey,phandle,(int)view);
    addclickevent(infoclick,phandle,(int)view);
    addhelpevent(infohelp,phandle,(int)view);
    addredrawevent(inforedraw,phandle,(int)view);
  
    err=wimp_get_wind_state(phandle,&wst);
    wst.o.box.x1+=*x-wst.o.box.x0;
    wst.o.box.x0=*x;
    wst.o.behind=-1;
 
    shift=(infow->y1-infow->y0)-(wst.o.box.y1-wst.o.box.y0);
    shift/=2;
    wst.o.box.y1-=shift;
    wst.o.box.y0-=shift;

    *x+=wst.o.box.x1-wst.o.box.x0;
    err=wimp_open_wind(&wst.o);
    toolbox->iplast[pane]=p;
			}
  }
  else
  {
   phandle=toolbox->iphandle[pane];
   if(phandle)
   {
    err=wimp_get_wind_state(phandle,&wst);
    *x+=wst.o.box.x1-wst.o.box.x0;
   }
  }
 }

 return(err);
}



static os_error * remlastpane(toolboxstr * toolbox,int i,viewstr * view)
{
 os_error  * err;
 int         phandle;
 ipstr     * p;
 iconmap   * map;


 err=NULL;

 phandle=toolbox->iphandle[i];
 if(phandle)
 {
  remkeyevent(infokey,phandle,(int)view);
  remclickevent(infoclick,phandle,(int)view);
  remhelpevent(infohelp,phandle,(int)view);
  remredrawevent(inforedraw,phandle,(int)view);

  p=toolbox->ipx[i];
  if(p)
  { 
   map=p->map;
   if(map)
   {
    while(1)
    {
     if(map->originalicon==0) break;
     if(map->flags & IP_FSUB)
     {
      remkeyeventicon(phandle,map->originalicon);
     }
     map++;
    }
   }
  }
 }

 return(err);
}




static os_error * createsubpanes(viewstr * view,filestr * file,int force)
{
 os_error   * err;
 int          handle;
 int          i;
 iconstr      icon;
 windowstr    window;
 int          x;
 toolboxstr * toolbox;
 ipstr      * ip;
 int          infoheight;

 err=NULL;


// if(force) cprintf("create sub force");
 
 handle=view->info;
 if(handle)
 {
  toolbox=file->toolbox;
  getw(handle,&window);
  geti(handle,11,&icon);     // was 0, but no 0 at the moment
  x=window.x0+icon.ix1+4;   // guess 0 was a template icon, fudge a shift from info icons
  infoheight=window.y1-window.y0;

  if(force)
  {
   for(i=0;i<IPMAXPANES;i++)
   {
    toolbox->ipchange[i]=-1;
   }
  }

  for(i=0;i<IPMAXPANES;i++)
  {
   if(toolbox->ipchange[i]==-1)
   {
    if(toolbox->iphandle[i]!=0)
    {
     remlastpane(toolbox,i,view);
     closedown(&toolbox->iphandle[i]);
    }
    toolbox->iplast[i]=NULL;
   }
  }

  for(i=0;i<IPMAXPANES;i++)
  {
   if((ip=toolbox->ipx[i])!=NULL)
   {
    err=createpane1(view,handle,toolbox,i,&x,&window);

    if(ip->refresh)
    {
     ip->refresh(view,toolbox->iphandle[i],-1);
    }
   }
   else
   {
    toolbox->ipchange[i]=0;
   }

   if(err) break;
  }
 }

 return(err);
}


os_error * ipinitsubpanes(toolboxstr * toolbox)
{
 int i;

 for(i=0;i<IPMAXPANES;i++)
 {
  toolbox->ipx[i]=NULL;
  toolbox->iphandle[i]=0;
  toolbox->ipchange[i]=0;
  toolbox->iplast[i]=NULL;
 }

 return(NULL);
}


os_error * ipchangepane(toolboxstr * toolbox,int pane,ipstr * ip)
{
 toolbox->ipx[pane]=ip;

 if(toolbox->iplast[pane]!=ip) toolbox->ipchange[pane]=-1;
 else                          toolbox->ipchange[pane]=0x7FFFFFFF;

 return(NULL);
}


static os_error * ipupdate(viewstr * view)
{
 os_error   * err;
 wimp_wstate  wst;
 int          handle;
 filestr    * file;
 toolboxstr * toolbox;
 int          i;
 ipstr      * ip;
// int          onscreen;

 err=NULL;
 handle=view->info;

 if(handle)
 {
  file=view->file;
  toolbox=file->toolbox;

  if(toolbox)      /* only going to fail when something is wrong */
  {
   for(i=0;i<IPMAXPANES;i++) 
   {
    if(toolbox->ipchange[i]==-1) break;
   }

   if(i<IPMAXPANES)
   {
    err=wimp_get_wind_state(handle,&wst);
    if(!err)
    {
//     onscreen=wonscreen(&wst.o);
//     if(onscreen) err=wimp_close_wind(handle);
     if(!err)
     {
      createsubpanes(view,file,0);
//      if(onscreen) err=wcheckopen(&wst.o,infopalattached);
     }
    }
   }
 
   for(i=0;i<IPMAXPANES;i++)
   {
    if(toolbox->ipchange[i])
    {
     ip=toolbox->ipx[i];

     if(ip && ip->refresh)
     {
      ip->refresh(view,toolbox->iphandle[i],toolbox->ipchange[i]);
     }
     toolbox->ipchange[i]=0;
    }
   }
  }
 }
 return(err);
}


void iprefreshpane(filestr * file,int code,int pane)
{
 toolboxstr * toolbox;
 toolbox=file->toolbox;
 toolbox->ipchange[pane]|=code;
}


/* called on poll exits and used to update info pal */

static void infopoll(int userhandle)
{
 if(infoview) ipupdate(infoview);

 USE(userhandle);
}


// this is here to stop ALT+F4 caret in info pal closing it

static os_error * infowclose(int handle,int userhandle)
{

// cprintf("infowclose");

 return(NULL);

 USE(handle);
 USE(userhandle);
}




/* called when pane opened by wimp */



static os_error *infowopen(int handle,int userhandle,wimp_openstr * o)
{
 os_error   * err;
 viewstr    * view;
 filestr    * file;
 windowstr    window;
 int          thandle;
 int          noopen;


// cprintf("infowopen");

 err=NULL;

 view=(viewstr*)userhandle;
 file=view->file;
 noopen=0;

 if(o->behind==-1)
 {
  gettoolshandle(view,file,&thandle);
  if(thandle)
  {
   getw(thandle,&window);
   if(window.bhandle==-1) 
   {
    o->behind=thandle;
    noopen=1;
   }
  }
 }

// err=wimp_open_wind(o);

 if(!err)
 {
 /* defviewdata.infoxshift= */

//  cprintf("open %d xshift %d",((wimp_openstr2*)o)->reason,view->data.infoxshift);

  if(((wimp_openstr2*)o)->reason==WM_MOVE)
  {
//   cprintf("set x shift 1");
   view->data.infoxshift=o->box.x0-view->mainwindow.x0;

 /* defviewdata.infoyshift= */
   view->data.infoyshift=-ypix2os(ycoordos2pix(view->mainwindow.y1)-ycoordos2pix(o->box.y1));

 /* defviewdata.infowheight= */
   view->data.infowheight=view->mainwindow.y1-view->mainwindow.y0;

   updateviewdata(view);
  }

  infopalposnx=o->box.x0;
  infopalposny=o->box.y1;

  if(!noopen) err=viewopenbehind(view,file,o->behind);
 }

 return(err);

 USE(handle);
}




os_error * closeinfopal(viewstr * view)
{
 os_error   * err;
 int          i;
 filestr    * file;
 toolboxstr * toolbox;



 if(view->data.infopal && view->info)
 {
// cprintf("close info pal %x",view);
  
  file=view->file;
  toolbox=file->toolbox;
 
  for(i=0;i<IPMAXPANES;i++)
  {
   if(toolbox->iphandle[i]!=0)
   {
    remlastpane(toolbox,i,view);
    toolbox->iphandle[i]=0; // because closed when parent is below
   }
  }

  remopenevent(infowopen,view->info,(int)view);
  remclickevent(infoclickmain,view->info,(int)view);
  remkeyevent(infokey,view->info,(int)view);
  remhelpevent(infohelp,view->info,(int)view);
  remcloseevent(infowclose,view->info,(int)view);
  err=closedown(&view->info);
  infoview=NULL;
 }
 else err=NULL;

 return(err);
}




static os_error * scrapinfopal(void)
{
 os_error   * err;
 filestr    * file;
 viewstr    * view;

 err=NULL;
 
 file=firstfile;
 while(file)
 {
  view=file->view;
  while(view)
  {
   closeinfopal(view);
   view=view->next;
  }
  file=file->next;
 }

 return(err);
}


static void infopalrescale(viewstr * view);



// called to ensure info pal is open for a given window

os_error * openinfopal(viewstr * view,filestr * file)
{
 os_error    * err;
 wimp_wstate   wst;
 windowstr     window;
 int           prevpane;
 int           w;
 int           h;


 err=NULL;

 if(!(view->data.infopal && view->info))
 {
  scrapinfopal();

//  cprintf("openinfo pal %x",view);

  if(view->data.infopal)
  {
   err=createwindowparent(TIPAL,&view->info,view->handle);
   if(!err)
   {
    addopenevent(infowopen,view->info,(int)view);
    addclickevent(infoclickmain,view->info,(int)view);
    addkeyevent(infokey,view->info,(int)view);
    addcloseevent(infowclose,view->info,(int)view);
    addhelpevent(infohelp,view->info,(int)view);
    if(!err) err=wimp_setwindowflags(view->info,WINDOWPANE,WINDOWPANE);

    createsubpanes(view,file,1);

    err=wimp_get_wind_state(view->info,&wst);
    if(!err)
    {
     w=wst.o.box.x1-wst.o.box.x0;
     h=wst.o.box.y1-wst.o.box.y0;

     if(infopalattached)
     {
      infopalrescale(view);

      wst.o.box.x0=view->mainwindow.x0+view->data.infoxshift;
      wst.o.box.y1=view->mainwindow.y1-view->data.infoyshift;

      if(!infopaloffscreen)
      {
       if(!(view->mainwindow.wflags & wimp_MINIMISED))
       {
        coerceboxscreen(&wst.o.box,w,h);
       }
      }

//      cprintf("openinfopal");
      infopalposnx=wst.o.box.x0;
      infopalposny=wst.o.box.y1;
     }
     else
     {
      wst.o.box.x0=infopalposnx;
      wst.o.box.y1=infopalposny;
     }
 
     /* set pane size */

     wst.o.box.x1=xpix2os(xos2pix(wst.o.box.x0)+xos2pix(w));
     wst.o.box.y0=ypix2os(yos2pix(wst.o.box.y1)-yos2pix(h));

     prevpane=viewprevpane(view,file,view->info);
     if(prevpane) 
     {
      getw(prevpane,&window);
      wst.o.behind=window.bhandle;
     }
     else
     {
      wst.o.behind=-1;
     }

     err=wcheckopen(&wst.o,infopalattached);

     infoview=view;
     updateinfopal(view,!view->dpage);
    }
   }
  }
 }
 return(err);
}



static os_error * addinfopal(viewstr * view)
{
 os_error * err;

 if(!view->data.infopal)
 {
  view->data.infopal=1;
  err=openinfopal(view,view->file);
 }
 else err=NULL;

 return(err);
}



static os_error * reminfopal(viewstr * view)
{
 os_error * err;

 if(view->data.infopal)
 {
  err=closeinfopal(view);
  view->data.infopal=0;
 }
 else err=NULL;

 return(err);
}



// called from main win open to open info pal after main window is opened

os_error * openinfopalpane(viewstr * view,wimp_openstr * o,windowstr * window)
{
 os_error   * err;
 wimp_openstr r;
 windowstr    iwindow;
 int          w;
 int          h;
 wimp_wstate  wst;

 err=NULL;

 if(infopalattached)
 {
  err=getw(view->info,&iwindow);

  if(window)
  {
   if(!(view->mainwindow.wflags & wimp_MINIMISED) && !(window->wflags & wimp_MINIMISED))
   {
    if(iwindow.x0>(window->x1+window->x0)/2) 
    {
//     cprintf("openinfopalpane X");
     view->data.infoxshift+=o->box.x1-window->x1;
     view->data.infoxshift-=o->box.x0-window->x0;
    }

    if(iwindow.y1<(window->y1+window->y0)/2) 
    {
//         cprintf("openinfopalpane Y");
     view->data.infoyshift-=o->box.y0-window->y0;
     view->data.infoyshift+=o->box.y1-window->y1;
    }

    view->data.infowheight=o->box.y1-o->box.y0;

/*   defviewdata.infoxshift=view->data.infoxshift;   */
/*   defviewdata.infoyshift=view->data.infoyshift;   */
/*   defviewdata.infowheight=view->data.infowheight; */

    updateviewdata(view);
   }
  } 

  w=(xcoordos2pix(iwindow.x1)-xcoordos2pix(iwindow.x0));
  h=(ycoordos2pix(iwindow.y0)-ycoordos2pix(iwindow.y1));

  r.w=view->info;
  r.x=0;
  r.y=0;
  r.behind=o->behind;

  r.box.x0=o->box.x0+view->data.infoxshift;
  r.box.y1=o->box.y1-view->data.infoyshift;

  r.box.x1=xpix2os(xos2pix(r.box.x0)+w);
  r.box.y0=ypix2os(yos2pix(r.box.y1)-h);

  w=xpix2os(w);
  h=ypix2os(h);


  if(!infopaloffscreen)
  {
   if(!(view->mainwindow.wflags & wimp_MINIMISED))
   {
    coerceboxscreen(&r.box,w,h);
   }
  }

//  cprintf("infopalpane");
  infopalposnx=r.box.x0;
  infopalposny=r.box.y1;

  err=wcheckopen(&r,1);

//  cprintf("infopalpaneX x %d y %d",infopalposnx,infopalposny);
 }
 else
 {
  wimp_get_wind_state(view->info,&wst);
  wst.o.behind=o->behind;
  err=wimp_open_wind(&wst.o);
 }

 return(err);
}




static void infopalrescale(viewstr * view)
{
 int yshift;
 int height;

 yshift=view->data.infoyshift;

 height=view->mainwindow.y1-view->mainwindow.y0;

// cprintf("ysift=%d height %d whgith %d",yshift,height,view->data.infowheight);

 if(yshift>=0 && yshift<=view->data.infowheight)
 {
  if(yshift>height) yshift=scale(yshift,height,view->data.infowheight);
 }
 else
 if(yshift>view->data.infowheight)
 {
  yshift-=view->data.infowheight;
  yshift+=height;
 }

// cprintf("yshift=%d",yshift);

/* view->data.infoxshift=infoxshift; */

 view->data.infoyshift=yshift;
 view->data.infowheight=height;
}



os_error * addinfostr(viewstr * view)
{
 infopalrescale(view);
 updateviewdata(view);
 return(NULL);
}





os_error * infopalclip(wimp_openstr * o,viewstr * view,int bits)
{
 os_error   * err;
 windowstr    iwindow;
 int          h;
 int          maxh;
 int          bottom;


 err=NULL;

 if(infopalattached && view->data.infopal)
 {
  if(view->info && view==infoview)
  {
   getw(view->info,&iwindow);

   h=iwindow.y1-iwindow.y0;

   if((view->data.infoyshift+h)>(view->data.infowheight+hscrlbar))
   {
    /* really if there's room for the info pal under the window */
    /* leave it alone...                                        */

    bottom=view->data.infoyshift-view->data.infowheight+h;
    if(o->box.y0<bottom)
    {
     o->box.y1+=(bottom-o->box.y0);
     o->box.y1=MIN(o->box.y1,cvdu.screeny-hscrlbar);
     o->box.y0=bottom;
    }

    if(!bits)
    {
     h=o->box.y1-o->box.y0;
     maxh=view->extent.y1-view->extent.y0;
     if(h>maxh) o->box.y0=o->box.y1-maxh;
    }
   }
  }
 }

 return(err);
}





int getinfopal(int fp)
{
 return(menuview->data.infopal);
 USE(fp);
}



void xsetinfopal(int open,viewstr * view)
{
 filestr * file;

 file=view->file;

 if(open && !view->data.infopal) addinfopal(view);
 else
 if(!open && view->data.infopal) reminfopal(view);
}


void setinfopal(int fp)
{
 xsetinfopal(stack[fp],menuview);
 updateviewdata(menuview);
}


static os_error * infomode(wimp_msgstr * msg,int * ack)
{
 filestr    * file;
 viewstr    * view;

 
 file=firstfile;
 while(file)
 {
  view=file->view;
  while(view)
  {
   if(view->data.infopal && view->info)
   {
    tempremapwindow(view->info);
   }
   view=view->next;
  }
  file=file->next;
 }

 return(NULL);
 USE(msg);
 USE(ack);
}


os_error * infopalinit(void)
{
 addpollexit(infopoll,0);
 addmessage(infomode,wimp_MMODECHANGE);
 return(NULL);
}


