/*->c.selaction */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "transform.h"

#include "err.h"
#include "fsx.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "colour.h"
#include "deb.h"

#include "etc.h"

#include "constants.h"
#include "str.h"

#include "object.h"

#include "viewr.h"
#include "view.h"
#include "file.h"
#include "chain.h"

#include "posn.h"



#include "undo.h"

#include "select.h"
#include "selectx.h"

#include "clip.h"
#include "tools.h"

#include "selaction.h"




void xselectall(int fp)
{
 os_error    * err;
 int           claim;
 pagestr     * pagep;
 int           child;
 chainobject * link;
 posnstr       posn;
 int           page;

 claim=0;


 err=undostart(menufile);
 if(!err)
 {
  err=event(EVENT_SELECTALL,menufile,(int)&claim);
  if(!err && !claim)
  {
   posn.file=menufile;
   page=menuview->dpage;

//			cprintf("menufile %x selfile %x",menufile,selfile);

   if(selectn)
   {
    if(menufile==selfile) page=selpagek;
    else                  err=clearselection();
   }

//			cprintf("menufile %x selfile %x",menufile,selfile);

 
   if(page)
   {
    pagep=(pagestr*)fob_find(page,menufile);
    child=pagep->chain.child;
    while(child)
    {
     link=(chainobject*)fob_find(child,menufile);
     child=link->chain.next;
     posn.object=child;
 
     objectselect((objhdrstr *)link,&posn,SELECTOBJECT);
    }
   }
  }

  undoend(menufile);
 }

 zreport(err);

 USE(fp);
}




void xclearselection(int fp)
{
 os_error * err;
 int        claim;


 err=undostart(menufile);
 if(!err)
 {
  claim=0;

  event(EVENT_CLEARSELECTION0,menuview,0);

  err=event(EVENT_CLEARSELECTION,menufile,(int)&claim);
  if(!err && !claim)
  {
   clearselectionlo();
  }

  event(EVENT_CLEARSELECTION1,menuview,claim);

  undoend(menufile);
 }

 zreport(err);

 USE(fp);
}





os_error * deleteselection2(viewstr * view)
{
 os_error * err;
 int        claim;
 filestr  * file;

 file=view->file;

 err=undostart(file);
 if(!err)
 {
  claim=0;

  event(EVENT_DELETESELECTION0,view,0);

  err=event(EVENT_DELETESELECTION,file,(int)&claim);
  if(!err && !claim)
  {
   err=deleteselection(file);
  }

  event(EVENT_DELETESELECTION1,view,claim);

  undoend(file);
 }

 return(err);
}



void xdeleteselection(int fp)
{
 zreport(deleteselection2(menuview));
 USE(fp);
}



os_error * copyselection2(void)
{
 os_error * err;
 int        claim;

 err=undostart(menufile);;
 if(!err)
 {
  event(EVENT_COPYSELECTION0,menuview,0);

  claim=0;

  err=event(EVENT_COPYSELECTION,menufile,(int)&claim);
  if(!err && !claim)
  {
   err=copyselection(menufile);
  }

  event(EVENT_COPYSELECTION1,menuview,claim);

  undoend(menufile);
 }

	return(err);
}

void xcopyselection(int fp)
{
 zreport(copyselection2());
 USE(fp);
}



os_error * pasteselection2(viewstr * view)
{
 os_error * err;
 int        claim;
 filestr  * file;

 file=view->file;

 claim=0;
 err=NULL;

 event(EVENT_PASTESELECTION0,view,0);

 err=event(EVENT_PASTESELECTION,file,(int)&claim);
 if(!err && !claim)
 {
  err=dopaste(file);
 }

 event(EVENT_PASTESELECTION1,view,claim);

 return(err);
}


void xpasteselection(int fp)
{
 zreport(pasteselection2(menuview));
 return;
 USE(fp);
}


os_error * cutselection2(void)
{
 os_error * err;
 int        claim;

 err=undostart(menufile);
 if(!err)
 {
  event(EVENT_CUTSELECTION0,menuview,0);

  claim=0;

  err=event(EVENT_CUTSELECTION,menufile,(int)&claim);
  if(!err && !claim)
  {
            err=copyselection(menufile);
   if(!err) err=deleteselection(menufile);
  }

  event(EVENT_CUTSELECTION1,menuview,claim);

  undoend(menufile);
 }

	return(err);
}


void xcutselection(int fp)
{
 zreport(cutselection2());
 USE(fp);
}





/* int activetype(int objecttype);                        */
/* return 0 not selected, 1 selected, 2 contents selected */
// extended to check the branch is right too - otherwise you can have a menu
// open from master pages regarding something selected in normal window
// trouble for things like tab ruler


int activetype(int fp)
{
 int         n;
 int         object;
 int         type;
 int         code;
 objhdrstr * obj;
 toolactstr  act;

 n=0;
 code=0;

 if(menufile && menuview && selectedbranch(menufile,menuview->branch))
 {
  type=stack[fp];

  act.object=0;
  toolactivepoint(menufile,&act);

  if(act.object && (obj=(objhdrstr*)fob_find(act.object,menufile))->type==type)
  {
   code=act.value;
  }
  else
  {
   while((object=nselectedobject(n,menufile))!=0)
   {
    obj=(objhdrstr*)fob_find(object,menufile);
    if(obj->type==type)
    {
     code=1;
     break;
    }
    n++;
   }
  }
 }

 return(code);
}






/*

 int getselectioncolour(int type,int bit);

type==0 selected object fill   colour
      1 selected object border colour
      2 selected object shadow colour
      3 sub selection colour - e.g. text colour

return 0 on failure e.g. if the caret is not in text.

*/


static int getcolourbits(colourvalue * cv,int bits)
{
 if(bits==1) return(cv->data.tint.tint);
 else
 if(bits==2) return(cv->data.tint.overprint);
 else        return(cv->data.tint.key);
}



int getselectioncolour(int fp)
{
 int        message;
 int        type;
 int        bit;
 int        claim;

 if(selectn)
 {
  type=stack[fp];
  bit=stack[fp+1];

  if(type==SELECTION_SUBCOLOUR)
  {
   claim=0;
   event(EVENT_GETCOLOUR,selfile,(int)&claim);
   if(claim) return(getcolourbits((colourvalue*)&claim,bit));
  }
  else
  {
   message=OM_GETCOLOUR;
   selectionmessage(selfile,&message,(void*)&type);
   if(!message) return(getcolourbits((colourvalue*)&type,bit));
  }
 }

 return(0);
}


typedef struct colourobjectstr
{
 int         type;
 colourvalue cv;

} colourobjectstr;



static os_error * colourobject(int object,int type,
                          int colourkey,int tint,int overprint,filestr * file)
{
 int             message;
 int             temp;
 colourobjectstr cx;

 message=OM_GETCOLOUR;
 temp=type;
 objectmessage2(object,file,&message,(void*)&temp);
 if(!message)
 {
  cx.cv=*((colourvalue*)&temp);

  undowrite(file,&cx.cv,sizeof(colourvalue));

  if(colourkey>0 || tint>=0 || overprint>=0)
  {
   if(colourkey>0)  cx.cv.data.tint.key=colourkey;
   if(tint>=0)      cx.cv.data.tint.tint=tint;
   if(overprint>=0) cx.cv.data.tint.overprint=overprint;
  }
  else
  {
   undoread(file,&cx.cv,sizeof(colourvalue));
  }

  cx.type=type;
  message=OM_SETCOLOUR;
  objectmessage2(object,file,&message,&cx);
 }

 return(NULL);
}





/* tagged to USCOLOURS */
/* this function is always called last in undo/redo */

os_error * uncolourselections(filestr * file)
{
 vxflush(file,VRBACK,selpagek,selsectk);
 vxscrap();
 return(undowritefn(file,USCOLOURF,NULL,0));
}


/* tagged to USCOLOURF */

os_error * uncolourselectionf(filestr * file)
{
 vxstart(file);
 return(undowritefn(file,USCOLOURS,NULL,0));
}



os_error * uncolourselection(filestr * file)
{
 os_error     * err;
 int            type;
 int            i;
 int            master;
 objectbitstr   bits;


 err=undoread(file,&type,sizeof(int));
 undowritefn(file,USCOLOUR,&type,sizeof(int));

 for(i=0;i<selectn;i++)
 {
  objectmaster(selection[i].object,file,&master,&bits);
  if((!master || bits.local))
  {
   err=colourobject(selection[i].object,type,0,-1,-1,file);
   if(err) break;
  }
 }

 return(err);
}




/* void setselectioncolour(int type,int colourkey,int tint,int overprint); */

void setselectioncolour(int fp)
{
 os_error   * err;
 int          type;
 int          colourkey;
 int          tint;
 int          overprint;
 colourvalue  cv;
 int          claim;
 int          i;
 int          master;
 objectbitstr bits;


 err=NULL;

 if(selectn)
 {
  type=stack[fp];
  colourkey=stack[fp+1];
  tint=stack[fp+2];
  overprint=stack[fp+3];

  if(colourkey>0 || tint>=0 || overprint>=0)
  {
   if(type==SELECTION_SUBCOLOUR)
   {
    claim=0;
    event(EVENT_GETCOLOUR,selfile,(int)&claim);
    if(claim)
    {
     cv=*((colourvalue*)&claim);
     if(colourkey>0)  cv.data.tint.key=colourkey;
     if(tint>=0)      cv.data.tint.tint=tint;
     if(overprint>=0) cv.data.tint.overprint=overprint;
     err=event(EVENT_SETCOLOUR,selfile,(int)&cv);
    }
   }
   else
   {
    err=modfile(selfile,selsectk);
    if(!err)
    {
     err=undostart(selfile);
     if(!err)
     {
      uncolourselectionf(selfile);

      undowritefn(selfile,USCOLOUR,&type,sizeof(int));

      for(i=0;i<selectn;i++)
      {
       objectmaster(selection[i].object,selfile,&master,&bits);
       if((!master || bits.local))
       {
        err=colourobject(selection[i].object,type,
                                            colourkey,tint,overprint,selfile);
        if(err) break;
       }
      }

      uncolourselections(selfile);

      undoend(selfile);
     }
    }
   }
  }

  zreport(err);
 }
}





//  int objecthandle(int objectindex,int pageindex,int sectionindex,int branch,int file);


int objecthandle(int fp)
{
	int          pagei;
	int          page;
	pagestr    * pagep;
	int          sectioni;
	int          section;
	sectionstr * sectionp;
 int          objecti;
	int          object;
	int          branch;
	filestr    * file;


	objecti=stack[fp];
	pagei=stack[fp+1];
	sectioni=stack[fp+2];
	branch=stack[fp+2];
	file=(filestr*)stack[fp+3];

	if(file)
	{
		if(branch==DOC || branch==MST)
		{
			section=file->hdr.section[branch];
			if(sectioni<0) return(file->hdr.key);

			while(1)
			{
				sectionp=(sectionstr*)fob_find(section,file);
				if(!sectionp) break;
				if(sectioni--<=0)
				{	
					page=sectionp->chain.child;
					if(pagei<0) return(sectionp->key);
					
					while(1)
					{
						pagep=(pagestr*)fob_find(page,file);
						if(!pagep) break;
						if(pagei--<=0)
						{
							object=pagep->chain.child;
					  if(objecti<0) return(pagep->key);




							break;
						}
					}
					break;
				}
				section=sectionp->chain.next;
				if(!section) break;
			}


		}
	}

	return(0);
}



//  int objecttype(int handle);

int objecttype(int fp)
{
 objhdrstr * obj;

	if(menufile)
	{
  obj=(objhdrstr*)fob_find(stack[fp],menufile);
 	if(obj)	return(obj->type);
	}

	return(0);
}



//  selectionaddobject(int handle);

int selectionaddobject(int fp)
{


	return(0);
}


//  selectionremobject(int handle);

int selectionremobject(int fp)
{


	return(0);
}




//  int selectionobject(int index);  handle of nth object in selection


int selectionobject(int fp)
{
	int i;

	i=stack[fp];
	if(i>=0 && i<selectn)
	{
		return(selection[i].object);
	}

	return(0);
}





