/*->h.xxcolour */

#define COLNAMELEN 24

#define IDXMODEL  (-3)
#define BADMODEL  (-2)
#define RGBMODEL  0
#define CMYKMODEL 1
#define HSVMODEL  2
#define GREYMODEL 3


#define TRANSPARENTMODEL (-1)



/* can this colour be changed */

#define COLOURLOCKED     0x1

/* print this colour on a separate plate */

#define COLOURPLATE      0x2
                    
/* colour chart colour */

#define COLOURCHART      0x4

/* transparent */

#define COLOURTRANS      0x8

/* overprint   */

#define COLOUROVERPRINT  0x10

/* process colour */

#define COLOURPROCESS    0x20

/* all plates  */

#define COLOURALLPLATES  0x40

/* transparent on print */

#define COLOURNOPRINT    0x80





#define PROCESST_COLVAL  0x100








typedef struct quadstr
{
 union
 {
  struct
  {
   int r;
   int g;
   int b;

  } rgb;

  struct
  {
   int h;
   int s;
   int v;

  } hsv;

  struct
  {
   int c;
   int m;
   int y;
   int k;

  } cmyk;


  struct
  {
   int x[6];
  } xxx;

 } type;
} quadstr;



typedef struct xquadstr
{
	quadstr x;
	int     no;			/* model no */

}	xquadstr;




#define MOD3LEN 16
#define MOD4LEN 20



typedef struct modelstr
{
 int pal;      /* palette word */
 int len;      /* extension size */
 int no;       /* model no */

 union
 {

  int     word[15];
  quadstr quad;

 } data;

} modelstr;



typedef struct colourstr
{
 char         name[COLNAMELEN];
 int          n;      /* unique number */
 int          flags;
 modelstr     model;
 unsigned int overprintlimit:17;
 unsigned int spare:15;

} colourstr;




typedef struct chartstr
{
 quadstr quad;
 char    name[COLNAMELEN];
} chartstr;


#define COLMODELNAMELEN 12


typedef struct charthdrstr
{
 char    name[COLMODELNAMELEN];

} charthdrstr;



typedef struct chartmodelstr
{
 int pal;      /* palette word */
 int len;      /* extension size */
 int no;       /* model no */

 chartstr    chart;
 charthdrstr charthdr;
} chartmodelstr;




typedef struct colourbasestr
{
 int         key;
 int         type;
 chainstr    chain;
 flagstr     flags;

 int         n;
 int         sequence;
 charthdrstr charthdr;
 int         spare[2];


 colourstr   colour[1];
} colourbasestr;





extern os_error * copycolourmap(filestr * file,colourbasestr ** colourbase);
extern os_error * updatecolourmap(filestr * file,colourbasestr ** colour);
extern os_error * losecolourmap(filestr * file,colourbasestr ** newcolourbase);
extern os_error * deletecolour(colourbasestr ** colourbase,int n);
extern os_error * createcolour(colourbasestr ** colourbase);

extern int        findcolourindex(colourbasestr * colourbase,int colourn);


extern int        xfindcolour(filestr * file,colourvalue * cv);
extern int        tintpal(int tint,int pal);

extern int        findcolourbyname(char * name,filestr * file,colourstr * cs);
extern int        findcolourbynameb(char * name,colourbasestr * colourbase,
                                                              colourstr * cs);  
extern os_error * findcolours(int key,colourstr * cs,filestr * file);
extern os_error * findcoloursp(int key,colourstr ** csp,filestr * file);
extern os_error * findcolourkey(int key,
                                colourbasestr * colourbase,colourstr ** csp);

extern void       newcolourname(char * name,filestr * file);
extern void       newcolournameb(char * name,colourbasestr * colourbase);

extern os_error * addcolour(colourstr * cs,filestr * file,
                                           int * key,int overwrite);


