/*->c.dbchart */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>
#include <ctype.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "font.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "wimptext.h"
#include "fsx.h"
#include "bf.h"
#include "deb.h"

#include "dbhi.h"
#include "mhi.h"


#include "str.h"
#include "reslink.h"

#include "view.h"

#include "file.h"
#include "units.h"

#include "dbscale.h"


#include "xxcolour.h"
#include "xcolour.h"
#include "colsep.h"

#include "dbcolour.h"
#include "dbedcol.h"
#include "chart.h"
#include "dbchart.h"



/**************************************************************************/

#define PCWIDTH        224

#define PCXDELTA        16
#define PCCOLOURWIDTH  (PCWIDTH-2*PCXDELTA)

#define PCYDELTA1       12
#define PCCOLOURHEIGHT  32
#define PCYDELTA2       23 // 28

#define PCYDELTA3       (PCYDELTA2+2)
#define PCYDELTA4       4

#define PCHEIGHT (PCYDELTA1+PCCOLOURHEIGHT+PCYDELTA2) //72


extern dboxstr chartcol[2];


static int selectedn;
static int oldselectedn;

static int chartflags;

static int rulerfonthandle;

static int lastaddition;
static int lastchart;

static filestr * cfile;



static void chartdemon(int force);


static os_error * rulerfontstart(void)
{
 os_error * err;

 err=font_find("Arial",0,8*16,0,0,&rulerfonthandle);
 font_setfont(rulerfonthandle);

 return(err);
}


static void rulerfontend(void)
{
 if(rulerfonthandle)
 {
  font_lose(rulerfonthandle);
  rulerfonthandle=0;
 }
}


static void xrulerprint(int n,int x,int y,int invert)
{
 os_error * err;

 err=font_align(FA_CENTRE|FA_BASELINE);
 if(!err) err=font_setcolour(0,PALTRANSPARENT,invert?PALWHITE:PALBLACK,0);

 x+=(PCWIDTH>>1);       /* centre     */

 font_paint(chart[n].name,font_ABS|font_OSCOORDS,x,y);
}




static os_error * paneredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;
 int        ox;
 int        oy;
 int        ylo;
 int        yhi;
 int        xlo;
 int        xhi;
 int        nxlo;
 int        nxhi;
 int        nylo;
 int        nyhi;
 int        ny;
 int        n;
 int        x;
 int        y;
 int        pal;

 err=NULL;

	if(more)
	{
  rulerfontstart();

  while(more)
  {
   ox=redrawstr->box.x0-redrawstr->scx;
   oy=redrawstr->box.y1-redrawstr->scy;

   ylo=-(redrawstr->g.y1-oy);            /* small number, top of window */
   yhi=-(redrawstr->g.y0-oy);            /* bigger, bottom of window */
   xlo=redrawstr->g.x0-ox;
   xhi=redrawstr->g.x1-ox;

   ny=(redrawstr->box.y1-redrawstr->box.y0)/PCHEIGHT;

   nxlo=xlo/PCWIDTH;
   nxhi=(xhi+PCWIDTH-1)/PCWIDTH;
   nylo=(ylo-PCYDELTA1)/PCHEIGHT;
   nyhi=(yhi-PCYDELTA1+PCHEIGHT-1)/PCHEIGHT;
   nyhi=MIN(nyhi,(ny-1));

   for(x=nxlo;x<=nxhi;x++)
   {
    for(y=nylo;y<=nyhi;y++)
    {
     n=x*ny+y;

     if(n<chartindex && chart[n].name[0])
     {
      pal=modelgetpal(NULL,cfile,chartmodel,&chart[n].quad);

      if(pal==PALWHITE)
      {
       setgcol(PALBLACK);
       bbc_rectangle(ox+x*PCWIDTH+PCXDELTA,
                    oy-(y*PCHEIGHT+PCYDELTA1),PCCOLOURWIDTH,-PCCOLOURHEIGHT);
      }
      else
      {
       setgcol(pal);

       bbc_rectanglefill(ox+x*PCWIDTH+PCXDELTA,
                       oy-(y*PCHEIGHT+PCYDELTA1),PCCOLOURWIDTH,-PCCOLOURHEIGHT);
      }


      if(n==selectedn || n==oldselectedn)
      {
       wimp_setcolour(n==selectedn?WIMPBLACK:WIMPWHITE);
       bbc_rectanglefill(ox+x*PCWIDTH+PCXDELTA,
                         oy-(y*PCHEIGHT+PCYDELTA1+PCCOLOURHEIGHT+PCYDELTA4),
                         PCCOLOURWIDTH,-PCYDELTA3);
      }

      xrulerprint(n,ox+x*PCWIDTH,
                   oy-(y*PCHEIGHT+PCYDELTA1+PCCOLOURHEIGHT+PCYDELTA2),
                   n==selectedn);
     }
    }
   }
   wimp_get_rectangle(redrawstr,&more);
  }
  rulerfontend();
	}

 return(err);
 handle=handle;
}


static os_error * paneredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) paneredrawsub(handle,&redrawstr,more);
 return(err);
 userhandle=userhandle;
}


static void panerefreshn(int handle,int n)
{
 windowstr      window;
 wimp_redrawstr r;
 int            more;
 int            x;
 int            y;
 int            ny;

 getw(handle,&window);

 ny=(window.y1-window.y0)/PCHEIGHT;
 x=n/ny;
 y=n-x*ny;

 r.box.x0=x*PCWIDTH+PCXDELTA;
 r.box.x1=r.box.x0+PCWIDTH+cvdu.deltax;
 r.box.y1=-(y*PCHEIGHT+PCYDELTA1);
 r.box.y0=r.box.y1-PCHEIGHT-cvdu.deltay;
 r.w=handle;

 wimp_update_wind(&r,&more);
 paneredrawsub(handle,&r,more);
}


static void paneselectn(int handle,int n)
{
 oldselectedn=selectedn;
 selectedn=-1;
 if(oldselectedn>=0) panerefreshn(handle,oldselectedn);
 selectedn=n;
 if(n>=0) panerefreshn(handle,n);
}






static os_error * paneicon(int handle,int userhandle,wimp_mousestr * m)
{
 windowstr window;
 int       ny;
 int       x;
 int       y;
 int       n;

 getw(handle,&window);

 ny=(window.y1-window.y0)/PCHEIGHT;

 x=m->x-window.bx;
 y=window.by-m->y;

 n=(x/PCWIDTH)*ny+(y/PCHEIGHT);

 if(n>=0 && n<chartindex && chart[n].name[0])
 {
  if(n!=selectedn)
  {
   paneselectn(handle,n);
   dbchangevalue(&selectedn,chartcol);
  }

  if(m->bbits==wimp_DOUBLELEFT) return(dbclose(chartcol,DBAPPLY));
  else
  if(m->bbits==wimp_DOUBLERIGHT) return(dbclose(chartcol,DBOK));
 }

 return(NULL);
 USE(userhandle); 
}




static os_error * setpaneextent(int handle)
{
 int nx;
 int ny;
 windowstr window;

 getw(handle,&window);

 ny=(window.y1-window.y0)/PCHEIGHT;
 nx=(chartindex+ny-1)/ny;
 nx*=PCWIDTH;

 nx=MAX(nx,window.x1-window.x0);

 return(extent(handle,0,window.y0-window.y1,nx,0));
}


/***************************************************************************/

static edcolfn edcolclose;


void setcolourchart(int fp)
{
 os_error * err;
 int        i;

 i=stack[fp];

 if(i>=0 && i<charthdrn && i!=chartn)
 {
  err=loadchart(i);

  setpaneextent(chartcol[1].handle);
  refreshwindow(chartcol[1].handle);
  reopenw(chartcol[1].handle);
//  dbchangevalue(&chartn,chartcol);
  selectedn=-1;
  chartdemon(1);
 }
}



int getcolourchart(int fp)
{
 int i;

 i=stack[fp];
 if(i<charthdrn)
 {
  assignstring(stack[fp+1],charthdr[i].name);
  return(1);
 }

 return(0);
}



int iscurrentchart(int fp)
{
 return(stack[fp]==chartn);
}




static os_error * charticon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

// if(m->i==5) err=openmenuparent("colourchart_menu",handle);

 return(err);

 USE(handle);
 USE(userhandle);
}





static os_error * chartopenentry(int handle,int n)
{
 windowstr window;
 int       ny;
 int       x;

 getw(handle,&window);

 ny=(window.y1-window.y0)/PCHEIGHT;

 x=(n/ny)*PCWIDTH;

 return(openatscroll(handle,x-(window.x1-window.x0)/2,0));
}




static void chartnormalname(char * string,char * colname,char * chname)
{
 sprintf(string,"%s %s",chname,colname);
}


void chartcolourname(char * string,modelstr * colour)
{
 chartnormalname(string,((chartmodelstr*)colour)->chart.name,
                        ((chartmodelstr*)colour)->charthdr.name);
}





static int findchart(char * name)
{
 int i;

 for(i=0;i<charthdrn;i++)
  if(!cstrcmp(charthdr[i].name,name)) return(i);

 return(0);
}





static int ccstrncmp(char * first,char * second,int * n)
{
 int    f;
 int    s;
 char * f1;

 f1=first;

 while(1)
 {
  f=toupper(*first++);
  s=toupper(*second++);
  if(f!=s || !f) 
  {
   *n=first-f1;
   return(f-s);
  }
 }
}




/* return 1 found, 0 not found, nearest in n */

static int findchartcolourname(char * name,int * n)
{
 int    i;
 char * p;
 char * name1;
 int    code;
 int    max;
 int    m;


 max=0;
 *n=0;

 name1=name;

 p=strstr(name,charthdr[chartn].name);
 if(p==name)
 {
  name+=strlen(charthdr[chartn].name);
  while(*name && *name<=' ') name++;
 }

 for(i=0;i<chartindex;i++)
 {
  if(chart[i].name[0])
  {
   code=ccstrncmp(name,chart[i].name,&m);
   if(!code)
   {
    *n=i;
    return(1);
   }

   code=ccstrncmp(name1,chart[i].name,&m);
   if(!code)
   {
    *n=i;
    return(1);
   }

   if(m>max)
   {
    *n=i;
    max=m;
   }
  }
 }

 return(0);
}







/* called from zero when words window is open */
/* if word icon has changed, reopen window at appropriate point */

static char chartstring[COLNAMELEN];

static void chartdemon(int force)
{
 int    found;
 int    n;
 int    handle;
 char * p;


 handle=chartcol[1].handle;

 iconaddr(chartcol[0].handle,3,&p);

 if(strcmp(chartstring,p) || force)
 {
  xzstrncpy(chartstring,p,sizeof(chartstring));

  found=findchartcolourname(p,&n);

  if(found && n==selectedn) return;

  chartopenentry(handle,n);

  if(found) 
  {
   paneselectn(handle,n);
  }
 }
}


/*
static void chartzero(int userhandle)
{
 chartdemon(0);
 USE(userhandle);
}
*/

static os_error * chartupdate(int handle,int icon,int userhandle)
{
 chartdemon(0);
 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(icon);
}




static os_error * chartclose(int code)
{
 os_error      * err;
 chartmodelstr   model;

 err=NULL;

 if((code==DBOK || code==DBAPPLY) && edcolclose 
               && (lastaddition!=selectedn || lastchart!=chartn)
               && selectedn>=0 && selectedn<chartindex)
 {
  model.len=sizeof(chartstr)+sizeof(charthdrstr);
  model.no=chartmodel;
  model.pal=modelgetpalnaive(NULL,cfile,chartmodel,&chart[selectedn].quad);
  model.chart=chart[selectedn];
  model.charthdr=charthdr[chartn];

  chartflags=COLOURCHART;

  err=edcolclose((modelstr*)&model,chartflags);
  if(!err) 
  {
   lastaddition=selectedn;
   lastchart=chartn;
  }
 }

 if(code!=DBAPPLY && !err) 
 {
//  remzeroevent(chartzero,0);
  remeditevent(chartupdate,chartcol[0].handle,0);
  unloadchart();
 }

 return(err);
}


static os_error * wrchartname(int value,char * string)
{


 strcpy(string,charthdr[chartn].name);

	cprintf("wr chart name %s",string);

 return(NULL);
 USE(value);
}


static os_error * wrcolourname(int value,char * string)
{
 if(value>=0 && value<chartindex)
 {
  strcpy(string,chart[value].name);
 }
 else *string=0;

 return(NULL);
 USE(value);
}


static os_error * chcombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

//	cprintf("chart combo");

 err=menucombo(chartcol,10,"colourchart_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);

	return(NULL);
}



static dbiconstr charticondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,
//   10, &chartn,      DBTEXT,   0,   0,      0,  0,  0,   0,  NULL,wrchartname,
   10, &chartn,      DBCOMBO,  0,   DBCOMBOSTATIC,      0,  0,  0,   0,  NULL,(dbwritefn)chcombo,
    3, &selectedn,   DBWRITE,  0,   0,      0,  0,  0,   0,  NULL,wrcolourname,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};





static dboxstr chartcol[2]=
{
 0,
 TCHART,
 DBFIX,
 0,
 chartclose,
 charticon,
 NULL,
 NULL,
 charticondefs,
 0,
 0,
 0,0,0,0,

 0,
 TCHARTP,
 DBPANE,
 0,
 NULL,
 paneicon,
 NULL,
 paneredraw,
 NULL,
 0,
 0,
 0,NULL,
 0,
 0,

};


os_error * colourchart(modelstr * colour,int flags,edcolfn edcolx,dboxstr * parent)
{
 os_error * err;

 edcolclose=edcolx;

 selectedn=-1;
 lastaddition=lastchart=-1;

 chartflags=flags;

 loadchart(findchart(((chartmodelstr*)colour)->charthdr.name));

 err=dodboxsp(chartcol,2,parent,&dbviewstack);

 if(!err)
 {
  wimp_setwindowbackground(chartcol[1].handle,CCRGB|PALWHITE);
//  err=addzeroevent(chartzero,0);
  err=addeditevent(chartupdate,chartcol[0].handle,0);
  setpaneextent(chartcol[1].handle);

  writeicon(chartcol[0].handle,3,((chartmodelstr*)colour)->chart.name);
  chartdemon(1);
 }

 return(err);
}


