/*->c.dbcolour */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"
#include "filetype.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "wimptext.h"
#include "fsx.h"
#include "bf.h"
#include "deb.h"


#include "dbhi.h"
#include "mhi.h"

#include "dbdec.h"


#include "str.h"
#include "constants.h"


#include "reslink.h"

#include "view.h"

#include "xcolour.h"
#include "xxcolour.h"
#include "colsep.h"


#include "file.h"
#include "units.h"

#include "dbscale.h"


#include "dbedcol.h"
#include "dbchart.h"

#include "dbcolour.h"


static void panerefreshline(int handle,int n);
static os_error * setpaneextent(int panehandle,int handle);
static os_error * paneopenat(int n,int handle);
static os_error * newselectedn(int n);
static os_error * oldselectedn(int n);
static os_error * cheditcolour(void);


static colourbasestr * colourbase;
static int             selectedcolourn;
static int             focusn;
static int             spotcolour;
static int             noprintcolour;

static int             panemaxx;
static int             paneminy;
static int             colourmaxx;
static int             colourminy;



static filestr * editfile;


extern dboxstr editcol[2];


/*****************************************************************************/

static os_error * colgetdboxdims(int temp)
{
/*
 wimp_wind     * w;

 findtemp(temp,&w);
 colourmaxx=w->box.x1-w->box.x0;
 colourminy=w->box.y1-w->box.y0;

 findtemp(TCOLP,&w);
 panemaxx=w->box.x1-w->box.x0;
 paneminy=w->box.y1-w->box.y0;
*/
 USE(temp);
 return(NULL);
}


/*****************************************************************************/


static char tempcolourname[COLNAMELEN+1];


static int xfindcolourname(char * name)
{
 int i;

 for(i=0;i<colourbase->n;i++)
  if(!cstrcmp(name,colourbase->colour[i].name)) break;

 if(i>=colourbase->n) return(-1);
 else                 return(i);
}


static os_error * rdrenname(int * value,char * string)
{
 xzstrncpy(tempcolourname,string,sizeof(tempcolourname));
 return(NULL);
 value=value;
}

static os_error * renameclose(int code)
{
 os_error * err;
 int        n;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  n=strlen(tempcolourname)+1;
  if(n<=1 || n>COLNAMELEN) err=geterror(EC00);
  else
  {
   n=xfindcolourname(tempcolourname);
   if(n!=-1 && n!=selectedcolourn) err=geterror(EC01);
   else
   {
    xzstrncpy(colourbase->colour[selectedcolourn].name,tempcolourname,sizeof(colourbase->colour[selectedcolourn].name));
    panerefreshline(editcol[1].handle,selectedcolourn);
   }
  }
 }
 return(err);
}


static int     newbasecolour;
extern dboxstr newcol;


void setcolour(int fp)
{
 newbasecolour=stack[fp];
// dbchangevalue(&newbasecolour,&newcol);
}





/* int getcolour(int i,string & s,int file); */


int xgetcolour(int fp)
{
 filestr       * file;
 int             i;
 colourbasestr * xcolourbase;


 file=(filestr*)stack[fp+2];
 if(file) xcolourbase=(colourbasestr*)fob_find(file->hdr.colours,file);
 else     xcolourbase=colourbase;

	if(xcolourbase)
	{
  i=stack[fp];

  if(i>=0 && i<xcolourbase->n)
  {
   assignstring(stack[fp+1],xcolourbase->colour[i].name);
   return(xcolourbase->colour[i].n);
  }
	}

 return(0);
}



/* int getcolourpal(int i,int tint,int spare,int file); */


int getcolourpal(int fp)
{
 filestr       * file;
 colourbasestr * xcolourbase;
 colourstr     * cs;

 file=(filestr*)stack[fp+3];
 if(file)
 {
  xcolourbase=(colourbasestr*)fob_find(file->hdr.colours,file);

  cs=xcolourbase->colour+stack[fp];

  if(cs->flags & COLOURTRANS) return(-1);
  else    return(tintpal(stack[fp+1],colourgetpal(cs,NULL,file)));
 }

 return(0);
}




/* create a new colour */


static os_error * newnamesub(char * name,colourstr * colour)
{
 os_error * err;
 int        n;
 int        seq;

 err=NULL;

 n=strlen(name)+1;
 if(n<=1 || n>COLNAMELEN) err=geterror(EC00);
 else
 {
  n=xfindcolourname(name);

  if(n!=-1) err=geterror(EC01);
  else
  {
   err=createcolour(&colourbase);
   n=colourbase->n-1;


   seq=colourbase->colour[n].n;
   colourbase->colour[n]=*colour;
   xzstrncpy(colourbase->colour[n].name,name,sizeof(colourbase->colour[n].name));
   colourbase->colour[n].n=seq;


   oldselectedn(selectedcolourn);
   selectedcolourn=n;
   newselectedn(selectedcolourn);
   setpaneextent(editcol[1].handle,editcol[0].handle);
   refreshwindow(editcol[1].handle);
   paneopenat(n,editcol[1].handle);
  }
 }

 return(err);
}



static os_error * newnameclose(int code)
{
 os_error * err;
 colourstr  colour;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  colour=colourbase->colour[newbasecolour];

  if(colour.flags & COLOURCHART)
  {
   if(colour.model.no==RGBMODEL || colour.model.no==HSVMODEL)
                     colour.model.len=4*sizeof(int);
   else              colour.model.len=5*sizeof(int);
  }

  colour.flags&=~(COLOURLOCKED|COLOURCHART|COLOURALLPLATES);
  err=newnamesub(tempcolourname,&colour);
 }
 return(err);
}



static os_error * chnewclose(modelstr * model,int flags)
{
 colourstr colour;
 char      temp[COLNAMELEN];

 colour.model=*model;
 colour.flags=flags;
 colour.overprintlimit=DEFOVERPRINT;

 chartcolourname(temp,model);

 colourbase->charthdr=((chartmodelstr*)model)->charthdr;

 return(newnamesub(temp,&colour));
}




static os_error * newnameicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 if(m->i==4) err=openmenuparent("colour_menu",handle);

 return(err);

 USE(handle);
 USE(userhandle);
}





static os_error * wrnewname(int value,char * string)
{
 strcpy(string,"");
 return(NULL);
 value=value;
}


static os_error * wroldname(int value,char * string)
{
 strcpy(string,colourbase->colour[newbasecolour].name);
 return(NULL);
 value=value;
}



static os_error * newcombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

 err=menucombo(&newcol,3,"colour_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);
}




static dbiconstr newcolicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0, NULL ,0,

//    3, &newbasecolour,DBTEXT,  0,   0,      0,  0,  0,   0,     NULL,wroldname,
   3, &newbasecolour,DBCOMBO,0,DBCOMBOSTATIC,      0,  0,  0,   0,     NULL,(dbwritefn)newcombo,

    5, NULL,          DBWRITE,  0,   0,     -1, -1, -1,  -1,rdrenname,wrnewname,

   -1, NULL,         0,        0,   0,      0,  0,  0,  0,  0,      0
};



static dboxstr newcol=
{
 0,
 TNEWCOL,
 DBFIX,
 0,
 newnameclose,
 newnameicon,
 NULL,
 NULL,
 newcolicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};






static os_error * wrrnewname(int value,char * string)
{
 strcpy(string,"");
 return(NULL);
 value=value;
}


static os_error * wrroldname(int value,char * string)
{
 strcpy(string,colourbase->colour[selectedcolourn].name);
 return(NULL);
 value=value;
}



static dbiconstr rencolicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0, NULL ,0,

    3, NULL,         DBWRITE,  0,   0,     -1, -1, -1, -1,rdrenname,wrrnewname,
    4, NULL,         DBTEXT,   0,   0,      0,  0,  0,  0,     NULL,wrroldname,

   -1, NULL,         0,        0,   0,      0,  0,  0,  0,  0,      0
};



static dboxstr rencol=
{
 0,
 TRENCOL,
 DBFIX,
 0,
 renameclose,
 NULL,
 NULL,
 NULL,
 rencolicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};



static os_error * delcolour(void)
{
 os_error * err;
 int        result;

 if(colourbase->colour[selectedcolourn].flags & COLOURLOCKED) 
                                                     err=geterror(EC02);
 else
 {
  err=confirmparent(NULL,CONDC,&result,"{COL00}");
  if(!err)
  {                                                                                if(result==1)
   {
    err=deletecolour(&colourbase,selectedcolourn);
    if(!err)
    {
     if(selectedcolourn>0) selectedcolourn--;
     newselectedn(selectedcolourn);
     setpaneextent(editcol[1].handle,editcol[0].handle);
     refreshwindow(editcol[1].handle);
     paneopenat(selectedcolourn,editcol[1].handle);
    }
   }
  }
 }

 return(err);
}




/****************************************************************************/


static int overlimit;
static int overprint;


static os_error * overclose(int code)
{
 os_error * err;


 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  colourbase->colour[selectedcolourn].overprintlimit=overlimit;
  colourbase->colour[selectedcolourn].flags&=(~COLOUROVERPRINT);
  colourbase->colour[selectedcolourn].flags|=overprint;
 }

 return(err);
}



static os_error * wrover(int value,char * string)
{
 return(writepc(value,string));
}



static os_error * rdover(int * value,char * string)
{
 return(readpc100(value,string));
}



static dbiconstr overicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,       NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0,   NULL, 0,

    5,&overlimit,    DBWRITE,  0,   0,     -1, -1, -1, -1,   rdover,wrover,
    0,&overprint,    DBTOGGLE, 0,   0,      COLOUROVERPRINT,F1,0,0, NULL, 0,

   -1, NULL,         0,        0,   0,      0,  0,  0,  0,  0,      0
};



static dboxstr overbox=
{
 0,
 TOVERPRINT,
 DBFIX,
 0,
 overclose,
 NULL,
 NULL,
 NULL,
 overicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};



static os_error * dboverprint(void)
{
 overlimit=colourbase->colour[selectedcolourn].overprintlimit;
 overprint=(colourbase->colour[selectedcolourn].flags & COLOUROVERPRINT);
 return(dodboxsp(&overbox,1,editcol,&dbviewstack));
}



/***************************************************************************/
/* colour selector pane */

#define PANETOPMARGIN  8
#define PANESTEP       32 // 44
#define PANEHEIGHT     28 // 36
#define PANETEXTSHIFT  0  // 4
#define PANEBLOCKX     24 //36
#define PANEBLOCKY     24 //36
#define PANELEFTMARGIN 4
#define PANETEXT       16*23
#define PANEBLOCKSHIFT 8


static os_error * setpaneextent(int panehandle,int handle)
{
 os_error * err;
 int        height;

 height=MAX(paneminy,PANETOPMARGIN+colourbase->n*PANESTEP);

          err=extent(panehandle,0,-height,panemaxx,0);
// if(!err) err=extent(handle,0,-colourminy,colourmaxx,height-paneminy);

 return(err);

 USE(handle);
}


static os_error * paneopenat(int n,int handle)
{
 os_error * err;
 windowstr  window;

 err=getw(handle,&window);

 openatscroll(handle,0,
              -(PANETOPMARGIN+n*PANESTEP)+(window.y1-window.y0)/2);

 return(err);
}



static os_error * paneredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;
 int        ox;
 int        oy;
 int        ylo;
 int        yhi;
 int        n;
 int        y;
 err=NULL;

	if(more)
	{
  wimpfontstart(0);

  while(more)
  {
   ox=redrawstr->box.x0-redrawstr->scx;
   oy=redrawstr->box.y1-redrawstr->scy;

   ylo=-(redrawstr->g.y1-oy);            /* small number, top of window */
   yhi=-(redrawstr->g.y0-oy);            /* bigger, bottom of window */


   n=(ylo-PANETOPMARGIN)/PANESTEP;
   if(n<0) n=0;
   y=n*PANESTEP+PANETOPMARGIN;

   while(y<=yhi && n<colourbase->n)
   {
    if(colourbase->colour[n].flags & COLOURTRANS)
    {
     transparentblock(ox+PANELEFTMARGIN,oy-y-PANEBLOCKY,
                      ox+PANELEFTMARGIN+PANEBLOCKX,oy-y);
    }
    else
    {
     setgcol(colourgetpal(&colourbase->colour[n],NULL,editfile));
     bbc_rectanglefill(ox+PANELEFTMARGIN,oy-y,PANEBLOCKX,-PANEBLOCKY);
    }

    wimp_setcolour(WIMPBLACK);
    bbc_rectangle(ox+PANELEFTMARGIN,oy-y,PANEBLOCKX,-PANEBLOCKY);

    wimp_setcolour(n==selectedcolourn?WIMPBLACK:WIMPWHITE);
    bbc_rectanglefilli(ox+PANELEFTMARGIN+PANEBLOCKX+PANEBLOCKSHIFT,oy-y,
                         PANETEXT,-PANEHEIGHT);

    if(n==focusn)
    {
     wimp_setcolour(WIMPWHITE);
     wimp_setcolour(0xF0+WIMPBLACK);
     bbc_setstyle(1);
     bbc_rectanglei(ox+PANELEFTMARGIN+PANEBLOCKX+PANEBLOCKSHIFT,oy-y,PANETEXT,-PANEHEIGHT);
    }

    stringat(ox+PANELEFTMARGIN+PANEBLOCKX+PANEBLOCKSHIFT,oy-y-PANETEXTSHIFT,
       colourbase->colour[n].name,
       n==selectedcolourn?(WIMPWHITE|(WIMPTRANS<<8)):(WIMPBLACK|(WIMPTRANS<<8)),
       PANEHEIGHT);

    y+=PANESTEP;
    n++;
   }
   wimp_get_rectangle(redrawstr,&more);
  }

  wimpfontend();
	}

 return(err);
 handle=handle;
}


static os_error * paneredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) paneredrawsub(handle,&redrawstr,more);
 return(err);
 userhandle=userhandle;
}


static void panerefreshline(int handle,int n)
{
 wimp_redrawstr r;
 int more;

 r.box.x0=PANELEFTMARGIN-cvdu.extrax;
 r.box.x1=r.box.x0+PANEBLOCKX+PANEBLOCKSHIFT+PANETEXT+2*cvdu.extrax;
 r.box.y1=-(n*PANESTEP+PANETOPMARGIN)+cvdu.extray;
 r.box.y0=r.box.y1-PANEHEIGHT-2*cvdu.extray;

 r.w=handle;

 wimp_update_wind(&r,&more);
 paneredrawsub(handle,&r,more);
}




static os_error * newselectedn(int n)
{
 os_error * err;

 err=shadeiconst(editcol[0].handle,5,
                   colourbase->colour[n].flags & (COLOURCHART|COLOURLOCKED));
 if(!err)
 err=shadeiconst(editcol[0].handle,4,
                   colourbase->colour[n].flags & COLOURLOCKED);

 spotcolour=(colourbase->colour[n].flags & COLOURPLATE);
 noprintcolour=(colourbase->colour[n].flags & COLOURNOPRINT);

 dbchangevalue(&spotcolour,editcol);
 dbchangevalue(&noprintcolour,editcol);

 return(err);
}



static os_error * oldselectedn(int n)
{
 colourbase->colour[n].flags&=(~(COLOURPLATE|COLOURNOPRINT));
 colourbase->colour[n].flags|=spotcolour;
 colourbase->colour[n].flags|=noprintcolour;
 return(NULL);
}


static os_error * paneselectn(int handle,int n)
{
 os_error * err;
 int        oldn;

 oldn=selectedcolourn;
 oldselectedn(selectedcolourn);
 selectedcolourn=n;
 if(focusn>=0) focusn=selectedcolourn;
 panerefreshline(handle,oldn);
 panerefreshline(handle,selectedcolourn);

 setfocus(handle);

 err=newselectedn(n);

 return(err);
}




static os_error * paneopenline(int handle,int n)
{
 wimp_wstate wblock;
 int         top;
 int         bot;

 wimp_get_wind_state(handle,&wblock);

 top=-((n)*PANESTEP+PANETOPMARGIN);
 bot=-((n+1)*PANESTEP+PANETOPMARGIN);

 if(top>wblock.o.y) wblock.o.y=top;

 if(bot<(wblock.o.y-(wblock.o.box.y1-wblock.o.box.y0))) wblock.o.y=bot+(wblock.o.box.y1-wblock.o.box.y0);

// wblock.o.y=-(n+1)*(PANESTEP)+(PANESTEP>>1)+((wblock.o.box.y1-wblock.o.box.y0)>>1);


 return(wimp_open_wind(&wblock.o));
}





static os_error * panecaret(int handle,int userhandle,int gain)
{
 os_error * err;
 int        oldfocusn;

 err=NULL;

// cprintf("gain %d",gain);

 if(gain)
 {
  focusn=selectedcolourn;
  panerefreshline(handle,focusn);
 }
 else
 {
  oldfocusn=focusn;
  focusn=-1;
  panerefreshline(handle,oldfocusn);
 }


 return(err);

 USE(userhandle);
}


static os_error * panegoton(int n,int panehandle)
{
 os_error * err;

 err=NULL;

 if(n<0) n=0;
 if(n>=colourbase->n) n=colourbase->n-1;

 if(n!=selectedcolourn)
 {
  paneselectn(panehandle,n);
  paneopenline(panehandle,n);
 }

 return(err);
}





static os_error * panekey(int panehandle,int mainhandle,int icon,int * key)
{
 int       ch;
 int       n;
 int       next;
 windowstr window;


 ch=*key;

 if(ch==HOME)
 {
  panegoton(0,panehandle);
  *key=-1;
 }
 else
 if(ch==COPY)
 {
  panegoton(colourbase->n-1,panehandle);
  *key=-1;
 }
 if(ch==PAGEUP || ch==PAGEDOWN)
 {
  getw(panehandle,&window);
  next=(window.y1-window.y0)/PANESTEP;
  n=focusn;
  n+=((*key==PAGEDOWN)?next:-next);
  panegoton(n,panehandle);
  *key=-1;
 }
 else
 if(ch==CUP || ch==CDOWN)
 {
  n=focusn;
  n+=((*key==CDOWN)?1:-1);
  panegoton(n,panehandle);
  *key=-1;
 }
 else
 if(ch==TAB || ch==SHFT_TAB)
 {
  findnexttabw(mainhandle,panehandle,ch==SHFT_TAB,&next);
//  cprintf("next %d",next);
  setfocusicon(mainhandle,next);
  *key=-1;
 }
 else
 if(ch>=' ' && ch<256) // move to next entry that starts with ch
 {
  n=focusn;
  do
  {
   n++;
   if(n>=colourbase->n) n=0;
   if(toupper(*colourbase->colour[n].name)==toupper(ch)) break;
  } while(n!=focusn);

  if(n!=focusn)
  {
   panegoton(n,panehandle);
   *key=-1;
  }
 }


 return(NULL);

 USE(icon);
}






static os_error * paneicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        n;
 windowstr  window;

 err=NULL;

 if(m->bbits==wimp_BLEFT)
 {
  err=getw(handle,&window);
  if(!err)
  {
   n=((window.by-m->y)-PANETOPMARGIN)/PANESTEP;
   if(n<0) n=0;
   if(n>=colourbase->n) n=colourbase->n-1;

   if(n!=selectedcolourn || n!=focusn)
   {
    paneselectn(handle,n);
   }
  }
 }
 else
 if(m->bbits==wimp_DOUBLELEFT) err=cheditcolour();

 return(err);

 USE(userhandle);
}


/***************************************************************************/
/* edit colour main window */

static os_error * edclose(modelstr * colour,int flags)
{
 colourbase->colour[selectedcolourn].model=*colour;
 colourbase->colour[selectedcolourn].flags=flags;

/* dprintf(6,"len=%d pal=%x w0=%x w1=%x w2=%x",
                               colour->len,
                               colour->pal,
                               colour->data.word[0],
                               colour->data.word[1],
                               colour->data.word[2]); */

 panerefreshline(editcol[1].handle,selectedcolourn);
 return(NULL);
}


static os_error * chedclose(modelstr * colour,int flags)
{
 char temp[COLNAMELEN];
 int  n;

 chartcolourname(temp,colour);

 n=xfindcolourname(temp);
 if(n!=-1 && n!=selectedcolourn) return(geterror(EC01));

 colourbase->colour[selectedcolourn].model=*colour;
 colourbase->colour[selectedcolourn].flags=flags;

 xzstrncpy(colourbase->colour[selectedcolourn].name,temp,sizeof(colourbase->colour[selectedcolourn].name));

 colourbase->charthdr=((chartmodelstr*)colour)->charthdr;

 panerefreshline(editcol[1].handle,selectedcolourn);

 return(NULL);
}


static os_error * cheditcolour(void)
{
 int      flags;
 modelstr model;

 flags=colourbase->colour[selectedcolourn].flags;
 model=colourbase->colour[selectedcolourn].model;

 if(flags & COLOURCHART)
 {
  return(colourchart(&model,flags,chedclose,editcol));
 }
 else
 {
  return(edcol(editfile,&model,flags,edclose,editcol));
 }
}


static os_error * editicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
  case 20:  /* edit colour */
          err=cheditcolour();
          break;  

  case  3:  /* colour chart */
          if(colourbase->colour[selectedcolourn].flags & COLOURCHART)
          {
           err=colourchart(&colourbase->colour[selectedcolourn].model,
                           colourbase->colour[selectedcolourn].flags,
                                                       chnewclose,editcol);
          }
          else
          {
           modelstr colour;
           colour=colourbase->colour[selectedcolourn].model;
           ((chartmodelstr*)(&colour))->charthdr=colourbase->charthdr;
           ((chartmodelstr*)(&colour))->chart.name[0]=0;
           err=colourchart(&colour,0,chnewclose,editcol);
          }
          break;

  case  6:
          newbasecolour=selectedcolourn;
          err=dodboxsp(&newcol,1,editcol,&dbviewstack);
          break;

  case  4:
          /* delete colour */
          err=delcolour();
          break;

  case  5:
          if(colourbase->colour[selectedcolourn].flags & COLOURLOCKED) 
                                                      err=geterror(EC03);
          else
          {
           if(colourbase->colour[selectedcolourn].flags & COLOURCHART)
           {
            err=colourchart(&colourbase->colour[selectedcolourn].model,
                             colourbase->colour[selectedcolourn].flags,
                                                        chedclose,editcol);
           }
           else
           {
            err=dodboxsp(&rencol,1,editcol,&dbviewstack);
           }
          }
          break;


  case  8:
          err=dboverprint();
          break;

 }

 return(err);

 USE(handle);
 USE(userhandle);
}




/*****************************************************************************/

#define COLOUROVER   0
#define COLOURRENAME 1
#define COLOURSKIP   2

#define COLOURADD    3


/* icon value key */


static deciconstr decicons[]=
{
  2,          -1,      27,
  0,  COLOUROVER,      0,
  4,COLOURRENAME,      0,
  1,  COLOURSKIP,      13,

 -1,           0,      0,
};


static decstr decs=
{
 TMERGESTYLE,
 3,
 decicons,

};





static os_error * loadcolour(char * name,int type,int userhandle,int xvolatile)
{
 return(loaddoc(name,type,userhandle,xvolatile));
}


static os_error * loadcolourpost(int userhandle)
{
 os_error      * err;
 int             load;
 int             colours;
 colourbasestr * cbase;
 int             i;
 colourstr       cs;
 colourstr       oldc;
 int             n;
 int             result;
 int             changed;

 err=loaddocpost1(&load,FL_NOFONTMISSING);

 if(load)
 {
  colours=xloadfile->hdr.colours;
  i=0;
  n=0;    /* compiler */
  changed=0;


  while(1)
  {
   cbase=(colourbasestr*)fob_find(colours,xloadfile);
   if(i>=cbase->n) break;

   cs=cbase->colour[i];

   /* search for name */

   if((n=findcolourbynameb(cs.name,colourbase,&oldc))>=0)
   {
    /* found, then overwrite, ignore, rename */

    decboxparent(&decs,editcol[0].handle,&result,"{COL05}",cs.name);

    if(result==-1) break;
    if(result==COLOURRENAME)
    {
     newcolournameb(cs.name,colourbase);
     result=COLOURADD;
    }
   }
   else
   {
    result=COLOURADD;
   }

   if(result==COLOUROVER)
   {
    cs.n=oldc.n;
    colourbase->colour[n]=cs;

    if(n==selectedcolourn)
    {
     newselectedn(n);
    }
   }
   else
   if(result==COLOURADD)
   {
    createcolour(&colourbase);

    n=colourbase->n-1;
    cs.n=colourbase->colour[n].n;
    colourbase->colour[n]=cs;

    changed=1;
   }

   i++;
  }

  if(changed)
  {
   setpaneextent(editcol[1].handle,editcol[0].handle);
   refreshwindow(editcol[1].handle);
  }

  closedoc(xloadfile);
 }

 return(err);

 USE(userhandle);
}



static os_error *loadcolourtype(char * name,int type,mousestr * m,
                                        int userhandle,int *method)
{
 *method=(type==FTYPE2 || type==STYPE2);
 return(NULL);
 USE(userhandle);
 USE(m);
 USE(name);
}




/*****************************************************************************/



static os_error * editclose(int code)
{
 os_error * err;
 int        i;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  oldselectedn(selectedcolourn);
  err=updatecolourmap(editfile,&colourbase);
 }

 if(!err && code!=DBAPPLY) 
 {
  for(i=0;i<2;i++)
  {
   remdataload(editcol[i].handle,0,loadcolour);
   remdataloadpost(editcol[i].handle,0,loadcolourpost);
   remdataloadtype(editcol[i].handle,0,loadcolourtype);
  }
  losecolourmap(editfile,&colourbase);
  remcaretevent(panecaret,editcol[1].handle,0);
 }

 return(err);
}



static os_error * editpanekey(int handle,int userhandle,int icon,int * key)
{
 return(panekey(handle,editcol[0].handle,icon,key));
 USE(userhandle);
}



static dbiconstr editicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,
   12, NULL,         DBACTION, 0,   0,      DBAPPLY,-1,0,0 ,NULL ,0,

    7, &spotcolour,  DBTOGGLE, 0,   0,      COLOURPLATE,F1, 0, 0,NULL ,0,
   11, &noprintcolour,DBTOGGLE,0,   0,      COLOURNOPRINT,F2,0,0,NULL, 0,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};





static dboxstr editcol[2]=
{
 0,
 TECOL,
 DBFIX,
 DBGRAB,
 editclose,
 editicon,
 NULL,
 NULL,
 editicondefs,
 0,
 0,
 0,NULL,
 0,
 0,

 0,
 TCOLP,
 DBPANE,
 0,
 NULL,
 paneicon,
 editpanekey,
 paneredraw,
 NULL,
 0,
 0,
 0,NULL,
 0,
 0,

};



void editcolour(int fp)
{
 os_error  * err;
 int         i;
 int         key;
 colourstr * cs;


 err=dodboxspparent(editcol,2,editcol,&dbviewstack,menuview->handle);
 if(!err)
 {
  editfile=menufile;
  copycolourmap(editfile,&colourbase);
  selectedcolourn=focusn=0;

  key=stack[fp];
  if(key)
  {
   findcolourkey(key,colourbase,&cs);
   if(cs) selectedcolourn=focusn=cs-colourbase->colour;
  }

  colgetdboxdims(TECOL);

  wimp_setwindowbackground(editcol[1].handle,CCRGB|PALWHITE);

  if(!err) err=setpaneextent(editcol[1].handle,editcol[0].handle);

  if(!err)
  {
   newselectedn(selectedcolourn);

   for(i=0;i<2;i++)
   {
    adddataload(editcol[i].handle,0,loadcolour);
    adddataloadpost(editcol[i].handle,0,loadcolourpost);
    adddataloadtype(editcol[i].handle,0,loadcolourtype);
   }

   shadeiconst(editcol[0].handle,8,!colsepactive());
   shadeiconst(editcol[0].handle,7,!colsepactive());

   if(!err) err=setfocus(editcol[1].handle);
   if(!err) err=addcaretevent(panecaret,editcol[1].handle,0);
   if(!err) err=wimp_setwindowflags(editcol[1].handle,WINDOWNOTDIALOGUE,0);
  }
 }

 zreport(err);
 USE(fp);
}


/*************************************************************************/

extern dboxstr       pickcol[2];
static filestr     * pickfile;
static pickclosefn   pickclosesub;
static int           picktint;
static int           origpal;
static int           pickoverprint;


#define PICKCOLICON     9
#define PICKCOLTINTICON 7


static os_error * pickpaneicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        n;
 windowstr  window;
 int        oldn;
 int        oldfocusn;

 err=getw(handle,&window);
 if(!err)
 {
  n=((window.by-m->y)-PANETOPMARGIN)/PANESTEP;

  oldfocusn=focusn;
  oldn=selectedcolourn;
  selectedcolourn=n;
  if(oldfocusn>=0) focusn=selectedcolourn;
  panerefreshline(handle,oldn);
  panerefreshline(handle,selectedcolourn);

  setfocus(handle); 

  err=wimp_set_icon_state(pickcol[0].handle,PICKCOLICON,
                                        (wimp_iconflags)0,(wimp_iconflags)0);
  if(!err) err=wimp_set_icon_state(pickcol[0].handle,PICKCOLTINTICON,
                                        (wimp_iconflags)0,(wimp_iconflags)0);

  if(m->bbits==wimp_DOUBLELEFT) err=dbclose(pickcol,DBOK);
 }

 return(err);
 userhandle=userhandle;
}


static os_error * pickredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;
 int        pal;

 err=NULL;

	if(more)
	{
  if(colourbase->colour[selectedcolourn].flags & COLOURTRANS) pal=-1;
  else pal=tintpal(picktint,colourgetpal(&colourbase->colour[selectedcolourn],NULL,pickfile));

  while(more)
  {
   redrawblock(redrawstr,handle,PICKCOLICON,origpal);
   redrawblock(redrawstr,handle,PICKCOLTINTICON,pal);
   wimp_get_rectangle(redrawstr,&more);
  }
	}

 return(err);
}


static os_error * pickredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) pickredrawsub(handle,&redrawstr,more);
 return(err);
 userhandle=userhandle;
}


static os_error * pickclose(int code)
{
 os_error    * err;
 colourvalue   colour;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  memset(&colour,0,sizeof(colourvalue));
  colour.data.tint.key=colourbase->colour[selectedcolourn].n;
  colour.data.tint.tint=picktint;
  colour.data.tint.overprint=pickoverprint;
  pickclosesub(&colour);
 }

 if(!err && code!=DBAPPLY)
 {
  losecolourmap(pickfile,&colourbase);
  remcaretevent(panecaret,pickcol[1].handle,0);
 }

 return(err);
}



static os_error * pickicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
   case  6:
           err=openmenuparent("tint_menu",handle);
           break;

 }

 return(err);

 handle=handle;
 userhandle=userhandle;
}


static os_error * wrtint(int value,char * string)
{
/* strcpy(string,numbertostring((value*100+(0x10000/200))/0x10000)); */
// strcpy(string,numbertostring(scale(value,100,0x10000)));
 writepc(value,string);
 return(NULL);
}


static os_error * rdtint(int * value,char * string)
{
// strcpy(string,numbertostring(scale(value,100,0x10000)));
 return(readpc100(value,string));
}



static os_error * pickpanekey(int handle,int userhandle,int icon,int * key)
{
 return(panekey(handle,pickcol[0].handle,icon,key));
 USE(userhandle);
}





#define TSTP ((MAXTINT+49)/100)
#define TSMX (MAXTINT)


static dbiconstr pickicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,

    8,&picktint,     DBWRITE,  0,    DBASSOCINC,     0,  0,  0, 0,     rdtint, wrtint,
    7,&picktint,     DBUPDATE, 0,    0,     0,  0,  0, 0,     NULL, NULL,
    5,&picktint,     DBINC,    0,    0,  TSTP, -1, TSMX,0,   NULL,  0,
    4,&picktint,     DBDEC,    0,    0,  TSTP, -1, TSMX,0,   NULL,  0,
   11,&pickoverprint,DBTOGGLE, 0,    0,     1,  F1,0,0,       NULL,  0,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr pickcol[2]=
{
 0,
 TCOLOUR,
 DBFIX,
 DBGRAB,
 pickclose,
 pickicon,
 NULL,
 pickredraw,
 pickicondefs,
 0,
 0,
 0,0,0,0,

 0,
 TCOLP,
 DBPANE,
 0,
 NULL,
 pickpaneicon,
 pickpanekey,
 paneredraw,
 NULL,
 0,
 0,
 0,NULL,
 0,
 0,
};


os_error * pickcolourparent(filestr * file,colourvalue * colour,pickclosefn close,
                                         dboxstr * parent,int parenthandle)
{
 os_error * err;
 int        colourn;

 pickfile=file;
 pickclosesub=close;
 picktint=colour->data.tint.tint;
 pickoverprint=colour->data.tint.overprint;
 colourn=colour->data.tint.key;

 colgetdboxdims(TCOLOUR);

// cprintf("parent %x handle %x",parent,parenthandle);

 /* put this here and try to take out multiple calls */

 err=dodboxspparent(pickcol,2,parent,&dbviewstack,parenthandle);
 if(!err)
 {
  err=copycolourmap(file,&colourbase);
  if(!err)
  {
   selectedcolourn=focusn=findcolourindex(colourbase,colourn);

   if(colourbase->colour[selectedcolourn].flags & COLOURTRANS) origpal=-1;
   else                                                        origpal=tintpal(picktint,
   colourgetpal(&colourbase->colour[selectedcolourn],NULL,pickfile));

   wimp_setwindowbackground(pickcol[1].handle,CCRGB|PALWHITE);
            err=setpaneextent(pickcol[1].handle,pickcol[0].handle);
   if(!err) err=paneopenat(selectedcolourn,pickcol[1].handle);
   if(!err) err=shadeiconst(pickcol[0].handle,11,!colsepactive());
   if(!err) err=setfocus(pickcol[1].handle);
   if(!err) err=addcaretevent(panecaret,pickcol[1].handle,0);
   if(!err) err=wimp_setwindowflags(pickcol[1].handle,WINDOWNOTDIALOGUE,0);
  }
 }
 return(err);
}


os_error * pickcolour(filestr * file,colourvalue * colour,pickclosefn close,
                                                             dboxstr * parent)
{
 return(pickcolourparent(file,colour,close,parent,0));
}







int gettint(int fp)
{
/* return((picktint*100+(0x10000/200))/0x10000); */
 return(scale(picktint,100,0x10000));
 USE(fp);
}

void settint(int fp)
{
/* picktint=(stack[fp]*0x10000)/100; */

 cprintf("settint %d",stack[fp]);

 picktint=scale(stack[fp],0x10000,100);
 picktint=CUT(picktint,0,MAXTINT);

 dbchangevalue(&picktint,pickcol);
}

