/*->c.dbnew */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "transform.h"

#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "redraw.h"
#include "etc.h"
#include "fsx.h"
#include "bf.h"
#include "conf.h"
#include "bits.h"
#include "deb.h"


#include "str.h"
#include "constants.h"
#include "object.h"

#include "reslink.h"

#include "dbhi.h"
#include "mhi.h"
#include "trans.h"

#include "main.h"
#include "units.h"
#include "view.h"
#include "file.h"
#include "xcolour.h"
#include "section.h"
#include "pref.h"

#include "txstr.h"

#include "new.h"
#include "newx.h"
#include "chsect.h"

#include "dbscale.h"

#include "dbcolour.h"

#include "dbcolumn.h"

#include "dbnew.h"



/* another of these in c.clip */

#define MARGIN ((10*720000)/254)


newstr defnewdata=
{
  595276,             /* width         */
  841890,             /* height        */
  "A4",               /* size A4       */

  OURWHITE, OURWHITE, /* page colour         */
  
  FILLSTR,  FILLSTR,  /* fill                */

  0,0,                /* mainkey             */


  0,                  /* portrait      */
  0,                  /* not user size */
  0,                  /* spare         */
  0,                  /* single sided  */


  0,                  /* omit header   */
  0,                  /* omit footer   */
  PNFNUMERIC,         /* page number format  */
  1,                  /* start               */

  0,                  /* start on right      */
  0,                  /* blanks              */

  1,                  /* number              */


  0,                  /* section number      */



  NEWMODEBOTH,

  1,        1,        /* columns             */
  1,        1,        /* principle frame     */
  MARGIN,   MARGIN,   /* 34016,    34016,     top margin          */
  MARGIN,   MARGIN,   /* 56692,    56692,     bot margin          */
  MARGIN,   MARGIN,   /* 34016,    34016,     left margin         */
  MARGIN,   MARGIN,   /* 34016,    34016,     right margin        */
  0,        0,        /* header margin       */
  0,        0,        /* footer margin       */


  0,                  /* column mode         */
  0,                  /* column guides       */
  MMSIZE,             /* guide width         */
  14173,              /* column width        */
  OURBLACK,           /* column guide colour */


  0,                  /* right hand values   */
  0,
  MMSIZE,
  14173,
  OURBLACK,


  MILIMS,             /* units               */


//  595276,             /* paper width         */
//  841890,             /* paper height        */

		
		COMPATABILITY,

  0,0,0                /* spare [3]            */

};



static dboxstr      * newboxp;


       newstr         cnew;
static int            cshape;
static int            cusersize;
static filestr      * cfile;


extern dboxstr newbox;

static int columns;
static int topmargin;
static int botmargin;
static int leftmargin;
static int rightmargin;
static int headermargin;
static int footermargin;
static int principleframe;

static int oldmode;

static int csection;



#define MINPAGEWIDTH   18000
#define MAXPAGEWIDTH   11338583  /* 4 metres */

/* 215000  */
/* 2590000 */

#define MINPAGEHEIGHT  18000
#define MAXPAGEHEIGHT  11338583

/* 2590000 */




static os_error * modwritetitle(int handle,int n);





static os_error * validnew(newstr * xnew)
{
 os_error * err;
 int        error;
 int        i;

 err=NULL;

 error=ENONE;

 for(i=0;i<2;i++)
 {
  if(xnew->principleframe[i])
  {
   if((xnew->leftmargin[i]+xnew->rightmargin[i])>xnew->sectiondata.width)
                      error=NE02; /* Left and right margins too large */ 
   else
   if((xnew->topmargin[i]+xnew->botmargin[i]+xnew->headermargin[i]+
                       xnew->footermargin[i])>xnew->sectiondata.height)
     error=NE03; /* Top, bottom, header and footer margins too large */
   else
   if(xnew->sectiondata.width<MINPAGEWIDTH) error=NE04;
                                           /* Page width too small */
   else
   if(xnew->sectiondata.width>MAXPAGEWIDTH) error=NE05;
                                           /* Page width too large */
   else
   if(xnew->sectiondata.height<MINPAGEHEIGHT) error=NE06;
                                             /*Page height too small*/
   else
   if(xnew->sectiondata.height>MAXPAGEHEIGHT) error=NE07; 
                                             /* Page height too large */
   
   if(error!=ENONE) err=geterror(error);

   else err=columncheck(xnew->sectiondata.width-xnew->leftmargin[i]+
                                                xnew->rightmargin[i],
                              xnew->columns[i],&xnew->columndata[i]);
  }

  if(err) break;
 }

 return(err);
}





#define NEWCOLICON 10



static os_error * colredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;
 int        hand;

 err=NULL;

	if(more)
	{
  hand=(cnew.mode==NEWMODERIGHT);

  while(more)
  {
   redrawblock(redrawstr,handle,NEWCOLICON,vfindcolour2(NULL,cfile,
                                             &cnew.sectiondata.colour[hand]));
   wimp_get_rectangle(redrawstr,&more);
  }
	}

 return(err);
}


static os_error * newredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) colredrawsub(handle,&redrawstr,more);
 return(err);
 userhandle=userhandle;
}


static void pickclose(colourvalue * colour)
{
 if(cnew.mode==NEWMODELEFT || cnew.mode==NEWMODEBOTH)
 {
  cnew.sectiondata.colour[0]=*colour;
 }

 if(cnew.mode==NEWMODERIGHT || cnew.mode==NEWMODEBOTH)
 {
  cnew.sectiondata.colour[1]=*colour;
 }

 wimp_set_icon_state(newboxp->handle,NEWCOLICON,
                                     (wimp_iconflags)0,(wimp_iconflags)0);
}


static void columnclose(dbcolumnstr * cdb)
{
 if(cnew.mode==NEWMODELEFT || cnew.mode==NEWMODEBOTH)
 {
  cnew.columndata[0]=cdb->ccol;
 }

 if(cnew.mode==NEWMODERIGHT || cnew.mode==NEWMODEBOTH)
 {
  cnew.columndata[1]=cdb->ccol;
 }
}


#ifdef NEVER

static void pagenumberclose(pagenumberstr * pdb)
{
 cnew.sectiondata.pagenumber=*pdb;
}


static os_error * setnewpageunits(int units)
{
 dbreadvalues(newboxp);
 cnew.units=units;
 return(dbwritevalues(newboxp));
}



/* getnewpageunits(void) */

static os_error * getnewpageunits(int * units)
{
 *units=cnew.units;
 return(NULL);
}


#endif




static os_error * newicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error     * err;
 dbcolumnstr    cdb;
 int            hand;


 err=NULL;

 hand=(cnew.mode==NEWMODERIGHT);

 switch(m->i)
 {

  case 18:
          cdb.ccol=cnew.columndata[hand];
          cdb.width=cnew.sectiondata.width-(leftmargin+rightmargin);
          cdb.columns=columns;
          cdb.units=cnew.units;
          err=docolumn(columnclose,&cdb,cfile,newboxp);
          break;

  case 11:  /* colour */
          err=pickcolour(cfile,&cnew.sectiondata.colour[hand],
                                                          pickclose,newboxp);
          break;

/*
  case  3:
          err=openmenuparent("newpagesize_menu",handle);
          break;
*/
/*  case 41:
          err=openunitsmenu(setnewpageunits,getnewpageunits);
          break;  */
 }

 return(err);

 USE(handle);
 USE(userhandle);
}



static void saveset(int hand,int reflect)
{
 cnew.columns[hand]=columns;

 cnew.principleframe[hand]=principleframe;
 cnew.principleframe[1-hand]=principleframe;

 cnew.topmargin[hand]=topmargin;
 cnew.botmargin[hand]=botmargin;

 if(reflect)
 {
  cnew.leftmargin[hand]=rightmargin;
  cnew.rightmargin[hand]=leftmargin;
 }
 else
 {
  cnew.leftmargin[hand]=leftmargin;
  cnew.rightmargin[hand]=rightmargin;
 }

 cnew.headermargin[hand]=headermargin;
 cnew.footermargin[hand]=footermargin;
}


static void loadset(int hand,int reflect)
{
 columns=cnew.columns[hand];
 principleframe=cnew.principleframe[hand];
 topmargin=cnew.topmargin[hand];
 botmargin=cnew.botmargin[hand];
 leftmargin=cnew.leftmargin[hand];
 rightmargin=cnew.rightmargin[hand];

 if(reflect) SWOP(leftmargin,rightmargin);

 headermargin=cnew.headermargin[hand];
 footermargin=cnew.footermargin[hand];
}




static os_error * newclosesub(void)
{
 cnew.sectiondata.shape=cshape;
 cnew.sectiondata.usersize=cusersize;

 if(cnew.mode==NEWMODELEFT  || cnew.mode==NEWMODEBOTH || 
                                !cnew.sectiondata.dble)
 {
  saveset(0,cnew.mode==NEWMODEBOTH && cnew.sectiondata.dble);
 }

 if(cnew.mode==NEWMODERIGHT || cnew.mode==NEWMODEBOTH || 
                                !cnew.sectiondata.dble)
 {
  saveset(1,0);
 }

 return(validnew(&cnew));
}




static os_error * newclose(int code)
{
 os_error       * err;
 filestr        * file=NULL;

 err=NULL;

 if(code==DBOK)
 {
           err=newclosesub();
  if(!err) err=createnewdoc(&cnew,&file,NULL);
           event(EVENT_FOPEN,file,0);
  if(!err) err=createnewview(file,DOC,NULL,0);
 }

 return(err);
}



static os_error * optfn(int handle,int userhandle,wimp_mousestr * m)
{

 dbreadvalues(newboxp);

 if(oldmode==NEWMODELEFT  || oldmode==NEWMODEBOTH)
 {
  saveset(0,oldmode==NEWMODEBOTH && cnew.sectiondata.dble);
 }

 if(oldmode==NEWMODERIGHT || oldmode==NEWMODEBOTH)
 {
  saveset(1,0);
 }

 if(oldmode==NEWMODERIGHT && cnew.mode==NEWMODELEFT)
 {
  loadset(0,0);
  dbwritevalues(newboxp);
  wimp_set_icon_state(newboxp->handle,NEWCOLICON,
                                      (wimp_iconflags)0,(wimp_iconflags)0);
 }
 
 if(oldmode==NEWMODELEFT  && cnew.mode==NEWMODERIGHT)
 {
  loadset(1,0);
  dbwritevalues(newboxp);
  wimp_set_icon_state(newboxp->handle,NEWCOLICON,
                                      (wimp_iconflags)0,(wimp_iconflags)0);
 }

 oldmode=cnew.mode;

 return(NULL);

 USE(userhandle);
 USE(handle);
 USE(m);
}



static os_error * dblfn(int handle,int userhandle,wimp_mousestr * m)
{
 return(dbshade(1,cnew.sectiondata.dble?0:DBSHADEG,newboxp));

 USE(userhandle);
 USE(handle);
 USE(m);
}



static os_error * shapefn(int handle,int userhandle,wimp_mousestr * m)
{
 dbreadvalues(newboxp);
 SWOP(cnew.sectiondata.width,cnew.sectiondata.height);
 dbchangevalue(&cnew.sectiondata.width,newboxp);
 dbchangevalue(&cnew.sectiondata.height,newboxp);

 return(NULL);

 USE(userhandle);
 USE(handle);
 USE(m);

}


static os_error * newoutu(int value,char * string)
{
 strcpy(string,unitstostring(value,cnew.units));
 return(NULL);
}

static os_error * newinu(int * value,char * string)
{
 return(stringtounits(string,value,cnew.units));
}

static os_error * newout(int value,char * string)
{
 strcpy(string,numbertostring(value));
 return(NULL);
}

static os_error * newin(int * value,char * string)
{
 return(stringtonumber(string,value));
}

static os_error * wrsize(int value,char * string)
{
 strcpy(string,cnew.sectiondata.size);
 return(NULL);
 USE(value);
}


#ifdef NEVER

static os_error * wrunits(int value,char * string)
{
 strcpy(string,unitstring[value]);
 return(NULL);
}

#endif


static os_error * wrinner(int value,char * string)
{
 tsprintf(32,string,
          (cnew.mode==NEWMODEBOTH && cnew.sectiondata.dble)?"{NEWI}":"{NEWL}");

 return(NULL);
 USE(value);
 USE(string);
}

static os_error * wrouter(int value,char * string)
{
 tsprintf(32,string,
          (cnew.mode==NEWMODEBOTH && cnew.sectiondata.dble)?"{NEWO}":"{NEWR}");
 return(NULL);
 USE(value);
 USE(string);
}




static os_error * newcombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

 err=menucombo(newboxp,36,"newpagesize_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);
}




static dbiconstr newicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

   15, &columns,       DBWRITE,0,   DBASSOCINC,   -1, -1, 14, -1, newin,  newout,
   17, &columns,       DBINC,  0,   0,       1,   -1,MAXCOLUMNS,1,  NULL,  0,
   16, &columns,       DBDEC,  0,   0,       1,   -1,MAXCOLUMNS,1,  NULL,  0,


   20, &topmargin,     DBWRITE,0,   0,      -1, -1, 16,  8, newinu, newoutu,
   22, &botmargin,     DBWRITE,0,   0,      -1, -1, 18, 14, newinu, newoutu,
   24, &leftmargin,    DBWRITE,0,   0,      -1, -1, 20, 16, newinu, newoutu,
   26, &rightmargin,   DBWRITE,0,   0,      -1, -1,  4, 18, newinu, newoutu,
   28, &headermargin,  DBWRITE,0,   0,      -1, -1, 24,  6, newinu, newoutu,
   30, &footermargin,  DBWRITE,0,   0,      -1, -1, -1, 22, newinu, newoutu,

   36,(int*)&cnew.sectiondata.size[0],DBCOMBO,0,DBCOMBOSTATIC,0,0,0,  0,   NULL,(dbwritefn)newcombo,

    7, &cnew.sectiondata.width,DBWRITE,2, 0,-1, -1,  6, 20, newinu, newoutu,
    5, &cnew.sectiondata.height,DBWRITE,2,0,-1, -1, 22,  4, newinu, newoutu,

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0, NULL, 0,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

    8, &cshape,      DBTOGGLE,0,0,1, F1,  0, 0,(dbreadfn)shapefn,0,
   31, &cnew.sectiondata.dble, DBTOGGLE,0,0,1, F2,  0, 0,(dbreadfn)dblfn,0,


   32, &cnew.mode,    DBRADIO,1,    0,NEWMODELEFT,0,1,0,(dbreadfn)optfn,  0,
   33, &cnew.mode,    DBRADIO,1,    0,NEWMODERIGHT,0,1,0,(dbreadfn)optfn, 0,
   34, &cnew.mode,    DBRADIO,1,    0,NEWMODEBOTH,0,1,0,(dbreadfn)optfn,  0,

   13, &principleframe,DBTOGGLE,0,  0,      1, F4,  0, 0,      NULL,   0,

 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */

   23, &cnew.mode,     DBTEXT,0,    0,      0,  0,  0,   0,   NULL,wrinner,
   23, &cnew.sectiondata.dble,DBTEXT,0, 0,      0,  0,  0,   0,   NULL,wrinner,
   25, &cnew.mode,     DBTEXT,0,    0,      0,  0,  0,   0,   NULL,wrouter,
   25, &cnew.sectiondata.dble,DBTEXT,0,  0,   0,  0,  0,   0,   NULL,wrouter,

/* 40, &cnew.units,    DBTEXT,0,    0,      0,  0,  0,   0,   NULL,wrunits,*/



   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};





static dboxstr newbox=
{
 0,
 TPAGEGUIDES,
 DBFIX,
 DBCARETRESET,
 newclose,
 newicon,
 NULL,
 newredraw,
 newicondefs,
 0,
 0,
 1,               /* size needed for dbshade */
 NULL,
 0,
 0,
};


/* script function opens the new document dialogue box */

os_error * opennewbox2(void)
{
 os_error * err;
 viewstr  * view;

 cfile=deffile;
 view=menuview;
 menuview=NULL;
 menufile=NULL;



 if(deffile)
 {
  getnewdata(&cnew,findsectioni(1,deffile,MST),deffile);
 }
 else
 {
  cnew=defnewdata;
 }

 cnew.units=defprefdata.units;
	cnew.compatability=workcompatability;


 cshape=cnew.sectiondata.shape;
 cusersize=cnew.sectiondata.usersize;

 newboxp=&newbox;

 oldmode=cnew.mode;

 if(cnew.mode==NEWMODELEFT || cnew.mode==NEWMODEBOTH) 
                    loadset(0,cnew.mode==NEWMODEBOTH && cnew.sectiondata.dble);
 else               loadset(1,0);


 err=dodboxspparent(&newbox,1,&newbox,&dbviewstack,view->handle);
	if(!err)
	{
  modwritetitle(newbox.handle,-1);
  dbshade(1,cnew.sectiondata.dble?0:DBSHADEG,&newbox);
  dbshade(2,cusersize?0:DBWRITEG|DBSHADEG,&newbox);
	}

	return(err);
}

void opennewbox(int fp)
{
 zreport(opennewbox2());
 USE(fp);
}








/* getnewpagesize(0/1) x/y */

int getnewpagesize(int fp)
{
 if(cusersize) dbreadvalues(newboxp);

 if(stack[fp]) return(cnew.sectiondata.height);
 else          return(cnew.sectiondata.width);
}


/* setnewpagesize(x,y,name,user) */

void setnewpagesize(int fp)
{
 int oldnowrite;
 int paperwidth;
 int paperheight;

 oldnowrite=cusersize;

 paperwidth=stack[fp];
 paperheight=stack[fp+1];
 cusersize=stack[fp+3];

 xzstrncpy(cnew.sectiondata.size,stringptr(stack[fp+2]),sizeof(cnew.sectiondata.size));

//	cprintf("set size %d %d %s %d",paperwidth,paperheight,stringptr(stack[fp+2]),cusersize);


 if(paperwidth<0 || paperheight<0)
 {
  if(!oldnowrite) dbshade(2,0,newboxp);
 }
 else
 {
  if(oldnowrite) dbshade(2,DBSHADEG|DBWRITEG,newboxp);

  if(cshape)
  {
   cnew.sectiondata.width=paperheight;
   cnew.sectiondata.height=paperwidth;
  }
  else
  {
   cnew.sectiondata.width=paperwidth;
   cnew.sectiondata.height=paperheight;
  }

  dbchangevalue(&cnew.sectiondata.width,newboxp);
  dbchangevalue(&cnew.sectiondata.height,newboxp);
 }

// this upsets combo box menu, because "other" usually has same dimensions as a real size like A4
// dbchangevalue((int*)&cnew.sectiondata.size[0],newboxp);
}


/************************************************************************/


static os_error * modclose(int code)
{
 os_error       * err;
 newstr           onew;
 int              was;
 int              now;
 int              result;

 err=NULL;

 if(code==DBOK)
 {
  err=newclosesub();
  if(!err)
  {
   err=getnewdata(&onew,csection,cfile);
   if(!err)
   {
    was=onew.principleframe[0] || 
                      (onew.principleframe[1] && onew.sectiondata.dble);
    now=cnew.principleframe[0] ||
                      (cnew.principleframe[1] && cnew.sectiondata.dble);

    if(was && !now) err=confirmparent(NULL,CONDC,&result,"{MOD03}");
    else            result=1;

    if(!err && result==1) err=changesection(&cnew,csection,cfile);
   }
  }
 }

 return(err);
}










static dboxstr modchapter=
{
 0,
 TPAGEGUIDES,
 DBFIX,
 0,
 modclose,
 newicon,
 NULL,
 newredraw,
 newicondefs,
 0,
 0,
 1,                    /* size needed for dbshade */
 NULL,
 0,
 0,
};



static os_error * modwritetitle(int handle,int n)
{
 os_error  * err;
 char        temp[128];

 err=NULL;

 if(n>=0) sprintf(temp,"{MOD00} %d",n);
 else     strcpy(temp,"{MOD02}");
 trans(temp,sizeof(temp));

 err=writetitle(handle,temp);

 return(err);
}



/* script function opens the mod chapter dialogue box */

void openpagebox(int fp)
{
 os_error   * err;
 sectionstr * sectionp;

 csection=menuview->dsection;
 cfile=menufile;
 err=getnewdata(&cnew,csection,cfile);

 cshape=cnew.sectiondata.shape;
 cusersize=cnew.sectiondata.usersize;

 newboxp=&modchapter;

 sectionp=(sectionstr*)fob_find(csection,cfile);

 oldmode=cnew.mode;

 if(cnew.mode==NEWMODELEFT || cnew.mode==NEWMODEBOTH) 
                    loadset(0,cnew.mode==NEWMODEBOTH && cnew.sectiondata.dble);
 else               loadset(1,0);

 err=dodboxspparent(&modchapter,1,&modchapter,&dbviewstack,menuview->handle);

 dbshade(1,cnew.sectiondata.dble?0:DBSHADEG,&modchapter);
 dbshade(2,cusersize?0:DBWRITEG|DBSHADEG,&modchapter);

 modwritetitle(modchapter.handle,sectionp->data.number);
 
 zreport(err);

 USE(fp);
}

