/*->c.pal */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "transform.h"
#include "flex.h"
#include "bbc.h"


#include "wos.h"
#include "err.h"
#include "task.h"
#include "xext.h"
#include "poll.h"
#include "temp.h"
#include "scrap.h"
#include "fsx.h"
#include "bf.h"
#include "etc.h"
#include "dbhi.h"
#include "key.h"
#include "units.h"
#include "redraw.h"
#include "colour.h"
#include "drag.h"
#include "xmath.h"
#include "deb.h"

#include "str.h"
#include "constants.h"

#include "object.h"

#include "reslink.h"
#include "file.h"
#include "view.h"
#include "viewo.h"
#include "viewr.h"
#include "xcolour.h"
#include "xxcolour.h"
#include "cconv.h"

#include "dbscale.h"

#include "dbpal.h"


int rback;
int gback;
int bback;
int tback;



/****************************************************************************/


extern dboxstr pbox;



#define PRGB  RGBMODEL
#define PCMYK CMYKMODEL
#define PHSV  HSVMODEL



#define WHEEL 10


#define PALTRANS 0x1

static int pmode;


static int v0;
static int v1;
static int v2;
static int v3;
static int vb;


static int rv;    /* current rgb and tint values */
static int gv;
static int bv;


static palclosefn  xpalclose;
static palgetpalfn xgetpal;
static palsetpalfn xsetpal;

static int palflags;



/****************************************************************************/

static os_error * rgbupdatecross(void);

static void writedboxv0(void);


static char * name[3]={
                       "RGB ",
                       "CMYK",
                       "HS  ",
                      };

static void writenames(void)
{
 char * table;

 table=name[pmode];

 writeiconf(pbox.handle, 9,"%c",table[0]);
 writeiconf(pbox.handle,12,"%c",table[1]);
 writeiconf(pbox.handle,25,"%c",table[2]);
 writeiconf(pbox.handle,26,"%c",table[3]);
}


static void palgetcolour(modelstr * colour)
{
 memset(colour,0,sizeof(modelstr));

 colour->no=pmode;
 colour->pal=(((rv*255)/MAXCV)<<8)|(((gv*255)/MAXCV)<<16)|(((bv*255)/MAXCV)<<24);
 colour->len=(colour->no==CMYKMODEL)?MOD4LEN:MOD3LEN;

 if(pmode==PRGB)
 {
  colour->data.quad.type.rgb.r=v0;
  colour->data.quad.type.rgb.g=v1;
  colour->data.quad.type.rgb.b=v2;
 }
 else
 if(pmode==PHSV)
 {
  colour->data.quad.type.hsv.h=v0;
  colour->data.quad.type.hsv.s=v1;
  colour->data.quad.type.hsv.v=vb;
 }
 else
 if(pmode==PCMYK)
 {
  colour->data.quad.type.cmyk.c=v0;
  colour->data.quad.type.cmyk.m=v1;
  colour->data.quad.type.cmyk.y=v2;
  colour->data.quad.type.cmyk.k=v3;
 }
}








/* a mode change has taken place */

static os_error * mfn(void)
{
 os_error * err;
 int        rgb[3];
 int        temp[4];

 rgb[0]=rv;
 rgb[1]=gv;
 rgb[2]=bv;

 writenames();
 writedboxv0();

 switch(pmode)
 {
  case  PRGB:
             v0=rv;
             v1=gv;
             v2=bv;

             v3=0;
             break;

  case  PHSV:
             rgb2hsv((quadstr*)rgb,(quadstr*)temp);
             v0=temp[0];
             v1=temp[1];
             vb=temp[2];

             v2=0;
             v3=0;

             hsv2rgb((quadstr*)temp,(quadstr*)rgb);
             break;

  case PCMYK:
             rgb2cmyk((quadstr*)rgb,(quadstr*)temp);
             v0=temp[0];
             v1=temp[1];
             v2=temp[2];
             v3=temp[3];
             cmyk2rgb((quadstr*)temp,(quadstr*)rgb);
             break;
 }

 rv=rgb[0];
 gv=rgb[1];
 bv=rgb[2];

 dbshade(1,pmode==PHSV,&pbox);
 dbshade(2,pmode==PHSV || pmode==PRGB,&pbox);

 err=dbwritevalues(&pbox);
 wimp_set_icon_state(pbox.handle,52,(wimp_iconflags)0,(wimp_iconflags)0);
 wimp_set_icon_state(pbox.handle,20,(wimp_iconflags)0,(wimp_iconflags)0);
 wimp_set_icon_state(pbox.handle,21,(wimp_iconflags)0,(wimp_iconflags)0);
 wimp_set_icon_state(pbox.handle,22,(wimp_iconflags)0,(wimp_iconflags)0);
// wimp_set_icon_state(pbox.handle,36,(wimp_iconflags)0,(wimp_iconflags)0);
 wimp_set_icon_state(pbox.handle,40,(wimp_iconflags)0,(wimp_iconflags)0);

 if(pmode==PHSV)
 {
  wimp_set_icon_state(pbox.handle,11,(wimp_iconflags)0,(wimp_iconflags)0);
  wimp_set_icon_state(pbox.handle,WHEEL,(wimp_iconflags)0,(wimp_iconflags)0);
 }
 else
 {
  rgbupdatecross();
 }

 return(err);
}



static void initvalues(modelstr * colour)
{
 int        rgb[3];


 rgb[0]=0;
 rgb[1]=0;
 rgb[2]=0;

 pmode=colour->no;

 vb=MAXCV;

 switch(colour->no)
 {
  case  PRGB:
             v0=rgb[0]=colour->data.quad.type.rgb.r;
             v1=rgb[1]=colour->data.quad.type.rgb.g;
             v2=rgb[2]=colour->data.quad.type.rgb.b;

             v3=0;
             break;

  case  PHSV:
             v0=colour->data.quad.type.hsv.h;
             v1=colour->data.quad.type.hsv.s;
             vb=colour->data.quad.type.hsv.v;

             v2=0;
             v3=0;

             hsv2rgb(&colour->data.quad,(quadstr*)rgb);
             break;

  case PCMYK:
             v0=colour->data.quad.type.cmyk.c;
             v1=colour->data.quad.type.cmyk.m;
             v2=colour->data.quad.type.cmyk.y;
             v3=colour->data.quad.type.cmyk.k;
             cmyk2rgb(&colour->data.quad,(quadstr*)rgb);
             break;
 }

 rv=rgb[0];
 gv=rgb[1];
 bv=rgb[2];
}




static os_error * newrgb(int tint,int vchange)
{
 os_error * err;
 int        rgb[3];
 int        temp[4];

 err=NULL;

 rgb[0]=rv;
 rgb[1]=gv;
 rgb[2]=bv;

 switch(pmode)
 {
  case  PRGB:
             v0=rv;
             v1=gv;
             v2=bv;

             v3=0;
             break;

  case  PHSV:
             rgb2hsv((quadstr*)rgb,(quadstr*)temp);
             v0=temp[0];
             v1=temp[1];
             vb=temp[2];

             v2=0;
             v3=0;

             hsv2rgb((quadstr*)temp,(quadstr*)rgb);
             break;

  case PCMYK:
             rgb2cmyk((quadstr*)rgb,(quadstr*)temp);
             v0=temp[0];
             v1=temp[1];
             v2=temp[2];
             v3=temp[3];
             cmyk2rgb((quadstr*)temp,(quadstr*)rgb);
             break;
 }

 rv=rgb[0];
 gv=rgb[1];
 bv=rgb[2];

 dbchangevalue(&v0,&pbox);
 dbchangevalue(&v1,&pbox);



 if(pmode!=PHSV)
 {
  dbchangevalue(&v2,&pbox);
 }

 if(pmode==PCMYK) 
 {
  dbchangevalue(&v3,&pbox);
 }

// wimp_set_icon_state(pbox.handle,36,(wimp_iconflags)0,(wimp_iconflags)0);
 wimp_set_icon_state(pbox.handle,40,(wimp_iconflags)0,(wimp_iconflags)0);

 if(pmode==PHSV && vchange)
 {
  dbchangevalue(&vb,&pbox);
  wimp_set_icon_state(pbox.handle,WHEEL,(wimp_iconflags)0,(wimp_iconflags)0);
 }
 else
 {
  rgbupdatecross();
 }

 return(err);

 USE(tint);
}



/* one of the colour sliders has changed */

static os_error * vfn(void)
{
 int        rgb[3];
 int        temp[4];

 switch(pmode)
 {
  case  PRGB:
             rv=v0;
             gv=v1;
             bv=v2;
             break;

  case  PHSV:
             temp[0]=v0;
             temp[1]=v1;
             temp[2]=vb;
             hsv2rgb((quadstr*)temp,(quadstr*)rgb);
             rv=rgb[0];
             gv=rgb[1];
             bv=rgb[2];
             break;

  case PCMYK:
             temp[0]=v0;
             temp[1]=v1;
             temp[2]=v2;
             temp[3]=v3;
             cmyk2rgb((quadstr*)temp,(quadstr*)rgb);
             rv=rgb[0];
             gv=rgb[1];
             bv=rgb[2];
             break;
 }


// wimp_set_icon_state(pbox.handle,36,(wimp_iconflags)0,(wimp_iconflags)0);
 wimp_set_icon_state(pbox.handle,40,(wimp_iconflags)0,(wimp_iconflags)0);

 rgbupdatecross();

 return(NULL);
}



/* called if the V slider changes */

static os_error * bfn(void)
{
 int        rgb[3];
 int        temp[4];



 if(pmode==PHSV)
 {
  temp[0]=v0;
  temp[1]=v1;
  temp[2]=vb;
  hsv2rgb((quadstr*)temp,(quadstr*)rgb);
  rv=rgb[0];
  gv=rgb[1];
  bv=rgb[2];
 }
 else
 if(pmode==PRGB)
 {
  rgb[0]=rv;
  rgb[1]=gv;
  rgb[2]=bv;
  rgb2hsv((quadstr*)rgb,(quadstr*)temp);
  temp[2]=vb;
  hsv2rgb((quadstr*)temp,(quadstr*)rgb);
  v0=rv=rgb[0];
  v1=gv=rgb[1];
  v2=bv=rgb[2];

  dbchangevalue(&v0,&pbox);
  dbchangevalue(&v1,&pbox);
  dbchangevalue(&v2,&pbox);
 }
 else
 if(pmode==PCMYK)
 {
  rgb[0]=rv;
  rgb[1]=gv;
  rgb[2]=bv;
  rgb2hsv((quadstr*)rgb,(quadstr*)temp);
  temp[2]=vb;
  hsv2rgb((quadstr*)temp,(quadstr*)rgb);
  rv=rgb[0];
  gv=rgb[1];
  bv=rgb[2];
  rgb2cmyk((quadstr*)rgb,(quadstr*)temp);
  v0=temp[0];
  v1=temp[1];
  v2=temp[2];
  v3=temp[3];

  dbchangevalue(&v0,&pbox);
  dbchangevalue(&v1,&pbox);
  dbchangevalue(&v2,&pbox);
  dbchangevalue(&v3,&pbox);
 }


//  wimp_set_icon_state(pbox.handle,36,(wimp_iconflags)0,(wimp_iconflags)0);
 wimp_set_icon_state(pbox.handle,40,(wimp_iconflags)0,(wimp_iconflags)0);

 wimp_set_icon_state(pbox.handle,WHEEL,(wimp_iconflags)0,(wimp_iconflags)0);

 return(NULL);
}


/*****************************************************************************/

static int rootsum(int x,int y)
{
 big x2;
 big y2;
 big r2;

 bigmul(&x2,x,x);
 bigmul(&y2,y,y);
 bigadd(&x2,&y2,&r2);
 return(bigsquareroot(&r2));
}


#define CROSSX 8
#define CROSSY 8

#define WNEWCROSS 1
#define WOLDCROSS 2
#define WUPDATE   3


static os_error * redwheel(wimp_redrawstr * redrawstr,int w,int mode)
{
 os_error * err;
 int        ox;
 int        oy;
 iconstr    icon;
 int        cx;
 int        cy;
 int        rd;
 double     angle;
 int        degrees;
 int        x;
 int        y;
 int        lx;
 int        ly;
 int        r;
 int        g;
 int        b;
 int        h;
 int        v;
 int        s;
 int        rmax;
 static int oldcx;
 static int oldcy;
 int        rgb[3];
 int        hsv[3];


 ox=redrawstr->box.x0-redrawstr->scx;
 oy=redrawstr->box.y1-redrawstr->scy;

  /* colour wheel */
 err=geti(w,WHEEL,&icon);

 if(iconinredraw(redrawstr,&icon))
 {
  cx=(icon.ix0+icon.ix1)/2;
  cy=(icon.iy0+icon.iy1)/2;
  rmax=MIN(icon.ix1-icon.ix0,icon.iy1-icon.iy0)/2
                                  -2*MAX(cvdu.deltax,cvdu.deltay);

//  v=scale(vb,MAXCV,MAXCV);
  v=vb;

  if(mode==WUPDATE)
  for(rd=rmax;rd>=0;rd-=32)
  {
   s=scale(v,rd,rmax);

   lx=rd;
   ly=0;

   for(degrees=HUE180/18,angle=PI/18;degrees<=HUE90;
                                         angle+=PI/18,degrees+=HUE180/18)
   {
    x=(int)(rd*cos(angle));
    y=(int)(rd*sin(angle));
   
    if(degrees<HUE60)
    {
     r=v;
     b=v-s;
     g=scale(s,degrees,(HUE120-degrees))+v-s;
    }
    else
    {
     g=v;
     b=v-s;
     r=scale(s,(HUE120-degrees),degrees)+v-s;
    }

    r=(r*255)/MAXCV;
    g=(g*255)/MAXCV;
    b=(b*255)/MAXCV;


    setgcol((b<<24) | (g<<16) | (r<<8));
    bbc_move(ox+cx,oy+cy);
    bbc_move(ox+cx+lx,oy+cy+ly);
    bbc_plot(176+5,ox+cx+x,oy+cy+y);

    setgcol((g<<24) | (b<<16) | (r<<8));
    bbc_move(ox+cx,oy+cy);
    bbc_move(ox+cx+x,oy+cy-y);
    bbc_plot(176+5,ox+cx+lx,oy+cy-ly);

    if(degrees<HUE60)
    {
     g=v;
     r=v-s;
     b=scale(s,(HUE60-degrees),(HUE60+degrees))+v-s;
    }
    else
    {
     g=v;
     b=v-s;
     r=scale(s,(degrees-HUE60),(HUE180-degrees))+v-s;
    }

    r=(r*255)/MAXCV;
    g=(g*255)/MAXCV;
    b=(b*255)/MAXCV;

    setgcol((b<<24) | (g<<16) | (r<<8));
    bbc_move(ox+cx,oy+cy);
    bbc_move(ox+cx-x,oy+cy+y);
    bbc_plot(176+5,ox+cx-lx,oy+cy+ly);

    setgcol((g<<24) | (b<<16) | (r<<8));
    bbc_move(ox+cx,oy+cy);
    bbc_move(ox+cx-lx,oy+cy-ly);
    bbc_plot(176+5,ox+cx-x,oy+cy-y);

    lx=x;
    ly=y;
   }
  }

  /* now do little cross */


  /* get hsv from rv,gv,bv */

  rgb[0]=rv;
  rgb[1]=gv;
  rgb[2]=bv;
  rgb2hsv((quadstr*)rgb,(quadstr*)hsv);
  h=hsv[0];
  s=hsv[1];
  v=hsv[2];

  if(mode==WUPDATE || mode==WNEWCROSS)
  {
   angle=(double)h*PI/((double)HUE180);

   rd=(s*rmax)/MAXCV;

   oldcx=x=(int)(cos(angle)*(double)rd);
   oldcy=y=(int)(sin(angle)*(double)rd);
  }
  else
  {
   x=oldcx;
   y=oldcy;
  }

  seteorcol(0,7);
  bbc_move(ox+cx+x-CROSSX,oy+cy+y);
  bbc_draw(ox+cx+x+CROSSX,oy+cy+y);
  bbc_move(ox+cx+x,oy+cy+y-CROSSY);
  bbc_draw(ox+cx+x,oy+cy+y+CROSSY);
 }
 return(err);
}



static os_error * wheelclick(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 windowstr  window;
 iconstr    icon;
 int        cx;
 int        cy;
 int        x;
 int        y;
 int        rmax;
 int        r;
 int        h;
 int        s;
 int        rgb[3];
 int        hsv[3];


          err=getw(handle,&window);
 if(!err) err=geti(handle,WHEEL,&icon);

 cx=(icon.ix0+icon.ix1)/2;
 cy=(icon.iy0+icon.iy1)/2;
 rmax=MIN(icon.ix1-icon.ix0,icon.iy1-icon.iy0)/2
                                      -2*MAX(cvdu.deltax,cvdu.deltay);
/* rmax=(rmax*vb)/1000; */

 x=m->x-window.bx-cx;
 y=m->y-window.by-cy;

 r=rootsum(x,y);
 if(r>rmax) r=rmax;

 if(r<=rmax)
 {
  if(x==0 && y==0) h=0;
  else             h=(int)((((double)HUE180)*atan2((double)y,(double)x))/PI);
  if(h<0) h+=HUE360;
  s=(MAXCV*r)/rmax;


  hsv[0]=h;
  hsv[1]=s;
  hsv[2]=vb;
  hsv2rgb((quadstr*)hsv,(quadstr*)rgb);



  rv=rgb[0];
  gv=rgb[1];
  bv=rgb[2];

//    cprintf("r=%d b=%d g=%d h=%d s=%d v=%d",rv,bv,gv,h,s,vb);

  newrgb(0,0);
 }
 return(err);
 userhandle=userhandle;
}



/* called when a value has changed */

static os_error * rgbupdatecross(void)
{
 wimp_redrawstr redrawstr;
 windowstr      window;
 iconstr        icon;
 int            more;

 /* get HSV values */


 if(1)
 {
  redrawstr.w=pbox.handle;

  getw(redrawstr.w,&window);
  geti(redrawstr.w,WHEEL,&icon);

  redrawstr.box.x0=icon.ix0;
  redrawstr.box.x1=icon.ix1;
  redrawstr.box.y0=icon.iy0;
  redrawstr.box.y1=icon.iy1;

  wimp_update_wind(&redrawstr,&more);

  while(more)
  {
   redwheel(&redrawstr,pbox.handle,WOLDCROSS);
   redwheel(&redrawstr,pbox.handle,WNEWCROSS);
   wimp_get_rectangle(&redrawstr,&more);
  }
 }
 return(NULL);
}




static os_error * startwheeldrag(int handle)
{
 os_error  * err;
 windowstr   window;
 iconstr     icon;

          err=getw(handle,&window);
 if(!err) err=geti(handle,WHEEL,&icon);

 if(!err) err=userdrag(handle,window.bx+icon.ix0,window.by+icon.iy0,
                                   window.bx+icon.ix1,window.by+icon.iy1);
 if(!err) err=startdrag2(handle,0,NULL,wheelclick);

 return(err);
}

/*****************************************************************************/









static os_error * predrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;
 int        pal;
 modelstr   colour;

 err=NULL;

 while(more)
 {
  if(palflags & PALTRANS) pal=-1;
  else                    pal=(((rv*255)/MAXCV)<<8)|(((gv*255)/MAXCV)<<16)|(((bv*255)/MAXCV)<<24);

  if(xgetpal)
  {
   palgetcolour(&colour);
   pal=xgetpal(palflags,&colour,pal);
  }

  redrawblock(redrawstr,handle,40,pal);

  if(pmode==PRGB)
  {
   redrawslider(redrawstr,52,handle,WIMPRED,  v0,MAXCV);
   redrawslider(redrawstr,20,handle,WIMPGREEN,v1,MAXCV);
   redrawslider(redrawstr,21,handle,WIMPDBLUE,v2,MAXCV);
   redrawslider(redrawstr,22,handle,WIMPGREY3,v3,MAXCV);
   redrawslider(redrawstr,11,handle,WIMPGREY3,vb,MAXCV); 
  }
  else
  if(pmode==PHSV)
  {
   redrawslider(redrawstr,52,handle,WIMPGREY3,v0,HUE360);
   redrawslider(redrawstr,20,handle,WIMPGREY3,v1,MAXCV);
   redrawslider(redrawstr,21,handle,WIMPGREY3,v2,MAXCV);
   redrawslider(redrawstr,22,handle,WIMPGREY3,v3,MAXCV);
   redrawslider(redrawstr,11,handle,WIMPGREY3,vb,MAXCV); 
  }
  else
  if(pmode==PCMYK)
  {
   redrawslider(redrawstr,52,handle,WIMPLBLUE, v0,MAXCV);
   redrawslider(redrawstr,20,handle,WIMPRED,   v1,MAXCV);
   redrawslider(redrawstr,21,handle,WIMPYELLOW,v2,MAXCV);
   redrawslider(redrawstr,22,handle,WIMPBLACK, v3,MAXCV);
   redrawslider(redrawstr,11,handle,WIMPGREY3, vb,MAXCV); 
  }


  err=redwheel(redrawstr,handle,WUPDATE);

  err=wimp_get_rectangle(redrawstr,&more);
 }
 return(err);
}


static os_error * predraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) err=predrawsub(handle,&redrawstr,more);
 return(err);
 USE(userhandle);
}





static os_error * picon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 int        buttons;

 err=NULL;

 buttons=m->bbits;


 switch(m->i)
 {

  case WHEEL:
             if(m->bbits==VBDRAGS) err=startwheeldrag(handle);
             else                  err=wheelclick(handle,userhandle,m);
             break;


 }

 return(err);
 USE(handle);
 USE(userhandle);
 USE(m);
}


static os_error * modpalevent(int eventn,int userhandle,void * data,int data1);


static os_error * pclose(int code)
{
 os_error * err;
 modelstr   colour;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  palgetcolour(&colour);
  if(xpalclose) err=xpalclose(&colour,palflags);
 }

 return(err);
}





static os_error * wrcol(int value,char * string)
{
 strcpy(string,numbertostringxdp(value,1,2));
 return(NULL);
}

static os_error * rdcol(int * value,char * string)
{
 os_error * err;
 err=stringtonumberxdpgelt100(string,value,1,2);
 return(err);
}




static os_error * wrv0(int value,char * string)
{
 if(pmode==PHSV)  strcpy(string,numbertostringxdp(value,1,0));
 else             wrcol(value,string);
 return(NULL);
}


static os_error * rdv0(int * value,char * string)
{
 os_error * err;
 if(pmode==PHSV) err=stringtonumberxdpge(string,value,1,0);
 else            err=rdcol(value,string);
 return(err);
}




// note the absolute position of icons is used by writedboxv0()

static dbiconstr picondefs[]=
{
 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,

    8, &pmode,       DBRADIO , 0,    0,     PRGB, F1, 1, 0,          NULL,NULL,
    7, &pmode,       DBRADIO , 0,    0,     PHSV, F2, 1, 0,          NULL,NULL,
    6, &pmode,       DBRADIO , 0,    0,     PCMYK,F3, 1, 0,          NULL,NULL,

    0, &pmode,       DBUPDATE, 0,   0,     -1, -1, -1, -1, (dbreadfn)mfn,NULL,

 /* N   &V           Type     Grp   Flags    R   L   D   U    In  Out */



    3, &v0,          DBINC   ,0,    0,(MAXCV/100),-1, MAXCV,  0,  NULL,   0,
    5, &v0,          DBDEC   ,0,    0,(MAXCV/100),-1, MAXCV,  0,  NULL,   0,
   51, &v0,          DBWRITE, 0,    DBASSOCINC,       -1,  -1, 13, 33, rdv0,   wrv0,
   52, &v0,          DBSLIDER,0,    0,       1,   -1, MAXCV,  0,  NULL,   0,
WHEEL, &v0,          DBUPDATE,0,    0,     -1, -1, -1, -1, (dbreadfn)vfn,NULL,


   14, &v1,          DBINC   ,0,    0,(MAXCV/100),-1, MAXCV,  0,  NULL,   0,
   17, &v1,          DBDEC   ,0,    0,(MAXCV/100),-1, MAXCV,  0,  NULL,   0,
   13, &v1,          DBWRITE, 0,    DBASSOCINC,       -1,  -1, 23,   1, rdcol,   wrcol,
   20, &v1,          DBSLIDER,0,    0,       1,   -1, MAXCV,  0,  NULL,   0,
WHEEL, &v1,          DBUPDATE,0,    0,     -1, -1, -1, -1, (dbreadfn)vfn,NULL,


   15, &v2,          DBINC   ,1,    0,(MAXCV/100),-1, MAXCV,  0,  NULL,   0,
   18, &v2,          DBDEC   ,1,    0,(MAXCV/100),-1, MAXCV,  0,  NULL,   0,
   23, &v2,          DBWRITE, 1,    DBASSOCINC,       -1,  -1, 24,  13, rdcol,   wrcol,
   21, &v2,          DBSLIDER,1,    0,       1,   -1, MAXCV,  0,  NULL,   0,
WHEEL, &v2,          DBUPDATE,0,    0,     -1, -1, -1, -1, (dbreadfn)vfn,NULL,


   16, &v3,          DBINC   ,2,    0,(MAXCV/100),-1, MAXCV,  0,  NULL,   0,
   19, &v3,          DBDEC   ,2,    0,(MAXCV/100),-1, MAXCV,  0,  NULL,   0,
   24, &v3,          DBWRITE, 2,    DBASSOCINC,       -1,  -1, 30,  23, rdcol,   wrcol, 
   22, &v3,          DBSLIDER,2,    0,       1,   -1, MAXCV,  0,  NULL,   0,
WHEEL, &v3,          DBUPDATE,0,    0,     -1, -1, -1, -1, (dbreadfn)vfn,NULL,


   29, &vb,          DBINC   ,0,    0,(MAXCV/100),  -1, MAXCV,  0,  NULL,   0,
   28, &vb,          DBDEC   ,0,    0,(MAXCV/100),  -1, MAXCV,  0,  NULL,   0,
   30, &vb,          DBWRITE, 0,    DBASSOCINC,       -1,  -1, -1,  24, rdcol,   wrcol,
   11, &vb,          DBSLIDER,0,    0,       1,   -1, MAXCV,  0,  NULL,   0,
WHEEL, &vb,          DBUPDATE,0,    0,     -1, -1, -1, -1, (dbreadfn)bfn,NULL,

   32, &palflags,    DBTOGGLE, 0,    0,     1,  F4,0,0,       (dbreadfn)vfn,  0,


   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};





static void writedboxv0(void)
{
 if(pmode==PHSV)
 {
  picondefs[6].data.stepbutton.max=HUE360;
  picondefs[6].data.stepbutton.step=HUE360/360;
  picondefs[7].data.stepbutton.max=HUE360;
  picondefs[7].data.stepbutton.step=HUE360/360;
  picondefs[9].data.slider.max=HUE360;
 }
 else
 {
  picondefs[6].data.stepbutton.max=MAXCV;
  picondefs[6].data.stepbutton.step=MAXCV/100;
  picondefs[7].data.stepbutton.max=MAXCV;
  picondefs[7].data.stepbutton.step=MAXCV/100;
  picondefs[9].data.slider.max=MAXCV;
 }
}



static dboxstr pbox=
{
 0,
 TPAL,
 DBFIX,
 DBUPDATECARET,
 pclose,
 picon,
 NULL,
 predraw,
 picondefs,
 0,
 0,

 0,
 NULL,
 NULL,
 0,

};





os_error * openpal(palclosefn palclose,palgetpalfn getpal,palsetpalfn setpal,int flags,modelstr * colour,dboxstr * parent)
{
 os_error * err;


 xpalclose=palclose;
 xgetpal=getpal;
 xsetpal=setpal;
 palflags=flags;

 initvalues(colour);

 err=dodboxsp(&pbox,1,parent,&dbviewstack);
 if(!err) 
 {
  writenames();
  dbshade(1,pmode==PHSV,&pbox);
  dbshade(2,pmode==PHSV || pmode==PRGB,&pbox);
 }

 return(err);
}


