/*->c.dslex  */



#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>
#include <locale.h>


#include "os.h"
#include "wimp.h"
#include "bbc.h"
#include "flex.h"
#include "transform.h"

#include "alloc.h"
#include "err.h"
#include "bf.h"
#include "etc.h"
#include "xext.h"

#include "dsint.h"




/*****************************************************************************/
/* lex analyser - read through file and feed back tokens */

#define LEXBUFFSIZE 0x8000

char * dstokstart;
static char * tokend;
static char * buffend;


static char * buff;

static buffer lexbf;

static int    lexeof;

int    dslexn;

int    dstoken;

static int    savedchar;
static int    savech;

static int    dslexline;

static char * lexfile;






/* fill up lex buffer */
/* copy stuff from dstokstart to buffend down to buff */
/* fill buffer */

static os_error * lexfill(void)
{
 os_error * err;
 int n;
 int m;

 m=dstokstart-buff;
 tokend-=m;

 n=buffend-dstokstart;
 memmove(buff,dstokstart,n);
 dstokstart=buff;
 buffend=buff+n;

 m=LEXBUFFSIZE-n;

 err=bf_readn(&lexbf,buff+n,m,&n);
 buffend+=n;
 lexeof=n<m;

 return(err);
}





static int skipspace(void)
{
 int ch;

 while(1)
 {
  if(dstokstart>=buffend)
  {
   if(lexeof) return(DSEOF);
   else       lexfill();
  }

  ch=*dstokstart;
  if(ch=='\n') dslexline++;
  if(!isspace(ch)) return(ch);
  dstokstart++;
 }
}




static int getstring(void)
{
 int    ch;
 char * w;
 int    state;
 int    offset;
 int    sum=0;


 w=tokend=++dstokstart;
 state=0;

 while(1)
 {
  if(tokend>=buffend)                 /* skip first " */
  {
   offset=w-dstokstart;
   if(lexeof) return(DSEOF);
   else       lexfill();
   w=dstokstart+offset;
  }

  ch=*tokend++;

  if(state==0)
  {
   if(ch=='"')
   {
    *w=0;
    return(DSSTRING);
   }
   else
   if(ch=='\\') state=1;
   else
   if(ch>=' ')  *w++=(char)ch;
  }
  else
  if(state==1)
  {
   if(ch=='a') ch='\a';
   else
   if(ch=='b') ch='\b';
   else
   if(ch=='n') ch='\n';
   else
   if(ch=='r') ch='\r';
   else
   if(ch=='t') ch='\t';
   else
   if(ch=='f') ch='\f';
   else
   if(ch=='v') ch='\v';
			else
			if(ch<' ')
   {
				state=0;
    continue;    /* !!!!!!!!! */
			}
			else
   if(ch=='x') // hex x + xn + xn
   {
    state=2;
    sum=0;
   }
   else
   if(ch>='0' && ch<'8')	// octal
   {
    sum=ch-'0';
    state=4;
   }

   if(state==1)
   {
    if(ch>=' ') *w++=(char)ch;
    state=0;
   }
  }
  else
  if(state==2 || state==3) // hex
  {
   ch=toupper(ch);
   if(ch>='0' && ch<='9') sum=(sum<<4)+ch-'0';
   else
   if(ch>='A' && ch<='F') sum=(sum<<4)+ch-'A'+10;
   else
   {
    *w++=(char)sum;
    tokend--;    // put back
    state=0;
   }

   if(state==2) state=3;
   else
   if(state==3)
   {
    *w++=(char)sum;
    state=0;
   }
  }
  else
  if(state==4 || state==5) // oct
  {
   if(ch>='0' && ch<'8')
   {
    sum=(sum<<3)|(ch-'0');
    if(state==5)
    {
     *w++=(char)sum;
     state=0;
    }
    else
    {
     state=5;
    }
   }
   else
   {
    *w++=(char)sum;
    tokend--;    // put back
    state=0;
   }
		}
 }
}







static int getid(void)
{
 int ch;

 tokend=dstokstart;

 while(1)
 {
  if(++tokend>=buffend)         
  {
   if(lexeof) return(DSEOF);
   else       lexfill();
  }

  ch=*tokend;

  if(!isalnum(ch) && ch!='_')
  {
   savech=ch;
   savedchar=1;
   *tokend=0;
   return(DSID);
  }
 }
}




static int getnumber(void)
{
 int ch;
 int state;

 tokend=dstokstart;
 dslexn=0;
 state=0;

 while(1)
 {
  ch=*tokend;

  if(state==0 && ch=='0')
  {
   state=1;
  }
  else
  if(state==2 || state==0) /* accumulating Dec. */
  {
   state=2;
   if(!isdigit(ch)) return(DSNUMBER);
   else             dslexn=dslexn*10+ch-'0';
  }
  else
  if(state==4 || state==1) /* accumulating oct */
  {
   if(ch>='0' && ch<='8') 
   {
    state=4;
    dslexn=(dslexn<<3)+ch-'0';
   }
   else 
   if((ch=='x' || ch=='X') && state==1) state=5;
   else                                 return(DSNUMBER);
  }
  else
  if(state==5) /* accumulating hex */
  {
   ch=toupper(ch);
   if(ch>='0' && ch<='9') dslexn=(dslexn<<4)+ch-'0';
   else
   if(ch>='A' && ch<='F') dslexn=(dslexn<<4)+ch-'A'+10;
   else                   return(DSNUMBER);
  }

  if(++tokend>=buffend)     
  {
   if(lexeof) return(DSEOF);
   else       lexfill();
  }
 }
}



/* looking for 'x' things */

static int chconst(void)
{
 int val=0; /* compiler */
 int ch;
 int state=0;

 while(1)
 {
  if(tokend>=buffend)  
  {
   if(lexeof) return(DSEOF);
   else       lexfill();
  }

  ch=*tokend++;

  if(state==0)
  {
   if(ch=='\\') state=2;
   else
   {
    val=ch;
    state=1;
   }
  }
  else
  if(state==1)
  {
   if(ch=='\'') break;
  }
  else
  if(state==2)
  {
   if(ch=='n') val='\n';
   else
   if(ch=='r') val='\r';
   else
   if(ch=='t') val='\t';
   else
   if(ch=='f') val='\f';
   else
   if(ch=='v') val='\v';
   else
               val=ch;
   state=1;
  }
 }

 dslexn=val;
 return(DSNUMBER);
}





static int getsmlcomment(void)
{
 int ch;

 while(1)
 {
  if(tokend>=buffend)        
  {
   if(lexeof) return(DSEOF);
   else       lexfill();
  }
  ch=*tokend++;
  if(ch=='\n' || ch=='\r')
  {
   if(ch=='\n') dslexline++;
   break;
  }
 }
 return(DSCOMMENT);
}






/* pull out tokens like '==' */

static int atom(int ch)
{
 int   ch2;

 tokend=dstokstart+1;

 if(ch=='\'') return(chconst());

 if(tokend>=buffend)     
 {
  if(lexeof) return(ch);
  else       lexfill();
 }

 ch2=*tokend;

 if(ch=='/' && ch2=='/') return(getsmlcomment());
 else                    return(ch);
}




/* return the next token */

static int nexttokensub(void)
{
 int ch;

 while(1)
 {
  dstokstart=tokend;
  if(savedchar)                                                                   {
   *tokend=(char)savech;
   savedchar=0;
  }

  switch(ch=skipspace())
  {
   case  DSEOF:
              return(DSEOF);
              break;

   case   '"':
              return(getstring());
              break;
    
      default:
              if(isdigit(ch))
                return(getnumber());
              else
              if(ch=='-')   /* !!!! fail to report lex error here */
              {
               tokend=dstokstart;

               if(++tokend>=buffend)     
               {
                if(lexeof) return(DSEOF);
                else        lexfill();
               }

               if((ch=nexttokensub())==DSNUMBER) dslexn=-dslexn;

               return(ch);
              }
              else
              if(isalpha(ch))
                return(getid());
              else
                if((ch=atom(ch))!=DSCOMMENT) return(ch);
              break;
  }
 }

 return(0);
}


os_error * dsgettoken(void)
{
 dstoken=nexttokensub();
 return(NULL);
}



os_error * dslexerror(int errno)
{
 return(geterrorf(errno,dslexline));
}


os_error * dslexend(int mode)
{
 os_error * err;
 err=flex_free((flex_ptr)&buff);
 if(mode==0) err=bf_close(&lexbf,err);
 return(err);
}


static os_error * dslock(int handle,int by)
{
 dstokstart+=by;
 tokend+=by;
 buffend+=by;

 return(NULL);
 USE(handle);
}



os_error * dslexstart(char * filename,int mode)
{
 os_error * err;
 int        len;


 err=NULL;


 if(mode==0)
 {
  err=bf_open(filename,'r',BUFFMINSIZE,&lexbf);
  lexfile=filename;
  if(!err)
  {
   if(!buff) err=flex_alloc((flex_ptr)&buff,LEXBUFFSIZE+1+3);
   else      err=flex_extend((flex_ptr)&buff,LEXBUFFSIZE+1+3);

   if(!err)
   {
    flex_setlock((flex_ptr)&buff,dslock,0);

    buffend=buff;
    dstokstart=tokend=buffend;
    lexeof=0;
    err=lexfill();

    if(err) flex_free((flex_ptr)&buff);
   }

   if(err) err=bf_close(&lexbf,err);
  }
 }
 else
 if(mode==1)
 {
  lexfile="script";

  len=stringlen(stack[(int)filename]);

  if(!buff) err=flex_alloc((flex_ptr)&buff,len+1+3);
  else      err=flex_extend((flex_ptr)&buff,len+1+3);

  if(!err)
  {
   flex_setlock((flex_ptr)&buff,dslock,0);

   strcpy(buff,stringptr(stack[(int)filename]));

   dstokstart=tokend=buff;
   buffend=buff+len;
   lexeof=1;
  }
 }

 dslexline=1;
 savedchar=0;


 return(err);
}


