/*->c.oplock */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "transform.h"
#include "etc.h"

#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "redraw.h"
#include "trans.h"
#include "fsx.h"
#include "bf.h"
#include "crc.h"
#include "bits.h"



#ifdef PRODLOCK


#define APPINSTALL


#include "$.Q.Install.h.lock"


#include "oplock.h"



/*****************************************************************************/


static int lockhandle;


static wimp_wind splashwind=
{
  0,-432,600,0, /* wimp_box box screen coords of work area */
  0,0,          /* scx,scy            scroll bar positions */
  -1,            /* wimp_w behind handle to open window behind, or -1 if top */

                 /* wimp_wflags flags word of flag bits defined above */

  wimp_WMOVEABLE |
  wimp_REDRAW_OK |
  wimp_WTOP      |
  wimp_WFULL     |
  wimp_WTITLE    |
  wimp_WNEW,   

                 /* 8 colours: index using wimp_wcolours. */
  7,
  2,
  7,
  1,
  3,
  1,
  2,
  7,

  0,-432,600,0,  /* maximum extent of work area */

  /* wimp_iconflags titleflags icon flags for title bar */

  wimp_ITEXT      |
  wimp_IBORDER    |
  wimp_IHCENTRE   |
  wimp_IVCENTRE   |
  wimp_IFILLED    |
  wimp_IFORECOL*2 |
  wimp_IBACKCOL*3,

  0,                      /* just button type relevant */
  0,                      /* 0->use the common sprite area */
  0,                      /* two 16-bit OS-unit fields, (width/height)
                             giving min size of window. 0->use title. */
  "Ovation Pro",          /* title icon data */
  0,                      /* no. of icons in window */

};


#define CSH2 55


static char lockname[]=
{
 '<'+CSH2,
 'O'+CSH2,
 'v'+CSH2,
 'a'+CSH2,
 't'+CSH2,
 'i'+CSH2,
 'o'+CSH2,
 'n'+CSH2,
 'P'+CSH2,
 'r'+CSH2,
 'o'+CSH2,
 '$'+CSH2,
 'D'+CSH2,
 'i'+CSH2,
 'r'+CSH2,
 '>'+CSH2,
 '.'+CSH2,
 'R'+CSH2,
 'e'+CSH2,
 'g'+CSH2,
 'D'+CSH2,
 'a'+CSH2,
 't'+CSH2,
 'a'+CSH2,
 '\0'

};



static char sitetext[]=
{
 '('+CSH2,
 's'+CSH2,
 'i'+CSH2,
 't'+CSH2,
 'e'+CSH2,
 ' '+CSH2,
 'l'+CSH2,
 'i'+CSH2,
 'c'+CSH2,
 'e'+CSH2,
 'n'+CSH2,
 'c'+CSH2,
 'e'+CSH2,
 ')'+CSH2,
 '\0'
};




static char susertext[]=
{
 '('+CSH2,
 's'+CSH2,
 'i'+CSH2,
 'n'+CSH2,
 'g'+CSH2,
 'l'+CSH2,
 'e'+CSH2,
 ' '+CSH2,
 'u'+CSH2,
 's'+CSH2,
 'e'+CSH2,
 'r'+CSH2,
 ')'+CSH2,
 '\0'
};







static wimp_icreate iblock=
{
 0,            /* window handle */
 10,0,590,0,  /* bounding box  */

 wimp_ITEXT      |
 wimp_IBORDER    |
 wimp_IHCENTRE   |
 wimp_IVCENTRE   |
 wimp_IFILLED    |
 wimp_IFORECOL*7 |
 wimp_IBACKCOL*1 |
 wimp_INDIRECT,

 "",

};



static char       serialdata[SNOSIZE];
static char       regdata[REGNMAX][REGSTRINGLEN];


static void lockzero(int user)
{
 wimp_close_wind(lockhandle);
 wimp_delete_wind(lockhandle);
 USE(user);
}



static os_error * lockredrawsub(wimp_redrawstr * redrawstr,int more)
{
 os_error * err;

 err=NULL;

 while(more)
 {
  err=wimp_get_rectangle(redrawstr,&more);
 }

 return(err);
}



static os_error * lockredraw(void)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;

 redrawstr.w=lockhandle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) err=lockredrawsub(&redrawstr,more);

 return(err);
}


static void decrypttext(char * string)
{
 int i;

 for(i=0;i<strlen(string);i++)
 {
  string[i]-=CSH2;
 }
}

static void encrypttext(char * string)
{
 int i;

 for(i=0;i<strlen(string);i++)
 {
  string[i]+=CSH2;
 }
}







os_error * checklock(void)
{
 os_error * err;
 int        i;
 int        icon;
 char     * regdatap[REGNMAX];
 char       temp[REGSTRINGLEN];
 int        len;

 return(NULL);

 for(i=0;i<REGNMAX;i++)
 {
  regdatap[i]=&regdata[i][0];
 }

 decrypttext(lockname);

          err=lockinit();
 if(!err) err=loadlockfile(lockname,regdatap,temp);

 if(!err)
 {
  len=strlen(temp);

  if(len && temp[len-1]=='S')
  {
   temp[len-1]=0;
   decrypttext(sitetext);
   sprintf(serialdata,"%s %s",temp,sitetext);
   encrypttext(sitetext);
  }
  else
  {
   decrypttext(susertext);
   sprintf(serialdata,"%s %s",temp,susertext);
   encrypttext(susertext);
  }

  err=wimp_create_wind(&splashwind,&lockhandle);

  for(i=0;i<(REGNMAX-1);i++)
  {
   iblock.w=lockhandle;
   iblock.i.box.y0=-(20+48+i*56);
   iblock.i.box.y1=-(20+i*56);
   iblock.i.data.indirecttext.buffer=(i==(REGNMAX-2))?serialdata:regdatap[i];
   iblock.i.data.indirecttext.validstring="R2";
   iblock.i.data.indirecttext.bufflen=REGSTRINGLEN;

   err=wimp_create_icon(&iblock,&icon);
   if(err) break;
  }

  if(!err) err=popup(lockhandle,0);
  if(!err) err=lockredraw();
  if(!err) err=addscheduledevent(lockzero,0,250);
 }


 encrypttext(lockname);

 lockfinit();

 return(err);
}



#endif



