/*->c.swind */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <ctype.h>


#include "os.h"
#include "flex.h"
#include "wimp.h"
#include "werr.h"
#include "transform.h"

#include "err.h"
#include "alloc.h"
#include "xext.h"
#include "wos.h"
#include "poll.h"
#include "key.h"
#include "etc.h"
#include "fsx.h"
#include "bits.h"
#include "avl.h"
#include "temp.h"
#include "sp.h"
#include "dbhi.h"
//#include "txcb.h"
#include "deb.h"



#include "constants.h"
#include "str.h"

#include "mhi.h"


#include "swind.h"




#define MAXEVENT 8

/*
event 0     void clickfn(int handle,int icon,int bbits,int mx,int my);
event 1     int  keyfn(int handle,int icon,int key);
event 2     void closefn(int handle);
event 3     void openfn(int handle,int x0,int x1,int y0,int y1,
                                               int scx,int scy,int bhandle);
event 4     void redrawfn(int handle,int x0,int x1,int y0,int y1,
                                     int scx,int scy,
                                     int x0,int x1,int y0,int y1);

event 5     void openfn(int handle,int x0,int x1,int y0,int y1,
                                               int scx,int scy,int bhandle);

event 6     void deletefn(int handle);

event 7     void parentclosefn(int handle);

*/


#define SWCLICK      0
#define SWKEY        1
#define SWCLOSE      2
#define SWOPEN       3
#define SWREDRAW     4
#define SWPOSTOPEN   5
#define SWDELETE     6
#define SWPCLOSE     7


typedef struct iconmemstr
{
 struct iconmemstr * next;
 int                 icon;
 char                stuff[1];
} iconmemstr;



typedef struct swindstr
{
 int          handle;
 int          parent;
 int          len;
 int          tempno;
 iconmemstr * first;

 char         fns[1];

} swindstr;



static swindstr * swindbase;
static int        swindlen;



static swindstr * findsw(int handle)
{
 swindstr * sw;
 swindstr * limit;

 sw=swindbase;
 limit=(swindstr*)(((char*)swindbase)+swindlen);

//		cprintf("swindlen %d",swindlen);

 while(sw<limit)
 {
//		cprintf("handle %x sw-> %x",handle,sw->handle);
  if(sw->handle==handle) return(sw);
  sw=(swindstr*)(((char*)sw)+sw->len);
 }

 return(NULL);
}




static char * nthfn(char * base,int n)
{
 while(n--) base+=strlen(base)+1;
 return(base);
}




/* event 4     void redrawfn(int handle,int x0,int x1,int y0,int y1,
                                     int scx,int scy,
                                     int x0,int x1,int y0,int y1); */



static os_error * sredraws(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error     * err;
 swindstr     * sw;
 char         * p;
 int            result;


 err=NULL;
 
 while(!err && more)
 {
  sw=findsw(handle);
  if(sw)
  {
   p=nthfn(sw->fns,SWREDRAW);
   if(*p)
   {
    xexec(p,&result,"IIIIIIIIIII",handle,
                                  redrawstr->box.x0,
                                  redrawstr->box.x1,
                                  redrawstr->box.y0,
                                  redrawstr->box.y1,
                                  redrawstr->scx,
                                  redrawstr->scy,
                                  redrawstr->g.x0,
                                  redrawstr->g.x1,
                                  redrawstr->g.y0,
                                  redrawstr->g.y1);

   }
  }
  err=wimp_get_rectangle(redrawstr,&more);
 }

 return(err);
}



static os_error * sredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;

 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) err=sredraws(handle,&redrawstr,more);
 return(err);

 USE(userhandle);
}




/* event 5     void openfn(int handle,int x0,int y0,int x1,int y1,
                                           int scx,int scy,int bhandle); */

static os_error * swopen5(int handle,int userhandle,wimp_openstr * o)
{
 swindstr * sw;
 char     * p;
 int        result;

// zreport(wimp_open_wind(o));  
// this is a change from RISC OS, there the open call is after the script stuff

 sw=findsw(handle);
 if(sw)
 {
  p=nthfn(sw->fns,SWPOSTOPEN);
  if(*p)
  {
   return(xexec(p,&result,"IIIIIIII",handle,o->box.x0,o->box.y0,
                                            o->box.x1,o->box.y1,
                                            o->x,o->y,o->behind));
  }
 }

 return(NULL);

 USE(userhandle);
}




/* event 3     void openfn(int handle,int x0,int y0,int x1,int y1,
                                           int scx,int scy,int bhandle); */


// this is an open by the script it comes before the OS has opened the window

static os_error * swopen3(int handle,int userhandle,wimp_openstr * o)
{
 swindstr * sw;
 char     * p;
 int        result;

 sw=findsw(handle);
 if(sw)
 {
  p=nthfn(sw->fns,SWOPEN);
  if(*p)
  {
   return(xexec(p,&result,"IIIIIIII",handle,o->box.x0,o->box.y0,
                                            o->box.x1,o->box.y1,
                                            o->x,o->y,o->behind));
  }
 }

 zreport(wimp_open_wind(o));

 return(NULL);

 USE(userhandle);
}



/* event 2     void closefn(int handle); */

static os_error * swclose(int handle,int userhandle)
{
 swindstr * sw;
 char     * p;
 int        result;

// cprintf("swclose");

 sw=findsw(handle);
 if(sw)
 {
  p=nthfn(sw->fns,SWCLOSE);
  if(*p)
  {
   return(xexec(p,&result,"I",handle));
  }
 }

 return(wimp_close_wind(handle));

 USE(userhandle);
}



/* event 2     void closefn(int handle); */

static os_error * swpclose(int handle,int userhandle)
{
 swindstr * sw;
 char     * p;
 int        result;

// cprintf("swclose");

 sw=findsw(handle);
 if(sw)
 {
  p=nthfn(sw->fns,SWPCLOSE);
  if(*p)
  {
   return(xexec(p,&result,"I",handle));
  }
 }

 return(NULL);

 USE(userhandle);
}





static os_error * deleteswind(int handle);

/* event 6     void deletefn(int handle); */

static os_error * swdelete(int handle,int userhandle)
{
 swindstr * sw;
 char     * p;
 int        result;

// cprintf("swdelete");

 sw=findsw(handle);
 if(sw)
 {
  p=nthfn(sw->fns,SWDELETE);
  if(*p)
  {
   return(xexec(p,&result,"I",handle));
  }
 }

 return(deleteswind(handle));

 USE(userhandle);
}








/* event 0     void clickfn(int handle,int icon,int bbits,int mx,int my); */

static os_error * swclick(int handle,int userhandle,wimp_mousestr * m)
{
 swindstr * sw;
 char     * p;
 int        result;

//	cprintf("swclick handle %x m->w %x bbits %x icon %d",handle,m->w,m->bbits,m->i);

 sw=findsw(handle);
 if(sw)
 {


  p=nthfn(sw->fns,SWCLICK);
//		cprintf("swclick2 %s",p);

  if(*p)
  {
   xexec(p,&result,"IIIII",m->w,m->i,m->bbits,m->x,m->y);
  }
 }

 return(NULL);

 USE(userhandle);
}



/* event 1     int  keyfn(int handle,int icon,int key); */

static os_error * swkey(int handle,int userhandle,int icon,int * key)
{
 swindstr * sw;
 char     * p;
 int        result;

// cprintf("swkey %x",*key);

 sw=findsw(handle);
 if(sw)
 {
// cprintf("swfind");
  
  p=nthfn(sw->fns,SWKEY);
  if(*p)
  {
//   cprintf("icon %d key %d",icon,*key);
   xexec(p,&result,"III/R",handle,icon,*key,key);
  }
 }

// txcbkey(key,handle,icon);

 return(NULL);

 USE(userhandle);
}






static os_error * createswind(int handle,int parent,int tempno)
{
 os_error * err;
 int        len;
 swindstr * sw;
 int        size;

 size=sizeof(swindstr)+MAXEVENT;
 size=(size+0x3)&(~0x3);

 len=swindlen+size;


 if(swindbase) err=flex_extend((flex_ptr)&swindbase,len);
 else          err=flex_alloc((flex_ptr)&swindbase,len);

//	cprintf("createswind %x",handle);

 if(!err)
 {
  sw=(swindstr*)(((char*)swindbase)+swindlen);
  sw->handle=handle;
  sw->parent=parent;
  sw->tempno=tempno;
  sw->len=size;
  sw->first=NULL;
  memset(&sw->fns[0],0,MAXEVENT);
  swindlen+=size;

  addopenevent(swopen5,handle,0);
  addcloseevent(swclose,handle,0);
  addparentcloseevent(swpclose,handle,0);
  adddeleteevent(swdelete,handle,0);
//		cprintf("add click %x",handle);
  addclickevent(swclick,handle,0);
  addkeyevent(swkey,handle,0);
  addhelpevent(NULL,handle,tempno);
  addredrawevent(sredraw,handle,0);
 }


 return(err);
}





static os_error * deleteswind(int handle)
{
 os_error   * err;
 swindstr   * sw;
 int          tempno;
 iconmemstr * iconp;
 iconmemstr * last;
	int          length;

 err=NULL;

 sw=findsw(handle);
 if(sw)
 {
  tempno=sw->tempno;

  iconp=sw->first;
  while(iconp)
  {
   last=iconp;
   iconp=last->next;
   sfree((flex_ptr)&last);
  }
  
		sw=findsw(handle);
		length=sw->len;
  err=flex_midextend((flex_ptr)&swindbase,((char*)sw-(char*)swindbase)+length,-length);
  swindlen-=length;

  remopenevent(swopen5,handle,0);
  remcloseevent(swclose,handle,0);
  remparentcloseevent(swpclose,handle,0);
  remdeleteevent(swdelete,handle,0);
  remclickevent(swclick,handle,0);
  remkeyevent(swkey,handle,0);
  remhelpevent(NULL,handle,tempno);
  remredrawevent(sredraw,handle,0);
 }

 return(err);
}






static os_error * insertfnname(int handle,int event,char * name)
{
 os_error * err;
 swindstr * sw;
 int        size;
 int        delta;
 int        len;
 char     * p;
 char     * q;
 char     * r;
 int        i;
 int        roffset;
 int        poffset;
 int        qoffset;
 int        swoffset;

 err=NULL;

//	cprintf("insert fn name %s handle %x",name,handle);

 sw=findsw(handle);
 if(sw)
 {
  p=q=sw->fns;
  for(i=0;i<MAXEVENT;i++)
  {
   if(i==event) p=q;
   q+=strlen(q)+1;
  }

  size=strlen(name);
  size-=strlen(p);

  len=q-sw->fns;
  len+=size;

  len=(len+sizeof(swindstr)+0x3)&(~0x3);

  delta=len-sw->len;

  r=p+strlen(p)+1;

  if(size<0)
  {
   strcpy(p,name);
   p+=strlen(p)+1;
   memmove(p,r,q-r);
  }

  roffset=r-(char*)swindbase;
  poffset=p-(char*)swindbase;
  qoffset=q-(char*)swindbase;
  swoffset=((char*)sw)-((char*)swindbase);


  err=flex_midextend((flex_ptr)&swindbase,q-(char*)swindbase,delta);
  if(!err)
  {
   sw=(swindstr*)(((char*)swindbase)+swoffset);
   r=((char*)swindbase)+roffset;
   p=((char*)swindbase)+poffset;
   q=((char*)swindbase)+qoffset;

   sw->len+=delta;
   swindlen+=delta;

   if(size>=0)
   {
    memmove(r+size,r,q-r);
    strcpy(p,name);
   }

  }
 }


 return(err);
}






/*

void addwindowhandler(int event,int handle,string & fnname);

event 0     void clickfn(int handle,int icon,int bbits,int mx,int my);
event 1     int  keyfn(int handle,int icon,int key);
event 2     void closefn(int handle);
event 3     void openfn(int handle,int x0,int x1,int y0,int y1,
                                               int scx,int scy,int bhandle);
event 4     void redrawfn(int handle,int x0,int x1,int y0,int y1,
                                     int scx,int scy,
                                     int x0,int x1,int y0,int y1);

event 5     void openfn(int handle,int x0,int x1,int y0,int y1,
                                               int scx,int scy,int bhandle);

event 6     void deletefn(int handle);


*/




void addwindowhandler(int fp)
{
 int   event;
 int   handle;
 char  name[128];

 event=stack[fp];
 handle=stack[fp+1];
 strcpy(name,stringptr(stack[fp+2]));

 zreport(insertfnname(handle,event,name));
}




/* int create_window(string & name); */

int create_window(int fp)
{
 os_error * err;
 int        handle;
 int        tempno;

 handle=0;

 findtempname(&tempno,stringptr(stack[fp]));
// cprintf("findtempname %s %d",stringptr(stack[fp]),tempno);

 if(tempno)
 {
  err=createwindow(tempno,&handle);
  if(!err)
  {
   err=createswind(handle,0,tempno);
  }

  zreport(err);
 }

 return(handle);
}




/* int create_windowparent(string & name,int parent); */

int create_windowparent(int fp)
{
 os_error * err;
 int        handle;
 int        tempno;

 handle=0;

 findtempname(&tempno,stringptr(stack[fp]));
// cprintf("findtempname %s %d",stringptr(stack[fp]),tempno);

 if(tempno)
 {
  err=createwindowparent(tempno,&handle,stack[fp+1]);
  if(!err)
  {
   err=createswind(handle,stack[fp+1],tempno);
  }

  zreport(err);
 }

 return(handle);
}





/* void delete_window(int handle); */

void delete_window(int fp)
{
 int handle;

 handle=stack[fp];
 if(handle)
 {
  wimp_delete_wind(handle);
  zreport(deleteswind(handle));
 }
}



/* void display_window(int handle,int diddle,int bits); */

void display_window(int fp)
{
 int         handle;
 int         bits;
 wimp_wstate wst;
 int         behind;

 handle=stack[fp];
 bits=stack[fp+2];

 if(handle)
 {
  wimp_get_wind_state(handle,&wst);

  if(bits & 0x1) centerwindow2(&wst,stack[fp+1]);

//  cprintf("center x %d y %d",wst.o.box.x0,wst.o.box.y1);
  
  behind=(bits>>1) & 0x7;
  if(behind==1) behind=-1;
  else
  if(behind==0) behind=-3;
  else
  if(behind==2) behind=-2;
  else
  if(behind==3) behind=-4;
  else
  if(behind==4) behind=-5;
  

  wst.o.behind=behind;

  zreport(swopen3(handle,0,&wst.o));
 }
}





/* void open_window(int handle,int x0,int x1,int y0,int y1,
                                              int scx,int scy,int bhandle); */

void open_window(int fp)
{
// cprintf("bhandle %d",stack[fp+7]);

 
 zreport(open(stack[fp+0],
              stack[fp+1],
              stack[fp+2],
              stack[fp+3],
              stack[fp+4],
              stack[fp+5],
              stack[fp+6],
              stack[fp+7]));
}




/* void close_window(int handle); */

void close_window(int fp)
{
 zreport(wimp_close_wind(stack[fp]));
}



/* void writetitle(int handle,string & s); */


void swritetitle(int fp)
{
 zreport(writetitle(stack[fp],stringptr(stack[fp+1])));
}



/* int getcaretposition(int info) */

int sgetcaretposition(int fp)
{
 int chandle;
 int cicon;

 findcaret(&chandle,&cicon);

 if(stack[fp]) return(cicon);
 else          return(chandle);
}




/* void writeicon(int handle,int icon,string & s); */


void swriteicon(int fp)
{
 zreport(writeicon(stack[fp],stack[fp+1],stringptr(stack[fp+2])));
}



/* string readicon(int handle,int icon); */


int sreadicon(int fp)
{
 char * p;
 iconaddr(stack[fp],stack[fp+1],&p);
 return(createstring(p));
}



/* int create_menuwindow(int handle,int menuhandle); */


int create_menuwindow(int fp)
{
 return(create_dbox(stack[fp],stack[fp+1]));
}


/* void delete_menuwindow(int menuhandle); */

void  delete_menuwindow(int fp)
{
 delete_dbox(stack[fp]);
}


/* void extent_window(int handle,int x0,int y0,int x1,int y1) */

void extent_window(int fp)
{
 zreport(extent(stack[fp],stack[fp+1],stack[fp+2],stack[fp+3],stack[fp+4]));
}



/* void refresh_area(int update,int handle,int x0,int y0,int x1,int y1); */

void refresh_area(int fp)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;

 redrawstr.w=stack[fp+1];
 redrawstr.box.x0=stack[fp+2];
 redrawstr.box.y0=stack[fp+3];
 redrawstr.box.x1=stack[fp+4];
 redrawstr.box.y1=stack[fp+5];

 if(stack[fp])
 {
  err=wimp_update_wind(&redrawstr,&more);
  if(!err) err=sredraws(redrawstr.w,&redrawstr,more);
 }
 else
 {
  err=wimp_force_redraw(&redrawstr);
 }

 zreport(err);
}



/* void refresh_icon(int update,int handle,int icon) */

void refresh_icon(int fp)
{
 os_error     * err;
 wimp_icon      isblock;
 wimp_redrawstr redrawstr;
 windowstr      w;
 int            more;
 int            icon;
 int            update;

 update=stack[fp];
 redrawstr.w=stack[fp+1];
 icon=stack[fp+2];

 if(icon>=0)
 {
  err=wimp_get_icon_info(redrawstr.w,icon,&isblock);
  redrawstr.box=isblock.box;
 }
 else
 {
  err=getw(redrawstr.w,&w);
  redrawstr.box.x0=w.x0-w.bx;
  redrawstr.box.x1=w.x1-w.bx;
  redrawstr.box.y0=w.y0-w.by;
  redrawstr.box.y1=w.y1-w.by;
 }

 if(!err)
 {
  if(update)
  {
   err=wimp_update_wind(&redrawstr,&more);
   if(!err) err=sredraws(redrawstr.w,&redrawstr,more);
  }
  else
  {
   err=wimp_force_redraw(&redrawstr);
  }
 }

 zreport(err);
}




/* int copy_icon(int handle,int icon,int x0,int y1) */



/* void delete_icon(int handle,int icon)  */

void delete_icon(int fp)
{
 int          handle;
 int          icon;
 swindstr   * sw;
 iconmemstr * iconp;
 iconmemstr * last;

 handle=stack[fp];
 icon=stack[fp+1];

 sw=findsw(handle);
 if(sw)
 {
  iconp=sw->first;
  last=NULL;
  while(iconp)
  {
   if(iconp->icon==icon)
   {
    if(last) last->next=iconp->next;
    else     sw->first=iconp->next;
    sfree((flex_ptr)&iconp);
    break;
   }
   last=iconp;
   iconp=iconp->next;
  }
 }

 zreport(wimp_delete_icon(handle,icon));
}


/* void select_icon(int handle,int icon,int select) */

void select_icon(int fp)
{
 zreport(selectst(stack[fp],stack[fp+1],stack[fp+2]));
}


/* void shade_icon(int handle,int icon,int shade) */

void shade_icon(int fp)
{
 zreport(shadeiconst(stack[fp],stack[fp+1],stack[fp+2]));
}



void insert_caret(int fp)
{
 zreport(iecarrot(stack[fp],stack[fp+1]));
}



int find_caret(int fp)
{
 wimp_caretstr c;

 zreport(wimp_get_caret_pos(&c));

	switch(stack[fp])
	{
		case 0:
									return(c.w);
									break;

		case	1:
									return(c.i);
									break;

		case	2:
									return(c.startindex);
									break;

		case	3:
									return(c.endindex);
									break;
	}																																																	

	return(-1);
}




static os_error * setupicon(int fp,wimp_icon * isblock,int handle)
{
 os_error   * err;
 int          flags;

 err=NULL;

 isblock->box.x0=stack[fp];
 isblock->box.y0=stack[fp+1];
 isblock->box.x1=stack[fp+2];
 isblock->box.y1=stack[fp+3];
 isblock->flags=(wimp_iconflags)(flags=stack[fp+4]);

 isblock->data.indirecttext.buffer=stringptr(stack[fp+5]);
 isblock->data.indirecttext.bufflen=0;
 isblock->data.indirecttext.validstring=stringptr(stack[fp+6]);

 return(err);

	USE(handle);

}



/* RISC OS int  create_icon(int handle,int x0,int y0,int x1,int y1,int flags,
                 string & name,int maxlen,string & valid);  */


/* WIN     int  create_icon(int handle,int x0,int y0,int x1,int y1,int flags,
                 string & name,string & class,int id);  */



int create_icon(int fp)
{
 os_error     * err;
 wimp_icreate   iblock;
 int            icon;

 iblock.w=stack[fp];

	icon=stack[fp+8];

 err=setupicon(fp+1,&iblock.i,iblock.w);
 if(!err)
 {
  err=wimp_create_icon(&iblock,&icon);
 }

 zreport(err);

	return(icon);
}


// void write_slice_icon(int handle,int icon,int param,string & value)

void write_slice_icon(int fp)
{

// cprintf("write slice %s",stringptr(stack[fp+3]));

	zreport(wimp_slice_icon(stack[fp],stack[fp+1],stack[fp+2],stringptr(stack[fp+3])));

}


// read_slice_icon(int handle,int icon,int param,string & value)

int read_slice_icon(int fp)
{
 os_error * err;
 int        present;
 char       buffer[1024];

 err=wimp_read_slice(stack[fp],stack[fp+1],stack[fp+2],&present,buffer,NULL);
 if(!err)
 {
  if(present)
  {
   assignstring(stack[fp+3],buffer);
  }
 }

 zreport(err);

 return(present);
}



/* void  plot_icon(int handle,int x0,int y0,int x1,int y1,int flags,
                   string & name,string & valid);  */

void plot_icon(int fp)
{
 wimp_icon  isblock;


 setupicon(fp+1,&isblock,0);

 zreport(wimp_ploticon(stack[fp],&isblock,(sprite_area*)sprites));
}


/* void set_icon_state(int handle,int icon,int value,int mask); */

void set_icon_state(int fp)
{
// cprintf("sw seticon %d",stack[fp]);
 zreport(wimp_set_icon_state(stack[fp],stack[fp+1],
                  (wimp_iconflags)stack[fp+2],(wimp_iconflags)stack[fp+3]));
}


// int geticon(int window,int icon,int coord);

int geticon(int fp)
{
	iconstr icon;

	geti(stack[fp],stack[fp+1],&icon);

	switch(stack[fp+2])
	{
		case	0:
									return(icon.ix0);

		case	1:
									return(icon.iy0);

		case	2:
									return(icon.ix1);

	 case	3:
									return(icon.iy1);
	}

	return(0);
}


void swsetwindowflags(int fp)
{
	zreport(wimp_setwindowflags(stack[fp],stack[fp+1],stack[fp+2]));
}


void swsetactivewindow(int fp)
{
 zreport(setactive(stack[fp]));
}


void swsetfocus(int fp)
{
 zreport(setfocus(stack[fp]));
}


void swsetfocusicon(int fp)
{
 zreport(setfocusicon(stack[fp],stack[fp+1]));
}


