/*->c.test */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <ctype.h>


#include "os.h"
#include "flex.h"
#include "wimp.h"
#include "werr.h"
#include "transform.h"

#include "err.h"
#include "alloc.h"
#include "xext.h"
#include "wos.h"
#include "poll.h"
#include "key.h"
#include "etc.h"
#include "scrap.h"
#include "fsx.h"
#include "bits.h"
#include "avl.h"
#include "deb.h"
#include "bf.h"


#include "constants.h"
#include "str.h"

#include "file.h"
#include "view.h"
#include "obj.h"
#include "object.h"
#include "txstr.h"
#include "tx.h"
#include "vl.h"
#include "fmapstr.h"
#include "style.h"
#include "codes.h"
#include "pxstr.h"
#include "dc.h"
#include "spell.h"
#include "line.h"
#include "undo.h"


#include "test.h"



#ifdef _DEBUG

static int fixmode;
static int verbosemode;

static int objectcount;


typedef struct omapstr
{
 int    type;
 int    count;
 char * name;



} omapstr;



static omapstr omap[]=
{
 OFILEHDR, 0, "File Header",   //   0x1000
 OCOLOUR,  0, "Colours",       //   0x1001
 OSECTION, 0, "Section",       //   0x1002
 OPAGE,    0, "Page",          //   0x1003
 OLINE,    0, "Line",          //   0x1004
 OGROUP,   0, "Group",         //   0x1005
 OHEADER,  0, "Header",        //   0x1006
 OFOOTER,  0, "Footer",        //   0x1007
 OTEXTVBOX,0, "vbox",          //   0x1008
 OTEXTBOX, 0, "Text frame",    //   0x1009
 OPICTURE, 0, "Picture",       //   0x100A
 OPICTBOX, 0, "Picture frame", //   0x100B
 OPATH,    0, "Path",          //   0x100C
 OASTYLE,  0, "A style",       //   0x100D
 OSOURCE,  0, "Source",        //   0x100E
 OVSOURCE, 0, "Vsource",       //   0x100F
 OCSTYLE,  0, "C style",       //   0x1010
 OTABS,    0, "Tabs",          //   0x1011
 OFLOW,    0, "Flow",          //   0x1012
 OSPELL,   0, "Spell",         //   0x1013
 ODICT,    0, "Dictionary",    //   0x1014
 OBUFFER,  0, "Buffer",        //   0x1015
 OPRINT,   0, "Print",         //   0x1016
 OFONTMAP, 0, "Fontmap",       //   0x1017
 OPREF,    0, "Preferences",   //   0x1018
 OGLINE,   0, "Guide line",    //   0x1019
 OINDEXCON,0, "Index+contents",//   0x101A
 OBORDER,  0, "Border",        //   0x101B
 OUSTYLE,  0, "U style",       //   0x101C
 OTXSCRAP, 0, "Text scrap",    //   0x101D
 OBMS,     0, "Book marks",    //   0x101E
 OFILL,    0, "Fill",          //   0x101F
 OCOLSEPS, 0, "Colour seps.",  //   0x1020
 OPROCESS, 0, "Process",       //   0x1021
 OTAG,     0, "Tags",          //   0x1022
 OFIELDS,  0, "Fields",        //   0x1023
 OPXCACHE, 0, "Pict. cache",   //   0x1024
 OPXNAME,  0, "Pict. name",    //   0x1025
 ODICT2,   0, "Dictionary 2",  //   0x1026

 OUNDO,    0, "Undo",          //   0x2000

};


#define NOBJECT (sizeof(omap)/sizeof(omapstr))


typedef struct orecordstr
{
 int key;
 int type;
 int count;

} orecordstr;


static void * xmaphandle;

static int recordcmp(void * p1,void * p2)
{

 return(((orecordstr*)p1)->key-((orecordstr*)p2)->key);

}




typedef struct srecordstr
{
 int key;

} srecordstr;


static void * smaphandle;

static int srecordcmp(void * p1,void * p2)
{

 return(((srecordstr*)p1)->key-((srecordstr*)p2)->key);

}




static os_error * touchsource(int object)
{
 srecordstr   srecord;
 srecordstr * s;

 if(object)
 {
  srecord.key=object;

  s=(srecordstr*)xmapsearch(&srecord,smaphandle);
  if(!s)
  {
   xmapadd(&srecord,&smaphandle);
  }
 }

 return(NULL);
}



typedef struct astylestr
{
 int key;
 int count;

} astylestr;


static void * astylehandle;

static int astylecmp(void * p1,void * p2)
{

 return(((astylestr*)p1)->key-((astylestr*)p2)->key);
}




typedef struct ttabstr
{
 int key;
 int count;

} ttabstr;


static void * tabhandle;

static int tabcmp(void * p1,void * p2)
{

 return(((ttabstr*)p1)->key-((ttabstr*)p2)->key);
}




typedef struct fostr
{
 int key;
 int count;

} fostr;


static void * fohandle;

static int focmp(void * p1,void * p2)
{

 return(((fostr*)p1)->key-((fostr*)p2)->key);
}



typedef struct chstr
{
 int key;
 int count;

} chstr;


static void * chhandle;

static int chcmp(void * p1,void * p2)
{

 return(((chstr*)p1)->key-((chstr*)p2)->key);
}






static os_error * teststyles(filestr * file)
{
 int               i;
 srecordstr      * s;
 absstylebasestr * sbase;
 sourcestr       * sourcep;
 int               offset;
 int               bits;
 int               slen;
 int               c;
 char            * p;
 int               sn;
 astylestr         astyle;
 astylestr       * a;
 int               tn;
 ttabstr           tab;
 ttabstr         * t;
 tabbasestr      * tbase;
 int               fn;
 fostr             fo;
 fostr           * f;
 fmapbasestr     * fbase;
 int               cn;
 chstr             ch;
 chstr           * cp;





 xmapinit(&astylehandle,sizeof(astylestr),256*sizeof(astylestr),astylecmp);


 i=0;
 while(1)
 {
  s=(srecordstr*)xmaprecord(smaphandle,i);
  if(!s) break;

  offset=0;
  sourcep=(sourcestr*)fob_find(s->key,file);

  while(1)
  {
   p=txptr(sourcep,offset);
   c=*p;
   bits=codex[c];
   slen=bits & CODELEN;

   if(c==SNO)
   {
    sn=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);

    astyle.key=sn;
    astyle.count=1;

    a=(astylestr*)xmapsearch(&astyle,astylehandle);
    if(a)
    {
     a->count++;
    }
    else
    {
     xmapadd(&astyle,&astylehandle);
    }
   }
   else
   if(c==EOT)
   {
    break;
   }

   offset+=slen;
  }


  i++;
 }

 

 if(verbosemode) cprintf("astyles found %d",xmapcount(astylehandle));

 sbase=(absstylebasestr*)fob_find(file->hdr.astyles,file);
 if(sbase)
 {
 if(verbosemode) cprintf("stylebase contains %d",sbase->n);

  for(i=0;i<sbase->n;i++)
  {
   sn=sbase->absstyle[i].style.n;

   astyle.key=sn;
   astyle.count=0;

   a=(astylestr*)xmapsearch(&astyle,astylehandle);

   if(!a) cprintf("*** extra style not used in doc");
   else
   {
    if(a->count!=(int)sbase->absstyle[i].count)
    {
     cprintf("*** doc count %d style base %d",a->count,sbase->absstyle[i].count);
     if(fixmode)
     {
      int count;

      count=sbase->absstyle[i].count-(a->count);

      cprintf("*** count %d",count);

      if(count>0)
      {
       while(count-->0) remabsstyle(file,sn);
      }
      else
      if(count<0)
      {
       count=-count;

       while(count-->0) dupabsstyle(file,sn);

      }
     }
    }
    a->count=0;
   }
  }
 }


 i=0;
 while(1)
 {
  a=(astylestr*)xmaprecord(astylehandle,i);
  if(!a) break;

  if(a->count>0)
  {
   cprintf("*** missing style count %d",a->count);
  }
  i++;
 }


/************************** tabs ***********************************/

 xmapinit(&tabhandle,sizeof(ttabstr),256*sizeof(ttabstr),tabcmp);

 sbase=(absstylebasestr*)fob_find(file->hdr.astyles,file);
 if(sbase)
 {
  for(i=0;i<sbase->n;i++)
  {
   tn=sbase->absstyle[i].style.data.tab;

   tab.key=tn;
   tab.count=1;

   t=(ttabstr*)xmapsearch(&tab,tabhandle);
   if(t)
   {
    t->count++;
   }
   else
   {
    xmapadd(&tab,&tabhandle);
   }
  }
 }


 userstylebasestr * ustylebase;
 ustylebase=(userstylebasestr*)fob_find(file->hdr.ustyles,file);
 if(ustylebase)
 {
  for(i=0;i<ustylebase->n;i++)
  {
//    cprintf("add user style tab");

    tn=ustylebase->userstyle[i].style.data.tab;

    tab.key=tn;
    tab.count=1;

    t=(ttabstr*)xmapsearch(&tab,tabhandle);
    if(t)
    {
     t->count++;
    }
    else
    {
     xmapadd(&tab,&tabhandle);
    }

  }
 }

 if(verbosemode) cprintf("tabs found %d",xmapcount(tabhandle));

 tbase=(tabbasestr*)fob_find(file->hdr.tabs,file);
 if(tbase)
 {
  if(verbosemode) cprintf("tabbase contains %d",tbase->n);
  for(i=0;i<tbase->n;i++)
  {
   tn=tbase->tabhdr[i].key;

   tab.key=tn;
   tab.count=0;

   t=(ttabstr*)xmapsearch(&tab,tabhandle);

   if(!t) cprintf("*** extra tab not used in doc");
   else
   {
    if(t->count!=(int)tbase->tabhdr[i].count) cprintf("*** styles tab count %d tab base %d for tab %d",t->count,tbase->tabhdr[i].count,tn);
    t->count=0;
   }
  }
 }

 xmapfinit(&tabhandle);
 

/************************** tabs  ***********************************/ 


/************************** fmaps ***********************************/


 xmapinit(&fohandle,sizeof(fostr),256*sizeof(fostr),focmp);

 sbase=(absstylebasestr*)fob_find(file->hdr.astyles,file);
 if(sbase)
 {
  for(i=0;i<sbase->n;i++)
  {
   fn=sbase->absstyle[i].style.data.mfont;

//   cprintf("as fn %d",fn);

   fo.key=fn;
   fo.count=1;

   f=(fostr*)xmapsearch(&fo,fohandle);
   if(f)
   {
    f->count+=sbase->absstyle[i].count;
   }
   else
   {
    fo.count=sbase->absstyle[i].count;
    xmapadd(&fo,&fohandle);
   }
  }
 }



 ustylebase=(userstylebasestr*)fob_find(file->hdr.ustyles,file);
 if(ustylebase)
 {
  for(i=0;i<ustylebase->n;i++)
  {
//    cprintf("add user style tab");

    fn=ustylebase->userstyle[i].style.data.mfont;

    fo.key=fn;
    fo.count=1;

//   cprintf("us fn %d",fn);

    f=(fostr*)xmapsearch(&fo,fohandle);
    if(f)
    {
     f->count++;
    }
    else
    {
     xmapadd(&fo,&fohandle);
    }

  }
 }

 if(verbosemode) cprintf("fonts found %d",xmapcount(fohandle));

 fbase=(fmapbasestr*)fob_find(file->hdr.fmap,file);
 if(fbase)
 {
  if(verbosemode) cprintf("font map contains %d",fbase->n);
  for(i=0;i<fbase->n;i++)
  {
   fn=fbase->fmaphdr[i].key;

   fo.key=fn;
   fo.count=0;

   f=(fostr*)xmapsearch(&fo,fohandle);

//   cprintf("fm fn %d",fn);

   if(!f) cprintf("*** extra font not used in doc");
   else
   {
    if(f->count!=(int)fbase->fmaphdr[i].count) cprintf("*** styles font count %d fontmap %d for font %d",f->count,fbase->fmaphdr[i].count,fn);
    f->count=0;
   }
  }
 }

 xmapfinit(&fohandle);

/************************** fmaps ***********************************/

/************************** style chains ***********************************/



 cstylebasestr * cbase;


 xmapinit(&chhandle,sizeof(chstr),256*sizeof(chstr),chcmp);

 sbase=(absstylebasestr*)fob_find(file->hdr.astyles,file);
 if(sbase)
 {
  for(i=0;i<sbase->n;i++)
  {
   cn=sbase->absstyle[i].chain;

   ch.key=cn;
   ch.count=1;

   cp=(chstr*)xmapsearch(&ch,chhandle);
   if(cp)
   {
    cp->count++;
   }
   else
   {
    xmapadd(&ch,&chhandle);
   }
  }
 }


 if(verbosemode) cprintf("chains found %d",xmapcount(chhandle));


 cbase=(cstylebasestr*)fob_find(file->hdr.cstyles,file);
 if(cbase)
 {
  if(verbosemode) cprintf("chain base contains %d",cbase->n);
  for(i=0;i<cbase->n;i++)
  {
   cn=cbase->stylechain[i].key;

   ch.key=cn;
   ch.count=0;

   cp=(chstr*)xmapsearch(&ch,chhandle);

//   cprintf("fm fn %d",fn);

   if(!cp) cprintf("*** extra chain not used in doc");
   else
   {
    if(cp->count!=(int)cbase->stylechain[i].count) cprintf("*** chain count %d chain base %d for chain %d",cp->count,cbase->stylechain[i].count,cn);
    cp->count=0;
   }
  }
 }

 xmapfinit(&chhandle);


/************************** style chains ***********************************/


 xmapfinit(&astylehandle);
 
 return(NULL);
}






static os_error * touchobject(int object,char * what)
{
 orecordstr   record;
 orecordstr * r;

 if(object)
 {
  record.key=object;
  record.count=0;

  r=(orecordstr*)xmapsearch(&record,xmaphandle);
  if(r)
  {
   r->count++;
  }
  else
  {
   cprintf("*** touch: %s object %x not found in records",what,object);
  }
 }

 return(NULL);
}



static os_error * touchcurve(curvestr * c,filestr * file)
{
 if(c->type==CPATH) touchobject(c->data.path.path,"curve");

 return(NULL);

 USE(file);
}



static os_error * pfn(sobjectstr * sob,filestr * file,int * message)
{
 orecordstr   record;
 orecordstr * r;

 record.key=sob->key;
 record.count=0;

 r=(orecordstr*)xmapsearch(&record,xmaphandle);
 if(r)
 {
  r->count++;
 }
 else
 {
  cprintf("*** object %x not found in records during message broadcast",record.key);
 }

 if(sob->type==OLINE)
 {
  linestr * linep;

  linep=(linestr*)sob;

  touchcurve(&linep->fcurve,file);

  touchobject(linep->data.fill.fill,"line fill");

 }
 else
 if(sob->type==OTEXTBOX)
 {
  textboxstr    * textp;
  int             header;
  int             footer;
  texsrc        * texsp;
  texsub        * texup;
  int             u;
  textvbox      * v;
  int             usize;
  int             vbox;
  int             columns;
  int             j;
 
  textp=(textboxstr*)sob;
  header=textp->data.header;
  footer=textp->data.footer;
  columns=textp->data.columns;

  touchcurve(&textp->fcurve,file);
  touchcurve(&textp->icurve,file);
  touchcurve(&textp->ocurve,file);

  for(u=0;u<3;u++)
  {
   if((u==0) || (u==1 && header) || (u==2 && footer))
   {
    texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));
 
    touchobject(texsp[u].source,"source");
    touchobject(texsp[u].vsource,"vsource");
    touchsource(texsp[u].source);
   }
  }

  touchobject(textp->frame,"text border");
  touchobject(textp->data.fill.fill,"text fill");

  if(textp->data.header || textp->data.footer) 
  {
   usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr);
   columns+=2;
  }
  else
  {
   usize=sizeof(textboxstr)+sizeof(texsrc);
  }

  texup=(texsub*)(((char*)textp)+usize);

  for(u=0;u<columns;u++)
  {
   vbox=texup->vbox;
   while(vbox)
   {
    touchobject(vbox,"vbox");
    v=(textvbox*)fob_find(vbox,file);

    for(j=0;j<v->nc;j++)
    {
     touchcurve(&v->curve[j],file);

    }
    vbox=v->down;
   }

   texup++;
  }

 }
 else
 if(sob->type==OPICTBOX)
 {
  pictboxstr    * pictp;

  pictp=(pictboxstr*)sob;

  touchobject(pictp->frame,"pict border");
  touchobject(pictp->data.fill.fill,"pict fill");
  touchobject(pictp->picture,"pict picture");

  touchcurve(&pictp->fcurve,file);
  touchcurve(&pictp->icurve,file);
  touchcurve(&pictp->ocurve,file);

  touchobject(pictp->process.process,"process");

 }


 return(NULL);

 USE(message);
}





static int typeindex(int type)
{
 int i;

 for(i=0;i<NOBJECT;i++)
 {
  if(type==omap[i].type)
  {
   return(i);
  }
 }

 return(-1);
}


static os_error * testfn(void * o)
{
 sobjectstr * sobj;
 int          i;
 orecordstr   record;
 orecordstr * r;

 objectcount++;

 sobj=(sobjectstr*)o;

 for(i=0;i<NOBJECT;i++)
 {
  if(sobj->type==omap[i].type)
  {
   omap[i].count++;
   break;
  }
 }

 if(i>=NOBJECT) cprintf("*** Unknown object %x",sobj->type);

 record.key=sobj->key;
 record.type=sobj->type;
 record.count=0;

 r=(orecordstr*)xmapsearch(&record,xmaphandle);
 if(!r)
 {
  xmapadd(&record,&xmaphandle);
 }
 else
 {
  cprintf("*** duplicate object %x",sobj->key);
 }

 return(NULL);
}



static os_error * testsections(filestr * file,int section)
{
 sectionstr * sectionp;
 pagestr    * pagep;
 int          page;

 do
 {
  touchobject(section,"section");
  sectionp=(sectionstr*)fob_find(section,file);

  page=sectionp->chain.child;
  while(page)
  {
   touchobject(page,"page");
   pagep=(pagestr*)fob_find(page,file);
   page=pagep->chain.next;

  }

  sectionp=(sectionstr*)fob_find(section,file);
  section=sectionp->chain.next;
 } while(section);
 return(NULL);
}


static os_error * testspell(filestr * file,int spellk)
{
 os_error * err;
 int        i;
 spellstr * spellp;
 odictstr * dp;
 int        n;
 int        good;




 err=NULL;

 if(spellk)
 {
  spellp=(spellstr*)fob_find(spellk,file);
  if(spellp)
  {
   for(n=i=0;i<spellp->nodc;i++)
   {
    good=0;
    if(spellp->spdict[i].embedded)
    {
     dp=(odictstr*)fob_find(spellp->spdict[i].index,file);
     if(dp)
     {
      if(dp->type==ODICT)
      {
       touchobject(dp->dict.words,"dict0 words");
       touchobject(dp->dict.index,"dict0 index");
      }
      else
      if(dp->type==ODICT2)
      {
       touchobject(dp->dict.words,"dict2 words");
       touchobject(dp->dict.index,"dict2 index");
      }
     }

     touchobject(spellp->spdict[i].index,"spell index");
    }
   }
  }
 }


 return(NULL);
}



static os_error * testfilehdr(filestr * file)
{

 touchobject(file->hdr.colours,"colours");
 touchobject(file->hdr.astyles,"astyles");
 touchobject(file->hdr.bms,"bookmarks");
// touchobject(file->hdr.border);
 touchobject(file->hdr.colsep,"colsep");
 touchobject(file->hdr.cstyles,"cstyles");
 touchobject(file->hdr.fields,"fields");
 touchobject(file->hdr.fmap,"font map");
 touchobject(file->hdr.indexcon,"index con");
 touchobject(file->hdr.preferences,"pref");
 touchobject(file->hdr.ustyles,"ustyles");
 touchobject(file->hdr.undo,"undo");
 touchobject(file->hdr.tag,"tag");
 touchobject(file->hdr.spell,"spell");
 touchobject(file->hdr.tabs,"tabs");
 touchobject(file->hdr.key,"key");
 touchobject(file->hdr.print,"print");

 return(NULL);
}




os_error * testdoc(filestr * file)
{
 int          i;
 int          message;
 orecordstr * r;


 cprintf("*** test document ***");

 flushundobuffer(0);

 objectcount=0;

 for(i=0;i<NOBJECT;i++)
 {
  omap[i].count=0;
 }

 xmapinit(&xmaphandle,sizeof(orecordstr),256*sizeof(orecordstr),recordcmp);
 xmapinit(&smaphandle,sizeof(srecordstr),256*sizeof(srecordstr),srecordcmp);

 ob_enum(file->domain,testfn);

 message=OM_FUNCTION2;
 broadcastmessage(file,&message,(void*)pfn);

 testfilehdr(file);

 testsections(file,file->hdr.section[DOC]);
 testsections(file,file->hdr.section[MST]);

 testspell(file,file->hdr.spell);


 i=0;
 while(1)
 {
  r=(orecordstr*)xmaprecord(xmaphandle,i);
  if(!r) break;

  if(r->count==0)
  {
   cprintf("*** null count key %d type %s",r->key,omap[typeindex(r->type)].name);

   if(fixmode)
   {
    if(r->type==OSOURCE)
    {
     txsourcedel(r->key,file,1);
    }
    else
    if(r->type==OVSOURCE)
    {
     vsourcedel(r->key,file);
    }
   }
  }

  i++;
 }


 teststyles(file);



 cprintf("total number of objects %d",objectcount);
 cprintf("objects in map %d",xmapcount(xmaphandle));

 for(i=0;i<NOBJECT;i++)
 {
//  cprintf("%-6d %s",omap[i].count,omap[i].name);
 }

 xmapfinit(&xmaphandle);
 xmapfinit(&smaphandle);

 return(NULL);
}


void xtestdoc(int fp)
{
 zreport(testdoc(menufile));
 USE(fp);
}


#else

void xtestdoc(int fp)
{
 USE(fp);
}


#endif
