/*->c.splink */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "sprite.h"
#include "sprx.h"
#include "transform.h"
#include "xprocess.h"
#include "colour.h"
#include "bf.h"
#include "imlib.h"
#include "xxjpeg.h"


#include "etc.h"



#include "str.h"
#include "constants.h"


#include "xprint.h"

#include "splib.h"


#include "splink.h"





static splinkblockstr * spfirstlink;



os_error * sp_addblock(splinkblockstr * link)
{
 splinkblockstr * next;

 next=spfirstlink;
 spfirstlink=link;
 spfirstlink->next=next;

 return(NULL);
}




static os_error * setuppixtrans(newsprite_header * sprite,int * pixtrans,
                                       processstr * pr,int ** pixtransp)
{
 os_error   * err;
 int          palentries;
 int          i;
 int       *  from;
 int       *  to;
 int          spbpp=0;
 int          spbitmask;


 err=NULL;

 *pixtransp=NULL;

 palentries=(sprite->image-sizeof(sprite_header))/8;
 if((palentries>256) || (palentries<0)) palentries=0;

 if(palentries==0)
 {
  getbpp(sprite->selector.mode.mode,&spbpp,&spbitmask);
 }

 if(pr->mode==PROCESSNONE && (palentries>0 || spbpp>3))
 {
  *pixtransp=NULL;
 }
 else
 {
  if(palentries==0)
  {
   /* must be spbpp<=3 */
   genpalbpp(pixtrans,spbpp,&palentries);
   *pixtransp=pixtrans;
//			cprintf("draw gen pal %d spbpp %d",palentries,spbpp);

   /* no palette, use default for sprite.mode */
  }
  else
  {
   getbpp(sprite->selector.mode.mode,&spbpp,&spbitmask);
  }

  if(pr->mode!=PROCESSNONE)
  {
//			cprintf("draw process");

   if(!*pixtransp)
   {
    from=(int*)(((char*)sprite)+sizeof(sprite_header));
    to=pixtrans;            

    for(i=palentries;i>0;i--)
    {
     *to++=*from;
     from+=2;
    }
    *pixtransp=pixtrans;
   }

   genpal256(pixtrans,ln2(spbpp),&palentries);

   for(i=0;i<palentries;i++) 
   {
    pixtrans[i]=processcolour(pixtrans[i] & 0xFFFFFF00,pr);
   }
  }
 }

 return(err);
}




os_error * sp_enhanced_render(newsprite_header * sp,
                              transformstr * tr,processstr * pr,int * claimed)
{
 os_error       * err;
 splinkblockstr * splink;

 *claimed=0;
 err=NULL;

 splink=spfirstlink;


 while(splink)
 {
  if(splink->render) err=splink->render(sp,tr,pr,claimed);
  if(*claimed) break;
  splink=splink->next;
 }


 if(!*claimed)
 {
  int              pixtrans[256]; /* pixel conversion tab                */
  int            * pixtransp;
  sprite_id        id;

  err=setuppixtrans(sp,pixtrans,pr,&pixtransp);
  if(!err)
		{
   id.tag=sprite_id_addr;
   id.s.addr=sp;
 
   err=sprite_put_transproc((sprite_area*)0xFF,&id,8|pr->spritebits,
                 (sprite_transform*)tr,pr,(sprite_pixtrans*)pixtransp);
 
   *claimed=1;
		}
 }

 return(err);
}




/********************************************************************************/




static jplinkblockstr * jpfirstlink;



os_error * jp_addblock(jplinkblockstr * link)
{
 jplinkblockstr * next;

 next=jpfirstlink;
 jpfirstlink=link;
 jpfirstlink->next=next;

 return(NULL);
}






os_error * jp_enhanced_render(char * data,int len,
                              transformstr * tr,processstr * pr,int * claimed)
{
 os_error       * err;
 jplinkblockstr * jplink;
 jpeginfostr      info;

 *claimed=0;
 err=NULL;

 jplink=jpfirstlink;

 while(jplink)
 {
  if(jplink->render) err=jplink->render(data,len,tr,pr,claimed);
  if(*claimed) break;
  jplink=jplink->next;
 }

 if(!*claimed)
 {
  err=jpeg_info(data,len,&info);
  if(!err)
  {
   err=jpeg_render(data,len,tr,(pr->jpegbits & ~0x1),pr);
  }
  *claimed=1;
 }
 
 return(err);
}


