/*->c.dbfields */


#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>



#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "flex.h"
#include "sprite.h"
#include "transform.h"


#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "key.h"
#include "wimptext.h"
#include "temp.h"
#include "sp.h"

#include "bits.h"
#include "err.h"
#include "trans.h"
#include "save.h"
#include "xhelp.h"
#include "fsx.h"
#include "bf.h"
#include "csv.h"
#include "alloc.h"
//#include "txcb.h"
#include "colour.h"
#include "deb.h"


#include "xext.h"


#include "str.h"
#include "constants.h"
#include "reslink.h"

#include "dbhi.h"


#include "file.h"
#include "view.h"
#include "object.h"
#include "caret.h"
#include "macros.h"
#include "units.h"
#include "codes.h"

#include "dscript.h"


#include "prstr.h"

#include "fields.h"

#include "dbfields.h"





/******************************************************************************/

typedef struct ofieldsstr
{
 int      key;
 int      type;
 chainstr chain;
 int      size;
 int      spare[2];
 char     stuff[1];

} ofieldsstr;




typedef struct fieldsstr
{
 int  tag;
 int  size;
 char stuff[4];

} fieldsstr;



#define FIELDLEN 256
#define FIELDNAMELEN 16







/*****************************************************************************/

#define FCHUNK 0x100

static char * xfield;
static int    xfieldn;


static os_error * fexfn(int c)
{
 os_error * err;
 int        ch;


 err=flex_chunk((flex_ptr)&xfield,xfieldn+4,FCHUNK);
 if(!err) 
 {
  ch=-1;
  
  switch(c)
  {
         case XTABCH:
         case   '\t':
                     ch=TABCH;
                     break;
          
       case XNEWPARA:
          case  '\r':
//         case RETURN:            /* i.e. \r */
                     ch='\n';
                     break;

           case '\n':
       case XNEWLINE:
//    case SHFT_RETURN:
                     ch='\r';
                     break;

    case CTRL_RETURN:
        case XEOPAGE:
                     ch=EOPAGE;
                     break;

  /*  case SHFT_ENTER: */ // this could be taken out using the extended flag
    case     XEOBOX:
                    ch=EOBOX;
                    break;

    case     XDCHYPH:
    case  CTRL_MINUS:
                     ch=DCHYPH;
                     break;

     case     NBHYPH:
     case    XNBHYPH:
                     ch=NBHYPH;
                     break;

     case    NBSPACE:
     case   XNBSPACE:
                     ch=NBSPACE;
                     break;
     

             default:
                     if(c>255)
                     {
                      ch=code16inv(c);
                     }
                     else
                     {
 	                    ch=code8symbolinv(c);

                      if(ch<0)
                      {
                       c=code16win(c);
                      }
                     }
                     break;
  }

  if(ch==TABCH)
  {
   xfield[xfieldn++]=TABSEQ;
   xfield[xfieldn++]=0;
   xfield[xfieldn++]=0;
   xfield[xfieldn++]=0;
  }
  else
  if(ch>=0)
  {
   xfield[xfieldn++]=(char)ch;
  }
 }

 return(err);
}



/* first 4 bytes are length of string */

os_error * getfield(int n,csvstr * newcsv,filestr * file,char ** string)
{
 os_error   * err;
 ofieldsstr * ofp;
 char       * p;
 char       * q;
 char       * limit;
 int          len;
 int          size;
 fieldsstr  * fs;
 char         field[FIELDLEN];


 err=NULL;

 *string=NULL;

 if(file->hdr.fields)
 {
  ofp=(ofieldsstr*)fob_find(file->hdr.fields,file);
  size=ofp->size;

  p=ofp->stuff;
  limit=p+size;

  fs=NULL; /* compiler */

  while(p<limit)
  {
   fs=(fieldsstr*)p;
   if(fs->tag==n) break;
   p+=fs->size;
  }

  if(p<limit)
  {
   p=fs->stuff;
   p+=strlen(p)+1;
   xzstrncpy(field,p,sizeof(field));

   if(strlen(field))
   {
    xfieldn=0;
    err=flex_alloc((flex_ptr)&xfield,FCHUNK);
    if(!err)
    {
     err=expandmacro(fexfn,field);
   /* if(xfieldn) */   /* want to be able to return null fields */
     {
      err=fexfn(0);
      if(!err)
      {
       len=xfieldn+EINTLEN;
       err=salloc((flex_ptr)string,len);
       if(!err)
       {
        q=*string;
        XMEMCPYX(q+EINTLEN,xfield,xfieldn);
        *q++=EINTSEQ;
        len--;
        *q++=(char)(len & 0xFF);
        *q++=(char)((len>>8) & 0xFF);
        *q++=(char)((len>>16) & 0xFF);
        *q++=(char)((len>>24) & 0xFF);
       }
      }
     }
     flex_free((flex_ptr)&xfield);
    }
   }
  }
 }


 if(!(*string) && newcsv)
 {
  if(n<=newcsv->records && n>=1)
  {
   p=newcsv->record[n-1];
   len=strlen(p)+EINTLEN+1;

   err=salloc((flex_ptr)string,len);
   if(!err)
   {
    q=*string;
    *q++=EINTSEQ;
    len--;
    *q++=(char)(len & 0xFF);
    *q++=(char)((len>>8) & 0xFF);
    *q++=(char)((len>>16) & 0xFF);
    *q++=(char)((len>>24) & 0xFF);
    strcpy(q,p);
   }
  }
 }

 return(err);
}




os_error * losefield(char ** string)
{
 return(sfree((flex_ptr)string));
}




/***************************************************************************/


static char      * fieldsp;
static int         fieldsn;



static os_error * getfields(filestr * file)
{
 os_error   * err;
 ofieldsstr * ofp;

 err=NULL;

 if(file->hdr.fields)
 {
  ofp=(ofieldsstr*)fob_find(file->hdr.fields,file);
  fieldsn=ofp->size;



  if(fieldsp) err=flex_extend((flex_ptr)&fieldsp,fieldsn);
  else        err=flex_alloc((flex_ptr)&fieldsp,fieldsn);

  if(!err)
  {
   ofp=(ofieldsstr*)fob_find(file->hdr.fields,file);
   XMEMCPYX(fieldsp,ofp->stuff,fieldsn);
  }
 }
 else
 {
  fieldsn=0;

  if(fieldsp) err=flex_extend((flex_ptr)&fieldsp,fieldsn);
  else        err=flex_alloc((flex_ptr)&fieldsp,fieldsn);
 }

 return(err);
}




static os_error * putfields(filestr * file)
{
 os_error   * err;
 ofieldsstr * ofp;


 if(file->hdr.fields)
 {
  err=fob_change(file->hdr.fields,file,
                        sizeof(ofieldsstr)+fieldsn,(fobjptr)&ofp); 
  if(!err)
  {
   ofp->size=fieldsn;
   XMEMCPYX(ofp->stuff,fieldsp,fieldsn);
  }
 }
 else
 {
  err=fob_create(sizeof(ofieldsstr)+fieldsn,file,OFIELDS,(fobjptr)&ofp);
  if(!err)
  {
   ofp->size=fieldsn;
   XMEMCPYX(ofp->stuff,fieldsp,fieldsn);
   file->hdr.fields=ofp->key;
  }
 }

 return(err);
}




static os_error * clearfields(void)
{
 if(fieldsp) return(flex_free((flex_ptr)&fieldsp));
 return(NULL);
}




static os_error * addfield(char * newname,int newnumber,int * np)
{
 os_error  * err;
 fieldsstr   fs;
 int         nlen;
 char      * p;
 char      * limit;
 fieldsstr * fsp;
 int         offset;
 int         n;


 err=NULL;

 nlen=strlen(newname)+1;

 if(nlen<=1 || nlen>=FIELDNAMELEN) err=geterror(PR11);
 else
 if(newnumber<1) err=geterror(PR10);
 else
 {
  p=fieldsp;
  limit=p+fieldsn;
  n=0;

  while(p<limit)
  {
   fsp=(fieldsstr*)p;
   if(fsp->tag>newnumber) break;
   if(fsp->tag==newnumber) err=geterror(PR13);
   if(!cstrcmp(newname,fsp->stuff)) err=geterror(PR14);
   p+=fsp->size;
   n++;
  }

  if(!err)
  {
   *np=n;

   offset=p-fieldsp;

   fs.tag=newnumber;
   nlen=strlen(newname)+1;
   fs.size=sizeof(fieldsstr)-4+nlen+1;
   fs.size=(fs.size+0x3)&(~0x3);

   err=flex_midextend((flex_ptr)&fieldsp,offset,fs.size);
   if(!err)
   {
    XMEMCPYX(fieldsp+offset,&fs,sizeof(fieldsstr));
    strcpy(((fieldsstr*)(fieldsp+offset))->stuff,newname);
    ((fieldsstr*)(fieldsp+offset))->stuff[nlen]=0;
    fieldsn+=fs.size;
   }
  }
 }

 return(err);
}



static int countfields(char * data,int size)
{
 int         n;
 char      * limit;
 char      * p;
 fieldsstr * fs;

 p=data;
 limit=data+size;

 n=0;

 while(p<limit)
 {
  fs=(fieldsstr*)p;
  p+=fs->size;
  n++;
 }

 return(n);
}



static fieldsstr * findfieldn(int index,char * data,int size)
{
 int         n;
 char      * limit;
 char      * p;
 fieldsstr * fs;

 p=data;
 limit=data+size;

 n=0;

 while(p<limit)
 {
  fs=(fieldsstr*)p;
  p+=fs->size;
  if(n==index) return(fs);
  n++;
 }

 return(NULL);
}





static os_error * remfield(int index)
{
 fieldsstr * fs;
 int         offset;
 int         size;

 fs=findfieldn(index,fieldsp,fieldsn);

 size=fs->size;
 offset=(((char*)fs)-fieldsp);

 memmove(fieldsp+offset,fieldsp+offset+size,fieldsn-offset-size);
 fieldsn-=size;

 return(NULL);
}




static os_error * updatefield(int index,char * text)
{
 os_error  * err;
 fieldsstr * fs;
 int         offset;
 int         oldsize;
 int         newsize;
 int         nlen;

 fs=findfieldn(index,fieldsp,fieldsn);

 oldsize=fs->size;
 offset=(((char*)fs)-fieldsp);
 nlen=strlen(fs->stuff)+1;

 newsize=sizeof(fieldsstr)-4+nlen+strlen(text)+1;
 newsize=(newsize+0x3)&(~0x3);

 err=flex_midextend((flex_ptr)&fieldsp,offset+oldsize,newsize-oldsize);
 if(!err)
 {
  fieldsn+=newsize-oldsize;
  fs=(fieldsstr*)(fieldsp+offset);
  fs->size+=newsize-oldsize;
  strcpy(fieldsp+offset+sizeof(fieldsstr)-4+nlen,text);
 }

 return(err);
}







os_error * dsmerge(int fp,int argc,objectloc * loc)
{
 os_error    * err;
 dsobjectstr * ds;
 int           tag;
 int           sp;
 int           nsp;
 filestr     * file;
 char        * p;
 char        * limit;
 int           size;
 fieldsstr   * fs;
 char          fieldname[FIELDNAMELEN];
 int           namelen;
 int           fieldlen;
 int           oldsize;
 ofieldsstr  * ofp;




 err=dsneeddoc(loc);

 sp=fp+2;

 if(argc)
 {
  file=loc->file;

  ds=(dsobjectstr*)(dsstack+sp);
  if(ds->type==DSTINT)
  {
   nsp=sp+ds->len/sizeof(int);
   tag=ds->data.integer;
   argc--;
  }
  else
  {
   tag=1;                 /* find max tag value */
   nsp=sp;

   if(file->hdr.fields)
   {
    ofp=(ofieldsstr*)fob_find(file->hdr.fields,file);
    size=ofp->size;

    p=ofp->stuff;
    limit=p+size;

    while(p<limit)
    {
     fs=(fieldsstr*)p;
     tag=MAX(fs->tag+1,tag);
     p+=fs->size;
    }
   }
  }


  if(argc>0)
  {
   sp=nsp;
   ds=(dsobjectstr*)(dsstack+sp);
   nsp=sp+ds->len/sizeof(int);

   strncpy(fieldname,ds->data.string,sizeof(fieldname));
   namelen=strlen(fieldname)+1;

   if(argc==2)
   {
    ds=(dsobjectstr*)(dsstack+nsp);
    fieldlen=strlen(ds->data.string)+1;
   }
   else
   {
    fieldlen=1;
   }

   size=sizeof(fieldsstr)-4+namelen+fieldlen;
   size=(size+0x3)&(~0x3);

   fs=NULL;  /* compiler */


   if(file->hdr.fields)
   {
    ofp=(ofieldsstr*)fob_find(file->hdr.fields,file);
    oldsize=ofp->size;

    err=fob_change(file->hdr.fields,file,
                        sizeof(ofieldsstr)+oldsize+size,(fobjptr)&ofp); 
    if(!err)
    {
     fs=(fieldsstr*)(((char*)ofp->stuff)+oldsize);
     ofp->size+=size;
    }
   }
   else
   {
    err=fob_create(sizeof(ofieldsstr)+size,file,OFIELDS,(fobjptr)&ofp);
    if(!err)
    {
     ofp->size=size;
     fs=(fieldsstr*)(ofp->stuff);
     file->hdr.fields=ofp->key;
    }
   }

   if(!err)
   {
    fs->tag=tag;
    fs->size=size;

    strcpy(fs->stuff,fieldname);
    if(fieldlen>1)
    {
     ds=(dsobjectstr*)(dsstack+nsp);
     strcpy(fs->stuff+namelen,ds->data.string);
    }
    else
    {
     strcpy(fs->stuff+namelen,"");
    }
   }
  }

  ds=(dsobjectstr*)(dsstack+fp);
  ds->data.integer=tag;
  ds->len=3*sizeof(int);
 }

 return(err);
}





os_error * fieldds(filestr * file,buffer * bf)
{
 os_error    * err;
 char        * p;
 char        * limit;
 int           size;
 fieldsstr   * fs;
 char          temp1[2*FIELDNAMELEN];
 char          temp2[2*FIELDLEN];
 ofieldsstr  * ofp;


 err=NULL;


 if(file->hdr.fields)
 {
  ofp=(ofieldsstr*)fob_find(file->hdr.fields,file);
  size=ofp->size;

  p=ofp->stuff;
  limit=p+size;

  err=bf_printfeol(bf,"");

  if(!err)
  {
   while(p<limit)
   {
    fs=(fieldsstr*)p;
    err=bf_printfeol(bf,"MERGE_%02x={merge %d \"%s\" \"%s\"}",
                  fs->tag,
                  fs->tag,
                  unquotec(fs->stuff,temp1),
                  unquotec(fs->stuff+strlen(fs->stuff)+1,temp2));

    p+=fs->size;
   }
  }

  if(!err) err=bf_printfeol(bf,"");
 }

 return(err);
}




/*****************************************************************************/
/* code for macros windows */

                        /* step between each macro entry in window */
#define MACDY   56
                        /* step between top of window and first macro */
#define MACFY   12
                        /* height of macro definitions */
#define MACHY   52

#define MACFX    8
#define MACSX    12*16+MACFX+8

#define MACSTRW  48


#define MACFXW   12*16
#define MACSXW   16*MACSTRW

#define MACWIDTH 1024


#define XICON 10

#define MAXICONLEN (FIELDLEN+64)


static int     fieldsselectn;

extern dboxstr fieldsbox[2];



#define MODENAME   0
#define MODETEXT   1
#define MODENUMBER 2


static wimp_icon * modeicons[3];



static int         curtot;



static os_error  * fieldsextent(void);
static void fieldsnewselect(int t,int x);


static filestr   * cfile;
static viewstr   * cview;

static int         panemaxx;
static int         paneminy;
static int         fieldsmaxx;
static int         fieldsminy;



static dbstackstr * fieldstack;

static dbstackstr ourfieldstack;




/****************************************************************************/


static char   newname[FIELDNAMELEN];
static int    newnumber;


static os_error * newfieldclose(int code)
{
 os_error * err;
 int        n;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  err=addfield(newname,newnumber,&n);
  if(!err)
  {
   if(fieldsselectn>=0 && fieldsselectn>=n) fieldsselectn++;
   curtot++;
   fieldsnewselect(n,-1);
   fieldsextent();
   refreshwindow(fieldsbox[1].handle);
  }
 }

 return(err);
}


static os_error * wrnewname(int value,char * string)
{
 strcpy(string,"");
 return(NULL);
 value=value;
}


static os_error * rdnewname(int * value,char * string)
{
 xzstrncpy(newname,string,sizeof(newname));
 return(NULL);
 USE(value);
}


static os_error * wrnewnumber(int value,char * string)
{
 if(value<0) strcpy(string,"");
 else        strcpy(string,numbertostring(value));
 return(NULL);
}


static os_error * rdnewnumber(int * value,char * string)
{
 return(stringtonumber(string,value));
 return(NULL);
}







static dbiconstr newfieldicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0, NULL ,0,

    3, &newnumber,   DBWRITE,  0,   0,     -1, -1, -1,  -1,rdnewnumber,
                                                           wrnewnumber,

    5, NULL,         DBWRITE,  0,   0,     -1, -1, -1,  -1,rdnewname,
                                                           wrnewname,


   -1, NULL,         0,        0,   0,      0,  0,  0,  0,  0,      0
};


static dboxstr newfieldbox=
{
 0,
 TNEWFIELD,
 DBFIX,
 DBCARETRESET,
 newfieldclose,
 NULL,
 NULL,
 NULL,
 newfieldicondefs,
 0,
 0,
 0,NULL,
 0,0,
};



static os_error * opennewfield(void)
{
 newnumber=-1;
 return(dodboxsp(&newfieldbox,1,fieldsbox,fieldstack));
}



/*****************************************************************************/
/* code for handling macro windows */

static void posnicon(wimp_icon * isblock,int n,int dy,int ox,int oy)
{
 int h;
 h=isblock->box.y1-isblock->box.y0;
 isblock->box.y1=oy-MACFY-n*MACDY-dy;
 isblock->box.y0=isblock->box.y1-h;
 USE(ox);
}




static void xmcpystring(int dlen,char * dest,char * s1,char * s2)
{
 int    ch;
 char * lt;

 lt=dest+dlen-2;
 xzstrncpy(dest,s1,dlen);
 dest=dest+strlen(dest);

 while(1)
 {
  ch=*s2++;
  if(ch=='{') *dest++='{';
  if(ch=='\\') *dest++='\\';
  *dest++=(char)ch;
  if(ch==0) break;
  if(dest>=lt)
  {
   *dest=0;
   break;
  }
 }

}




static os_error * redfield(int n,fieldsstr * fp,int ox,int oy)
{
 wimp_icon  * isblock;
 char         string[MAXICONLEN];
 char         temp[16];
 char       * oldbuffer;


 isblock=modeicons[MODENAME];
 posnicon(isblock,n,0,ox,oy);

 oldbuffer=isblock->data.indirecttext.buffer;
 xmcpystring(sizeof(string),string,oldbuffer,fp->stuff);
 isblock->data.indirecttext.buffer=string;
 wimp_ploticon(fieldsbox[1].handle,isblock,NULL);
 isblock->data.indirecttext.buffer=oldbuffer;


 isblock=modeicons[MODENUMBER];
 posnicon(isblock,n,0,ox,oy);

 oldbuffer=isblock->data.indirecttext.buffer;
 sprintf(temp,"%d",fp->tag);
 xmcpystring(sizeof(string),string,oldbuffer,temp);
 isblock->data.indirecttext.buffer=string;
 wimp_ploticon(fieldsbox[1].handle,isblock,NULL);
 isblock->data.indirecttext.buffer=oldbuffer;


 if(n!=fieldsselectn)
 {
  isblock=modeicons[MODETEXT];
  posnicon(isblock,n,0,ox,oy);

  oldbuffer=isblock->data.indirecttext.buffer;
//   cprintf("string %s",fp->stuff+strlen(fp->stuff)+1);
  xmcpystring(sizeof(string),string,oldbuffer,fp->stuff+strlen(fp->stuff)+1);
  isblock->data.indirecttext.buffer=string;
  wimp_ploticon(fieldsbox[1].handle,isblock,NULL);
  isblock->data.indirecttext.buffer=oldbuffer;
 }

 return(NULL);
}






/* redraw macros pane */

static os_error * fieldsredrawsub(int handle,wimp_redrawstr * redrawstr,
                                                                 int more)
{
 int         oy;
 int         ox;
 int         ylo;
 int         yhi;
 int         n;
 int         y;
 fieldsstr * fp;

 while(more)
 {
  ox=redrawstr->box.x0-redrawstr->scx;
  oy=redrawstr->box.y1-redrawstr->scy;

  if(1)
  {
   ylo=-(redrawstr->g.y1-oy);            /* small number, top of window */
   yhi=-(redrawstr->g.y0-oy);            /* bigger, bottom of window */

   n=(ylo-MACFY)/MACDY;
   if(n<0) n=0;
   y=n*MACDY+MACFY;

   fp=findfieldn(n,fieldsp,fieldsn);

   while(y<=(yhi+MACFY) && n<curtot)
   {
//	cprintf("redfield 1");
    redfield(n,fp,ox,oy);
    y+=MACDY;
    n++;
//    cprintf("redfield 2");
    fp=(fieldsstr*)(((char*)fp)+fp->size);
//		cprintf("redfield 3");
   } 
  }
  wimp_get_rectangle(redrawstr,&more);
 }

 return(NULL);
 USE(handle);
}



static os_error * fieldsredraw(int handle,int userhandle)
{
 os_error       * err;
 wimp_redrawstr   redrawstr;
 int              more;

 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) fieldsredrawsub(handle,&redrawstr,more);
 return(err);
 USE(userhandle);
}





static void fieldsrefreshentry(int n)
{
 wimp_redrawstr r;
 int            more;

 r.box.x0=0;
 r.box.x1=MACWIDTH;
 r.box.y1=/*-MACFY*/-n*MACDY+cvdu.deltay;
 r.box.y0=r.box.y1-MACHY-cvdu.deltay-MACFY;
 r.w=fieldsbox[1].handle;

 wimp_update_wind(&r,&more);
 fieldsredrawsub(fieldsbox[1].handle,&r,more);
}





/* scroll window to show entry */

static void displayfield(int n)
{
 int yhi=-MACFY-n*MACDY;
 int ylo=-MACFY-(n+1)*MACDY;
 int wlo;
 int whi;
 windowstr window;

 getw(fieldsbox[1].handle,&window);

 whi=window.by-window.y1;
 wlo=window.by-window.y0;

 if(ylo<wlo || yhi>whi)
   openatscroll(fieldsbox[1].handle,0,
                           -MACFY-n*MACDY-MACDY/2+(window.y1-window.y0)/2);
}





static os_error * fieldsextent(void)
{
 os_error * err;
 int        sety;


 sety=MACFY+MACDY*curtot;
 if(sety<paneminy) sety=paneminy;

          err=extent(fieldsbox[1].handle,0,-sety,panemaxx,0);
 if(!err) err=extent(fieldsbox[0].handle,0,
                                       -fieldsminy,fieldsmaxx,sety-paneminy);

 if(!err) err=reopenw(fieldsbox[1].handle);
 if(!err) err=reopenw(fieldsbox[0].handle);

 return(err);
}



/* takes the selected macro, and stashes it */

static void fieldstash(void)
{
 char string[MAXICONLEN];
 
 if(fieldsselectn>=0)
 {
  readicon(fieldsbox[1].handle,XICON,string,sizeof(string));
  updatefield(fieldsselectn,string);
 }
}


/* we use this to put an icon over the given macro        */
/* n can be -1 in which case the icon goes somewhere safe */

static void fieldsselectone(int n,int x)
{
 wimp_icon     * isblock;
 fieldsstr     * fp;
 windowstr       window;
 wimp_icon       result;

 if(n>=0)
 {
  isblock=modeicons[MODETEXT];

  fp=findfieldn(n,fieldsp,fieldsn);

  getw(fieldsbox[1].handle,&window);

  posnicon(isblock,n,0,window.scx,-window.scy);

  wimp_move_icon(fieldsbox[1].handle,XICON,isblock,WMOVEICONSIZE);
  writeicon(fieldsbox[1].handle,XICON,fp->stuff+strlen(fp->stuff)+1);

  iecarrot(fieldsbox[1].handle,XICON);

  if(x<0) report(iecarrot(fieldsbox[1].handle,XICON));
  else    report(caret(fieldsbox[1].handle,XICON,x,0,-1,-1));
 }
 else
 {
  wimp_get_icon_info(fieldsbox[1].handle,XICON,&result);
  result.box.y0=-result.box.y0;
  result.box.y1=-result.box.y1;
  wimp_move_icon(fieldsbox[1].handle,XICON,&result,0);
 }
}



static void fieldsnewselect(int t,int x)
{
 int oldn;

 oldn=fieldsselectn;
 fieldstash();

 fieldsselectone(t,x);

 fieldsselectn=t;

 fieldsrefreshentry(fieldsselectn);

 if(oldn>=0) fieldsrefreshentry(oldn);
}


static void fieldsnewselectx(int t)
{
 fieldsnewselect(t,-1);
 displayfield(fieldsselectn);
}






/* key presses */

static os_error * fieldskey(int handle,int userhandle,int icon,int * key)
{
 int t;
 int ch;

 ch=*key;

 switch(ch)
 {
  case   CUP:
             if(fieldsselectn>0)
             {
              t=(fieldsselectn-1);
              fieldsnewselectx(t);
             }
             break;

 case  CDOWN:
 case RETURN:
             if(fieldsselectn<(curtot-1))
             {
              t=(fieldsselectn+1);
              fieldsnewselectx(t);
             }
             break;

     default:
//             return(txcbkey(key,handle,icon));
			 return(NULL);
             break;
 }


 *key=-1;
 return(NULL);

 USE(handle);
 USE(userhandle);
 USE(icon);
}



static os_error * fieldsdelete(void)
{

 if(fieldsselectn>=0)
 {
  remfield(fieldsselectn);
  curtot--;
  fieldsextent();
  if(fieldsselectn>=curtot) fieldsselectn=curtot-1;
  fieldsselectone(fieldsselectn,-1);
  refreshwindow(fieldsbox[1].handle);
 }

 return(NULL);
}







/* click on macros pane */

static os_error * fieldsicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error  * err;
 int         n;
 windowstr   window;
 int         x;
 int         y;
 wimp_icon * isblock;

 err=NULL;

 {
  getw(handle,&window);

  y=m->y-window.by;
  n=(-y-MACFY)/MACDY;
  if(!(n<0 || n>=curtot)) 
  {
   x=m->x-window.bx;

   if(m->bbits==wimp_BLEFT || m->bbits==wimp_BRIGHT)
   {
    isblock=modeicons[MODETEXT];

    if(x>=isblock->box.x0 && x<=isblock->box.x1)
    {
     fieldsnewselect(n,x);
    }
   }
  }
 }

 return(err);

 USE(userhandle);
}





/* close macros window */

static os_error * fieldsclose(int code)
{
 os_error    * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  err=modfile(cfile,-1);
  if(!err)
  {
   fieldstash();
   putfields(cfile);
  }
 }

 if(!err)
 {
  if(code!=DBAPPLY) 
  {
   clearfields();
   remkeyeventicon(fieldsbox[1].handle,XICON);
  }
 }

 return(err);
}








static os_error * newfield(int handle,int userhandle,wimp_mousestr * m)
{
 return(opennewfield());
 USE(userhandle);
 USE(handle);
 USE(m);
}




static os_error * delfield(int handle,int userhandle,wimp_mousestr * m)
{
 fieldsdelete();
 return(NULL);
 USE(userhandle);
 USE(handle);
 USE(m);
}








static os_error * fieldhelp(int handle,int userhandle,int icon,char ** p)
{
 windowstr   window;
 mousestr    mouse;
 wimp_icon * isblock;
 int         x;
 int         i;


 icon=-1;

 getw(handle,&window);
 getpointer(&mouse);

 x=mouse.x-window.bx;

 for(i=0;i<3;i++)
 {
  isblock=modeicons[i];
  if(isblock->box.x0<=x && isblock->box.x1>=x)
  {
   icon=i;
   break;
  }
 }

 *p=helpfindtagstring(userhandle,icon);

 return(NULL);
}




static dbiconstr fieldsicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,
    0, NULL,         DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)delfield,0,
    3, NULL,         DBACTION, 0,   0,      0,  0,  0,  0,(dbreadfn)newfield,0,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr fieldsbox[2]=
{
 0,
 TFIELDS,
 DBFIX,
 0,
 fieldsclose,
 NULL,
 NULL,
 NULL,
 fieldsicondefs,
 0,
 0,
 0,NULL,
 0,
 0,


 0,
 TFIELDSP,
 DBPANE,
 0,
 NULL,
 fieldsicon,
 fieldskey,
 fieldsredraw,
 NULL,
 0,
 0,
 0,NULL,
 fieldhelp,
 0,
};








/* click on menu, display macro window */
/* called with zero arg below          */


static os_error * openfieldss(dboxstr * parent,dbstackstr * dbstack,viewstr * view,int parenthandle)
{
 os_error * err;
 windowstr  window;
 int        pane;
 wimp_icon  result;
 int        i;

 err=NULL;

 if(fieldsbox[0].handle && cview==view)
 {
  dboxforward(fieldsbox);
 }
 else
 {
  if((view->file)->merge)
  {
   err=geterror(EMRG);
  }

  if(!err)
  {
   if(fieldsbox[0].handle)
   {
    dbclose(fieldsbox,DBCANCEL);
   }

   cview=view;
   cfile=view->file;
   fieldstack=dbstack;

   err=getfields(cfile);
   if(!err)
   {
    curtot=countfields(fieldsp,fieldsn);
    err=dodboxspparent(fieldsbox,2,parent,dbstack,parenthandle);
    if(!err) 
    {
     getw(fieldsbox[0].handle,&window);
     fieldsmaxx=window.x1-window.x0;
     fieldsminy=window.y1-window.y0;
   
     pane=fieldsbox[1].handle;
    
     getw(pane,&window);
     panemaxx=window.x1-window.x0;
     paneminy=window.y1-window.y0;

     for(i=0;i<3;i++)
     {
      wimp_lose_icon_info(&modeicons[i]);
      wimp_get_icon_info(pane,i,&result);
      wimp_copy_icon_info(&modeicons[i],&result);
      wimp_delete_icon(pane,i);
     }

     addkeyeventicon(pane,XICON);

     err=fieldsextent();

     fieldsselectn=-1;
     fieldsselectone(-1,-1);
    }
   }
  }
 }

 return(err);
}


os_error * openfields(viewstr * view,dboxstr * parent,dbstackstr * dbs,int parenthandle)
{
 return(openfieldss(parent,dbs,view,parenthandle));
}



void openfieldsx(int fp)
{
 zreport(openfields(menuview,fieldsbox,&ourfieldstack,menuview->handle));
 USE(fp);
}



static os_error * viewclose(int eventn,int user,viewstr * view,int data1)
{
 if(view==cview)
 {
  dbclose(fieldsbox,DBCANCEL);
  cview=NULL;
  cfile=NULL;
 }

 return(NULL);

 USE(eventn);
 USE(user);
 USE(data1);
}



os_error * dbfieldsinit(void)
{
 os_error * err;

 err=addevent(EVENT_VCLOSE,(eventfn)viewclose,0);

 return(err);
}



