/*->c.dbmarks */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "wimptext.h"
#include "trans.h"
#include "bf.h"
#include "csv.h"


#include "obj.h"



#include "dbhi.h"
#include "mhi.h"


#include "str.h"
#include "reslink.h"

#include "units.h"

#include "geometry.h"

#include "view.h"
#include "file.h"
#include "object.h"
#include "xpage.h"
#include "dbscale.h"
#include "xxcolour.h"
#include "dbchoices.h"


#include "colsep.h"




#include "xprint.h"
#include "psppd.h"

#include "dbmarks.h"





/***************************************************************************/



static markstr marks;
static markfn  markclosefn;





static os_error * marksclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  if(markclosefn) err=markclosefn(&marks);
 }

 return(err);
}



#define RTB (1+2)
#define RLR (4+8)

#define CTB (((1+2)<<4)+((1+2)<<8))
#define CLR (((4+8)<<4)+((4+8)<<8))



static dbiconstr marksicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

 /* Cancel */

    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,
    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,    0,0 ,NULL ,0,

    8,&marks.marks,  DBTOGGLE, 0,   0,      RTB,  F1,    0,  0,  NULL,   0,
    7,&marks.marks,  DBTOGGLE, 0,   0,      RLR,  F2,    0,  0,  NULL,   0,

    4,&marks.marks,  DBTOGGLE, 0,   0,      CTB,  F3,    0,  0,  NULL,   0,
    5,&marks.marks,  DBTOGGLE, 0,   0,      CLR,  F3,    0,  0,  NULL,   0,
  
   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};




static dboxstr marksbox=
{
 0,
 TPRINTMARKS,
 DBFIX,
 DBGRAB,
 marksclose,
 NULL,
 NULL,
 NULL,
 marksicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};



os_error * openmarksbox(dboxstr * parent,dbstackstr * dbs,
                                       markstr * xmarks,markfn xmarkfn)
{
 os_error * err;

 marks=*xmarks;
 markclosefn=xmarkfn;

 err=dodboxsp(&marksbox,1,parent,dbs);

 return(err);
}






/****************************************************************************/




static int xprintmode; /* 0==poll 1==don't poll */

static int xbleedsize;

static int xregthickness;

static int xprintmemory;

static int xprintbits;

static int xcrophlength;
static int xcrophstandoff;
static int xcropvlength;
static int xcropvstandoff;

static int xreghlength;
static int xregvlength;
static int xregradius;
static int xreghstandoff;
static int xregvstandoff;


static pschoicestr xpschoice;


static os_error * chprintclose(int code)
{
 if(code==DBOK || code==DBAPPLY)
 {
  printmode=xprintmode;
  printmode=0; // Win
  bleedsize=xbleedsize;
  regthickness=xregthickness;
  printmemory=xprintmemory;
  printbits=xprintbits;
  crophlength=xcrophlength;
  crophstandoff=xcrophstandoff;
  cropvlength=xcropvlength;
  cropvstandoff=xcropvstandoff;
  reghlength=xreghlength;
  regvlength=xregvlength;
  regradius=xregradius;
  reghstandoff=xreghstandoff;
  regvstandoff=xregvstandoff;
  defpschoice=xpschoice;
 }

 return(NULL);
}


/*
static os_error * outm(int value,char * string)
{
 strcpy(string,memstring(value));
 return(NULL);
}

*/

static os_error * outu(int value,char * string)
{
 strcpy(string,unitstostring(value,MILIMS));
 return(NULL);
}


static os_error * inu(int * value,char * string)
{
 return(stringtounits(string,value,MILIMS));
}


static os_error * chpsfn(pschoicestr * pschoice)
{
 xpschoice=*pschoice;
 return(NULL);
}



static os_error * chicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 if(m->i==33) err=openpostscriptchoice(&xpschoice,chpsfn,choicebox,&dbchoicestack);

 return(err);

 USE(handle);
 USE(userhandle);
}







static dbiconstr chprinticondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

//    3, &xprintmode,   DBTOGGLE, 0,    0,      1,  F1, 0, 0,  NULL,    0,

//   52, &xprintmemory, DBTEXT,   0,     0,    -1, -1, -1, -1, NULL, outm,
//    7, &xprintmemory, DBINC,    0,     0,   10*1024,-1,0x7FFFFFFF,0,NULL,0,
//    6, &xprintmemory, DBDEC,    0,     0,   10*1024,-1,0x7FFFFFFF,0,NULL,0,

    4, &xprintbits,   DBTOGGLE, 0,    0,  PRB_MERGE, F2,0,0, NULL,  NULL,
    8, &xprintbits,   DBTOGGLE, 0,    0,  PRB_CROPCHECK,F3,0,0,NULL,  NULL,
//   32, &xprintbits,   DBTOGGLE, 0,    0,PRB_PRESCAN, F4,0,0, NULL,  NULL,
																															
   32, &xprintbits,   DBTOGGLE, 0,    0,  PRB_PSDIRECT, F4,0,0, NULL,  NULL,

    9, &xbleedsize,   DBWRITE,  0,     0,    -1, -1, -1, -1,  inu, outu,
   13, &xregthickness,DBWRITE,  0,     0,    -1, -1, -1, -1,  inu, outu,
   15, &xcrophlength, DBWRITE,  0,     0,    -1, -1, -1, -1,  inu, outu,
   17, &xcrophstandoff,DBWRITE, 0,     0,    -1, -1, -1, -1,  inu, outu,
   19, &xcropvlength, DBWRITE,  0,     0,    -1, -1, -1, -1,  inu, outu,
   21, &xcropvstandoff,DBWRITE, 0,     0,    -1, -1, -1, -1,  inu, outu,
   23, &xreghlength,  DBWRITE,  0,     0,    -1, -1, -1, -1,  inu, outu,
   25, &xreghstandoff,DBWRITE,  0,     0,    -1, -1, -1, -1,  inu, outu,
   27, &xregvlength,  DBWRITE,  0,     0,    -1, -1, -1, -1,  inu, outu,
   29, &xregvstandoff,DBWRITE,  0,     0,    -1, -1, -1, -1,  inu, outu,
   31, &xregradius,   DBWRITE,  0,     0,    -1, -1, -1, -1,  inu, outu,


   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};




static dboxstr chprintbox=
{
 0,
 TCHPRINT,
 DBPANE,
 0,
 NULL,
 chicon,
 NULL,
 NULL,
 chprinticondefs,
 0,
 0,

 0,NULL,
 0,
 0,

};



static os_error * chprintopen(void)
{
 xprintmode=printmode;
 xbleedsize=bleedsize;
 xregthickness=regthickness;
 xprintmemory=printmemory;
 xprintbits=printbits;
 xcrophlength=crophlength;
 xcrophstandoff=crophstandoff;
 xcropvlength=cropvlength;
 xcropvstandoff=cropvstandoff;
 xreghlength=reghlength;
 xregvlength=regvlength;
 xregradius=regradius;
 xreghstandoff=reghstandoff;
 xregvstandoff=regvstandoff;
 xpschoice=defpschoice;

 return(NULL);
}





static subchoicestr chprint=
{
 NULL,

 &chprintbox,

 "ch_printer",
 "{CHPR}",

 chprintsave,
 chprintclose,
 NULL,
 chprintopen,
};




os_error * prchoicesinit(void)
{
 os_error * err;

 err=choicesadd(&chprint);

 return(err);
}



