/*->c.dbprint */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>
#include <limits.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "wimptext.h"
#include "trans.h"
#include "bf.h"
#include "csv.h"
#include "osprint.h"
#include "deb.h"
#include "load.h"

#include "obj.h"



#include "dbhi.h"
#include "mhi.h"


#include "str.h"
#include "reslink.h"

#include "units.h"

#include "geometry.h"

#include "view.h"
#include "file.h"
#include "object.h"
#include "xpage.h"
#include "dbscale.h"
#include "xxcolour.h"

#include "colsep.h"

#include "merge.h"


#include "prstr.h"

#include "xprint.h"
#include "pract.h"
#include "prf.h"
#include "preg.h"
#include "psppd.h"

#include "dbfields.h"
#include "dbmarks.h"

#include "dbprint.h"




#define TOPRULE  41
#define BOTRULE  42






static filestr * pfile;
static viewstr * pview;


static int prmode;
static int fit;

static int sideways;
static int reverse;
static int collate;

static int pause;
static int nopics;

static int all;
static int oddevenall;

static int options;

static int bleed;
static int marks;
static int marksbits;

static int reflect;
static int tumble;
static int printtofile;
static int printproxies;

static int copies;

static char ranges[PRRANGESIZE];


static int prscale;
static int aspect;

static int cx;
static int cy;

static int centre;

static int merge;

static int record;

static char mergepath[FILENAMELEN];

static int headings;    /* ignore headings record? */

static int  sheet;
static int  sheetn;
static int  sheetoddeven;

/*
static int thumbn;
static int tile;
static int draft;
*/

static int  contpages;

static int  nochange;


extern dboxstr print[1];




static os_error * getpr(filestr * file)
{
 oprintstr * opr;

 opr=(oprintstr*)fob_find(file->hdr.print,file);

 copies=opr->pr.copies;

 oddevenall=opr->pr.oddevenall;
 options=opr->pr.options;
 prmode=opr->pr.mode+(opr->pr.mode2<<4);
 prscale=opr->pr.scale;
 aspect=opr->pr.aspect;
 sideways=opr->pr.sideways;
 fit=opr->pr.fitx || opr->pr.fity;
 nopics=opr->pr.nopics;
 reverse=opr->pr.backwards;
 collate=opr->pr.collate;
 pause=opr->pr.pause;


 bleed=opr->pr.bleed;
 marks=opr->pr.regm;
 marksbits=opr->pr.marks;
 reflect=opr->pr.reflect;
 tumble=opr->pr.tumble;
 printtofile=opr->pr.printtofile;
	printproxies=opr->pr.printproxies;

 cx=opr->pr.cx;
 cy=opr->pr.cy;
 centre=opr->pr.centrex || opr->pr.centrey;

/* 
 draft=opr->pr.draft;
 thumbn=opr->pr.thumbn;
 tile=opr->pr.tile;
*/

 merge=opr->pr.merge;
 record=opr->pr.record;
 headings=opr->pr.headings;

 sheetn=opr->pr.sheetn+1;
 sheetoddeven=opr->pr.sheetoddeven+(opr->pr.sheetoddevenall<<1);


 all=opr->pr.all && !opr->pr.range;
 if(all) ranges[0]=0;
 else
 {
  if(!opr->pr.all) /* old file */
  {
   tsprintf(PRRANGESIZE,ranges,"%s {PR15} %s",opr->pr.froms,opr->pr.tos);
  }
  else
  {
   xzstrncpy(ranges,(char*)&opr->pr.from,sizeof(ranges));
  }
 }

 xzstrncpy(mergepath,opr->pr.mergepath,sizeof(mergepath));

 return(NULL);
}





static void makepr(oprintstr * opr)
{
 opr->pr.copies=copies;

 opr->pr.oddevenall=oddevenall;
 opr->pr.options=options;
 opr->pr.mode=prmode&0xF;
 opr->pr.mode2=prmode>>4;
 opr->pr.scale=prscale;
 opr->pr.aspect=aspect;

 opr->pr.sideways=sideways;
 opr->pr.fitx=fit;
 opr->pr.fity=fit;
 opr->pr.nopics=nopics;
 opr->pr.backwards=reverse;
 opr->pr.collate=collate;
 opr->pr.pause=pause;

 opr->pr.bleed=bleed;
 opr->pr.regm=marks;
 opr->pr.marks=marksbits;
 opr->pr.reflect=reflect;
 opr->pr.tumble=tumble;
 opr->pr.printtofile=printtofile;
 opr->pr.printproxies=printproxies;

 opr->pr.cx=cx;
 opr->pr.cy=cy;

 opr->pr.centrex=opr->pr.centrey=centre;

 opr->pr.all=1;
 opr->pr.range=!all;
 xzstrncpy((char*)&opr->pr.from,ranges,PRFROMSIZE);

 xzstrncpy(opr->pr.mergepath,mergepath,sizeof(opr->pr.mergepath));

 opr->pr.merge=merge;
 opr->pr.record=record;
 opr->pr.headings=headings;

 opr->pr.sheet=sheet;
 opr->pr.sheetn=sheetn-1;
 opr->pr.sheetoddeven=(sheetoddeven & 0x1);
 opr->pr.sheetoddevenall=(sheetoddeven>>1);
/* 
 opr->pr.thumbn=thumbn;
 opr->pr.tile=tile; 
 opr->pr.draft=draft;
*/

}



static os_error * putpr(filestr * file)
{
 oprintstr * opr;
 fob_mod(file->hdr.print,file,(fobjptr)&opr);
 makepr(opr);
 return(NULL);
}




static os_error * newout(int value,char * string)
{
 strcpy(string,numbertostring(value));
 return(NULL);
}


#define MAXCOPIES INT_MAX
#define MINCOPIES 1



static os_error * newin(int * value,char * string)
{
 return(stringtonumber(string,value));
}



/***************************************************************************/

extern dboxstr sheetbox[1];

static int sheetmax;
static int frontleft;
static int frontright;
static int backleft;
static int backright;




static os_error * sheetin(int * value,char * string)
{
 os_error * err;
 int        n;

 err=stringtonumber(string,&n);
 if(!err)
 {
  *value=CUT(n,1,sheetmax);
 }

 return(err);
}




static void prgetpage(int page,int section,int * n,filestr * file)
{
 pagestr    * pagep;
 sectionstr * sectionp;
 int          pn;

 if(page)
 {
  pagep=(pagestr*)fob_find(page,file);
  pn=pagep->data.number;
  sectionp=(sectionstr*)fob_find(section,file);
  *n=pn+((sectionp->data.number)<<16);
 }
 else
 {
  *n=-1;
 }
}



static void getpapernumbers(void)
{
 xpaperstr   paper;
 oprintstr   opr;

 opr=*((oprintstr*)fob_find(pfile->hdr.print,pfile));
 makepr(&opr);

 opr.pr.oddevenall=PRODD;

 paper.paper.n=2;

 prsetlogicalpage(&opr.pr,&paper.paper,sheetn-1,sheetmax,pfile,pview->branch);

 prgetpage(paper.paper.pset[0].page,
           paper.paper.pset[0].section,&frontleft,pfile);

 prgetpage(paper.paper.pset[1].page,
           paper.paper.pset[1].section,&frontright,pfile);

 opr.pr.oddevenall=PREVEN;

 prsetlogicalpage(&opr.pr,&paper.paper,sheetn-1,sheetmax,pfile,pview->branch);

 prgetpage(paper.paper.pset[0].page,
           paper.paper.pset[0].section,&backleft,pfile);

 prgetpage(paper.paper.pset[1].page,
           paper.paper.pset[1].section,&backright,pfile);
}



static os_error * chsheet(int handle,int userhandle,wimp_mousestr * m)
{
 getpapernumbers();

 dbchangevalue(&frontleft,sheetbox);
 dbchangevalue(&frontright,sheetbox);
 dbchangevalue(&backleft,sheetbox);
 dbchangevalue(&backright,sheetbox);

 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(m);
}


static os_error * pout(int value,char * string)
{
 if(value<0) *string=0;
 else
 {
  if(contpages) sprintf(string,"%d",value & 0xFFFF);
  else          sprintf(string,"%d/%d",value>>16,value & 0xFFFF);
 }
 return(NULL);
}



static os_error * sheetclose(int code)
{
 os_error * err;

 err=NULL;

 if((code==DBOK || code==DBAPPLY) && !inprinter)
 {
  merge=record=0;
  sheet=1;
  nochange=1;
  err=dbclose(print,code);
  nochange=0;
  if(!err) err=startprint(0,pview,pfile,pview->branch);
 }

 return(err);
}



static dbiconstr sheeticondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

    5, &sheetn,      DBINC,    0,   0,      1,-1,2,1,(dbreadfn)chsheet,   0,
    4, &sheetn,      DBDEC,    0,   0,      1,-1,2,1,(dbreadfn)chsheet,   0,

    3, &sheetn,      DBWRITE,  0,   DBASSOCINC,-1,-1,-1,-1,  sheetin,  newout,
    7, &sheetmax,    DBTEXT,   0,   0,     -1,-1,-1,-1,  NULL,   newout,

 /* Cancel */

    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,
    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,    0,0 ,NULL ,0,

    0,&sheetoddeven, DBRADIO, 0,    0,    PRODD,  F2,    1,  0,  NULL,   0,
   15,&sheetoddeven, DBRADIO, 0,    0,    PRALL,  F2,    1,  0,  NULL,   0,
    8,&sheetoddeven, DBRADIO, 0,    0,    PREVEN, F2,    1,  0,  NULL,   0,

   10,&frontleft,    DBTEXT,   0,   0,     -1,-1,-1,-1,  NULL,   pout,
   11,&frontright,   DBTEXT,   0,   0,     -1,-1,-1,-1,  NULL,   pout,
   12,&backleft,     DBTEXT,   0,   0,     -1,-1,-1,-1,  NULL,   pout,
   13,&backright,    DBTEXT,   0,   0,     -1,-1,-1,-1,  NULL,   pout,
  
   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};




static dboxstr sheetbox[1]=
{
 0,
 TPRINTSHEET,
 DBFIX,
 0,
 sheetclose,
 NULL,
 NULL,
 NULL,
 sheeticondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};



static os_error * openprintsheet(void)
{
 os_error * err;
 oprintstr  opr;

 err=dbreadvalues(print);
 if(!err)
 {
  opr=*((oprintstr*)fob_find(pfile->hdr.print,pfile));
  makepr(&opr);

  opr.pr.oddevenall=PRODD; // was sheetoddeven; and this has to be wrong because the answer can't depend on even/odd

  sheetmax=prcountpages(&opr.pr,pfile,pview->branch);
  sheetn=CUT(sheetn,1,sheetmax);

  sheeticondefs[0].data.stepbutton.max=
  sheeticondefs[1].data.stepbutton.max=sheetmax;

  getpapernumbers();

  err=dodboxsp(sheetbox,1,print,&dbviewstack);
 }
 return(err);
}



/***************************************************************************/


static os_error * marksclose(markstr * marks)
{
 marksbits=(marks->marks ^ 0xFFFFFFFF);
 return(NULL);
}


static os_error * openmarks(void)
{
 os_error * err;
 markstr    marks;

 marks.marks=marksbits ^ 0xFFFFFFFF;
 marks.thickness=regthickness;

 err=openmarksbox(print,&dbviewstack,&marks,marksclose);

 return(err);
}



/***************************************************************************/






static void dbscalefit(int xfit,int xcentre)
{
 oprintstr    opr;
 prscalestr   prs;
 int          width;
 int          height;
 int          oldcx;
 int          oldcy;
 int          oldscale;
 int          oldaspect;
 paperstr     paper;



 oldcx=cx;
 oldcy=cy;
 oldscale=prscale;
 oldaspect=aspect;

 if(fit || centre)
 {
  makepr(&opr);

  memset(&paper,0,sizeof(paperstr));

  prbox(&opr.pr,&paper,pfile,pview->branch);

  if(paper.marks)
  {
   praddmarks(&paper.cbox,&paper.cbox,paper.marks);
   getsumabox(&paper.mbox,&paper.cbox);
  }

  width =(paper.mbox.x1-paper.mbox.x0);
  height=(paper.mbox.y1-paper.mbox.y0);

  autoscalecentres(width,height,&opr.pr,&prs,printerarea());

  if(fit)
  {
   prscale=prs.yscale;
   aspect=scale(prs.xscale,0x10000,prs.yscale);
  }

  if(centre || fit)
  {
   cx=prs.xshift;
   cy=prs.yshift;
  }
 }

/*
 if(xfit || xcentre)
 {
  oprp=fob_find(pfile->hdr.print,pfile);

  if(xfit)
  {
   prscale=oprp->pr.scale;
   aspect=oprp->pr.aspect;
  }

  if(!centre && !fit)
  {
   cx=oprp->pr.cx;
   cy=oprp->pr.cy;
  }
 }
*/

 if(prscale!=oldscale) dbchangevalue(&prscale,print);
 if(aspect!=oldaspect) dbchangevalue(&aspect,print);
 if(cx!=oldcx)         dbchangevalue(&cx,print);
 if(cy!=oldcy)         dbchangevalue(&cy,print);

 USE(xfit);
 USE(xcentre);
}









static os_error * printicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 oprintstr  opr;
 int        propvalue;
 int        propmode;
 int        ok;
 int        prtype;

 err=NULL;


 switch(m->i)
 {

  case 16:  // print format
          err=dbreadvalues(print);
          opr=*((oprintstr*)fob_find(pfile->hdr.print,pfile));
          makepr(&opr);
          prfsetup(&opr.pr,pfile,pview->branch);

          err=openmenuparent("print_menu",handle);
          break;

  case 37:
          err=openprintsheet();
          break;

  case 38:
          err=opencolsep(pview,print);
          break;

  case 40:
          err=openmarks();
          break;

  case 47: // select printer
          err=openmenuparent("printers_menu",handle);
          break;

  case 48: // properties
          err=dbreadvalues(print);

          if(!err) err=osprgetcurrenttype(&prtype);
          if(!err)
          {
#ifdef NEVER
           if(prtype==PRPSTYPE && (printbits & PRB_PSDIRECT))
           {
            err=ps_properties(handle,print);

           }
           else
#endif
           {
            osxprintpropscale(scale(100,prscale,0x10000),NULL,PRPROP_WRITE,NULL);
            osxprintpropcopies(copies,NULL,PRPROP_WRITE,NULL);
            osxprintpropcollate(collate,NULL,PRPROP_WRITE,NULL);
            osxprintproporient(sideways,NULL,PRPROP_WRITE,NULL);

            err=osxprintpropertiesdbox(handle,&ok);

            if(!err && ok==0)
            {
             osxprintpropscale(0,&propvalue,PRPROP_READ,&propmode);
             if(propmode & PRPROP_SET)
             {
              if(!fit)
              {
               prscale=scale(0x10000,propvalue,100);
               dbchangevalue(&prscale,print);
              }
             }

             osxprintpropcopies(0,&propvalue,PRPROP_READ,&propmode);
             if(propmode & PRPROP_SET)
             {
              copies=propvalue;
              dbchangevalue(&copies,print);
             }

             osxprintpropcollate(0,&propvalue,PRPROP_READ,&propmode);
             if(propmode & PRPROP_SET)
             {
              collate=propvalue;
              dbchangevalue(&collate,print);
             }

             osxprintproporient(0,&propvalue,PRPROP_READ,&propmode);
             if(propmode & PRPROP_SET)
             {
              sideways=propvalue;
              dbchangevalue(&sideways,print);
             }

             // paper size may have changed, recalc fit to scale/center posn
             dbscalefit(!fit,0);
            }
           }
          }
          break;

 }

 return(err);

 USE(handle);
 USE(userhandle);
}



static os_error * printclose(int code)
{
 os_error  * err;
 int         change;
 int         pasteboard;
 oprintstr   opr;


 err=NULL;

 if((code==DBOK || code==DBAPPLY) && !inprinter)
 {

  if(!err) 
  {
   opr=*((oprintstr*)fob_find(pfile->hdr.print,pfile));

   change=(sideways!=(signed)opr.pr.sideways) ||
          (prscale!=opr.pr.scale)     ||
          (aspect!=opr.pr.aspect)     ||
          ((prmode & 0xF)!=(signed)opr.pr.mode) ||
          ((prmode >>4)!=(signed)opr.pr.mode2) ||
          (fit!=(opr.pr.fitx || opr.pr.fity)) ||
          (centre!=(opr.pr.centrex || opr.pr.centrey)) ||
          (bleed!=(signed)opr.pr.bleed) || /* maybe and !centred */
          (marks!=(signed)opr.pr.regm) ||
          (marks && marksbits!=(signed)opr.pr.marks) ||
          (cx!=opr.pr.cx) ||
          (cy!=opr.pr.cy);

   pasteboard=(marks!=(signed)opr.pr.regm || (marks && marksbits!=(signed)opr.pr.marks));

   if(!change) prfchange(&opr.pr,pfile,&change);

   if(change) prupdatefile(pfile,pasteboard,0);

   makepr(&opr);
   err=putpr(pfile);
   if(!err) err=prfupdate(&opr.pr,pfile);

   if(change) prupdatefile(pfile,pasteboard,1);
  }

  if(!nochange) modfile(pfile,-1);
 }

 return(err);
}


static os_error * printfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 if(!inprinter)
 {
  merge=record=sheet=0;
  nochange=1;
  err=dbclose(print,m->bbits==0x4?DBOK:DBAPPLY);
  nochange=0;
  if(!err)
  {
   err=startprint(0,pview,pfile,pview->branch);
  }
 }

 return(err);

 USE(handle);
 USE(userhandle);
 USE(m);
}



static os_error * wrpc(int value,char * string)
{
 strcpy(string,numbertostringxdp(value,2,2));
 return(NULL);
}


#define MINSCALE (0x10000/100)


static os_error * rdpcnz(int * value,char * string)
{
 os_error * err;
 int        rd;

 err=stringtonumberxdp(string,&rd,2,2);
 rd=FLOOR(rd,MINSCALE);
 *value=rd;

 return(err);
}


static os_error * outu(int value,char * string)
{
 strcpy(string,unitstostring(value,pview->data.units));
 return(NULL);
}

static os_error * inu(int * value,char * string)
{
 return(stringtounits(string,value,pview->data.units));
}


static void setall(viewstr * view)
{
 filestr    * file;
 int          section;
 sectionstr * sectionp;
 int          fromsect;
 int          tosect;
 int          page;
 pagestr    * pagep;
 int          from;
 int          to;
 char         temp1[PRRANGESIZE];
 char         temp2[PRRANGESIZE];


 if(all)
 {
  file=view->file;

  section=file->hdr.section[view->branch];

  sectionp=(sectionstr*)fob_find(section,file);

  fromsect=sectionp->data.number;
  page=sectionp->chain.child;
  pagep=(pagestr*)fob_find(page,file);
  from=pagep->data.number;

  while(sectionp->chain.next) 
  {
   section=sectionp->chain.next;
   sectionp=(sectionstr*)fob_find(section,file);
  }

  tosect=sectionp->data.number;

  page=sectionp->chain.child;
  pagep=(pagestr*)fob_find(page,file);
  while(pagep->chain.next)
  {
   page=pagep->chain.next;
   pagep=(pagestr*)fob_find(page,file);
  }

  to=pagep->data.number;

  if(contpages)
  {
   tsprintf(PRRANGESIZE,ranges,"%d {PR15} %d",from,to);
  }
  else
  {
   writepagenumber(temp1,fromsect,from);
   writepagenumber(temp2,tosect,to);
   tsprintf(PRRANGESIZE,ranges,"%s {PR15} %s",temp1,temp2);
  }

 }
}


static os_error * rangeout(int value,char * string)
{
 strcpy(string,ranges);
 return(NULL);
 USE(value);
}


static os_error * prreadpagerange(char * string,viewstr * view,
                                                int * range,int * max)
{
 os_error * err;

 err=readpagerange(string,range,max,view->file,view->branch);

/* {
  int i;

  for(i=0;i<(*max);i++)
  {
   dprintf(i,"%d - %d",range[i*2],range[i*2+1]);
  }
 } */

 return(err);
}





static os_error * rangein(int * value,char * string)
{
 os_error * err;
 int        range[PRRANGEMAX*2];
 int        max;

 err=prreadpagerange(string,pview,range,&max);
 if(!err) xzstrncpy(ranges,string,sizeof(ranges));
 return(err);
 USE(value);
}



static os_error * wrmode(int value,char * string)
{
 return(tsprintf(16,string,"%s",prmodestring(value)));
}


static void writesides(void)
{
 int bits;

 bits=prmodebits(prmode);

 if(bits & PRMDOUBLE)
 {
  writeiconf(print->handle,8,"{PR0C}");
  writeiconf(print->handle,9,"{PR0E}");
 }
 else
 {
  writeiconf(print->handle,8,"{PR0D}");
  writeiconf(print->handle,9,"{PR0B}");
 }

 shadeiconst(print->handle,21,(bits & PRMNOSCALETOFIT));
 shadeiconst(print->handle,37,(prmode!=PRPAM && prmode!=PRGAL && prmode!=PRPPAIR));
}



static micons[]={1,2,19,-1};



static os_error * optfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error    * err;
 wimp_wstate   wst;
 wimp_box      ibox;
 iconstr       iconb;
 iconstr       icont;
 int           shift;


 geti(handle,BOTRULE,&iconb);
 geti(handle,TOPRULE,&icont);

 err=geticonbox(handle,micons,&ibox);
 
 if((options && ibox.y1>iconb.iy1) || (!options && ibox.y1<iconb.iy1) || m==NULL)
 {
  err=wimp_get_wind_state(handle,&wst);
  if(m==NULL && !options) shift=0;
  else
  if(options)
  {
   shift=ibox.y1-(iconb.iy1-8);
  }
  else
  {
   shift=ibox.y1-(icont.iy1-8);
  }

  moveicongroup(handle,micons,0,-shift);

  wst.o.box.y0=wst.o.box.y1+ibox.y0-8-shift;

//  cprintf("dx %d",ibox.y0-8-shift);

  if(!err) wimp_open_wind(&wst.o);
 }

 if(!fit)            dbshade(2,options?0:DBWRITEG|DBSHADEG,print);
 if(!fit && !centre) dbshade(3,options?0:DBWRITEG|DBSHADEG,print);

 return(err);

 USE(userhandle);
 USE(m);
}



static os_error * allxfn(int handle,int userhandle,wimp_mousestr * m)
{

 if(all) 
 {
  setall(pview);
  dbchangevalue((int*)ranges,print);
 }


 dbshade(1,all?DBSHADEG|DBWRITEG:0,print);


 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(m);
}




static os_error * fitfn(int handle,int userhandle,wimp_mousestr * m)
{
             dbshade(2,fit?DBSHADEG|DBWRITEG:0,print);
 if(!centre) dbshade(3,(fit || centre)?DBSHADEG|DBWRITEG:0,print);

 dbscalefit(!fit,0);

 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(m);
}


static os_error * cenfn(int handle,int userhandle,wimp_mousestr * m)
{
 if(!fit) dbshade(3,(fit || centre)?DBSHADEG|DBWRITEG:0,print);
 dbscalefit(0,!centre);

 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(m);
}



static os_error * chkfit(int handle,int userhandle,wimp_mousestr * m)
{
 dbscalefit(0,0);
 return(NULL);
 USE(handle);
 USE(userhandle);
 USE(m);
}



static os_error * xwrprname(int value,char * string)
{

 return(osprgetcurrentname(string,256));

 USE(value);
}



os_error * prdbwritetitle(void)
{
 os_error  * err;
 char        string[256];

 err=NULL;

 if(print->handle)
 {
  dbscalefit(0,0);
  osprgetcurrentname(string,256);
  writeicon(print->handle,46,string);
 }

 return(err);
}




os_error * dbprintfix(int arg,int value)
{
 if(arg==1)
 {
  marks=value;
  dbchangevalue(&marks,print);
 }

 return(NULL);
}






static dbiconstr printicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */

 /* Set */

   19, NULL,         DBACTION, 0,   0,      DBOK,-1,0,0,     NULL ,0,
   36, NULL,         DBACTION, 0,   0,      DBOK,-1,0,0,     NULL ,0,

 /* Print */

    1, NULL,         DBACTION, 0,   0,      0,RETURN,0,0,(dbreadfn)printfn,0,

 /* Cancel */

    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,


   17,&copies,       DBWRITE,  0,   DBASSOCINC,      -1, -1, -1, -1,  newin,  newout,
   43,&copies,       DBDEC,    0,   0,      1,-1,MAXCOPIES,MINCOPIES,NULL,NULL,
   44,&copies,       DBINC,    0,   0,      1,-1,MAXCOPIES,MINCOPIES,NULL,NULL,

  
 /*18,&thumbn,       DBWRITE,  0,   0,      -1, -1, -1, -1,  newin,  newout,*/

 /*20,&tile,         DBWRITE,  0,   0,      -1, -1, -1, -1,  inu,    outu,*/

    4, NULL,         DBWRITENC,  1,   0,      -1, -1, -1, -1, rangein,rangeout,
/* 6,&to,            DBWRITENC,  1,   0,      -1, -1, -1, -1,    toin,toout, */


 /* N   &V           Type     Grp   Flags   Msk Key   ESG   -   clickfn 0 */

   18,&all,          DBRADIO, 0,    0,     1,  F2,    1,  0,(dbreadfn)allxfn,0,
    3,&all,          DBRADIO, 0,    0,     0,  F2,    1,  0,(dbreadfn)allxfn,0,


/* 15,&prmode,       DBRADIO, 0,    0,     0,  F2,    2,  0,  NULL,   0,
   16,&prmode,       DBRADIO, 0,    0,     1,  F2,    2,  0,  NULL,   0,
   17,&prmode,       DBRADIO, 0,    0,     2,  F2,    2,  0,  NULL,   0,
   19,&prmode,       DBRADIO, 0,    0,     3,  F2,    2,  0,  NULL,   0,*/


   15,&prmode,       DBTEXT,   0,   0,      0,  0,  0,   0,  NULL,   wrmode,

    7,&oddevenall,   DBRADIO, 0,    0, PRALL,  F2,    3,  0,  NULL,   0,
    8,&oddevenall,   DBRADIO, 0,    0, PRODD,  F2,    3,  0,  NULL,   0,
    9,&oddevenall,   DBRADIO, 0,    0,PREVEN,  F2,    3,  0,  NULL,   0,


 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */

   23, &prscale,     DBWRITE, 2,   0,      -1, -1, -1, -1,  rdpcnz,  wrpc,

 /*25, &prscale,  DBINC   ,2,   0,0x10000/100,-1,10*0x10000,0x10000/10,NULL,0,
  24, &prscale,  DBDEC   ,2,   0,0x10000/100,-1,10*0x10000,0x10000/10,NULL,0,*/

   25, &aspect,      DBWRITE, 2,   0,      -1, -1, -1, -1,  rdpcnz,  wrpc,

/* 30, &aspect,   DBINC   ,2,   0,0x10000/100,-1,10*0x10000,0x10000/10,NULL,0,
  29, &aspect,   DBDEC   ,2,   0,0x10000/100,-1,10*0x10000,0x10000/10,NULL,0,*/

   28, &cx,          DBWRITE, 3,   0,      -1, -1, -1, -1,  inu,   outu,

   30, &cy,          DBWRITE, 3,   0,      -1, -1, -1, -1,  inu,   outu,

   31, &sideways,    DBTOGGLE,0,    0,      1, F1,  0, 0,(dbreadfn)chkfit,0,
   21, &fit     ,    DBTOGGLE,4,    0,      1, F1,  0, 0,(dbreadfn)fitfn,0,
   13, &nopics  ,    DBTOGGLE,0,    0,      1, F1,  0, 0,      NULL,   0,
   11, &reverse ,    DBTOGGLE,0,    0,      1, F1,  0, 0,      NULL,   0,
   12, &collate ,    DBTOGGLE,0,    0,      1, F1,  0, 0,      NULL,   0,
   10, &pause   ,    DBTOGGLE,0,    0,      1, F1,  0, 0,      NULL,   0,

/* 10, &merge   ,    DBTOGGLE,0,    0,      1, F1,  0, 0,      NULL,   0, */

   26, &centre  ,    DBTOGGLE,0,    0,      1, F1,  0, 0,(dbreadfn)cenfn,0,
                    
   20, &options,     DBTOGGLE,0,    0,      1, F1,  0, 0,(dbreadfn)optfn,0,

   32, &bleed,       DBTOGGLE,0,    0,      1, F1,  0, 0,(dbreadfn)chkfit,0,
   33, &marks,       DBTOGGLE,0,    0,      1, F1,  0, 0,(dbreadfn)chkfit,0,

   39, &reflect,     DBTOGGLE,0,    0,      1, F1,  0, 0,      NULL,   0,
   34, &printtofile, DBTOGGLE,0,    0,      1, F1,  0, 0,      NULL,   0,

   45, &tumble,      DBTOGGLE,0,    0,      1, F1,  0, 0,      NULL,   0,      

   46, NULL,         DBTEXT,  0,    0,     -1,-1,-1,-1,        NULL, xwrprname,   

   50, &printproxies, DBTOGGLE,0,    0,      1, F1,  0, 0,      NULL,   0,


   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};





static dboxstr print[1]=
{
 0,
 TPRINT,
 DBFIX,
 0,
 printclose,
 printicon,
 NULL,
 NULL,
 printicondefs,
 0,
 0,
 1,
 NULL,
 0,
 0,
};




os_error * openprintdbox(viewstr * view)
{
 os_error * err;
 oprintstr  opr;
 int        bits;

 err=NULL;

 pfile=view->file;
 pview=view;

 getpr(pfile);
 sheet=0;
 opr=*((oprintstr*)fob_find(pfile->hdr.print,pfile));
 if(!prvalidmode(prmode)) prmode=opr.pr.mode=opr.pr.mode2=0;

 bits=prmodebits(prmode);
 if(bits & PRMNOSCALETOFIT) fit=0;

 contpages=contnum(pfile,pview->branch);

 setall(view);

 dodboxspparent(print,1,print,&dbviewstack,pview->handle);

 err=prdbwritetitle();
 optfn(print->handle,0,NULL);
 allxfn(print->handle,0,NULL);

 dbshade(2,(!options || fit)?DBSHADEG|DBWRITEG:0,print);
 dbshade(3,(fit || centre || !options)?DBSHADEG|DBWRITEG:0,print);

 shadeiconst(print->handle,38,!colsepactive());

 prsetfromfile(&opr.pr,pfile);

 writesides();

 return(err);
}


void setprintmode(int fp)
{
 int         xscale;
 int         xsideways;
 int         bits;
 oprintstr   opr;


 prmode=prfmodefromindex(stack[fp]);
 dbchangevalue(&prmode,print);

 opr=*((oprintstr*)fob_find(pfile->hdr.print,pfile));
 makepr(&opr);
 prsetmode(&opr.pr,pfile,&xscale,&xsideways);

 bits=prmodebits(prmode);

 if((bits & PRMSETORIENTATION))
 {
  sideways=xsideways;
  dbchangevalue(&sideways,print);
 }

 if((bits & PRMSETSCALE))
 {
  if(!fit)
  {
   prscale=xscale;
   dbchangevalue(&prscale,print);
  }
 }

 if(bits & PRMNOSCALETOFIT)
 {
  if(fit)
  {
   fit=0;
   dbchangevalue(&fit,print);
   dbshade(2,fit?DBSHADEG|DBWRITEG:0,print);
   if(!centre) dbshade(3,(fit || centre)?DBSHADEG|DBWRITEG:0,print);
  }
 }

 dbscalefit(0,0);

 writesides();

 makepr(&opr);
 prfsetup(&opr.pr,pfile,0);
}



int getprintmode(int fp)
{
 return(prfindexfrommode(prmode));
 USE(fp);
}


void printbox(int fp)
{
 zreport(openprintdbox(menuview));
 USE(fp);
}



/**************************************************************************/

extern dboxstr mergebox[1];


#define MSTATENONE   0
#define MSTATEOPEN   1
#define MSTATENOFILE 2

static int mergestate;



static os_error * outpath(int value,char * string)
{
 strcpy(string,mergepath);
 return(NULL);
 USE(value);
}


static os_error * inpath(int * value,char * string)
{
 cprintf("inpath %s",string);
 xzstrncpy(mergepath,string,sizeof(mergepath));
 return(NULL);
 USE(value);
}



static os_error * mergeshade(void)
{
 dbshade(1,(mergestate!=MSTATENONE)?DBSHADEG:0,mergebox);
 dbshade(2,(mergestate!=MSTATENONE)?0:DBSHADEG,mergebox);
 return(NULL);
}


static os_error * recordfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 merge=sheet=0;

          err=putpr(pfile);
 if(!err) err=startprint(0,pview,pfile,pview->branch);

 return(err);

 USE(handle);
 USE(userhandle);
 USE(m);
}


/* called below with m==NULL */

static os_error * clearfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 if(mergestate!=MSTATENONE)
 {
  if(mergestate==MSTATEOPEN) err=mergeclose(pfile);
  else                       err=mergefinish(pfile);
  mergestate=0;
  mergeshade();
 }

 return(err);

 USE(handle);
 USE(userhandle);
 USE(m);
}




static os_error * nextsubfn(int record)
{
 os_error * err;
 int        eof;

 err=NULL;

 if(mergestate==MSTATEOPEN)
 {
  err=mergeseek(record,pfile,&eof);
  if(eof)
  {
   err=mergeclose(pfile);
   mergestate=0;
   mergeshade();
  }
 }
 else
 if(mergestate==MSTATENOFILE)
 {
  err=mergeupdate(NULL,pfile);
 }

 return(err);
}


static os_error * nextfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=nextsubfn(-1);

 return(err);

 USE(handle);
 USE(userhandle);
 USE(m);
}



static os_error * firstfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 if(!mergestate)
 {
  dbreadvalues(mergebox);

  if(strlen(mergepath))
  {
   err=mergeopen(mergepath,pfile);
   if(!err) mergestate=MSTATEOPEN;
  }
  else
  {
   err=mergestart(pfile);
   if(!err) mergestate=MSTATENOFILE;
  }

  if(!err)
  {
   mergeshade();
  }
 }

 if(!err) err=nextsubfn(headings?1:0);

 return(err);

 USE(handle);
 USE(userhandle);
 USE(m);
}





static os_error * fixfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 if(mergestate!=MSTATENONE)
 {
  err=mergeclear(pfile);
  if(mergestate==MSTATEOPEN) err=mergeclose(pfile);
  else                       err=mergefinish(pfile);
  mergestate=MSTATENONE;
  mergeshade();
 }

 return(err);

 USE(handle);
 USE(userhandle);
 USE(m);
}




static os_error * allfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 if(!inprinter)
 {
  record=-1;
  merge=1;
  sheet=0;

  clearfn(handle,userhandle,m);

  err=dbclose(mergebox,m->bbits==0x4?DBOK:DBAPPLY);
  if(!err)
  {
   err=startprint(0,pview,pfile,pview->branch);
  }
 }

 return(err);
 USE(handle);
 USE(userhandle);
 USE(m);
}



static os_error * mergeloadtype(char * name,int type,mousestr * m,int userhandle,
                                                      int * method)
{
 if(!(*method)) 
 {
  *method=1;
 }

 return(NULL);
 USE(type);
 USE(m);
 USE(userhandle);
 USE(name);
}



#define MFNIC 3

static os_error * mergeload(char * name,int type,int userhandle,int xvolatile)
{
 if(!xvolatile)
 {
  if(mergestate==MSTATENONE) writeicon(mergebox->handle,MFNIC,name);

 }
 return(NULL);
 USE(userhandle);
 USE(type);
}



static os_error * savepath(char * name,int type,int userhandle,int xvolatile)
{
 os_error * err;

 err=writeicon(mergebox->handle,3,name); 
 
 return(err);

 USE(type);
 USE(userhandle);
 USE(xvolatile);
}





// click on path arrow

static os_error * mergepathfn(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;
 loadoptstr opts[2];
 int        xtype=-1;
 int        csvtype=CSV;
 int        copt;
 char       name[FILENAMELEN];


 opts[0].description="CSV (*.csv)";
 opts[0].ntypes=1;
 opts[0].types=&csvtype;

 opts[1].description="All files (*.*)";
 opts[1].ntypes=1;
 opts[1].types=&xtype;

 readicon(mergebox->handle,3,name,sizeof(name)); 

 err=openloadparent(name,&copt,opts,2,savepath,0,pview->handle);

 return(err);

 USE(handle);
 USE(m);
 USE(userhandle);
}












static os_error * mergeicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 if(m->i==6)  err=openfields(pview,mergebox,&dbviewstack,0);
 else
 if(m->i==11)
 {
  dbreadvalues(mergebox);
  cprintf("path %s",mergepath);
  err=putpr(pfile);
 }

 return(err);

 USE(handle);
 USE(userhandle);
}






static os_error * mergedbclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  err=putpr(pfile);
 }

 if(!err && (code==DBOK || code==DBCANCEL))
 {
  remdataload(mergebox->handle,0,mergeload);
  remdataloadtype(mergebox->handle,0,mergeloadtype);
  clearfn(mergebox->handle,0,NULL);
 }

 return(err);
}



static dbiconstr mergeicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key -  -       Clickfn 0 */


 /* Next */

    7, NULL,         DBACTION, 2,   0,        0,-1,0,0,(dbreadfn)nextfn,0,

 /* Print record */

    5, NULL,         DBACTION, 2,   0,        0,-1,0,0,(dbreadfn)recordfn,0,

 /* First */

    4, NULL,         DBACTION, 1,   0,        0,-1,0,0,(dbreadfn)firstfn,0,

 /* Clear */

    8, NULL,         DBACTION, 2,   0,        0,-1,0,0,(dbreadfn)clearfn,0,


 /* Fix */

    9, NULL,         DBACTION, 2,   0,        0,-1,0,0,(dbreadfn)fixfn,0,


   10, &headings,    DBTOGGLE, 0,   0,        1,  F1,    0,  0,  NULL,   0,



 /* Print all */

    1, NULL,         DBACTION, 0,   0,        0,RETURN,0,0,(dbreadfn)allfn,0,

 /* Cancel */

    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,


MFNIC,NULL,DBWRITENC,0,   0,      -1, -1, -1, -1,  inpath,outpath,

   13, NULL,         DBACTION, 0,   0,      0,0, 1,0, (dbreadfn)mergepathfn,0,
  
   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr mergebox[1]=
{
 0,
 TMAILMERGE,
 DBFIX,
 0,
 mergedbclose,
 mergeicon,
 NULL,
 NULL,
 mergeicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};



static os_error * openprintmerge(viewstr * view)
{
 os_error  * err;

 pfile=view->file;
 pview=view;

 err=getpr(pfile);
 if(!err)
 {
//  findtemp(TMAILMERGE,&w);
//  i=(wimp_icon *)((char*)w+sizeof(wimp_wind));
//  i[1].data.indirecttext.buffer=mergepath;
//  i[1].data.indirecttext.bufflen=sizeof(mergepath);

  err=dodboxspparent(mergebox,1,mergebox,&dbviewstack,pview->handle);
  if(!err)
  {
   adddataload(mergebox->handle,0,mergeload);
   adddataloadtype(mergebox->handle,0,mergeloadtype);
   mergeshade();
  }
 }

 return(err);
}


void printmergebox(int fp)
{
 zreport(openprintmerge(menuview));
 USE(fp);
}



