/*->c.act */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  
#include <ctype.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "font.h"

#include "transform.h"

#include "etc.h"
#include "err.h"
#include "wos.h"
#include "poll.h"
#include "key.h"
#include "fsx.h"
#include "bf.h"
#include "timex.h"
#include "dbhi.h"
#include "xmath.h"
#include "colour.h"
#include "deb.h"
#include "bits.h"

#include  "xext.h"


#include "str.h"
#include "constants.h"

#include "obj.h"
#include "object.h"
#include "chain.h"
#include "posn.h"

#include "main.h"
#include "file.h"

#include "view.h"
#include "viewr.h"
#include "viewo.h"
#include "dbscale.h"
#include "tools.h"

#include "caret.h"
#include "clip.h"

#include "xcolour.h"
#include "undo.h"
#include "geometry.h"
#include "xredraw.h"
#include "curve.h"

#include "select.h"
#include "frameflow.h"
#include "new.h"


#include "pxstr.h"
#include "pict.h"



#include "txstr.h"
#include "codes.h"
#include "tx.h"
#include "fox.h"
#include "vec.h"
#include "sx.h"
#include "vl.h"
#include "texttool.h"
#include "fx.h"
#include "style.h"
#include "fl.h"
#include "spell.h"
#include "spchk.h"
#include "txchoices.h"
#include "stylemap.h"
#include "styleif.h"
#include "mx.h"
#include "dbstyle.h"
#include "textimport.h"
#include "find.h"

#include "th.h"


#include "txdd.h"

#include "act.h"




#define AUNDO_LEFT  14
#define AUNDO_RIGHT 15
#define AUNDO_UP    16
#define AUNDO_DOWN  17


#define SSHIFTKEY   F12




/* control of caret, active text object, marking etc. */

/* vector for caret */

vector    act;
vector    zon;
int       zone;     /* zone exists?                    */
vector  * lozon;  /* zone vector with lowest offset  */
vector  * hizon;  /* zone vector with highest offset */


static int oldccx=-1;



absstylestr   txastyle;


/* make sure caret is on screen */

os_error * screenvector(vector * s,viewstr * view)
{
 os_error * err;
 int        wlox;
 int        whix;
 int        wloy;
 int        whiy;
 int        wwidth;
 int        wwheight;
 int        wcx;
 int        wcy;
 int        oscx;
 int        oscy;
 int        scx;
 int        scy;
 int        cheight;
 int        cwidth;
 int        maxshift;
 vlstr    * vline;
 boxstr     box;
 boxstr     maxbox;
 int        xpo;
 int        ypo;
 sectionstr * sectionp;
 int        vs;


 err=NULL;

 if(s->valid==VVECTOR && view && view->file==s->file)
 {
  sectionp=(sectionstr*)fob_find(s->section,s->file);
  if((int)sectionp->branch==view->branch)
  {
   getpagecoords(view,s->page,s->section,&xpo,&ypo);

   vline=vlptr(s->textsrc.vsourcep,s->textsrc.voffset);
   vs=getvshift(s);

   box.x=s->textsrc.textp->fcurve.box.x+s->x;
   box.y=s->textsrc.textp->fcurve.box.y+LY(vline->line.yy)+vs; /* s->y; */
   box.h=vline->line.h;
   box.w=0;

   getmaxbox(&maxbox,&box,&(s->textsrc.textp->data.transform));

   cheight=osunits(maxbox.h,view);
   cwidth=osunits(maxbox.w,view);

   oscx=scx=view->mainwindow.scx;       //mainpane
   oscy=scy=view->mainwindow.scy;

   wcx=view->mainwindow.bx+osunits(xpo+maxbox.x,view);
   wcy=view->mainwindow.by-osunits(ypo+maxbox.y,view); /* top of caret */

   wwidth=view->mainwindow.x1-(view->mainwindow.x0-view->extent.x0);
   wwheight=(view->mainwindow.y1-view->extent.y1)-view->mainwindow.y0;
   wlox=view->mainwindow.x0-view->extent.x0;
   whix=view->mainwindow.x1;
   wloy=view->mainwindow.y0;
   whiy=view->mainwindow.y1-view->extent.y1;

   if(cwidth>wwidth)
   {
    scx=osunits(xpo+maxbox.x,view)-cwidth/2+wwidth/2;
   }
   else
   if(wcx<wlox) 
   {
    maxshift=whix-(wcx+cwidth);
    if(maxshift>(wwidth/4)) maxshift=wwidth/4;

    if((wlox-wcx)<maxshift) scx-=maxshift;
    else                    scx-=(wlox-wcx)+maxshift;
   }
   else
   if((wcx+cwidth)>whix) 
   {
    maxshift=(wcx-wlox)/2;
    if(maxshift>(wwidth/4)) maxshift=wwidth/4;

    if((wcx+cwidth-whix)<maxshift) scx+=maxshift;
    else                           scx+=(wcx+cwidth-whix)+maxshift;
   }

   if(cheight>wwheight)
   {
    scy=-osunits(ypo+maxbox.y,view)-cheight/2+wwheight/2;
   }
   else
   if((wcy-cheight)<wloy) 
   {
    maxshift=(whiy-wcy)/2;
    if(maxshift>(wwheight/4)) maxshift=wwheight/4;

    if((wloy-wcy+cheight)<maxshift) scy-=maxshift;
    else                            scy-=(wloy-wcy+cheight)+maxshift;
   }
   else
   if(wcy>whiy)
   {
    maxshift=((wcy-cheight)-wloy)/2;
    if(maxshift>(wwheight/4)) maxshift=wwheight/4;

    if((wcy-whiy)<maxshift)         scy+=maxshift;
    else                            scy+=(wcy-whiy)+maxshift;
   }

   if(oscy!=scy || oscx!=scx) viewopenat(view,view->file,scx,scy);
  }
 }

 return(err);
}





os_error * screencaret(vector * s)
{
 return(screenvector(s,caretview));
}




static os_error * returntocaret(void)
{
	os_error * err;
	vector     s;

	err=NULL;

 if(act.valid)
 {
		s=act;
  err=txlock(&s.textsrc,s.file);
  if(!err)
  {
   screenvector(&s,caretview);
   txunlock(&s.textsrc,s.file);
		}
	}

	return(err);
}




static os_error * setxya(vector * s)
{
 os_error * err;
 err=vsetxy(s);
 oldccx=s->x;
 return(err);
}


os_error * setxa(vector * s)
{
 oldccx=s->x;
 return(NULL);
}



/* v is locked */

static os_error * checkboxselected(vector * v)
{
 posnstr posn;
 int     object;
 int     n;

 n=nselected(&object,v->file);

 if(!n || !(object==v->textsrc.text || 
            objectinobject(v->textsrc.text,object,v->file)))
 {
  vector2posn(&posn,v);

  clearselection();

  objectselect((objhdrstr *)v->textsrc.textp,&posn,SELECTOBJECT);
 }

 return(NULL);
}



/* beware, vector v should be locked ! */

/* for drop caps we rely on vector code setting y as if normal text          */
/* a better alternative would be to make it set y to zero relative to line   */
/* the correct solution of actually setting y to the baseline would not help */
/* unless the vector carried the true height of the text                     */


os_error * setupcaret(vector * v,absstylestr * astyle)
{
 int          x;
 int          y;
 int          h;
 int          l;
 vlstr      * vline;
 char       * p;
 int          base;
 int          height;
 int          offset;
 int          c;
 int          eoffset;
 int          sn;



 if(v->valid==VVECTOR && v->textsrc.voffset<(v->textsrc.vsourcep)->len)  // changed to prevent access past end of vl buffer
 {
  x=v->textsrc.textp->fcurve.box.x+v->x;
  y=v->textsrc.textp->fcurve.box.y+v->y;

  vline=vlptr(v->textsrc.vsourcep,v->textsrc.voffset);

  p=NULL;
 
  if(vline->line.object)
  {
   offset=v->textsrc.loffset;
   while(offset<v->textsrc.offset)
   {
    c=*(p=txptr(v->textsrc.sourcep,offset));
    offset+=codex[c] & CODELEN;
   }
  }

  if(p && (*p==EOB))
  {
   height=(*(p+15))+((*(p+16))<<8)+((*(p+17))<<16);
   base=(*(p+21))+((*(p+22))<<8)+((*(p+23))<<16)+((*(p+24))<<24);
   base=scale(height,base,0x10000);

   y-=base;
   l=h=height;
  }
  else
  {
  /* if there are SNO's between caret and first text, height will be wrong */

   offset=v->textsrc.loffset;
   eoffset=offset+vline->line.len;
   sn=0;
   while(offset<eoffset)
   {
    c=*(p=txptr(v->textsrc.sourcep,offset));
    if(c!=SNO) break;
    sn=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);
    offset+=codex[c] & CODELEN;
   }

   if(offset>v->textsrc.offset && sn)
   {
    findabsstylep(v->file,sn,&astyle);
   }

  /* caret is from baseline+l to baseline+l-h */

   if(vline->line.eol==ISDROP)
   {
    y-=astyle->style.data.lead;
    h=astyle->style.data.dropno*astyle->style.data.height;
    l=0;
   }
   else
   {
    h=astyle->style.data.height;
    l=astyle->style.data.lead;
   }

   y-=astyle->style.data.baseshift;
  }

  /*backcol=findcolourtint(v->file,&v->textsrc.textp->data.colour); */
  posncaret(v->file,v->page,x,y,h,l,
                            0,&v->textsrc.textp->data.transform);
 }
 else
 {
  clearcaret();
 }

 return(NULL);
}





static os_error * setactives(vector * v,int pcaret)
{
 int          wasvalid;

 checkboxselected(v);
 wasvalid=act.valid;

 act=*v;

 getcaretstyle(v,&txastyle);

 if(pcaret) setupcaret(v,&txastyle);

 stylesetall(&txastyle.style);

 if(!wasvalid) txactchange();
 else          txactstylechange(0x2);

 return(NULL);
}



os_error * setactive(vector * v)
{
 return(setactives(v,1));
}



/* beware, vector v is not locked ! */

static os_error * checkactive(vector * v)
{
 os_error * err;
 vector     s;

 act=*v;
 s=*v;

 err=txlock(&s.textsrc,s.file);
 if(!err)
 {
  err=checkboxselected(&s);
  txunlock(&s.textsrc,s.file);
 }

 return(err);
}



os_error * resetactive(void)
{
 os_error * err;
 vector     s;

 s=act;

 err=txlock(&s.textsrc,s.file);
 if(!err)
 {
  err=setactive(&s);
  txunlock(&s.textsrc,s.file);
 }

 return(err);
}




os_error * txmodvec(vector * v)
{
 os_error   * err;
 texhdr     * texhp;
 textboxstr * textp;
 int          u;

 err=NULL;

 textp=v->textsrc.textp;

 if(textp->master)
 {
  u=v->textsrc.u;

  if(u==0)
  {
   if(textp->flags.masterdata)
   {


    textp->flags.masterdata=0;
   }
  }
  else
  {
   texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));

   if(u==1)
   {
    if(texhp->headerdata)
    {

     texhp->headerdata=0;
    }
   }
   else
   if(u==2)
   {
    if(texhp->footerdata)
    {

     texhp->footerdata=0;
    }
   }
  }
 }

 return(err);
}





typedef struct saveactstr
{
 vector v;
 int    offset;
} saveactstr;



static os_error * unsaveacts(int code)
{
 saveactstr sa;

/* dprintf(0,"unsave act %d",code); */

 if(act.valid)
 {
  actclearpend();
  spclearpend();

  sa.v=act;
  if(zone) sa.offset=zon.textsrc.offset;
  else     sa.offset=act.textsrc.offset;

  return(undowritefn(act.file,code,&sa,sizeof(saveactstr)));
 }
 else
  return(NULL);
}


os_error * unsaveact(void)
{
 return(unsaveacts(UACTPOSN));
}


/* used by undo fix to save tool posn on file save */

os_error * txsaveact(filestr * file)
{
 if(act.valid && act.file==file) unsaveact();
 return(NULL);
}


static os_error * unloadact1(filestr * file)
{
 os_error * err;
 saveactstr sa;
 vector     s;

 err=undoread(file,&sa,sizeof(saveactstr));

 if(!err)
 {
  sa.v.file=file;

  if(sa.offset==sa.v.textsrc.offset)
  {
   unselects(0);
   toolclaimsubtool(file,OTEXTBOX);

   err=txlock(&sa.v.textsrc,file);

  /* dprintf(2,"text=%d p=%x valid=%d",sa.v.textsrc.text,
                                     sa.v.textsrc.textp,
                                     sa.v.valid);  */
  /* setxya(&sa.v);  */

   setactive(&sa.v);
   screencaret(&sa.v);

   txunlock(&sa.v.textsrc,file);

   event(EVENT_SUBTOOL,file,sa.v.textsrc.text);
  }
  else
  {
   s=sa.v;
   movevector(&s,sa.offset);
   setupzone(&sa.v,&s);
  }

  txactchange();
 }
 return(err);
}



static os_error * unloadact(filestr * file)
{
 os_error * err;

/* dprintf(0,"uload act in"); */

          err=unsaveact();
 if(!err) err=unloadact1(file);

/* dprintf(0,"uload act xx\n\n\n"); */

 return(err);
}



/* tidy active sources */

static os_error * actclose(void)
{
 os_error * err;

 err=NULL;

 if(act.valid)
 {
  err=txclosesrc(&act.textsrc,act.file);
 }

 return(err);
}



static os_error * clearactives(int code)
{
/* dprintf(0,"clear actives %d code=%d",act.valid,code); */

 if(act.valid)
 {
  unsaveacts(code);
  unselects(0);
  clearcaret();
  actclose();
  act.valid=0;
  txactchange();
 }

/* dprintf(0,"clear actives x\n\n"); */

 return(NULL);
}


os_error * clearactive(void)
{
 return(clearactives(UACTPOSN));
}



os_error * clearactiveff(int object,filestr * file)
{
 if(act.valid)
 {
  if(act.textsrc.text==object && act.file==file)
  {
   clearactive();
  }
 }
 return(NULL);
}





/* NB calling this on a vector that will be locked */

os_error * makeactive(vector * s)
{
 os_error * err;
 filestr  * file;

 file=s->file;

 if(act.valid && 
    act.file==file &&
    s->textsrc.source==act.textsrc.source &&
    s->textsrc.offset==act.textsrc.offset && !zone) return(NULL);

 err=undostart(file);
 if(!err)
 {
  err=clearactive();
  if(!err)
  {
   toolclaimsubtool(file,OTEXTBOX);

   err=txlock(&s->textsrc,file);
   if(!err)
   {
    err=setactive(s);
    if(!err) err=setxa(s);
    txunlock(&s->textsrc,file);
    txactchange();
   }

			event(EVENT_SUBTOOL,file,s->textsrc.text);
  }

  undoend(file);
 }

 return(err);
}


/* used on opening document, sets x,y */

os_error * makeactive2(vector * v)
{
 os_error * err;

 err=txlock(&v->textsrc,v->file);
 if(!err)
 {
  flowvalidate(v,FLVBOX);

  setxya(v); 
  setactive(v);
  screencaret(v);

  txunlock(&v->textsrc,v->file);
  txactchange();
 }

 return(err);
}

/*****************************************************************************/
/* block of functions concerned with inserting stuff                         */


/*

  There can be problems with changes of selection clearing the act vector

*/


/* tagged to UINSERTS */
/* this function is always called last in undo/redo */

static os_error * uninserts(filestr * file) 
{
 vector     s1;
 vector     s2;
 flowstr    fl;
 int        offset[2];
 int        coffset;
 int        cdelta;
 int        hoffset;
 os_error * err;


 act.valid=VVECTOR;
 s1=act;


 unselects(0); 

 undoread(file,offset,2*sizeof(int));

 txundoend(&coffset,&hoffset,&cdelta,file);

 fl.opcode=FLV0|FDATA|FSUB;

 /*if(backflow)*/ fl.opcode|=FLPREV; /*need this but don't know how to get it*/

 /* problems here if cdelta is zero, but text is changed                */
 /* a delta flow can't really have a length - or else dirty flow anyway */

 /* major problem is that s1==act may not be at the start of insert */

 if(coffset>=0)
 {
  if(coffset<s1.textsrc.offset)
  {
   err=txlock(&s1.textsrc,s1.file);
   settosot(&s1);
   resetpoint(&s1,coffset);
   txunlock(&s1.textsrc,s1.file);
  }

/*  dprintf(3,"s=%d cols=%d",s1.textsrc.s,s1.textsrc.columns);
  dprintf(4,"cdelta=%d coffset=%d hoffset=%d offset=%d",
               cdelta,coffset,hoffset,offset[0]); */

  fl.data.type=cdelta?FLDELTA:FLDIRTY;
  fl.data.offset=coffset;
  fl.data.delta=cdelta;
  fl.data.length=hoffset-coffset;
  fl.roff[0]=offset[0];
  fl.resultv[0]=&s1;

  flow(&s1,&fl);
 }       

/* dprintf(0,"coffset=%d offset0=%d 1=%d",coffset,offset[0],offset[1]); */

 if(offset[0]!=offset[1])
 {
  s2=s1;
  movevector(&s2,offset[1]);
  setupzone(&s1,&s2);
 }
 else
 {
  err=txlock(&s1.textsrc,s1.file);

  setxa(&s1);
  setactive(&s1);
  screencaret(&s1);

  txunlock(&s1.textsrc,s1.file);
 }

 undowritefn(file,UINSERTF,NULL,0);

 return(NULL);
}


/* tagged to UINSERTF */
/* this function is always first in undo/redo */


os_error * uninsertfx(int code)
{
 int offset[2];

 offset[0]=act.textsrc.offset;

 if(zone) offset[1]=zon.textsrc.offset;
 else     offset[1]=offset[0];

 return(undowritefn(act.file,code,offset,2*sizeof(int)));
}


static os_error * uninsertf(filestr * file)
{
 uninsertfx(UINSERTS);
 txundostart(&act.textsrc,file);
 act.valid=0;

 return(NULL);
}



/* text input routine */

static os_error * instext(char * string,int stringlen,int sn,int after)
{
 os_error * err;
 vector     s;
 int        check;
 int        insword=0; /* compiler */


 if(act.valid==VVECTOR)
 {
  err=modfile(act.file,act.section);
  if(!err)
  {
   undostart(act.file);

   if(txovertype) deleteselectedlo();
   else           unselects(0);

   uninsertfx(UINSERTS);

   s=act;

   check=contcheck(s.file);

   if(check)insword=inword(&s);

   insertv(&s,string,stringlen,sn,after);

   err=txlock(&s.textsrc,s.file);

   setxa(&s);
   setactive(&s);
   screencaret(&s);

   txunlock(&s.textsrc,s.file);

   if(check && (insword!=inword(&s)) && insword) checkprevword(&s); 

   undowritefn(act.file,UINSERTF,NULL,0);
   undoend(act.file);

  }
 }
 else err=NULL;

 return(err);
}



/* if called with stringlen none zero, assume control codes embedded */
/* don't pass on to text vector                                      */

os_error * actinstext(char * string,int stringlen,int maxlen)
{
 os_error * err;
 int        sn;
 int        after;
 int        claimed[2];
 static int norecurse;
 int        len;
 char     * p;
 char     * q;
 int        c;


 err=NULL;

 claimed[1]=0;       // holds claimed flag
 claimed[0]=maxlen;

 if(!norecurse && !stringlen)
 {
  norecurse=1;
  event(EVENT_INSTEXT0,string,(int)claimed);
  norecurse=0;
 }

 if(!claimed[1])
 {
  len=stringlen;
  if(!len)
  {
   p=string;
   while((c=*p++)!=0)
   {
    if(c=='\t') len+=TSLEN;
    else        len++;
   }

   if(len>((p-string)-1))
   {                    /* expand tabs */
    q=string+(len+1);
    while(p>=string)
    {
     c=*p--;

     if(c=='\t')
     {
      *q--=0;
      *q--=0;
      *q--=0;
      *q--=TABSEQ;
     }
     else
     {
      *q--=(char)c;
     }
    }
   }
  }

//		cprintf("len %d s0 %x s1 %x s2 %x",len,string[0],string[1],string[2]);


  stylependflush(&sn,&after);
  err=instext(string,len,sn,after);
  stylependflushpost(sn,after);
 }

 if(!norecurse && !stringlen)
 {
  norecurse=1;
  event(EVENT_INSTEXT1,string,(int)claimed);
  norecurse=0;
 }

 return(err);
}



static os_error * insname(void)
{
 char path[FILENAMELEN];

 if(act.valid)
 {
  xzstrncpy(path,fs_leaf(act.file->name),sizeof(path));
  return(actinstext(path,0,sizeof(path)));
 }
 return(NULL);
}


static os_error * inspath(void)
{
 TCHAR path[FILENAMELEN];

 if(act.valid)
 {
  xzstrncpyu(path,act.file->name,NITEM(path));
  return(actinstext(path,0,NITEM(path)));
 }
 return(NULL);
}


static os_error * insdir(void)
{
 TCHAR path[FILENAMELEN];

 if(act.valid)
 {
  fs_path(act.file->name,path,NITEM(path));
  return(actinstext(path,0,NITEM(path)));
 }
 return(NULL);
}




static os_error * inspageno(int ispage)
{
 char string[4];
 string[0]=(char)(ispage?PAGENO:CHAPNO);
 string[1]=0;
 return(actinstext(string,0,sizeof(string)));
}


static os_error * insactdate(void)
{
 char string[4];
 string[0]=ACTDATE;
 string[1]=0;
 return(actinstext(string,0,sizeof(string)));
}


static os_error * insdate(void)
{
 char string[64];
 writesysdate(string);
 return(actinstext(string,0,sizeof(string)));
}


static os_error * instime(void)
{
 char string[64];
 writesystime(string);
 return(actinstext(string,0,sizeof(string)));
}



static os_error * insdatetime(void)
{
 char string[64];
 writesystimedate(string);
 return(actinstext(string,0,sizeof(string)));
}



static os_error * insspace(int key)
{
 char string[64];
 int  flgspace;
 int  vspace;
 int  hspace;


/* dprintf(0,"insspace  %d",key); */

 flgspace=SPACESEQEM; 

 vspace=0;

 if(key==XEMSPACEN  || key==XENSPACEN ||
    key==XEMSPACEND || key==XENSPACEND) flgspace|=SPACESEQNB;

 if(key==XEMSPACED  || key==XENSPACED ||
    key==XEMSPACEND || key==XENSPACEND) flgspace|=SPACESEQDL;

 if(key==XEMSPACE  || key==XEMSPACED || 
    key==XEMSPACEN || key==XEMSPACEND) hspace=0x10000;
 else                                  hspace=0x8000;

 string[0]=SPACESEQ;
 string[1]=(char)flgspace;
 string[2]=(char)(flgspace>>8);
 string[3]=(char)(flgspace>>16);
 string[4]=(char)hspace;
 string[5]=(char)(hspace>>8);
 string[6]=(char)(hspace>>16);
 string[7]=(char)(hspace>>24);
 string[8]=(char)vspace;
 string[9]=(char)(vspace>>8);
 string[10]=(char)(vspace>>16);
 string[11]=(char)(vspace>>24);
 string[12]=0;
 string[13]=0;
 string[14]=0;
 string[15]=0;

 return(actinstext(string,SPACELEN,sizeof(string)));
}


os_error * actinschar(int c,xstylestr * style)
{
 os_error   * err;
 char         string[4];
 absstylestr  astyle;
	int          length;

 err=NULL;

 if(act.valid)
 {
		length=0;

  if(actpend!=PENDSSHIFT)
  {
   err=getcaretstylex(&act,&astyle);
   if(astyle.style.data.font==style->data.font)     style->action.font=0;
   if(astyle.style.data.bold==style->data.bold)     style->action.bold=0;
   if(astyle.style.data.italic==style->data.italic) style->action.italic=0;

   if(style->action.font || style->action.bold || style->action.italic)
   {
    txfixstyle(style);
   }
  }


		if(c>31)
		{
 		if(c<256)
 		{
    string[0]=(char)c;
    string[1]=0;
 		}
   else
   {
    string[0]=(char)UNC16;
    string[1]=(char)(c&0xFF);
    string[2]=(char)((c>>8)&0xFF);
 			string[3]=0;
 			err=txunccheck(act.file);
				length=UNC16LEN;
 		}
		}

  if(!err) err=actinstext(string,length,sizeof(string));
 }

 return(err);
}



/*****************************************************************************/



static os_error * swopcase(void)
{
 os_error * err;
 vector     s1;
 vector     s2;
 vector   * v1;
 vector   * v2;
 int        off1;
 int        off2;
 int        c;
 char     * p;
 int        change;
 int        bits;
 int        slen;
 flowstr    fl;


 err=NULL;
 change=0;
 slen=0;


 if(act.valid)
 {
  err=modfile(act.file,act.section);
  if(!err)
  {
   undostart(act.file);
   undowritefn(act.file,USWOPCASE,NULL,0);


   if(!zone && !undoforward(act.file))
   {
    s1=act;
    err=txlock(&s1.textsrc,s1.file);
    if(!err)
    {
     prevch(&s1,NULL);

     setxya(&s1);
     setactive(&s1);
     screencaret(&s1);
     txunlock(&s1.textsrc,s1.file);
    }
   }


   if(zone) 
   {
    s1=*lozon;v1=lozon;off1=v1->textsrc.offset;
    s2=*hizon;v2=hizon;off2=v2->textsrc.offset;
   }
   else
   {
    s1=act;v1=&act;off1=v1->textsrc.offset;
    s2=act;v2=NULL;off2=0;
   }


   err=txlock(&s1.textsrc,s1.file);
   if(!err)
   {
    if(undoforward(s1.file)) txmodvec(&s1);

    do
    {
     do
     {
      p=txptr(s1.textsrc.sourcep,s1.textsrc.offset+slen);
      c=*p;
      bits=codex[c];
      slen+=bits & CODELEN;
     } while(c==SNO);


					if(c==UNC16)
					{
						c=(*(p+1))+((*(p+2))<<8);
						if(iswlower((unsigned short)c))
      {
       c=towupper((unsigned short)c);
							change=1;
						}
						else
						if(iswupper((unsigned short)c))
      {
					  c=towlower((unsigned short)c);
							change=1;
						}

						if(change)
						{
						 *(p+1)=(char)(c & 0xFF);
						 *(p+2)=(char)((c>>8) & 0xFF);
						}
					}
					else
					{
      if(riscos_isalpha((char)c))
      {
       if(riscos_isupper((char)c)) {*p=(char)riscos_tolower((char)c);change=1;}
       else                        {*p=(char)riscos_toupper((char)c);change=1;}
      }
					}

     if(c==EOT) break;

    } while((s1.textsrc.offset+slen)<s2.textsrc.offset);

    txunlock(&s1.textsrc,s1.file);
   }

   if(change)
   {
   /* if(!zone) remcaret(); */
  
    fl.opcode=FLV0|FDATA|FSUB;
    fl.data.type=FLDIRTY;
    fl.data.offset=s1.textsrc.offset;
    fl.data.delta=0;
    fl.data.length=slen;

    fl.roff[0]=v1->textsrc.offset;
    fl.resultv[0]=v1;

    if(v2)
    {
     fl.opcode|=FLV1;
     fl.resultv[1]=v2;
     fl.roff[1]=v2->textsrc.offset;
    }

    flow(v1,&fl);
   }

   if(!zone && undoforward(s1.file))
   {
    s1=act;
    err=txlock(&s1.textsrc,s1.file);
    if(!err)
    {
     nextch(&s1,NULL);

     setxya(&s1);
     setactive(&s1);
     screencaret(&s1);
     txunlock(&s1.textsrc,s1.file);
    }
   }

   undoend(s1.file);
  }
 }
 return(err);
}

/* tagged to USWOPCASE */

static os_error * unswopcase(filestr * file)
{
 return(swopcase());
 USE(file);
}



void swopcases(int fp)
{
	USE(fp);
 zreport(swopcase());
}


#define CCUNDO  0x0
#define CCUPPER 0x1
#define CCLOWER 0x2


static os_error * changecase(int ccmode)
{
 os_error * err;
 vector     s1;
 vector     s2;
 vector   * v1;
 vector   * v2;
 int        off1;
 int        off2;
 int        c;
 char     * p;
 int        change;
 int        bits;
 int        slen;
 flowstr    fl;


 err=NULL;
 change=0;
 slen=0;


 if(act.valid)
 {
  err=modfile(act.file,act.section);
  if(!err)
  {
   undostart(act.file);
   undowritefn(act.file,UCHANGECASE,NULL,0);


   if(!zone && !undoforward(act.file))
   {
    s1=act;
    err=txlock(&s1.textsrc,s1.file);
    if(!err)
    {
     prevch(&s1,NULL);

     setxya(&s1);
     setactive(&s1);
     screencaret(&s1);
     txunlock(&s1.textsrc,s1.file);
    }
   }


   if(zone) 
   {
    s1=*lozon;v1=lozon;off1=v1->textsrc.offset;
    s2=*hizon;v2=hizon;off2=v2->textsrc.offset;
   }
   else
   {
    s1=act;v1=&act;off1=v1->textsrc.offset;
    s2=act;v2=NULL;off2=0;
   }


   err=txlock(&s1.textsrc,s1.file);
   if(!err)
   {
    if(undoforward(s1.file)) txmodvec(&s1);

    do
    {
     do
     {
      p=txptr(s1.textsrc.sourcep,s1.textsrc.offset+slen);
      c=*p;
      bits=codex[c];
      slen+=bits & CODELEN;
     } while(c==SNO);


					if(c==UNC16)
					{
						c=(*(p+1))+((*(p+2))<<8);
						undowrite(s1.file,&c,2);

						if(ccmode==CCUPPER)
      {
       c=towupper((unsigned short)c);
							change=1;
						}
						else
						if(ccmode==CCLOWER)
      {
					  c=towlower((unsigned short)c);
							change=1;
						}
						else
						{
       undoread(s1.file,&c,2);
							change=1;
      }

						if(change)
						{
						 *(p+1)=(char)(c & 0xFF);
						 *(p+2)=(char)((c>>8) & 0xFF);
						}
					}
					else
					{
      if(riscos_isalpha((char)c))
      {
						 undowrite(s1.file,&c,1);

       if(ccmode==CCLOWER) {*p=(char)riscos_tolower((char)c);change=1;}
       else
							if(ccmode==CCUPPER) {*p=(char)riscos_toupper((char)c);change=1;}
							else
							{
        undoread(s1.file,&c,1);
	 						change=1;
        *p=(char)c;
							}
      }
					}

     if(c==EOT) break;

    } while((s1.textsrc.offset+slen)<s2.textsrc.offset);

    txunlock(&s1.textsrc,s1.file);
   }

   if(change)
   {
   /* if(!zone) remcaret(); */
  
    fl.opcode=FLV0|FDATA|FSUB;
    fl.data.type=FLDIRTY;
    fl.data.offset=s1.textsrc.offset;
    fl.data.delta=0;
    fl.data.length=slen;

    fl.roff[0]=v1->textsrc.offset;
    fl.resultv[0]=v1;

    if(v2)
    {
     fl.opcode|=FLV1;
     fl.resultv[1]=v2;
     fl.roff[1]=v2->textsrc.offset;
    }

    flow(v1,&fl);
   }

   if(!zone && undoforward(s1.file))
   {
    s1=act;
    err=txlock(&s1.textsrc,s1.file);
    if(!err)
    {
     nextch(&s1,NULL);

     setxya(&s1);
     setactive(&s1);
     screencaret(&s1);
     txunlock(&s1.textsrc,s1.file);
    }
   }

   undoend(s1.file);
  }
 }
 return(err);
}


/* tagged to UCHANGECASE */

static os_error * unchangecase(filestr * file)
{
 return(changecase(CCUNDO));
 USE(file);
}



void uppercases(int fp)
{
	USE(fp);
 zreport(changecase(CCUPPER));
}


void lowercases(int fp)
{
	USE(fp);
 zreport(changecase(CCLOWER));
}


static os_error * transpose(void)
{
 os_error * err;
 vector     s1;
 vector     s2;
 char       temp1[MAXCODELEN];
 int        len1;
 char       temp2[MAXCODELEN];
 int        len2;
 flowstr    fl;
 int        c;
 char     * p;
 int        coffset;


 len1=len2=0; /* compiler */


 if(act.valid && !zone)
 {
  err=modfile(act.file,act.section);
  if(!err)
  {
   s1=act;
   s2=act;

   err=txlock(&s1.textsrc,s1.file);
   if(!err)
   {
    c=prevch(&s1,NULL);
    if(c!=-1)
    {
     while(1)
     {
      p=txptr(s1.textsrc.sourcep,s1.textsrc.offset);
      len1=codex[c] & CODELEN;
      if(*p!=SNO)
      {
       XMEMCPYX(temp1,p,len1);
       break;
      }
      else
      {
       s1.textsrc.offset+=len1;
      }
     }
    }

    txunlock(&s1.textsrc,s1.file);

    if(c!=-1)
    {
     err=txlock(&s2.textsrc,s1.file);
     if(!err)
     {
      coffset=s2.textsrc.offset;

      while(1)
      {
       p=txptr(s2.textsrc.sourcep,s2.textsrc.offset);
       c=*p;
       len2=codex[c] & CODELEN;
       if(c!=SNO)
       {
        XMEMCPYX(temp2,p,len2);
        break;
       }
       else
       {
        s2.textsrc.offset+=len2;
       }
      }
      txunlock(&s2.textsrc,s2.file);

      if(c!=EOT)
      {
       undostart(s1.file);

       undowritefn(s1.file,UTRANSPOSE,NULL,0);

       txlock(&s1.textsrc,s1.file);

       if(undoforward(s1.file)) txmodvec(&s1);

       txsourcereplace(len1,len2,temp2,&s1.textsrc,s1.file);
       txunlock(&s1.textsrc,s1.file);

       s2.textsrc.offset+=len2-len1;
       coffset+=len2-len1;

       txlock(&s2.textsrc,s2.file);
       txsourcereplace(len2,len1,temp1,&s2.textsrc,s2.file);
       txunlock(&s2.textsrc,s2.file);

       undoend(s1.file);


       fl.opcode=FLV0|FDATA|FSUB;
       fl.data.type=FLDIRTY;
       fl.data.offset=s1.textsrc.offset;
       fl.data.delta=0;
       fl.data.length=s2.textsrc.offset+len2-s1.textsrc.offset;

       fl.roff[0]=coffset;
       fl.resultv[0]=&s2;

       flow(&s1,&fl);

       setxya(&s2);
       setactive(&s2);
       screencaret(&s2);
      }
     }
    }
   }
  }
 }

 return(NULL);
}



static os_error * utranspose(filestr * file)
{
 return(transpose());
 USE(file);
}



/*****************************************************************************/

// convert XXXX (hex) to unicode character

// look at char before the caret
// either a sequence of hex digits in which case take them out and insert char
// or take out char and stick in hex value, do this for UNC and normal chars
// clear any selection


/* tagged to UUNIHEXF */
/* this function is always last in undo/redo */


static os_error * uunihexf(filestr * file) 
{

 return(undowritefn(file,UUNIHEXS,NULL,0));
}


/* tagged to UUNIHEXS */
/* this function is always first in undo/redo */

static os_error * uunihexs(filestr * file)
{

 return(undowritefn(file,UUNIHEXF,NULL,0));
}





static os_error * unicodehex(void)
{
	os_error * err;
	vector     s1;
	vector     s2;
	char     * p;
	int        c=0;
	int        n=0;
	unsigned short string[16];
	int        mod;
	int        nlen;
	int        olen=0;
	int        backflow;
 flowstr    fl;
	int        hexvalue;


 if(act.valid)
 {
		if(act.file->compatability>=UNICOMPAT)
		{
			s1=act;

   err=txlock(&s1.textsrc,s1.file);
			if(!err)
			{
				n=-1;
				hexvalue=0;
				s2=s1;

				// n is a state variable
				// n == -1 we've not seen anything, we're not doing anything
				// n ==  0	seen a code which is going to be replaced by hex
				// n  >  0 number of hex digits seen


				while(1)
				{
     c=prevch(&s1,NULL);			// drop out at start
					if(c<0) break;

					if(c==UNC16)
     {
      p=txptr(s1.textsrc.sourcep,s1.textsrc.offset);
      c=(*(p+1))+((*(p+2))<<8);
					}

					if(c<32) break;	// take out white space

					if(n<0) n=0;				// we are going to do something

			 	if(c>255 || (!isxdigit(c)))	// protect isxdigit() from unicodes
     {
						if(n==0)	s2=s1;
     	break;
					}

					n++;

					s2=s1;

		   c=toupper(c);
     if(c>='0' && c<='9') hexvalue+=(c-'0')<<((n-1)*4);
     else
     if(c>='A' && c<='F') hexvalue+=(c-'A'+10)<<((n-1)*4);

					if(n>3) break;
				}


				// n is how many codes we have looked at

				olen=act.textsrc.offset-s2.textsrc.offset;
				if(n==0)		// we are going to take out the single code and insert hex string
				{
					xsprintf2(NITEM(string),NULL,string,L"%x",c);
				}
				else						// we are going to take out hex and insert glyph
				if(n>0)
				{
					if(hexvalue<32) n=-1;	// don't insert control codes
					else
					{
				 	c=code16inv(hexvalue);
				 	if(c<0) c=hexvalue;
				 	string[0]=(unsigned short)c;
				 	string[1]=0;
					}
				}

    txunlock(&s1.textsrc,s1.file);
			}

//			cprintf("hexvalue %d n %d",hexvalue,n);

			if(n>=0 && !err)
			{
    err=modfile(act.file,act.section);
    if(!err)
    {
     undostart(act.file);

     undowritefn(act.file,UUNIHEXS,NULL,0);

 				if(!err)
 				{
      backflow=1;

      uninsertfx(UINSERTS);

      unselects(0);

      err=freplacesub(&s2,olen,&nlen,string,&mod);

						s1=s2;

      fl.opcode=FDATA|FSUB;
      if(backflow) fl.opcode|=FLPREV;
      fl.data.type=FLDIRTY;
      fl.data.offset=s1.textsrc.offset;
      fl.data.delta=nlen-olen;
      fl.data.length=nlen;

      fl.opcode|=FLV0;
      fl.roff[0]=s2.textsrc.offset+nlen;
      fl.roff[1]=0;
      fl.resultv[0]=&s1;
      flow(&s2,&fl);
  
      err=txlock(&s1.textsrc,s1.file);
   			if(!err)
	   		{
       setxa(&s1);
       setactive(&s1);
       screencaret(&s1);
       txunlock(&s1.textsrc,s1.file);
		   	}

      undowritefn(act.file,UINSERTF,NULL,0);
 				}

     undowritefn(act.file,UUNIHEXF,NULL,0);
     undoend(act.file);
				}
   }
		}
	}

	return(NULL);
}


/*****************************************************************************/
/* block of functions concerned with deleting stuff                          */

/* NB used to all be setxya() */




os_error * deleteselectedlo(void)
{
 os_error * err;
 vector     s1;
 vector     s2;

 err=NULL;

 if(act.valid && zone)
 {
  err=modfile(act.file,act.section);
  if(!err)
  {
   uninsertfx(UDELETES);

   s1=*lozon;
   s2=*hizon;

   unselects(0);

   deletev(&s1,&s2);

   err=txlock(&s1.textsrc,s1.file);
   if(!err)
   {
    setxa(&s1);
    setactive(&s1);
    screencaret(&s1);
    txunlock(&s1.textsrc,s1.file);
   }

   undowritefn(act.file,UDELETEF,NULL,0);
  }
 }

 return(err);
}




/* used to delete a chunk of text - no copy to clipboard */

os_error * deleteselected(void)
{
 os_error * err;

 err=NULL;

 err=undostart(act.file);
 if(!err)
 {
  err=deleteselectedlo();
  undoend(act.file);
 }

 return(err);
}




/*****************************************************************************/

typedef os_error * (*adelfn)(vector * s);


static os_error * deletetext(adelfn delfn1,adelfn delfn2,int bits,int n) 
{
 os_error * err;
 vector     s1;
 vector     s2;
 int        i;

 err=NULL;

 if(act.valid)
 {
  s1=act;
  s2=act;

  if(delfn1)
  {
   i=n;
   err=txlock(&s1.textsrc,s1.file);
   while(i--) delfn1(&s1);
   txunlock(&s1.textsrc,s1.file);
  }

  if(bits & 0x1) s2=s1;

  if(delfn2)
  {
   i=n;
   txlock(&s2.textsrc,s2.file);
   while(i--) delfn2(&s2);
   txunlock(&s2.textsrc,s2.file);
  }

  if(s1.textsrc.offset<s2.textsrc.offset)
  {
   err=modfile(act.file,act.section);
   if(!err)
   {
    undostart(act.file);

    uninsertfx(UDELETES);

    deletev(&s1,&s2);

    err=txlock(&s1.textsrc,s1.file);
    setxa(&s1);
    setactive(&s1);
    screencaret(&s1);
    txunlock(&s1.textsrc,s1.file);

    undowritefn(act.file,UDELETEF,NULL,0);
    undoend(act.file);
   }
  }
 }

 return(err);
}




static os_error * deltosol(int i)
{
 return(deletetext(settosol,NULL,0,1));
 USE(i);
}


static os_error * settoeoldx1(vector * s)  /* also used for select */
{
 return(settoeol(s,1));
}


static os_error * deltoeol(int i)
{
 return(deletetext(NULL,settoeoldx1,0,1));
 USE(i);
}



static os_error * settoeoldx0(vector * s)
{
 return(settoeol(s,0));
}


static os_error * deleteline(int i)
{
 return(deletetext(settosol,settoeoldx0,0,1));
 USE(i);
}





static os_error * delprevword(int i)
{
 return(deletetext(settospw,settoeowx,1,1));
 USE(i);
}



static os_error * delnexts(vector * s)
{
 int offset;
 offset=s->textsrc.offset;
 settoeowx(s);
 if(s->textsrc.offset==offset) nextch(s,NULL);
 return(NULL);
}



static os_error * delnextword(int i)
{
 return(deletetext(settosow,delnexts,1,1));
 USE(i);
}




static os_error * delnextchars(vector * s)
{
 nextch(s,NULL);
 return(NULL);
}


os_error * delnextchar(int i)
{
 return(deletetext(NULL,delnextchars,0,i));
}



static os_error * delprevchars(vector * s)
{
 prevch(s,NULL);
 return(NULL);
}


static os_error * delprevchar(int i)
{
 return(deletetext(delprevchars,NULL,0,i));
}





/*****************************************************************************/

#ifdef NEVER




static os_error * delnextchar(int i)
{
 os_error * err;
 vector     s1;
 vector     s2;

 if(act.valid)
 {
  err=modfile(act.file,act.section);
  if(!err)
  {
   undostart(act.file);

   uninsertfx(UDELETES);

   s1=act;
   s2=act;

   err=txlock(&s2.textsrc,s2.file);
   while(i--) nextch(&s2);
   txunlock(&s2.textsrc,s2.file);

   deletev(&s1,&s2);

   err=txlock(&s1.textsrc,s1.file);
			if(!err)
			{
    setxa(&s1);
    setactive(&s1);
    screencaret(&s1);
    txunlock(&s1.textsrc,s1.file);
			}

   undowritefn(act.file,UDELETEF,NULL,0);
   undoend(act.file);
  }
 }
 else err=NULL;

 return(err);
}


static os_error * delprevchar(int i)
{
 os_error * err;
 vector     s1;
 vector     s2;

 if(act.valid)
 {
  err=modfile(act.file,act.section);
  if(!err)
  {
   undostart(act.file);

   uninsertfx(UDELETES);

   s1=act;
   s2=act;

   err=txlock(&s1.textsrc,s1.file);
   while(i--) prevch(&s1);
   txunlock(&s1.textsrc,s1.file);
 
   deletev(&s1,&s2);

   err=txlock(&s1.textsrc,s1.file);
   setxa(&s1);
   setactive(&s1);
   screencaret(&s1);
   txunlock(&s1.textsrc,s1.file);

   undowritefn(act.file,UDELETEF,NULL,0);
   undoend(act.file);
  }
 }
 else err=NULL;

 return(err);
}








static os_error * deltosol(int i)
{
 os_error * err;
 vector     s1;
 vector     s2;

 USE(i);

 if(act.valid)
 {
  err=modfile(act.file,act.section);
  if(!err)
  {
   undostart(act.file);

   uninsertfx(UDELETES);

   s1=act;
   s2=act;

   err=txlock(&s1.textsrc,s1.file);
   settosol(&s1);
   txunlock(&s1.textsrc,s1.file);

   err=txlock(&s1.textsrc,s1.file);
   deletev(&s1,&s2);
   setxa(&s1);
   setactive(&s1);
   screencaret(&s1);
   txunlock(&s1.textsrc,s1.file);

   undowritefn(act.file,UDELETEF,NULL,0);
   undoend(act.file);
  }
 }
 else err=NULL;

 return(err);
}


static os_error * deltoeol(int i)
{
 os_error * err;
 vector     s1;
 vector     s2;

 USE(i);

 if(act.valid)
 {
  err=modfile(act.file,act.section);
  if(!err)
  {
   undostart(act.file);

   uninsertfx(UDELETES);

   s1=act;
   s2=act;

   err=txlock(&s2.textsrc,s2.file);
   settoeol(&s2,1);
   txunlock(&s2.textsrc,s2.file);

   deletev(&s1,&s2);

   err=txlock(&s1.textsrc,s1.file);
   setxa(&s1);
   setactive(&s1);
   screencaret(&s1);
   txunlock(&s1.textsrc,s1.file);

   undowritefn(act.file,UDELETEF,NULL,0);
   undoend(act.file);
  }
 }
 else err=NULL;

 return(err);
}








static os_error * deleteline(int i)
{
 os_error * err;
 vector     s1;
 vector     s2;



 if(act.valid)
 {
  err=modfile(act.file,act.section);
  if(!err)
  {
   undostart(act.file);

   uninsertfx(UDELETES);

   s1=act;
   s2=act;

   err=txlock(&s1.textsrc,s1.file);
   settosol(&s1);
   txunlock(&s1.textsrc,s1.file);

   txlock(&s2.textsrc,s2.file);
   settoeol(&s2,0);
   txunlock(&s2.textsrc,s2.file);

   deletev(&s1,&s2);

   err=txlock(&s1.textsrc,s1.file);
   setxa(&s1);
   setactive(&s1);
   screencaret(&s1);
   txunlock(&s1.textsrc,s1.file);

   undowritefn(act.file,UDELETEF,NULL,0);
   undoend(act.file);
  }
 }
 else err=NULL;

 return(err);

 USE(i);
}





static os_error * delprevword(int i)
{
 os_error * err;
 vector     s1;
 vector     s2;

 USE(i);

 if(act.valid)
 {
  err=modfile(act.file,act.section);
  if(!err)
  {
   undostart(act.file);

   uninsertfx(UDELETES);

   s1=act;

   err=txlock(&s1.textsrc,s1.file);
   settosow(&s1);
   txunlock(&s1.textsrc,s1.file);

   s2=s1;

   txlock(&s2.textsrc,s2.file);
   settoeowx(&s2);
   if(s2.textsrc.offset==s1.textsrc.offset) nextch(&s2);
   txunlock(&s2.textsrc,s2.file);

   deletev(&s1,&s2);

   err=txlock(&s1.textsrc,s1.file);
   setxa(&s1);
   setactive(&s1);
   screencaret(&s1);
   txunlock(&s1.textsrc,s1.file);

   undowritefn(act.file,UDELETEF,NULL,0);
   undoend(act.file);
  }
 }
 else err=NULL;

 return(err);
}







static os_error * delnextword(int i)
{
 os_error * err;
 vector     s1;
 vector     s2;

 USE(i);

 if(act.valid)
 {
  err=modfile(act.file,act.section);
  if(!err)
  {
   undostart(act.file);

   uninsertfx(UDELETES);

   s1=act;

   err=txlock(&s1.textsrc,s1.file);
   settosnw(&s1);
   txunlock(&s1.textsrc,s1.file);
   s2=s1;

   txlock(&s2.textsrc,s2.file);
   settoeowx(&s2);
   txunlock(&s2.textsrc,s2.file);

   deletev(&s1,&s2);

   err=txlock(&s1.textsrc,s1.file);
   setxa(&s1);
   setactive(&s1);
   screencaret(&s1);
   txunlock(&s1.textsrc,s1.file);

   undowritefn(act.file,UDELETEF,NULL,0);
   undoend(act.file);
  }
 }
 else err=NULL;

 return(err);
}




#endif



/*****************************************************************************/
/* block of functions concerned with moving the caret around                 */


static os_error * caretsub(filestr * file,int code)
{
 os_error * err;
 int        data[2];

 err=NULL;

          data[0]=act.textsrc.offset;
 if(zone) data[1]=zon.textsrc.offset;
 else     data[1]=act.textsrc.offset;

 err=undostart(file);
 if(!err)
 {
  unselects(0);

  actclearpend();
  spclearpend();

  undowritefn(file,code,data,2*sizeof(int));

  undoend(file);
 }

 return(err);
}



static os_error * ucaretsub(filestr * file,int code)
{
 os_error * err;
 int        data[2];
 vector     s;
 vector     v;

 err=NULL;

 data[0]=act.textsrc.offset;
 if(zone) data[1]=zon.textsrc.offset;
 else     data[1]=act.textsrc.offset;

 undowritefn(act.file,code,data,2*sizeof(int));

 undoread(file,data,2*sizeof(int));

 if(data[0]==data[1])
 {
  unselects(0);
  s=act;
  movevector(&s,data[0]);

  err=txlock(&s.textsrc,file);
  if(!err)
  {
   setxya(&s); 
   setactive(&s);
   screencaret(&s);

   txunlock(&s.textsrc,file);
  }
 }
 else
 {
  s=act;
  movevector(&s,data[0]);
  v=act;
  movevector(&v,data[1]);
  setupzone(&s,&v);
 }

 return(err);
}


static os_error * ucaretleft(filestr * file)
{
 return(ucaretsub(file,UCARETRIGHT));
}

static os_error * ucaretright(filestr * file)
{
 return(ucaretsub(file,UCARETLEFT));
}

static os_error * ucaretup(filestr * file) 
{
 return(ucaretsub(file,UCARETDOWN));
}

static os_error * ucaretdown(filestr * file) 
{
 return(ucaretsub(file,UCARETUP));
}




static os_error * caretleft(int i)
{
 os_error * err;
 vector     s;
 int        n;

 err=NULL;


 if(act.valid)
 {
  caretsub(act.file,UCARETLEFT);

  s=act;
  n=0;

  err=txlock(&s.textsrc,s.file);
  if(!err)
  {
   while(i--) 
   {
    if(prevch(&s,NULL)<0) break;
    else                  n++;
   }

   if(n)
   {
             err=setxya(&s);
    if(!err) err=setactive(&s);
    if(!err) err=screencaret(&s);
   }

   txunlock(&s.textsrc,s.file);
  }
 }

 return(err);
}



static os_error * caretright(int i)
{
 os_error * err;
 vector     s;
 int        n;

 if(act.valid)
 {
  caretsub(act.file,UCARETRIGHT);

  s=act;
  n=0;

  err=txlock(&s.textsrc,s.file);

  while(i--)
  {
   if(nextch(&s,NULL)==EOT) break;
   else n++;
  }

  if(n)
  {
            err=setxya(&s);
   if(!err) err=setactive(&s);
   if(!err) err=screencaret(&s);
  }

  txunlock(&s.textsrc,s.file);
 }
 else err=NULL;

 return(err);
}



os_error * vectorup(vector * s,int oldx,int i,int * nr)
{
 int j;

 j=0;
 while(i--)
 {
  if(!prevvstrip(s)) break;
  else j++;
 }

 if(j)
 {
  findvlinex(oldx,s);
  s->x=oldx;
  s->y=LY(vvlptr(s)->line.yy);
  vsetcaretposn(s);
 }

 *nr=j;

 return(NULL);
}


static os_error * upline(vector * s)
{
 int j;
 vectorup(s,oldccx,1,&j);
 return(NULL);
}



static os_error * caretup(int i)
{
 os_error * err;
 vector     s;
 int        j;

 err=NULL;

 if(act.valid)
 {
  caretsub(act.file,UCARETUP);

  s=act;

  err=txlock(&s.textsrc,s.file);
  if(!err)
  {
   vectorup(&s,oldccx,i,&j);

   if(j)
   {
    setactive(&s);
    screencaret(&s);
   }

   txunlock(&s.textsrc,s.file);
  }
 }

 return(err);
}





os_error * vectordown(vector * s,int oldx,int i,int * nr)
{
 int j;

 j=0;
 while(i--)
 {
  if(!nextvstrip(s)) break;
  else j++;
 }

 if(j)
 {
  findvlinex(oldx,s);
  s->x=oldx;
  s->y=LY(vvlptr(s)->line.yy);
  vsetcaretposn(s);
 }

 *nr=j;

 return(NULL);
}



static os_error * downline(vector * s)
{
 int j;
 vectordown(s,oldccx,1,&j);
 return(NULL);
}




static os_error * caretdown(int i)
{
 os_error * err;
 vector     s;
 int        j;

 err=NULL;

 if(act.valid)
 {
  caretsub(act.file,UCARETDOWN);

  s=act;

  err=txlock(&s.textsrc,s.file);
  if(!err)
  {
   vectordown(&s,oldccx,i,&j);

   if(j)
   {
    setactive(&s);
    screencaret(&s);
   }
  }

  txunlock(&s.textsrc,s.file);
 }

 return(err);
}



static os_error * caretuplock(int i)
{
 os_error * err;
 int        x;
 int        y;
 int        xshift;
 int        yshift;
 int        xpo;
 int        ypo;
 int        page;

 err=NULL;

 if(act.valid)
 {
  getpagecoords(caretview,page=act.page,act.section,&xpo,&ypo);

  y=ypo+act.y;
  x=xpo;

  err=caretup(i);
  if(!err)
  {
   if(page!=act.page) getpagecoords(caretview,act.page,act.section,&xpo,&ypo);

   yshift=y-(ypo+act.y);
   xshift=x-xpo;

   viewopenat(caretview,caretview->file,
              caretview->mainwindow.scx+osunits(xshift,caretview),
              caretview->mainwindow.scy+osunits(yshift,caretview)); //mainpane
  }
 }

 return(err);
}



static os_error * caretdownlock(int i)
{
 os_error * err;
 int        x;
 int        y;
 int        xshift;
 int        yshift;
 int        xpo;
 int        ypo;
 int        page;

 err=NULL;

 if(act.valid)
 {
  getpagecoords(caretview,page=act.page,act.section,&xpo,&ypo);

  y=ypo+act.y;
  x=xpo;

  err=caretdown(i);
  if(!err)
  {
   if(page!=act.page) getpagecoords(caretview,act.page,act.section,&xpo,&ypo);

   yshift=y-(ypo+act.y);
   xshift=x-xpo;

   viewopenat(caretview,caretview->file,
              caretview->mainwindow.scx+osunits(xshift,caretview),  
              caretview->mainwindow.scy+osunits(yshift,caretview)); //mainpane
  }
 }

 return(err);
}






typedef os_error * (*amovefn)(vector * s);


static os_error * movetext(amovefn movefn)      /* start of text      */
{
 os_error * err;
 vector     s;

 if(act.valid)
 {
  undostart(act.file);

  unsaveact();

  unselects(0);

  s=act;

  err=txlock(&s.textsrc,s.file);

  movefn(&s);
  setxya(&s); 
  setactive(&s);
  screencaret(&s);

  txunlock(&s.textsrc,s.file);

  undoend(act.file);
 }
 else err=NULL;

 return(err);
}


static os_error * sotext(void)      /* start of text      */
{
 return(movetext(settosot));
}



static os_error * eotext(void)      /* end of text        */
{
 return(movetext(settoeot));
}



static os_error * soline(void)      /* start of line      */
{
 return(movetext(settosol));
}

static os_error * settoeoltx(vector * s)
{
 return(settoeol(s,3));
}

static os_error * eoline(void)      /* end of line        */
{
 return(movetext(settoeoltx));
}


static os_error * sopword(void)     /* start of prev word */
{
 return(movetext(settospwsp));
}



static os_error * sonpara(void)     /* start of next para */
{
 return(movetext(settosnpx));
}


static os_error * settospptx(vector * s)
{
 settospp(s);
 return(NULL);
}


static os_error * soppara(void)     /* start of prev para */
{
 return(movetext(settospptx));
}


static os_error * sonword(void)     /* start of next word */
{
 return(movetext(settosnw));
}






#ifdef NEVER


static os_error * sotext(void)      /* start of text      */
{
 os_error * err;
 vector     s;

 if(act.valid)
 {
  undostart(act.file);

  unsaveact();

  unselects(0);

  s=act;

  err=txlock(&s.textsrc,s.file);

  settosot(&s);
  setxya(&s); 
  setactive(&s);
  screencaret(&s);

  txunlock(&s.textsrc,s.file);

  undoend(act.file);
 }
 else err=NULL;

 return(err);
}



static os_error * eotext(void)      /* end of text        */
{
 os_error * err;
 vector     s;

 if(act.valid)
 {
  undostart(act.file);

  unsaveact();

  unselects(0);

  s=act;

  err=txlock(&s.textsrc,s.file);

  settoeot(&s);
  setxya(&s); 
  setactive(&s);
  screencaret(&s);

  txunlock(&s.textsrc,s.file);

  undoend(act.file);
 }
 else err=NULL;

 return(err);
}



static os_error * soline(void)      /* start of line      */
{
 os_error * err;
 vector     s;

 if(act.valid)
 {
  undostart(act.file);

  unsaveact();

  unselects(0);

  s=act;

  err=txlock(&s.textsrc,s.file);

  settosol(&s);
  setxya(&s);
  setactive(&s);
  screencaret(&s);

  txunlock(&s.textsrc,s.file);

  undoend(act.file);
 }
 else err=NULL;

 return(err);
}


static os_error * eoline(void)      /* end of line        */
{
 os_error * err;
 vector     s;

 if(act.valid)
 {
  undostart(act.file);

  unsaveact();

  unselects(0);

  s=act;

  err=txlock(&s.textsrc,s.file);

  settoeol(&s,3);
  setxya(&s);
  setactive(&s);
  screencaret(&s);

  txunlock(&s.textsrc,s.file);

  undoend(act.file);
 }
 else err=NULL;

 return(err);
}



static os_error * sopword(void)     /* start of prev word */
{
 os_error * err;
 vector     s;

 if(act.valid)
 {
  undostart(act.file);

  unsaveact();

  unselects(0);


  s=act;

  err=txlock(&s.textsrc,s.file);

  settospw(&s);
  setxya(&s);
  setactive(&s);
  screencaret(&s);

  txunlock(&s.textsrc,s.file);

  undoend(act.file);
 }
 else err=NULL;

 return(err);
}



static os_error * sonpara(void)     /* start of next para */
{
 os_error * err;
 vector     s;

 if(act.valid)
 {
  undostart(act.file);

  unsaveact();

  unselects(0);

  s=act;

  err=txlock(&s.textsrc,s.file);

  settosnpx(&s);
  setxya(&s);
  setactive(&s);
  screencaret(&s);

  txunlock(&s.textsrc,s.file);

  undoend(act.file);
 }
 else err=NULL;

 return(err);
}


static os_error * soppara(void)     /* start of prev para */
{
 os_error * err;
 vector     s;

 if(act.valid)
 {
  undostart(act.file);

  unsaveact();

  unselects(0);

  s=act;
  err=txlock(&s.textsrc,s.file);

  settospp(&s);
  setxya(&s);
  setactive(&s);
  screencaret(&s);

  txunlock(&s.textsrc,s.file);

  undoend(act.file);
 }
 else err=NULL;

 return(err);
}



static os_error * sonword(void)     /* start of next word */
{
 os_error * err;
 vector     s;

 if(act.valid)
 {
  undostart(act.file);

  unsaveact();

  unselects(0);

  s=act;
  err=txlock(&s.textsrc,s.file);

  settosnw(&s);
  setxya(&s);
  setactive(&s);
  screencaret(&s);

  txunlock(&s.textsrc,s.file);

  undoend(act.file);
 }
 else err=NULL;

 return(err);
}



#endif




#ifdef NEVER

static os_error * sosx(int section,filestr * file,int end)
{
 os_error   * err;
 int          object;
 vector       s;
 sobjectstr * sob;


 err=getmainframe(section,file,&object);
 if(!err && object)
 {
  sob=fob_find(object,file);
  if(sob->type==OTEXTBOX)
  {
   undostart(file);

   clearactive();

   setvectorfrombox(&s,0,object,file);

   err=txlock(&s.textsrc,s.file);

   if(end) settoeot(&s);
   setxya(&s); 
   setactive(&s);
   screencaret(&s);

   txunlock(&s.textsrc,s.file);

   undoend(file);
  }
 }

 return(err);
}

#endif




/* set caret to start of main line source */

#ifdef NEVER

static void settosect(int sectn)
{
 xstr * section=fh_sect[file][BRN];
 while(sectn--) section=section->next;
 sosx(section);
 USE(sectn);
}

#endif  


#ifdef NEVER

static void socrsx(void)     /* start of current section */
{
 if(!actex) return;
 sosx(act->section);
}

#endif 


#ifdef NEVER 

static void sonxsx(void)    /* start of next section     */
{
 if(!actex) return;
 sosx((act->section)->next);
}

#endif 










/*****************************************************************************/
/* control marked area */

/*
   in general, 
               act points to the fixed  point in the zone
               zon points to the dragged bit

 */


static void orderzone(void)
{
 if(zone)
 {
  if(act.textsrc.offset>zon.textsrc.offset)
  {
   lozon=&zon;
   hizon=&act;
  }
  else
  {
   lozon=&act;
   hizon=&zon;
  }
 }
}



static os_error * refreshchunk(vector * s,aboxstr * vbox)
{
 os_error      * err;
 viewredrawstr   v;
 sboxstr         sbox;
 transformstr    trx;
 transformstr    trw;
 transformstr    trz;


/* box2abox(&s->textsrc.textp->fcurve.box,&bbox); */

 initviewredraw(&v);

 v.file=s->file;
 v.page=s->page;
 v.section=s->section;
 v.sobject=s->textsrc.text;
 v.sboxn=1;

 sbox.box=*vbox;

 v.sbox=&sbox;
 v.szone=1;
 v.ignore=1;
 v.sshortcuts=1;
 v.sunit=s->textsrc.u;
 v.ssub=s->textsrc.s;

 trx=s->textsrc.textp->data.transform;
 tr_setshift(&trw,s->textsrc.textp->fcurve.box.x,
                  s->textsrc.textp->fcurve.box.y);
 tr_multiply(&trz,&trw,&trx);

 err=viewrefreshsobject(&v,vbox,&trz);

 return(err);
}





/* 
 aboxstr         bbox;
 aboxstr         abox;


 box2abox(&s->textsrc.textp->fcurve.box,&bbox);

 getmaxabox(&abox,&bbox,&s->textsrc.textp->transform);

 return(viewrefresharea(s->file,s->page,&abox,VRONELAYER|VRTOOLS2));

 USE(vbox);
*/





    /*
      cutmargins=printmarginsa(&zona);
  
      if(cutmargins)
      {
       orderzone();
       zone=tempz;
      }
      refreshz(s.box,s.page,&area,cutmargins); 
    */




/* refresh screen between s1 and s2 */

os_error * refreshzone(vector * s1,vector * s2)
{
 os_error   *  err;
 vector        from;
 vector        to;
 vector        s;
 vector     *  temp;
 int           tempz;
 int           visible=0;
 aboxstr       vbox;
 aboxstr       xbox;
 int           valid;
 int           newbox;
 int           vlimit;
 int           i;
 texsub      * texup;
 int           vshift=0;
 int           vdelta=0;
 int           voffset;
 vlstr       * vline;



 err=NULL;
 tempz=zone;
 newbox=1;
 valid=0;
 vlimit=0;     /* compiler */

/*
 dprintf(0,"refresh zone loffset1 =%d loffset2 =%d",s1->textsrc.loffset,s2->textsrc.loffset);
*/

 if(s1->textsrc.offset>s2->textsrc.offset)
 {
  temp=s1;
  s1=s2;
  s2=temp;
 }

 s=*s1;

 lozon=&from;
 hizon=&to;
 zone=1;

 err=txlock(&s.textsrc,s.file);
 if(!err)
 {
  while(1)
  {
   if(s.textsrc.loffset==s.boffset || newbox)
   {
    vvisible(&s,&visible);
    from=s;
    newbox=0;
    texup=(texsub*)(((char*)s.textsrc.textp)+s.textsrc.usize);

    txgetvshifts(s.textsrc.textp,texup+s.textsrc.s,&vshift,&vdelta);

    vlimit=s.bvoffset;
    for(i=0;i<s.textsrc.s;i++) 
    {
     vlimit+=texup[i].vlines;
    }

    vshift+=vdelta*((s.textsrc.voffset-vlimit)/sizeof(vlstr));
    vlimit+=texup[i].vlines-sizeof(vlstr);
   }
   else
   if(s.textsrc.voffset>vlimit)
   {
    texup=(texsub*)(((char*)s.textsrc.textp)+s.textsrc.usize);
    vlimit+=texup[s.textsrc.s].vlines;
    txgetvshifts(s.textsrc.textp,texup+s.textsrc.s,&vshift,&vdelta);
   }

   if(visible)
   {
    getlinearea(&s,NULL,&xbox,NULL);
    xbox.y0+=vshift;
    xbox.y1+=vshift;
    if(valid) getsumabox(&vbox,&xbox);
    else
    {
     vbox=xbox;
     valid=1;
    }

    voffset=s.textsrc.voffset+sizeof(vlstr);
    while(voffset<s.textsrc.vsourcep->len && voffset<=vlimit)
    {
     vline=vlptr(s.textsrc.vsourcep,voffset);
     if(vline->line.xl) voffset+=sizeof(vlstr);
     else               break;
    }

    if(voffset>=vlimit) /* last line in column/box */
    {
     if(s.textsrc.loffset==s2->textsrc.loffset) to=*s2;
     else                                       
     {
      to=s;
      to.textsrc.offset+=vlptr(s.textsrc.vsourcep,s.textsrc.voffset)->line.len;
      to.textsrc.voffset=voffset;
     }

     if(from.textsrc.offset!=to.textsrc.offset)
     {
      refreshchunk(&s,&vbox);
     }
     valid=0;
    }
   }

   if(!nextvline(&s)) break;
   if(s.textsrc.loffset>s2->textsrc.loffset) break;
   vshift+=vdelta;
  }

  if(valid)
  {
   to=*s2;
   if(from.textsrc.offset!=to.textsrc.offset)
   {
    refreshchunk(&s,&vbox);
   }
  }

  txunlock(&s.textsrc,s.file);
 }

 zone=tempz;
 orderzone();

 return(err);
}


/* called on a locked vector */

static os_error * extendvec(vector * s,coordstr * cx,posnstr * posn)
{
 os_error * err;

 err=NULL;

 if(cx->x>ourunits(2*cvdu.deltax,posn->view))
 {
  err=txlock(&s->textsrc,s->file);
  if(!err)
  {
   if(nextvline(s))
   {
    vsetxy(s);
   }
   txunlock(&s->textsrc,s->file);
  }
 }

 return(err);
}



/* called by update text drag */

os_error * updatezone(vector * v,coordstr * cx,posnstr * posn)
{
 os_error * err;
 vector     s;
 vector     oldzon;
 int        waszone;

 err=NULL;

 if(v->textsrc.source==act.textsrc.source) /* check lines etc. */
 {
  s=*v;

  err=extendvec(&s,cx,posn);

  if(!err)
  {
   /* we are going to set zon to s */

   if(zone) oldzon=zon;
   else
   {
    err=txlock(&act.textsrc,s.file);
    vsetxy(&act);
    txunlock(&act.textsrc,act.file);
    oldzon=act;
   }

  /* dprintf(1,"act offset=%d x=%d s offset=%d  y=%d",
               act.textsrc.offset,act.x,
                 s.textsrc.offset,s.x); */

   waszone=zone;

   if(!zone || zon.textsrc.offset!=s.textsrc.offset)   /* change */
   {
    zon=s;

    /* there's a loophole here if there wasn't a zone, and there's */
    /* not going to be one, why refresh?                           */

    if(zon.textsrc.offset==act.textsrc.offset) zone=0; 
    else                                       zone=1;

                               /* this has to go here or order zone */
                               /* does not set lozon etc.           */
    if(zone || waszone)
    {
     refreshzone(&oldzon,&zon);
     txactstylechange(0x1);
    }
   }
  }
 }
 return(err);
}



/* across vdi's ? */

os_error *  unselects(int pcaret)
{
 os_error * err;

 err=NULL;

 if(act.valid && zone)
 {
  zone=0;
  err=refreshzone(&act,&zon);
  if(pcaret) resetactive();
 }
 return(err);
}



os_error * unselect(void)
{
 return(unselects(1));
}


/* called to set up a zone */

os_error * setupzone(vector * s1,vector * s2)
{
 os_error * err;

 err=NULL;

 if(act.valid && !zone) clearcaret();

 unselects(0); 
 if(s1->textsrc.offset!=s2->textsrc.offset)
 {
  err=txlock(&s1->textsrc,s1->file);
  vsetxy(s1);
           
  setactives(s1,0);

  txunlock(&s1->textsrc,s1->file);

  err=txlock(&s2->textsrc,s2->file);
  vsetxy(s2);
  txunlock(&s2->textsrc,s2->file);

  zon=*s2;
  zone=1;

  txactstylechange(0x1);

  refreshzone(&act,&zon);
 }

 return(err);
}



os_error * setupzonehi(vector * s1,vector * s2)
{
 os_error * err;
 int        zone;

 err=nullzone(s1,s2,&zone);

 if(!err && zone)
 {
  err=undostart(s1->file);
  if(!err)
  {
   err=unsaveact();
   if(!err) err=setupzone(s1,s2);
   undoend(s1->file);
  }
 }

 return(err);
}



/* called when a drag starts */

os_error * actstartdrag(void)
{
 undostart(act.file);
 unsaveact();
 clearcaret();
 return(undoend(act.file));
}














/* either extend the zone or make it from pointer to caret */

os_error * extendzone(vector * s,coordstr * cx,posnstr * posn)
{
 os_error * err;
 vector     oldv;
 vector     v;

 err=NULL;

 if(act.valid)
 {
  if(s->textsrc.source==act.textsrc.source)
  {
   v=*s;
   extendvec(&v,cx,posn);
   if(zone)
   {
    undostart(act.file);
    unsaveact();

    if((v.textsrc.offset>=act.textsrc.offset && 
        v.textsrc.offset<=zon.textsrc.offset) ||
       (v.textsrc.offset<=act.textsrc.offset && 
        v.textsrc.offset>=zon.textsrc.offset))
    { /* shrinking the zone */
     if(ABS(v.textsrc.offset-zon.textsrc.offset)<
        ABS(v.textsrc.offset-act.textsrc.offset))
     {
      oldv=zon;   /* closer to zon so move that */
      zon=v;
      refreshzone(&oldv,&zon);
     }
     else          /* closer to act so move that instead */
     {
      if(zon.textsrc.offset<act.textsrc.offset)
      {
       oldv=act;
       checkactive(&v);
       refreshzone(&oldv,&act);
      }
      else
      if(zon.textsrc.offset>act.textsrc.offset)
      {
       oldv=act;
       checkactive(&v);
       refreshzone(&oldv,&act);
      }
     }
    }
    else
    if((v.textsrc.offset>zon.textsrc.offset && 
        act.textsrc.offset<zon.textsrc.offset) || 
       (v.textsrc.offset<zon.textsrc.offset && 
        act.textsrc.offset>zon.textsrc.offset))
    {
     oldv=zon;
     zon=v;
     refreshzone(&oldv,&zon);
    }
    else
    if((v.textsrc.offset>act.textsrc.offset && 
        zon.textsrc.offset<act.textsrc.offset))
    {
     oldv=act;
     checkactive(&v);
     refreshzone(&oldv,&act);
    }
    else
    if((v.textsrc.offset<act.textsrc.offset && 
        zon.textsrc.offset>act.textsrc.offset))
    {
     oldv=act;
     checkactive(&v);
     refreshzone(&oldv,&act);
    }
    undoend(act.file);
   }
   else
   {
    oldv=act;
    setupzonehi(&oldv,&v);
   }

   txactchange();
  }
 }
 return(err);
}




static os_error * changezone(amovefn movefn,int updatex)
{
 os_error * err;
 vector     s1;
 vector     s2;
 int        rzone;

 if(act.valid)
 {
  s2=act;
  if(zone) s1=zon;
  else     s1=act;

  err=txlock(&s2.textsrc,s2.file);
  if(!err)
  {
   if(movefn) err=movefn(&s2);
   txunlock(&s2.textsrc,s2.file);
  }

  nullzone(&s1,&s2,&rzone);
  if(zone)
  {
   err=undostart(menufile);
   if(!err)
   {
    unsaveact();

    if(rzone)
    {
     err=txlock(&s2.textsrc,s2.file);
     vsetxy(&s2);
     txunlock(&s2.textsrc,s2.file);

     s1=act;
     act=s2;
     refreshzone(&s1,&act);
    }
    else
    {
//     unselect();
     zone=0;
     err=refreshzone(&act,&zon);
     act=zon;
     resetactive();
    }

    undoend(menufile);
   }
  }
  else
  if(rzone)
  {
   setupzonehi(&s2,&s1);
  }

  if(rzone)
  {
   err=txlock(&s2.textsrc,s2.file);
   if(!err)
   {
    checkboxselected(&s2);
    screencaret(&s2);
    txunlock(&s2.textsrc,s2.file);
   }
  
   if(updatex) setxa(&act);
  }

  txactchange();
 }

 return(NULL);
}





static os_error * selecttext(vector * s,amovefn movefn1,amovefn movefn2)
{
 os_error * err;
 vector     s1;
 vector     s2;

 err=NULL;

 s1=*s;

 if(s1.valid)
 {
  err=txlock(&s1.textsrc,s1.file);
  if(!err)
  {
   if(movefn1) err=movefn1(&s1);
   txunlock(&s1.textsrc,s1.file);
  }

  if(!err)
  {
   s2=s1;
   err=txlock(&s2.textsrc,s2.file);
   if(!err)
   {
    if(movefn2) err=movefn2(&s2);
    txunlock(&s2.textsrc,s2.file);
   }
  }

  if(!err) err=setupzonehi(&s2,&s1);
 }

 return(err);
}





os_error * selectword(vector * s)
{
 return(selecttext(s,settosow,settoeowx));
}

os_error * selectword1(vector * s)
{
 return(selecttext(s,settosow,settoeow));
}


os_error * selectline(vector * s)
{
 return(selecttext(s,settosol,settoeoldx1));
}


os_error * selectpara(vector * s)
{
 return(selecttext(s,settosopx,settosnpx));
}


os_error * selectall(vector * s)
{
 return(selecttext(s,settosot,settoeot));
}





static os_error * markleft(int count)
{
 return(changezone(prevchx,1));
	USE(count);
}


static os_error * markright(int count)
{
 return(changezone(nextchx,1));
	USE(count);
}



static os_error * markwordleft(int count)
{
 return(changezone(settospwsp,1));
	USE(count);
}


static os_error * markwordright(int count)
{
 return(changezone(settosnw,1));
	USE(count);
}



static os_error * markup(int count)
{
 return(changezone(upline,0));
	USE(count);
}



static os_error * markdown(int count)
{
 return(changezone(downline,0));
	USE(count);
}


// idea is move act point, leave zon alone (if zone) or set to act 


static os_error * marksol(void)
{
 return(changezone(settosol,1));
 // return(selecttext(&act,NULL,settosol));
}



static os_error * markeol(void)
{
 return(changezone(settoeoldx1,1));
 // return(selecttext(&act,NULL,settoeoldx1));
}



static os_error * marksot(void)
{
 return(changezone(settosot,1));
 // return(selecttext(&act,NULL,settosot));
}



static os_error * markeot(void)
{
 return(changezone(settoeot,1));
 // return(selecttext(&act,NULL,settoeot));
}








/*****************************************************************************/

#ifdef NEVER



os_error * selectword(vector * s)
{
 os_error * err;
 vector     s1;
 vector     s2;

 s1=*s;

 err=txlock(&s1.textsrc,s1.file);
 if(!err)
 {
  settosow(&s1);
  txunlock(&s1.textsrc,s1.file);
 }

 if(!err)
 {
  s2=s1;
  err=txlock(&s2.textsrc,s2.file);
  if(!err)
  {
   settoeowx(&s2);
   txunlock(&s2.textsrc,s2.file);
  }
 }

 err=setupzonehi(&s1,&s2);

 return(err);
}



os_error * selectline(vector * s)
{
 os_error * err;
 vector     s1;
 vector     s2;

 err=NULL;

 s1=*s;

 err=txlock(&s1.textsrc,s1.file);
 if(!err)
 {
  settosol(&s1);
  txunlock(&s1.textsrc,s1.file);
 }

 if(!err)
 {
  s2=s1;
  err=txlock(&s2.textsrc,s2.file);
  if(!err)
  {
   settoeol(&s2,1);
   txunlock(&s2.textsrc,s2.file);
  }
 }

 err=setupzonehi(&s1,&s2);

 return(err);
}



os_error * selectpara(vector * s)
{
 os_error * err;
 vector     s1;
 vector     s2;

 err=NULL;

 s1=*s;

 err=txlock(&s1.textsrc,s1.file);
 if(!err)
 {
  settosopx(&s1);
  txunlock(&s1.textsrc,s1.file);
 }

 if(!err)
 {
  s2=s1;
  err=txlock(&s2.textsrc,s2.file);
  {
   settosnpx(&s2);
   txunlock(&s2.textsrc,s2.file);
  }
 }

 err=setupzonehi(&s1,&s2);

 return(err);
}



os_error * selectall(vector * s)
{
 os_error * err;
 vector     s1;
 vector     s2;

 err=NULL;

 s1=*s;

 err=txlock(&s1.textsrc,s1.file);
 if(!err)
 {
  settosot(&s1);
  txunlock(&s1.textsrc,s1.file);
 }

 if(!err)
 {
  s2=s1;
  err=txlock(&s2.textsrc,s2.file);
  if(!err)
  {
   settoeot(&s2);
   txunlock(&s2.textsrc,s2.file);
  }
 }

 err=setupzonehi(&s1,&s2);

 return(err);
}








#endif

/*****************************************************************************/


static int atransevent;


static os_error * atrans0(int eventn,int user,filestr * file,int data)
{
 os_error * err;

 err=NULL;

 atransevent=0;

 if(act.valid && file==act.file) 
 {
  err=clearactives(UACTPOSN1);
  if(!undoactive(file)) atransevent=1;
 }

 return(err);

 USE(data);
 USE(user);
 USE(eventn);
}



static os_error * atrans1(int eventn,int user,filestr * file,int data)
{
 os_error * err;
 vector     s;
 int        bytes;
 int        lines;

 err=NULL;


 if(atransevent)
 {
  /* many things may change, columns, offsets etc. */

  setvectorfrombox(&s,act.textsrc.u,act.textsrc.text,file);

  err=txlock(&s.textsrc,s.file);
  if(!err)
  {
   if(eventn==EVENT_MOVESELECTION1)
   {
    pagesectionof((chainobject*)s.textsrc.textp,file,&s.page,&s.section);
   }

   flowvalidate(&s,FLVBOX);

   if(s.boffset<=act.textsrc.offset)
   {
    boxcontents(s.textsrc.textp,s.textsrc.u,&bytes,&lines);

    if((s.boffset+bytes)>act.textsrc.offset)
    {
     resetpoint(&s,act.textsrc.offset);

     err=setxya(&s);
     if(!err) err=setactive(&s);
     txactchange();
    }
   }
   txunlock(&s.textsrc,s.file);
  }

  atransevent=0;
 }

 return(err);

 USE(data);
 USE(user);
 USE(eventn);
}



/*****************************************************************************/


static os_error * fsetsize(xstylestr * style,int size)
{
 styleclrall(style);
 style->action.size=1;
 style->data.ypts=CUT(size,MINPTSIZE*1000,MAXPTSIZE*1000);
 return(settextstyle(act.file,style,SCOPECURR));
}


static os_error * fstepsize(int delta)
{
 os_error * err;
 xstylestr  style;

 err=NULL;

 if(act.valid && act.file==menufile)
 {
  gettextstyle(act.file,&style);
  err=fsetsize(&style,style.data.ypts+delta);
 }

 return(err);
}


static int sizetab[14]={
                        8*1000,
                        10*1000,
                        12*1000,
                        14*1000,
                        18*1000,
                        24*1000,
                        36*1000,
                        48*1000,
                        60*1000,
                        72*1000,
                        84*1000,
                        96*1000,
                        108*1000,
                        120*1000
                       };


static os_error * fsteprange(int delta)
{
 os_error * err;
 xstylestr  style;
 int        size;
 int        i;

 err=NULL;

 if(act.valid && act.file==menufile)
 {
  gettextstyle(act.file,&style);

  size=style.data.ypts;

  if(delta>0)
  {
   for(i=0;i<(sizeof(sizetab)/sizeof(int));i++) 
   {
    if(sizetab[i]>size) break;
   }
  }
  else
  {
   for(i=(sizeof(sizetab)/sizeof(int))-1;i>=0;i--) 
   {
    if(sizetab[i]<size) break;
   }
  }

  if(i>=0 && i<(sizeof(sizetab)/sizeof(int)))
  {
   err=fsetsize(&style,sizetab[i]);
  }
 }

 return(err);
}


static os_error * fstepkern(int delta)
{
 os_error * err;
 xstylestr  style;
 int        track;

 err=NULL;

 if(act.valid && act.file==menufile)
 {
  gettextstyle(act.file,&style);
  track=readtrack(style.data.track,&style)+delta;
  track=CUT(track,MINTRACK,MAXTRACK);
  style.data.track=writetrack(track,&style);
  styleclrall(&style);
  style.action.track=1;
  err=settextstyle(act.file,&style,SCOPECURRK);
 }

 return(err);
}



static os_error * fstephscale(int delta)
{
 os_error * err;
 xstylestr  style;
 int        hscale;

 err=NULL;

 if(act.valid && act.file==menufile)
 {
  gettextstyle(act.file,&style);
  hscale=scale(0x10000,style.data.xpts,style.data.ypts)+delta;
  hscale=CUT(hscale,MINHSCALE,MAXHSCALE);
  style.data.xpts=scale(style.data.ypts,hscale,0x10000);
  styleclrall(&style);
  style.action.hscale=1;
  err=settextstyle(act.file,&style,SCOPECURR);
 }

 return(err);
}




static os_error * fstepbaseshift(int delta)
{
 os_error * err;
 xstylestr  style;
 int        baseshift;

 err=NULL;

 if(act.valid && act.file==menufile)
 {
  gettextstyle(act.file,&style);
  baseshift=readtrackpc(style.data.baseshift,&style);
  baseshift=CUT(baseshift+delta,MINBASESHIFT,MAXBASESHIFT);
  style.data.baseshift=writetrackpc(baseshift,&style);
  styleclrall(&style);
  style.action.baseshift=1;
  err=settextstyle(act.file,&style,SCOPECURR);
 }

 return(err);
}




/*****************************************************************************/
/* handle key presses in text */

#define TXTBUFFLEN 0x80

static char textbuff[TXTBUFFLEN];
static int  txindex;


 /* take textbuff and paste it into text at act */

static os_error * textflush(void)
{
 os_error * err;

 err=NULL;

 if(txindex)
 {
  textbuff[txindex]=0;
  txindex=0;
  err=actinstext(textbuff,0,sizeof(textbuff));
 }
 return(err);
}




/* when you get a key press you can't use, flush buffer */

// this should really only process character codes
// rather than keypresses


os_error * textkey(int * key)
{
	os_error * err;
 int        ch;
 int        c;

// cprintf("textkey %x %x",*key,key[KEYDATA]);

 if(act.valid && act.file==menufile)
 {
  c=*key;

  switch(c)
  {

           case '\t':
//            case TAB:
         case XTABCH:
                     ch='\t';
                     break;
          
       case XNEWPARA:
            case  '\r':
//         case RETURN:            /* i.e. \r */
                     ch='\n';
                     break;

           case '\n':
       case XNEWLINE:
//    case SHFT_RETURN:
                     ch='\r';
                     break;

    case CTRL_RETURN:
        case XEOPAGE:
                     ch=EOPAGE;
                     break;

  /*  case SHFT_ENTER: */ // this could be taken out using the extended flag
    case     XEOBOX:
                    ch=EOBOX;
                    break;

    case     XDCHYPH:
    case  CTRL_MINUS:
                     ch=DCHYPH;
                     break;

     case     NBHYPH:
     case    XNBHYPH:
                     ch=NBHYPH;
                     break;

     case    NBSPACE:
     case   XNBSPACE:
                     ch=NBSPACE;
                     break;
     

             default:
// The 'new' code below is no good because codes like XDATE don't flush
// any pending text
// XDATE outputs text direct, not via the buffer
//                     if(ch>255) return(NULL);
//                     if(ch<0)   return(textflush());
//                     if(ch<SPACE || ch==DEL) return(NULL);

																						


                     if(c<SPACE || c>0x10000 || c==DEL)
                     {
                      return(textflush());
                     }
																					else
																					{
//                      cprintf("ins %d %x",c,c);
#if (MAXCOMPATABILITY>=UNICOMPAT) && 0
                      if(act.file->compatability>=UNICOMPAT)
                      {
																						 ch=code8inv(c);
                       if(ch<0)
                       {
                        c=code16win(c);
                       }


                      }
                      else
#endif
                      {
                       if(c>255)
                       {
                        ch=code16inv(c);
                       }
                       else
                       {
                        ch=code8symbolinv(c);
                       }

//                       cprintf("ch %d c %d",ch,c);
                      }


#if (MAXCOMPATABILITY>=UNICOMPAT)
																						if(ch<0)
                      {
                       textflush();
																							err=txunccheck(act.file);
																							if(!err)
																							{
//                        cprintf("insert %x",c);
                        char buff[8];

                        buff[0]=(char)UNC16;
                        buff[1]=(char)(c&0xFF);
                        buff[2]=(char)((c>>8)&0xFF);
																						 	buff[3]=0;
                        err=actinstext(buff,UNC16LEN,sizeof(buff));
																							}

                       *key=-1;

                       return(err);
                      }
#else

                      if(ch<0)
                      {
                       return(textflush());
                      }

#endif
																					}

                     break;

  }

 /*
  if(ch=='\t')
  {
   textbuff[txindex++]=TABSEQ;
   textbuff[txindex++]=1;
   textbuff[txindex++]=1;
   textbuff[txindex++]=1;
  }
  else
  {
   textbuff[txindex++]=ch;
  }
 */

  textbuff[txindex++]=(char)ch;


  *key=-1;

  toolspointeroff();
 }

 return(NULL);
}




#ifdef NEVER


static os_error * actundo(int c,filestr * file)
{
 os_error * err;

 switch(c)
 {
   case AUNDO_LEFT:
                   err=caretleft(1);
                   break;

  case AUNDO_RIGHT:
                   err=caretright(1);
                   break;

     case AUNDO_UP:
                   err=caretup(1);
                   break;

   case AUNDO_DOWN:
                   err=caretdown(1);
                   break;

           default:
                   err=NULL;
                   break;
 }

 return(err);

 USE(file);
}



static char * actundoname(int c)
{
 char * p;

 p=NULL;

 switch(c)
 {
   case AUNDO_LEFT:
                   p="{UCLEFT}";
                   break;

  case AUNDO_RIGHT:
                   p="{UCRIGHT}";
                   break;

     case AUNDO_UP:
                   p="{UCUP}";
                   break;

   case AUNDO_DOWN:
                   p="{UCDOWN}";
                   break;

 }

 return(p);
}


#endif







static int actcount;
static int actkey;


static os_error * actflush(void)
{
 os_error * err;

 err=NULL;

// cprintf("actkey=%x",actkey);

 if(actcount)
 {
  switch(actkey)
  {
    /* caret movement */

         case  CLEFT:
                     caretleft(actcount);
                     break;

  case    SHFT_CLEFT:
                     markleft(actcount);
                     break;

  case    CTRL_CLEFT:
                     sopword();
                     break;

   case   CTSH_CLEFT:
                     markwordleft(actcount);
                     break;



         case CRIGHT:
                     caretright(actcount);
                     break;

  case   SHFT_CRIGHT:
                     markright(actcount);
                     break;

  case   CTRL_CRIGHT:
                     sonword();
                     break;

  case   CTSH_CRIGHT:
                     markwordright(actcount);
                     break;


  
         case  CDOWN:
                     caretdown(actcount);
                     break;

  case    SHFT_CDOWN: 
                     markdown(actcount); //sonpara();     /* start of next para */
                     break;

     case CTRL_CDOWN:
                     sonpara();//eotext();
                     break;

  case    CTSH_CDOWN:
                     caretdownlock(actcount);
                     break;



         case    CUP:
                     caretup(actcount);
                     break;

  case      SHFT_CUP: 
                     markup(actcount); // soppara();     /* start of prev para */
                     break;

    case    CTRL_CUP:
                     soppara(); // sotext();
                     break;

  case      CTSH_CUP:
                     caretuplock(actcount);
                     break;




  case          COPY:
                     eoline();
                     break;

  case     SHFT_COPY: 
                     markeol();
                     break;

   case     CTRL_COPY:
                     eotext();
                     break;

   case     CTSH_COPY:
                      markeot();
                      break;


  case          HOME:
                     soline();
                     break;

  case     SHFT_HOME:
                     marksol();
                     break;

  case     CTRL_HOME:
                     sotext();
                     break;

  case     CTSH_HOME:
                     marksot();
                     break;


    /* deleting stuff */


 case       SHFT_DEL:
                     err=delnextword(actcount);
                     break;

 case SHFT_BACKSPACE:
                     err=delprevword(actcount);
                     break;

 case       CTRL_DEL:
                     err=deltoeol(actcount);
                     break;

 case CTRL_BACKSPACE:
                     err=deltosol(actcount);
                     break;


 case CTSH_BACKSPACE:
  case      CTSH_DEL:
                     err=deleteline(actcount);
                     break;

  case      XDELETEB:
                     err=delprevchar(actcount);
                     break;

  case      XDELETEF:
                     err=delnextchar(actcount);
                     break;



  /* inserting stuff */


   case      XPAGENO:
   case      XCHAPNO:
                     err=inspageno(actkey!=XCHAPNO);
                     break;

   case     XACTDATE:
                     err=insactdate();
                     break;


   case        XDATE:
                     err=insdate();
                     break;


   case        XTIME:
                     err=instime();
                     break;


   case    XDATETIME:
                     err=insdatetime();
                     break;


   case     XDOCNAME:
                     err=insname();
                     break;


   case     XDOCPATH:
                     err=inspath();
                     break;


   case      XDOCDIR:
                     err=insdir();
                     break;

   case    XEMSPACED:
   case    XENSPACED:
   case    XEMSPACEN:
   case    XENSPACEN:
   case   XEMSPACEND:
   case   XENSPACEND:
   case     XEMSPACE:
   case     XENSPACE:
                     err=insspace(actkey);
                     break;



  /* manipulating text */

   case       CTSH_S:
                     err=swopcase();
                     break;


   case       CTSH_Q:
                     err=transpose();
                     break;


   case       CTSH_K:
                     err=markcontents();
                     break;


   case       CTSH_X:
//                     err=markindex();
																					err=returntocaret();
                     break;


   case       CTRL_T:
                     err=thword();
                     break;


			case								ALT_X:
																					err=unicodehex();
																					break;


  case  CTRL_LSQUARE: /* dec horiz scale by 1% */
                     err=fstephscale(-(0x10000/100));
                     break;


  case  CTSH_LSQUARE: /* dec horiz scale by 5% */
                     err=fstephscale(-(5*0x10000/100));
                     break;


  case  CTRL_RSQUARE: /* inc horiz scale by 1% */
                     err=fstephscale(0x10000/100);
                     break;

  case  CTSH_RSQUARE: /* inc horiz scale by 5% */
                     err=fstephscale((5*0x10000)/100);
                     break;




   case    SSHIFTKEY:
                     err=txsshiftstart();
                     break;


             default:
                     if(actkey==BACKSPACE)
                     {
                      if(zone) err=deleteselected();
                      else     err=delprevchar(actcount);
                     }
                     else
                     if(actkey==DEL)
                     {
//                      cprintf("del selected");
                      if(zone) err=deleteselected();
                      else     err=delnextchar(actcount);
                     }
                     else
                     if(actkey==keycanonical2code(COMMAINDEX|KEYCTRL))
                     {
                      /* dec pt size by 1 */
                      err=fstepsize(-1000);
                     }
                     else
                     if(actkey==keycanonical2code(COMMAINDEX|KEYCTSH))
                     {
                      /* dec pt size standard step */
                      err=fsteprange(-1);
                     }
                     else
                     if(actkey==keycanonical2code(POINTINDEX|KEYCTRL))
                     {
                      /* inc pt size by 1 */
                      err=fstepsize(1000);
                     } 
                     else
                     if(actkey==keycanonical2code(POINTINDEX|KEYCTSH))
                     {
                      /* inc pt size standard step */
                      err=fsteprange(1);
                     }
                     else
                     if(actkey==keycanonical2code(SEMICOINDEX|KEYCTRL))
                     {
                      /* dec kerning in step of 1 */
                      err=fstepkern(-1);
                     }
                     else
                     if(actkey==keycanonical2code(SEMICOINDEX|KEYCTSH))
                     {
                      /* dec kerning in step of 10 */
                      err=fstepkern(-10);
                     }
                     else
                     if(actkey==keycanonical2code(SQUOTEINDEX|KEYCTRL))
                     {
                      /* inc kerning in step of 1 */
                      err=fstepkern(1);
                     }
                     else
                     if(actkey==keycanonical2code(SQUOTEINDEX|KEYCTSH))
                     {
                      /* inc kerning in step of 10 */
                      err=fstepkern(10);
                     }
                     else
                     if(actkey==keycanonical2code(DIGIT9|KEYCTRL))
                     {
                      err=fstepbaseshift(-(0x10000/100));
                     }
                     else
                     if(actkey==keycanonical2code(DIGIT0|KEYCTRL))
                     {
                      err=fstepbaseshift((0x10000/100));
                     }
                     else
                     if(actkey==keycanonical2code(DIGIT9|KEYCTSH))
                     {
                      err=fstepbaseshift(-(5*0x10000/100));
                     }
                     else
                     if(actkey==keycanonical2code(DIGIT0|KEYCTSH))
                     {
                      err=fstepbaseshift((5*0x10000/100));
                     }
                     break;
  }

  actcount=0;
  if(actkey!=SSHIFTKEY) txsshiftclear();
 }

 return(err);
}



os_error * actionkey(int * key)
{
 os_error * err;
 int        ch;

 err=NULL;

 if(act.valid && act.file==menufile)
 {
  ch=*key;

//  cprintf("ch %x DEL %x",ch,DEL);

  switch(ch)
  {
   /* caret movement */

   case    CTRL_CLEFT:
   case   CTRL_CRIGHT:
   case    CTRL_CDOWN:
   case      CTRL_CUP:

   case    SHFT_CDOWN: 
   case      SHFT_CUP:
   case    SHFT_CLEFT:
   case   SHFT_CRIGHT: 

   case      CTSH_CUP:
   case    CTSH_CDOWN:
   case    CTSH_CLEFT:
   case   CTSH_CRIGHT:

   case         CLEFT:
   case        CRIGHT:
   case         CDOWN:
   case           CUP:

  case          COPY:
  case     SHFT_COPY: 
  case     CTRL_COPY:
  case     CTSH_COPY:
  case          HOME:
  case     SHFT_HOME:
  case     CTRL_HOME:
  case     CTSH_HOME:
                     break;

   /* deleting stuff */



   case           DEL:
   case     BACKSPACE:
   case CTRL_BACKSPACE:
   case SHFT_BACKSPACE:

   case      CTSH_DEL:
   case      SHFT_DEL:
   case      CTRL_DEL:


   case      XDELETEF:
   case      XDELETEB:


   /* inserting stuff */



    case      XPAGENO:
    case      XCHAPNO:
    case     XACTDATE:
    case        XDATE:
    case        XTIME:
    case    XDATETIME:
    case      XDOCDIR:
    case     XDOCNAME:
    case     XDOCPATH:
    case    XEMSPACEN:
    case    XENSPACEN:
    case    XEMSPACED:
    case    XENSPACED:
    case   XEMSPACEND:
    case   XENSPACEND:
    case     XEMSPACE:
    case     XENSPACE:

   /* manipulating text */

    case       CTSH_S:


    case       CTSH_Q:


    case       CTSH_K:


    case       CTSH_X:


    case       CTRL_T:


				case								ALT_X:

   /*  etc              */


   case  CTRL_LSQUARE:

   case  CTSH_LSQUARE:


   case  CTRL_RSQUARE:

   case  CTSH_RSQUARE:



    case    SSHIFTKEY:
                      break;

              default:
                      if(
                         ch==keycanonical2code(COMMAINDEX|KEYCTRL) ||
                         ch==keycanonical2code(COMMAINDEX|KEYCTSH) ||
                         ch==keycanonical2code(POINTINDEX|KEYCTRL) ||
                         ch==keycanonical2code(POINTINDEX|KEYCTSH) ||
                         ch==keycanonical2code(SEMICOINDEX|KEYCTRL)||
                         ch==keycanonical2code(SEMICOINDEX|KEYCTSH)||
                         ch==keycanonical2code(SQUOTEINDEX|KEYCTRL)||
                         ch==keycanonical2code(SQUOTEINDEX|KEYCTSH) ||
                         ch==keycanonical2code(DIGIT9|KEYCTRL)||
                         ch==keycanonical2code(DIGIT0|KEYCTRL)||
                         ch==keycanonical2code(DIGIT9|KEYCTSH)||
                         ch==keycanonical2code(DIGIT0|KEYCTSH)
                        ) 
                      {
                       break;
                      }
                      else
                      {
                       err=actflush();
                       return(err);
                      }
                      break;
  }

  if(ch==actkey) actcount++;
  else
  {
   err=actflush();
   actkey=ch;
   actcount++;
  }

  toolspointeroff();

  *key=-1;
 }

 return(err);
}




/* called when file is closed */

/*

 See txclose for doing this

static os_error * actfclose(int eventn,int user,filestr * file,int data1)
{

 if(act.valid && act.file==file) 
 {
  act.valid=0;
  zone=0;
 }

 return(NULL);
 USE(eventn);
 USE(user);
 USE(data1);
}

*/


/* called when file is about to be saved */
/* it is noteworthy this is called *after* the undo code has saved */
/* the caret posn etc.                                             */


static os_error * actfsave(int eventn,int user,filestr * file,int data1)
{
 if(act.valid && act.file==file) 
 {
  actclearpend();
  actclose();
 }

 return(NULL);
 USE(eventn);
 USE(user);
 USE(data1);
}



#define UNDOS 24


static undofnstr undos[UNDOS]=
{
 unloadact,     NULL,          UACTPOSN,     "{UACTPOSN}",
 uninserts,     NULL,          UINSERTS,     "{UINSERT}",
 uninsertf,     NULL,          UINSERTF,     "{UINSERT}",
 uninserts,     NULL,          UDELETES,     "{UDELETE}",
 uninsertf,     NULL,          UDELETEF,     "{UDELETE}",
 undelete,      NULL,          UDELETE,      NULL,
 undeleteb,     NULL,          UDELETEB,     NULL,
 uninsert,      uninsertscrap, UINSERT,      NULL,
 uninsertb,     uninsertscrapb,UINSERTB,     NULL,
 unswopcase,    NULL,          USWOPCASE,    "{USWOPCASE}",
	unchangecase,  NULL,          UCHANGECASE,  "{UCHANGECASE}",
 ussblock,      ussblockscrap, USSBLOCK,     NULL,
 ustyles,       NULL,          USTYLES,      "{USSTYLE}",
 ustylef,       NULL,          USTYLEF,      "{USSTYLE}",
 ucaretleft,    NULL,          UCARETLEFT,   "{UCLEFT}",
 ucaretright,   NULL,          UCARETRIGHT,  "{UCRIGHT}",
 ucaretup,      NULL,          UCARETUP,     "{UCUP}",
 ucaretdown,    NULL,          UCARETDOWN,   "{UCDOWN}",
 utranspose,    NULL,          UTRANSPOSE,   "{UTRANP}",
 unloadact1,    NULL,          UACTPOSN1,    "{UACTPOSN}",
 unfinserts,    NULL,          UFINSERTS,    "{UINSERT}",
 unfinsertf,    NULL,          UFINSERTF,    "{UINSERT}",
	uunihexs,						NULL,										UUNIHEXS,					"{UUNIHEX}",
	uunihexf,      NULL,										UUNIHEXF,					"{UUNIHEX}",

};




os_error * actinit(void)
{
 os_error * err;

/*          err=undoaddsbfn(actundo,actundoname);
 if(!err) */
            
/* if(!err) err=addevent(EVENT_FCLOSE,(eventfn)actfclose,0); */

          err=undoaddblock(undos,UNDOS);
 if(!err) err=addevent(EVENT_FPRESAVE,(eventfn)actfsave,0);
 if(!err) err=addevent(EVENT_TRANSFORMSELECTION0,(eventfn)atrans0,0);
 if(!err) err=addevent(EVENT_TRANSFORMSELECTION1,(eventfn)atrans1,0);
 if(!err) err=addevent(EVENT_TEXTFLOWSELECTION0,(eventfn)atrans0,0);
 if(!err) err=addevent(EVENT_TEXTFLOWSELECTION1,(eventfn)atrans1,0);
 if(!err) err=addevent(EVENT_MODIFYSELECTION0,(eventfn)atrans0,0);
 if(!err) err=addevent(EVENT_MODIFYSELECTION1,(eventfn)atrans1,0);
 if(!err) err=addevent(EVENT_SHAPESELECTION0,(eventfn)atrans0,0);
 if(!err) err=addevent(EVENT_SHAPESELECTION1,(eventfn)atrans1,0);
 if(!err) err=addevent(EVENT_MOVESELECTION0,(eventfn)atrans0,0);
 if(!err) err=addevent(EVENT_MOVESELECTION1,(eventfn)atrans1,0);
 if(!err) err=addevent(EVENT_SHIFTSELECTION0,(eventfn)atrans0,0);
 if(!err) err=addevent(EVENT_SHIFTSELECTION1,(eventfn)atrans1,0);
 if(!err) err=addevent(EVENT_PREFERENCES0,(eventfn)atrans0,0);
 if(!err) err=addevent(EVENT_PREFERENCES1,(eventfn)atrans1,0);

 if(!err) err=txddinit();

 return(err);
}


