/*->c.dbul */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "bbc.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "font.h"

#include "transform.h"
#include "etc.h"


#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "redraw.h"
#include "colour.h"
#include "conf.h"
#include "bits.h"
#include "trans.h"
#include "xmath.h"
//#include "wimptext.h"
#include "fsx.h"
#include "bf.h"
#include "deb.h"
#include "osunits.h"


#include "dbhi.h"
#include "mhi.h"



#include "str.h"
#include "constants.h"

#include "object.h"

#include "reslink.h"
#include "units.h"
#include "xcolour.h"
#include "file.h"
#include "undo.h"

#include "view.h"
#include "viewr.h"
#include "dbscale.h"
#include "macros.h"

#include "txstr.h"
#include "dbcolour.h"
#include "dbchars.h"
#include "dbstyle.h"
#include "txchoices.h"

#include "ustyle.h"
#include "codes.h"
#include "fox.h"
#include "act.h"
#include "fx.h"
#include "tx.h"

#include "dbul.h"



extern dboxstr ulbox;
extern dboxstr stbox;



/*****************************************************************************/
/* underline details */


static colourvalue ulcolour;
static int         uldouble;
static int         ulword;
static int         ulthickness;
static int         ultype;

static ulfn        ulcloser;


static colourvalue stcolour;
static int         stthickness;
static int         sttype;

static stfn        stcloser;



static filestr  *  cfile;
static viewstr  *  cview;


static void ul2style(xstylestr * style)
{
 style->data.uldouble=uldouble;
 style->data.ulcolour=ulcolour;
 style->data.ulword=ulword;
 style->data.ulthickness=ulthickness;
 style->data.ultype=ultype;
}



static void style2ul(xstylestr * style)
{
 uldouble=style->data.uldouble;
 ulcolour=style->data.ulcolour;
 ulword=style->data.ulword;
 ulthickness=style->data.ulthickness;
 ultype=style->data.ultype;
}




static os_error * wruls(int value,char * string,int type)
{
 if(type==0) strcpy(string,unitstostring(value,POINTS));
 else
 {
  strcpy(string,numbertostring(scale(value,100,0x10000)));
  strcat(string,"%");
 }

 return(NULL);
}


static os_error * wruls2(int value,char * string,int type)
{
 int result;
 wruls(value,string,type);
 xexec("ulinename",&result,"S/S",string,string);
 return(NULL);
}


static os_error * wrul(int value,char * string)
{
 return(wruls2(value,string,ultype));
}


static os_error * wrst(int value,char * string)
{
 return(wruls2(value,string,sttype));
}



static os_error * rduls(int * value,int * typep,char * input)
{
 os_error * err;
 int        type;
 int        i;
 char       string[256];
 int        result;


 err=xzstrncpye(string,input,sizeof(string));
	if(!err)
	{
  xexec("ulinereversename",&result,"S/NS",string,sizeof(string),string);

  i=0;
  type=-1;
  while(string[i])
  {
   if(string[i]=='%') type=1;
   i++;
  }
  if(type==-1) type=0;

  *typep=type;
  *value=0;

  switch(type)
  {
   case 1:
          err=stringtonumber(string,value);
          *value=scale(*value,0x10000,100);
          break;

  case  0:
          err=stringtounits(string,value,POINTS);
          break;
  }
	}

 return(err);
}



static os_error * rdul(int * value,char * string)
{
 return(rduls(value,&ultype,string));
}


static os_error * rdst(int * value,char * string)
{
 return(rduls(value,&sttype,string));
}





static int ulinemode;


/* void readulwidth(string & s); */

void readulwidth(int fp)
{
 if(ulinemode)
 {
  rduls(&ulthickness,&ultype,stringptr(stack[fp]));
  dbchangevalue(&ulthickness,&ulbox);
 }
 else
 {
  rduls(&stthickness,&sttype,stringptr(stack[fp]));
  dbchangevalue(&stthickness,&stbox);
 }
}


/* void writeulwidth(string & s); */

void writeulwidth(int fp)
{
 char string[16];

 if(ulinemode) wruls(ulthickness,string,ultype);
 else          wruls(stthickness,string,sttype);

 assignstring(stack[fp],string);
}


/*
static os_error * openulinewidth(int mode,int handle)
{
 ulinemode=mode;
 return(openmenuparent("ulinewidth_menu",handle));
}
*/


static os_error *ulcolredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;

 err=NULL;

 while(more)
 {
  redrawblock(redrawstr,handle,6,vfindcolour2(NULL,cfile,&ulcolour));
  wimp_get_rectangle(redrawstr,&more);
 }
 return(err);

 USE(handle);
}



static os_error * ulredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) ulcolredrawsub(handle,&redrawstr,more);
 return(err);
 USE(userhandle);
}

static void ulpickclose(colourvalue * colour)
{
 ulcolour=*colour;
 wimp_set_icon_state(ulbox.handle,6,(wimp_iconflags)0,(wimp_iconflags)0);
}

static os_error * ulclose(int code)
{
 os_error * err;
 xstylestr  cstyle;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  ul2style(&cstyle);
  if(ulcloser) ulcloser(&cstyle);
 }

 return(err);
}


/*
static os_error * setulwidth(int width)
{
 ulthickness=width;
 dbchangevalue(&ulthickness,&ulbox);
 return(NULL);
}
*/


static os_error * ulicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
//  case 4:
//          err=openulinewidth(1,handle);
//          break;

  case 7:
          err=pickcolour(cfile,&ulcolour,ulpickclose,&ulbox);
          break;
 }

 return(NULL);

 handle=handle;
 userhandle=userhandle;

 return(err);
}


static os_error * ulcombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

 ulinemode=1;

 err=menucombo(&ulbox,3,"ulinewidth_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);
}



static dbiconstr ulicondefs[15]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,

 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */
    3, &ulthickness, DBWRITE,  0,   0,      0,  0,  0,   0,      rdul,wrul,
    3, &ulthickness, DBCOMBO,  0,  DBCOMBOX,0,  0,  0,   0,      NULL,(dbwritefn)ulcombo,


 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

    0,  &ulword,     DBTOGGLE, 0,    0,      1,  F1, 0, 0,   NULL,   0,
    9,  &uldouble,   DBTOGGLE, 0,    0,      1,  F2, 0, 0,   NULL,   0,

   -1, NULL,         0,        0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr ulbox=
{
 0,
 TUNDER,
 DBFIX,
 0,
 ulclose,
 ulicon,
 NULL,
 ulredraw,
 ulicondefs,
 0,
 0,
 0,NULL,
 0,0,
};


os_error * openulattributes(filestr * file,xstylestr * cstyle,ulfn ulclosex,
                                                              dboxstr * parent)
{
 os_error * err;

 cfile=file;
 ulcloser=ulclosex;
 style2ul(cstyle);

 err=dodboxsp(&ulbox,1,parent,&dbviewstack);

 return(err);
}


/*****************************************************************************/


static void st2style(xstylestr * style)
{
 style->data.stcolour=stcolour;
 style->data.stthickness=stthickness;
 style->data.sttype=sttype;
}



static void style2st(xstylestr * style)
{
 stcolour=style->data.stcolour;
 stthickness=style->data.stthickness;
 sttype=style->data.sttype;
}





static os_error *stcolredrawsub(int handle,wimp_redrawstr * redrawstr,int more)
{
 os_error * err;

 err=NULL;

 while(more)
 {
  redrawblock(redrawstr,handle,4,vfindcolour2(NULL,cfile,&stcolour));
  wimp_get_rectangle(redrawstr,&more);
 }
 return(err);

 USE(handle);
}

static os_error * stredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) stcolredrawsub(handle,&redrawstr,more);
 return(err);
 USE(userhandle);
}

static void stpickclose(colourvalue * colour)
{
 stcolour=*colour;
 wimp_set_icon_state(stbox.handle,4,(wimp_iconflags)0,(wimp_iconflags)0);
}

static os_error * stclose(int code)
{
 os_error * err;
 xstylestr  cstyle;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  st2style(&cstyle);
  if(stcloser) stcloser(&cstyle);
 }

 return(err);
}

/*

static os_error * setstwidth(int width)
{
 stthickness=width;
 dbchangevalue(&stthickness,&stbox);
 return(NULL);
}

*/


static os_error * sticon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 switch(m->i)
 {
//  case 7:
//          err=openulinewidth(0,handle);
//          break;

  case 5:
          err=pickcolour(cfile,&stcolour,stpickclose,&stbox);
          break;
 }

 return(NULL);

 handle=handle;
 userhandle=userhandle;

 return(err);
}


static os_error * stcombo(int event,int data,void * datap,int * hit,uservalue * userp)
{
	os_error * err;

 ulinemode=0;

 err=menucombo(&stbox,6,"ulinewidth_menu",event,data,hit,userp);
																																																																																					 
	return(err);

	USE(datap);
}




static dbiconstr sticondefs[15]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,

 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */
    6, &stthickness, DBWRITE,  0,   0,      0,  0,  0,   0,      rdst,wrst,
    6, &stthickness, DBCOMBO,  0,   DBCOMBOX,0,  0,  0,   0,     NULL,(dbwritefn)stcombo,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   -1, NULL,         0,        0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr stbox=
{
 0,
 TSTRIKE,
 DBFIX,
 0,
 stclose,
 sticon,
 NULL,
 stredraw,
 sticondefs,
 0,
 0,
 0,NULL,
 0,0,
};


os_error * openstattributes(filestr * file,xstylestr * cstyle,stfn stclosex,
                                                             dboxstr * parent)
{
 os_error * err;

 cfile=file;
 stcloser=stclosex;
 style2st(cstyle);

 err=dodboxsp(&stbox,1,parent,&dbviewstack);

 return(err);
}


/**************************************************************************/
/* hyphenation details */


static hpfn        hpcloser;
static int         hpmin;
static int         hpbefore;
static int         hpafter;
static int         hpconsec;
static int         hpzone;
static int         hpbreaklast;
static int         hpbreakcaps;


static void style2hp(xstylestr * style)
{
 hpmin=style->data.hpmin;
 hpbefore=style->data.hpbefore;
 hpafter=style->data.hpafter;
 hpconsec=style->data.hpconsec;
 hpzone=style->data.hpzone;
 hpbreaklast=style->data.hpbreaklast;
 hpbreakcaps=style->data.hpbreakcaps;
}


static void hp2style(xstylestr * style)
{
 style->data.hpmin=hpmin;
 style->data.hpbefore=hpbefore;
 style->data.hpafter=hpafter;
 style->data.hpconsec=hpconsec;
 style->data.hpzone=hpzone;
 style->data.hpbreaklast=hpbreaklast;
 style->data.hpbreakcaps=hpbreakcaps; 
}



static os_error * hpclose(int code)
{
 os_error * err;
 xstylestr  cstyle;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  hp2style(&cstyle);
  if(hpcloser) hpcloser(&cstyle);
 }
 return(err);
}


static os_error * wrno(int value,char * string)
{
 strcpy(string,numbertostring(value));
 return(NULL);
}

static os_error * rdno(int * value,char * string) 
{
 return(stringtonumber(string,value));
}





static os_error * wrzo(int value,char * string)
{
 strcpy(string,unitstostring(value,POINTS));
 return(NULL);
}

static os_error * rdzo(int * value,char * string) 
{
 return(stringtounits(string,value,POINTS));
}



static dbiconstr hpicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,

 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */

   13, &hpmin,       DBWRITE,  0,    0,     -1, -1,  3, -1,     rdno,wrno,
    3, &hpbefore,    DBWRITE,  0,    0,     -1, -1,  5,  1,     rdno,wrno,
    5, &hpafter,     DBWRITE,  0,    0,     -1, -1,  7,  3,     rdno,wrno,
    7, &hpconsec,    DBWRITE,  0,    0,     -1, -1,  9,  5,     rdno,wrno,
    9, &hpzone,      DBWRITE,  0,    0,     -1, -1, -1,  7,     rdzo,wrzo,
 
   11, &hpbreaklast, DBTOGGLE, 0,    0,      1,  -1, 0,  0,     NULL,   0,
   12, &hpbreakcaps, DBTOGGLE, 0,    0,      1,  -1, 0,  0,     NULL,   0,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   -1, NULL,         0,        0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr hpbox=
{
 0,
 THANDJ,
 DBFIX,
 0,
 hpclose,
 NULL,
 NULL,
 NULL,
 hpicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};


os_error * openhyphenation(filestr * file,xstylestr * cstyle,hpfn hpclse,
                                                            dboxstr * parent)
{
 os_error * err;

 cfile=file;
 hpcloser=hpclse;
 style2hp(cstyle);

 err=dodboxsp(&hpbox,1,parent,&dbviewstack);

 return(err);
}

/****************************************************************************/

/* bullet details */

extern dboxstr bulletbox;


static stfn        bulletcloser;
static int         bulletornumber;
static int         bullettab;
static int         bulletsymbol;
static int         bulletformat;
static int         bulletstart;
static int         bulletstyle;
static int         bulletdostyle;
static int         bulletbefore;
static int         bulletafter;

static userstylebasestr ** stylebasep;



static void style2bullet(xstylestr * style)
{
 bulletornumber=style->data.bulletornumber;
 bullettab=style->data.bullettab;
 bulletstart=style->data.bulletstart;
 bulletstyle=style->data.bulletstyle;

 if(bulletstyle==BULLETNOSTYLE)
 {
  bulletstyle=BODYTEXT;
  bulletdostyle=0;
 }
 else
 {
  bulletdostyle=1;
 }

 bulletbefore=style->data.bulletbefore1+((style->data.bulletbefore2)<<8);

//	cprintf("before1 %x before2 %x",style->data.bulletbefore1,style->data.bulletbefore2);

 bulletafter=style->data.bulletafter1+((style->data.bulletafter2)<<8);

 if(bulletornumber)
 {
  bulletformat=0;
  bulletsymbol=style->data.bulletdata1+((style->data.bulletdata2)<<8);
 }
 else
 {
  bulletsymbol=0x8F;
  bulletformat=style->data.bulletdata1+((style->data.bulletdata2)<<8);
 }
}


static void bullet2style(xstylestr * style)
{
 style->data.bulletornumber=bulletornumber;
 style->data.bullettab=bullettab;
 style->data.bulletstart=bulletstart;

 if(bulletdostyle) style->data.bulletstyle=bulletstyle;
 else              style->data.bulletstyle=BULLETNOSTYLE;

 style->data.bulletbefore1=(bulletbefore & 0xFF);
 style->data.bulletbefore2=(char)((bulletbefore>>8) & 0xFF);

 style->data.bulletafter1=(bulletafter & 0xFF);
 style->data.bulletafter2=(char)((bulletafter>>8) & 0xFF);

 if(bulletornumber)
 {
  style->data.bulletdata1=(char)(bulletsymbol & 0xFF);
  style->data.bulletdata2=(char)((bulletsymbol>>8) & 0xFF);
 }
 else
 {
  style->data.bulletdata1=(char)(bulletformat & 0xFF);
  style->data.bulletdata2=(char)((bulletformat>>8) & 0xFF);
 }
}



static userstylestr * bfinduserstyle(int bulletstyle,filestr * file)
{
 userstylestr * s;
 int            n;

 if(stylebasep)
 {
  n=finduserstylebase(*stylebasep,bulletstyle);
  s=&((*stylebasep)->userstyle[n]);
 }
 else
 {
  finduserstylep(&s,bulletstyle,file);
 }

 return(s);
}


#define SYMICON 9

#define CXFRONT  0x0
#define CXFRONTSHADE 0x80808000

static os_error * bulletredrawsub(int handle,wimp_redrawstr * redrawstr,
                                                                  int more)
{
 os_error     * err;
 userstylestr   s;
 userstylestr * sp;
 int            fh;
 iconstr        icon;
 char           string[8];
 font_info      fi;
 int            ox;
 int            oy;
 int            xshift;
 int            yshift;
// int            ch;
 int            uni;
 int            osfont;

 err=NULL;

	if(more)
	{
  uni=txunicode;

  geti(handle,SYMICON,&icon);

  while(more)
  {
   if(bulletsymbol && iconinredraw(redrawstr,&icon)) 
   {
    ox=redrawstr->box.x0-redrawstr->scx;
    oy=redrawstr->box.y1-redrawstr->scy;

    wimp_setoscolour(CCSYSBASE+COLOR_BTNFACE);
    bbc_rectanglefilli(ox+icon.ix0,oy+icon.iy0,icon.ix1-icon.ix0,icon.iy1-icon.iy0);

    sp=bfinduserstyle(bulletstyle,cfile);
    if(sp)
    {
     s=*sp;
     osfont=fontosfromuser(s.style.data.font);

     memset(string,0,sizeof(string));

     err=font_find4(fontosname(osfont),fontcharset(osfont),0,fontitalic(osfont),
                      fontfamily(osfont),fontpitch(osfont),0,(12*cvdu.ydpi)/72,0,&fh);
					if(!err)
					{
      font_setcolour(fh,PALTRANSPARENT,bulletornumber?CXFRONT:CXFRONTSHADE,0);

      if(uni)
      {
 						if(bulletsymbol<256)
 						{
        fontgetcode16(bulletsymbol,osfont,(wchar_t*)string,NULL);
 						}
   				else
 	  			{
 		  			*((wchar_t*)string)=(wchar_t)bulletsymbol;
 			  	 *(((wchar_t*)string)+1)=0;
 		  		}

       font_stringbbox16((wchar_t*)string,&fi);
      } 
      else
      {
       if(bulletsymbol<256) fontgetcode8(bulletsymbol,osfont,string,NULL);
       font_stringbbox(string,&fi);
      }

      font_align(FA_BASELINE|FA_LEFT);

      xshift=((icon.ix1-icon.ix0)-xpix2os(fi.maxx-fi.minx))/2;
      yshift=((icon.iy1-icon.iy0)-ypix2os(fi.maxy-fi.miny))/2;

//					cprintf("iy1 %d iy0 %d maxy %d miny %d yshift %d",icon.iy1,icon.iy0,fi.maxy,fi.miny,yshift);

      yshift+=ypix2os(fi.maxy);
      if(uni) font_paint16((wchar_t*)string,font_OSCOORDS,(ox+icon.ix0+xshift),(oy+icon.iy1-yshift));
      else    font_paint(string,font_OSCOORDS,(ox+icon.ix0+xshift),(oy+icon.iy1-yshift));

      font_lose(fh);
					}
//    fontdefscale();
    }
   }

   wimp_get_rectangle(redrawstr,&more);
  }
	}

 return(err);
}


static os_error * bulletredraw(int handle,int userhandle)
{
 os_error     * err;
 wimp_redrawstr redrawstr;
 int            more;
 redrawstr.w=handle;
 err=wimp_redraw_wind(&redrawstr,&more);
 if(!err) bulletredrawsub(handle,&redrawstr,more);
 return(err);
 userhandle=userhandle;
}



static os_error * bulletclose(int code)
{
 os_error * err;
 xstylestr  cstyle;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  bullet2style(&cstyle);
  if(bulletcloser) bulletcloser(&cstyle);
 }
 return(err);
}


static os_error * charpickclose(int c,xstylestr * style)
{
	os_error * err;

	err=NULL;

	if(c>255) err=txunccheck(cfile);

	if(!err && c>31)
	{
  bulletsymbol=c;
  wimp_set_icon_state(bulletbox.handle,SYMICON,(wimp_iconflags)0,(wimp_iconflags)0);
	}

 return(err);

 USE(style);
}


static os_error * setbulletstyle(int style)
{
 bulletstyle=style;

 if(!bulletdostyle)
 {
  bulletdostyle=1;
  dbshade(1,0,&bulletbox);
  dbchangevalue(&bulletdostyle,&bulletbox);
 }
 else
 {
  dbchangevalue(&bulletstyle,&bulletbox);
 }

 wimp_set_icon_state(bulletbox.handle,SYMICON,(wimp_iconflags)0,(wimp_iconflags)0);
 return(NULL);
}


static os_error * getbulletstyle(int * style)
{
 *style=bulletdostyle?bulletstyle:BULLETNOSTYLE;
 return(NULL);
}


static os_error * bulleticon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error     * err;
 userstylestr * s;


 err=NULL;

 switch(m->i)
 {
  case   7:
           err=openuserstylemenu(setbulletstyle,getbulletstyle,handle);
           break;

  case  14:
           err=openmenuparent("bullet_menu",handle);
           break;

  case  10:
           s=bfinduserstyle(bulletstyle,cfile);
           if(s)
           {
            pickchar(charpickclose,&bulletbox,
                     s->style.data.font,CHARSNOCHOICE,handle,cfile);
           }
           break;
 }

 return(err);

 USE(handle);
 USE(userhandle);
}


int getbulletformat(int fp)
{
 return(bulletformat);
 USE(fp);
}


void setbulletformat(int fp)
{
 bulletformat=stack[fp];
 dbchangevalue(&bulletformat,&bulletbox);
}



static os_error * wrchar(int value,char * string)
{
 unsigned short temp[4];

 if(value>=32)
 {
  temp[0]=(unsigned short)value;
  temp[1]=0;
 }
 else
 {
  temp[0]=0;
 }
 
 stringtomacro2(temp,string,DBWRITEMAX);

 return(NULL);
}



static os_error * rdchar(int * value,char * string) 
{
	os_error       * err;
 unsigned short   temp[8];
	int              ch;

 err=macrotostring2(string,temp,NITEM(temp));
	if(!err)
	{
		ch=temp[0];
		if(ch>255) err=txunccheck(cfile);
		if(!err)
		{
   if(ch>=32) *value=ch;
   else       *value=0;
		}
	}

 return(err);
}



static os_error * wrstyle(int value,char * string)
{
 userstylestr * s;

 s=bfinduserstyle(value,cfile);
 if(s)
 {
  strcpy(string,s->name);
 }
 else
 {
  *string=0;
 }

 return(NULL);
}



/* formats     */
/* low  4 bits */
/* 0    1      */
/* 1    i      */
/* 2    I      */
/* 3    a      */
/* 4    A      */

/* hi   4 bits */
/* 0    n      */
/* 1    n.n... */
/* 2    c.n    */



static char * cformat[]={"123","iii","III","abc","ABC","123a","123A"};
static char * dformat[]={"n","n.n...","c.n..."};



os_error * wrbulletformat(int value,char * string)
{
 int c;
 int d;

 c=value & 0xF;
 d=(value>>4) & 0xF; 
 sprintf(string,"%s/%s",cformat[c],dformat[d]);

 return(NULL);
}




static os_error * optfn(int handle,int userhandle,wimp_mousestr * m)
{
 return(dbshade(1,bulletdostyle?0:DBSHADEG,&bulletbox));

 USE(handle);
 USE(userhandle);
 USE(m);
}



static os_error * optfn2(int handle,int userhandle,wimp_mousestr * m)
{
	cprintf("optfn2");

	shadeiconst(handle,9,!bulletornumber);
	shadeiconst(handle,10,!bulletornumber);
	shadeiconst(handle,4,!bulletornumber);
	shadeiconst(handle,8,!bulletornumber);

	wimp_set_icon_state(handle,SYMICON,(wimp_iconflags)0,(wimp_iconflags)0);


	shadeiconst(handle,14,bulletornumber);
	shadeiconst(handle,12,bulletornumber);
	shadeiconst(handle,15,bulletornumber);
	shadeiconst(handle,0,bulletornumber);

 return(dbshade(3,bulletornumber?DBSHADEG:0,&bulletbox));

 USE(userhandle);
 USE(m);
}







static dbiconstr bulleticondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,

 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */

   16, &bulletstart, DBWRITE,  3,    0,     -1, -1,  5,  1,     rdno,wrno,
   20, &bulletbefore,DBWRITE,  0,    0,     -1, -1,  3, -1,     rdchar,wrchar,
   22, &bulletafter, DBWRITE,  0,    0,     -1, -1,  5,  1,     rdchar,wrchar,

    6, &bulletstyle, DBTEXT,   1,    0,     -1, -1,  9,  5,     NULL,wrstyle,
   13, &bulletformat,DBTEXT,   3,    0,     -1, -1, -1,  7,     NULL,wrbulletformat,
 
   23, &bullettab,    DBTOGGLE, 0,   0,      1,  -1,  0,  0,    NULL,   0,

   25, &bulletdostyle,DBTOGGLE, 0,   0,      1,  -1,  0,  0,(dbreadfn)optfn,0,


   18, &bulletornumber,DBRADIO, 0,   0,      1,   0,  1,  0,(dbreadfn)optfn2,  NULL,
   17, &bulletornumber,DBRADIO, 0,   0,      0,   0,  1,  0,(dbreadfn)optfn2,  NULL,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   -1, NULL,         0,        0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr bulletbox=
{
 0,
 TBULLET,
 DBFIX,
 0,
 bulletclose,
 bulleticon,
 NULL,
 bulletredraw,
 bulleticondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};


os_error * openbullet(filestr * file,xstylestr * cstyle,bulletfn bulletclse,
                      dboxstr * parent,userstylebasestr ** xstylebasep)
{
 os_error * err;

 cfile=file;
 bulletcloser=bulletclse;
 style2bullet(cstyle);
 stylebasep=xstylebasep;

 err=dodboxsp(&bulletbox,1,parent,&dbviewstack);
	if(!err)
	{
  optfn2(bulletbox.handle,0,NULL);
 	optfn(bulletbox.handle,0,NULL);
	}

 return(err);
}


/***************************************************************************/

/* justification details */


static justfn      justcloser;
static int         justlettermin;
static int         justlettermax;
static int         justflushzone;
static int         justwordmin;
static int         justwordmax;
static int         justsingle;


static void style2just(xstylestr * style)
{
 justlettermin=style->data.justlettermin;
 justlettermax=style->data.justlettermax;
 justflushzone=style->data.justflushzone;
 justwordmin=style->data.justwordmin;
 justwordmax=style->data.justwordmax;
 justsingle=style->data.justsingle;
}


static void just2style(xstylestr * style)
{
 style->data.justlettermin=justlettermin;
 style->data.justlettermax=justlettermax;
 style->data.justflushzone=justflushzone;
 style->data.justwordmin=justwordmin;
 style->data.justwordmax=justwordmax;
 style->data.justsingle=justsingle;
}



static os_error * justclose(int code)
{
 os_error * err;
 xstylestr  cstyle;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  just2style(&cstyle);
  if(justcloser) justcloser(&cstyle);
 }
 return(err);
}


static os_error * wru(int value,char * string)
{
 strcpy(string,unitstostring(value,cview->data.units));
 return(NULL);
}

static os_error * rdu(int * value,char * string)
{
 return(stringtounits(string,value,cview->data.units));
}



static os_error * rdlt(int * value,char * string) 
{
 os_error * err;
 int        n;

 err=stringtonumber(string,&n);
 n=CUT(n,JUSTLETTMIN,JUSTLETTMAX);
 if(!err) *value=n;

 return(err);
}


static os_error * wrwd(int value,char * string)
{
 strcpy(string,numbertostring(value*JUSTWORDSCALE));
 return(NULL);
}

static os_error * rdwd(int * value,char * string) 
{
 os_error * err;
 int        n;

 err=stringtonumber(string,&n);
 n=CUT(n,JUSTWORDMIN,JUSTWORDMAX);
 if(!err) *value=n/JUSTWORDSCALE;

 return(err);
}





static dbiconstr justicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,

 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */

    3, &justlettermin,DBWRITE,  0,    0,     -1, -1,  3, -1,     rdlt,wrno,
    5, &justlettermax,DBWRITE,  0,    0,     -1, -1,  5,  1,     rdlt,wrno,
    7, &justwordmin,  DBWRITE,  0,    0,     -1, -1,  9,  5,     rdwd,wrwd,
    14,&justwordmax,  DBWRITE,  0,    0,     -1, -1, -1,  7,     rdwd,wrwd,
    19,&justflushzone,DBWRITE,  0,    0,     -1, -1, -1,  7,     rdu,wru,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

    11, &justsingle,  DBTOGGLE, 0,    0,      1,  F1, 0, 0,      NULL,0,

   -1, NULL,         0,        0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr justbox=
{
 0,
 TJUSTIFY,
 DBFIX,
 0,
 justclose,
 NULL,
 NULL,
 NULL,
 justicondefs,
 0,
 0
};


os_error * openjustification(viewstr * view,xstylestr * cstyle,justfn justclse,
                                                              dboxstr * parent)
{
 os_error * err;

 cview=view;
 cfile=view->file;
 justcloser=justclse;
 style2just(cstyle);

 err=dodboxsp(&justbox,1,parent,&dbviewstack);

 return(err);
}


/****************************************************************************/

static int mergetag;

static os_error * mergeclose(int code)
{
 os_error * err;
 char       string[8];

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  if(mergetag>0)
  {
   string[0]=MACSEQ;
   string[1]=(char)(mergetag);
   string[2]=(char)(mergetag>>8);
   string[3]=(char)(mergetag>>16);
   actinstext(string,MSLEN,sizeof(string));
  }
 }
 return(err);
}

static os_error * mwrno(int value,char * string)
{
 if(value>=0) strcpy(string,numbertostring(value));
 else         *string=0;
 return(NULL);
}

static os_error * mrdno(int * value,char * string) 
{
 if(*string) return(stringtonumber(string,value));
 else        *value=-1;
 return(NULL);
}

static dbiconstr mergeicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,

 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */

    3, &mergetag,    DBWRITE,  0,    0,     -1, -1,  3, -1,   mrdno,mwrno,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   -1, NULL,         0,        0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr mergebox=
{
 0,
 TMERGETAG,
 DBFIX,
 0,
 mergeclose,
 NULL,
 NULL,
 NULL,
 mergeicondefs,
 0,
 0
};


void openmergebox(int fp)
{
 os_error * err;

 cview=menuview;
 cfile=menufile;

 mergetag=-1;

 err=dodboxspparent(&mergebox,1,&mergebox,&dbviewstack,cview->handle);

 zreport(err);

 USE(fp);
}






/****************************************************************************/

extern dboxstr spacebox;

static int vspace;
static int hspace;
static int flgspace;

static int sxpts;
static int sypts;



static os_error * spaceclose(int code)
{
 os_error * err;
 char       string[SPACELEN];
 vector     v;
 int        c;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  string[0]=SPACESEQ;
  string[1]=(char)(flgspace);
  string[2]=(char)(flgspace>>8);
  string[3]=(char)(flgspace>>16);
  string[4]=(char)(hspace);
  string[5]=(char)(hspace>>8);
  string[6]=(char)(hspace>>16);
  string[7]=(char)(hspace>>24);
  string[8]=(char)(vspace);
  string[9]=(char)(vspace>>8);
  string[10]=(char)(vspace>>16);
  string[11]=(char)(vspace>>24);
  string[12]=0;
  string[13]=0;
  string[14]=0;
  string[15]=0;


  if(act.valid)
  {
   v=act;
   err=txlock(&v.textsrc,v.file);
   if(!err)
   {
    c=*txptr(v.textsrc.sourcep,v.textsrc.offset);
    txunlock(&v.textsrc,v.file);

    if(c==SPACESEQ)
    {
     err=undostart(act.file);
     if(!err)
     {
      delnextchar(1);
      err=actinstext(string,SPACELEN,sizeof(string));
      undoend(act.file);
     }
    }
    else
    {
     err=actinstext(string,SPACELEN,sizeof(string));
    }
   }
  }
 }

 return(err);
}



static os_error * spw(int value,char * string)
{
 if(flgspace & SPACESEQEM) strcpy(string,numbertostringxdp(value,0,3));
 else                    strcpy(string,unitstostring(value,cview->data.units));
 return(NULL);
}


static os_error * spr(int * value,char * string) 
{
 if(flgspace & SPACESEQEM) return(stringtonumberxdp(string,value,2,3));
 else                    return(stringtounits(string,value,cview->data.units));
}




static os_error * sopt(int handle,int userhandle,wimp_mousestr * m)
{
 flgspace^=SPACESEQEM;

 dbreadvalues(&spacebox);

 if(flgspace & SPACESEQEM)
 {
  vspace=scale(sypts,vspace,0x10000);
  hspace=scale(sxpts,hspace,0x10000);
 }
 else
 {
  vspace=scale(0x10000,vspace,sypts);
  hspace=scale(0x10000,hspace,sxpts);
 }

 flgspace^=SPACESEQEM;

 dbchangevalue(&vspace,&spacebox);
 dbchangevalue(&hspace,&spacebox);

 return(NULL);

 USE(handle);
 USE(userhandle);
 USE(m);
}







static dbiconstr spaceicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

    1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,0,0,     NULL ,0,
    2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE,0,0 ,NULL ,0,

 /* N   &V           Type     Grp   Flags   Step Key  max  min clickfn 0 */

    5, &vspace,      DBWRITE,  0,    0,     -1, -1,  3, -1,     spr, spw,
    4, &hspace,      DBWRITE,  0,    0,     -1, -1,  3, -1,     spr, spw,

    3, &flgspace,    DBTOGGLE, 0,    0,SPACESEQNB, F1,0, 0,   NULL,NULL,
    8, &flgspace,    DBTOGGLE, 0,    0,SPACESEQEM, F2,0, 0,(dbreadfn)sopt,NULL,
    9, &flgspace,    DBTOGGLE, 0,    0,SPACESEQDL, F3,0, 0,   NULL,NULL,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   -1, NULL,         0,        0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr spacebox=
{
 0,
 TINSERTSPACE,
 DBFIX,
 0,
 spaceclose,
 NULL,
 NULL,
 NULL,
 spaceicondefs,
 0,
 0
};


void openspacebox(int fp)
{
 os_error    * err;
 absstylestr   style;
 vector        v;
 char        * p;
 int           c;

 err=NULL;

 cview=menuview;
 cfile=menufile;

 if(act.valid)
 {
  err=getcaretstylex(&act,&style);
  if(!err)
  {
   sxpts=style.style.data.xpts;
   sypts=style.style.data.ypts;

   v=act;
   err=txlock(&v.textsrc,v.file);
   if(!err)
   {
    c=*(p=txptr(v.textsrc.sourcep,v.textsrc.offset));
    txunlock(&v.textsrc,v.file);

    if(c==SPACESEQ)
    {
     flgspace=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);
     hspace=(*(p+4))+((*(p+5))<<8)+
                       ((*(p+6))<<16)+((*(p+7))<<24); 
     vspace=(*(p+8))+((*(p+9))<<8)+
                           ((*(p+10))<<16)+((*(p+11))<<24); 

    }
    err=dodboxspparent(&spacebox,1,&spacebox,&dbviewstack,cview->handle);
   }
  }
 }

 zreport(err);

 USE(fp);
}



