/*->c.dc */

/* Ovation!   (c) D. J. Pilling,  December 1988                     */
/*                        Dictionary Code                             */


#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>

#include "os.h"
#include "wimp.h"
#include "sprite.h"
#include "font.h"
#include "bbc.h"
#include "flex.h"
#include "werr.h"
#include "transform.h"

#include "alloc.h"
#include "etc.h"
#include "fsx.h"
#include "bf.h"
#include "err.h"
#include "deb.h"
#include "wos.h"
#include "osreg.h"
#include "bits.h"

#include "constants.h"
#include "reslink.h"

#include "str.h"
#include "obj.h"




#include "dc.h"




void checkdict(int dict,domainstr * d);




/*****************************************************************************/


static char * dcbasepath[2]={
                             "HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\Dictionaries\\",
                             "HKEY_LOCAL_MACHINE\\Software\\DavidPilling\\UserDictionaries\\"
                            };


static char * dcuser="<HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders\\AppData>\\DavidPilling\\UserDictionaries";

char * dcpath[2];



os_error * dcpathinit(void)
{
 os_error * err;
 TCHAR      temp[FILENAMELEN];
 TCHAR      scrap[256];
 int        size;
	int        length;

 dcpath[0]=dcbasepath[0];
 dcpath[1]=dcbasepath[0];

	size=NITEM(temp);
 err=xzstrncpyu(scrap,dcbasepath[0],NITEM(scrap));
 if(!err) err=regreadstr(scrap,temp,&size);
	cprintf("regread1 size %d err %x",size,err);
	if(err || size==0)
 {
		err=NULL;
  dcpath[0]=TEXT("");
	}
	else
	{
		err=salloc((flex_ptr)&dcpath[0],(size+1)*sizeof(TCHAR));
		if(!err)
		{
			xzstrncpyu(dcpath[0],temp,size+1);
		}
	}

	size=NITEM(temp);
 err=xzstrncpyu(scrap,dcbasepath[1],NITEM(scrap));
 if(!err) err=regreadstr(scrap,temp,&size);
	cprintf("regread2 size %d err %x",size,err);

	if(err || size==0)
 {
		err=NULL;
  dcpath[1]=dcpath[0];
	}
	else
 if(size==1)
 {
  dcpath[1]=dcuser;
		err=fs_cdir(dcpath[1]);
  if(err)
  {
   err=NULL;
   dcpath[1]=dcpath[0];
  }
 }
 else
	{
  TCHAR uname[MAX_USERNAME];

  err=getusername(uname,sizeof(uname));
		if(!err)
		{
			length=size+1+strlen(uname)+1;
 		err=salloc((flex_ptr)&dcpath[1],length*sizeof(TCHAR));
 		if(!err)
 		{
 			fs_join(dcpath[1],length,temp,uname);
				err=fs_cdir(dcpath[1]);
 		}
		}
	}

	
	return(err);
}




#ifdef OLDVERSION


char * mfx[256]=
{
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"abilities", /* 31 */
"ability",
"phobia",
"ities",
"body",
"naut",
"olog",
"able",
"'",        /* ' 39 */
"ally",
"ance",
"edge",
"ance",
"ancy",
"-",        /* - 45 */
"ence",
"ency",
"0",        /* 0 48 */
"1",
"2",
"3",
"4",
"5",
"6",
"7",
"8",
"9",         /* 9 57 */
"hood",
"less",
"like",
"logy",
"ment",
"ness",
"ophy",
"A",         /* A 65 */
"B",
"C",
"D",
"E",
"F",
"G",
"H",
"I",
"J",
"K",
"L",
"M",
"N",
"O",
"P",
"Q",
"R",
"S",
"T",
"U",
"V",
"W",
"X",
"Y",
"Z",
"ship",
"tion",
"ace",
"act",
"age",
"ane",
"a",
"b",
"c",
"d",
"e",
"f",
"g",
"h",
"i",
"j",
"k",
"l",
"m",
"n",
"o",
"p",
"q",
"r",
"s",
"t",
"u",
"v",
"w",
"x",
"y",
"z",       /* z 122 */
"ant",
"ate",
"ent",
"ess",
"ful",
"ian",
"ies",
"ine",
"ing",
"ion",
"ise",
"ish",
"ism",
"ite",
"ity",
"ium",
"ive",
"ize",
"man",
"oid",
"ome",
"ous",
"tic",
"tum",
"ure",
"way",
"al",
"am",
"an",
"ar",
"ch",
"ck",
"de",
"ea",
"ed",
"ee",
"en",
"er",
"es",
"ey",
"gh",
"ic",
"ie",
"in",
"is",
"it",
"le",
"ll",
"ly",
"nd",
"ne",
"nn",
"nt",
"on",
"oo",
"or",
"ph",
"re",
"ry",
"se",
"sh",
"ss",
"te",
"th",
"tt",
"ty",
"um",
"un",
"us",
"",   /* 192 */
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
""};


#else

char * mfx[256]=
{
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"ng",
"ss",
"ess",
"on",
"er",
"ed",
"le",
"ion",
"'",
"te",
"ble",
"al",
"es",
"ce",
"-",
"nt",
"us",
"0",
"1",
"2",
"3",
"4",
"5",
"6",
"7",
"8",
"9",
"tion",
"an",
"ate",
"ic",
"ty",
"ent",
"ies",
"A",
"B",
"C",
"D",
"E",
"F",
"G",
"H",
"I",
"J",
"K",
"L",
"M",
"N",
"O",
"P",
"Q",
"R",
"S",
"T",
"U",
"V",
"W",
"X",
"Y",
"Z",
"se",
"able",
"ne",
"ation",
"re",
"nce",
"a",
"b",
"c",
"d",
"e",
"f",
"g",
"h",
"i",
"j",
"k",
"l",
"m",
"n",
"o",
"p",
"q",
"r",
"s",
"t",
"u",
"v",
"w",
"x",
"y",
"z",
"st",
"ing",
"ous",
"ge",
"de",
"ly",
"nd",
"ity",
"rd",
"ck",
"sm",
"ry",
"sh",
"en",
"ar",
"ia",
"in",
"ter",
"ul",
"ted",
"lity",
"ch",
"ility",
"bility",
"ard",
"lly",
"ence",
"is",
"et",
"ve",
"um",
"ct",
"ance",
"me",
"ine",
"ht",
"ay",
"tic",
"ad",
"ll",
"ian",
"ip",
"cal",
"ght",
"el",
"and",
"ries",
"ication",
"ant",
"cy",
"age",
"at",
"th",
"ial",
"ious",
"id",
"ke",
"ire",
"one",
"ish",
"ive",
"logy",
"ness",
"ogical",
"il",
"own",
"ties",
"it",
"ue",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
"",
};


#endif


#define NMIDFIX sizeof(mfx) / sizeof(char *)




typedef struct chardatastr
{
 char rank;
 char upper;
 char lower;
 char upperrank;
 char lowerrank;
 unsigned short bits;

} chardatastr;


static chardatastr chardata[256]=
{
  0,  0,  0,  0,  0,0x4   , //      
  1,  1,  1,  1,  1,0x4   , //      
  2,  2,  2,  2,  2,0x4   , //      
  3,  3,  3,  3,  3,0x4   , //      
  4,  4,  4,  4,  4,0x4   , //      
  5,  5,  5,  5,  5,0x4   , //      
  6,  6,  6,  6,  6,0x4   , //      
  7,  7,  7,  7,  7,0x4   , //      
  8,  8,  8,  8,  8,0x4   , //      
 43,  9,  9, 43, 43,0x284 , //      
 44, 10, 10, 44, 44,0x204 , //      
 45, 11, 11, 45, 45,0x204 , //      
 46, 12, 12, 46, 46,0x204 , //      
 47, 13, 13, 47, 47,0x204 , //      
  9, 14, 14,  9,  9,0x4   , //      
 10, 15, 15, 10, 10,0x4   , //      
 11, 16, 16, 11, 11,0x4   , //      
 12, 17, 17, 12, 12,0x4   , //      
 13, 18, 18, 13, 13,0x4   , //      
 14, 19, 19, 14, 14,0x4   , //      
 15, 20, 20, 15, 15,0x4   , //      
 16, 21, 21, 16, 16,0x4   , //      
 17, 22, 22, 17, 17,0x4   , //      
 18, 23, 23, 18, 18,0x4   , //      
 19, 24, 24, 19, 19,0x4   , //      
 20, 25, 25, 20, 20,0x4   , //      
 21, 26, 26, 21, 21,0x4   , //      
 22, 27, 27, 22, 22,0x4   , //      
 23, 28, 28, 23, 23,0x4   , //      
 24, 29, 29, 24, 24,0x4   , //      
 25, 30, 30, 25, 25,0x4   , //      
 26, 31, 31, 26, 26,0x4   , //      
 41, 32, 32, 41, 41,0x280 , //      
 48, 33, 33, 48, 48,0x190 , // ! ! !
 49, 34, 34, 49, 49,0x190 , // " " "
 50, 35, 35, 50, 50,0x190 , // # # #
 51, 36, 36, 51, 51,0x190 , // $ $ $
 52, 37, 37, 52, 52,0x190 , // % % %
 53, 38, 38, 53, 53,0x190 , // & & &
 36, 39, 39, 36, 36,0x190 , // ' ' '
 54, 40, 40, 54, 54,0x190 , // ( ( (
 55, 41, 41, 55, 55,0x190 , // ) ) )
 56, 42, 42, 56, 56,0x190 , // * * *
 91, 43, 43, 91, 91,0x190 , // + + +
 57, 44, 44, 57, 57,0x190 , // , , ,
 37, 45, 45, 37, 37,0x190 , // - - -
 58, 46, 46, 58, 58,0x190 , // . . .
 59, 47, 47, 59, 59,0x190 , // / / /
117, 48, 48,117,117,0x9a  , // 0 0 0
121, 49, 49,121,121,0x9a  , // 1 1 1
123, 50, 50,123,123,0x9a  , // 2 2 2
125, 51, 51,125,125,0x9a  , // 3 3 3
127, 52, 52,127,127,0x9a  , // 4 4 4
128, 53, 53,128,128,0x9a  , // 5 5 5
129, 54, 54,129,129,0x9a  , // 6 6 6
130, 55, 55,130,130,0x9a  , // 7 7 7
131, 56, 56,131,131,0x9a  , // 8 8 8
132, 57, 57,132,132,0x9a  , // 9 9 9
 60, 58, 58, 60, 60,0x190 , // : : :
 61, 59, 59, 61, 61,0x190 , // ; ; ;
 92, 60, 60, 92, 92,0x190 , // < < <
 93, 61, 61, 93, 93,0x190 , // = = =
 94, 62, 62, 94, 94,0x190 , // > > >
 62, 63, 63, 62, 62,0x190 , // ? ? ?
 63, 64, 64, 63, 63,0x190 , // @ @ @
134, 65, 97,134,133,0xd3  , // A A a
151, 66, 98,151,150,0xd3  , // B B b
153, 67, 99,153,152,0xd3  , // C C c
157, 68,100,157,156,0xd3  , // D D d
161, 69,101,161,160,0xd3  , // E E e
171, 70,102,171,170,0xd3  , // F F f
174, 71,103,174,173,0xd3  , // G G g
176, 72,104,176,175,0xd3  , // H H h
178, 73,105,178,177,0xd3  , // I I i
188, 74,106,188,187,0xd3  , // J J j
190, 75,107,190,189,0xd3  , // K K k
192, 76,108,192,191,0xd3  , // L L l
194, 77,109,194,193,0xd3  , // M M m
196, 78,110,196,195,0xd3  , // N N n
200, 79,111,200,199,0xd3  , // O O o
217, 80,112,217,216,0xd3  , // P P p
219, 81,113,219,218,0xd3  , // Q Q q
221, 82,114,221,220,0xd3  , // R R r
223, 83,115,223,222,0xd3  , // S S s
228, 84,116,228,227,0xd3  , // T T t
233, 85,117,233,232,0xd3  , // U U u
243, 86,118,243,242,0xd3  , // V V v
245, 87,119,245,244,0xd3  , // W W w
247, 88,120,247,246,0xd3  , // X X x
249, 89,121,249,248,0xd3  , // Y Y y
255, 90,122,255,254,0xd3  , // Z Z z
 64, 91, 91, 64, 64,0x190 , // [ [ [
 65, 92, 92, 65, 65,0x190 , // \ \ \  continuation char
 66, 93, 93, 66, 66,0x190 , // ] ] ]
 67, 94, 94, 67, 67,0x190 , // ^ ^ ^
 69, 95, 95, 69, 69,0x190 , // _ _ _
 70, 96, 96, 70, 70,0x190 , // ` ` `
133, 65, 97,134,133,0xb3  , // a A a
150, 66, 98,151,150,0xb3  , // b B b
152, 67, 99,153,152,0xb3  , // c C c
156, 68,100,157,156,0xb3  , // d D d
160, 69,101,161,160,0xb3  , // e E e
170, 70,102,171,170,0xb3  , // f F f
173, 71,103,174,173,0xb3  , // g G g
175, 72,104,176,175,0xb3  , // h H h
177, 73,105,178,177,0xb3  , // i I i
187, 74,106,188,187,0xb3  , // j J j
189, 75,107,190,189,0xb3  , // k K k
191, 76,108,192,191,0xb3  , // l L l
193, 77,109,194,193,0xb3  , // m M m
195, 78,110,196,195,0xb3  , // n N n
199, 79,111,200,199,0xb3  , // o O o
216, 80,112,217,216,0xb3  , // p P p
218, 81,113,219,218,0xb3  , // q Q q
220, 82,114,221,220,0xb3  , // r R r
222, 83,115,223,222,0xb3  , // s S s
227, 84,116,228,227,0xb3  , // t T t
232, 85,117,233,232,0xb3  , // u U u
242, 86,118,243,242,0xb3  , // v V v
244, 87,119,245,244,0xb3  , // w W w
246, 88,120,247,246,0xb3  , // x X x
248, 89,121,249,248,0xb3  , // y Y y
254, 90,122,255,254,0xb3  , // z Z z
 71,123,123, 71, 71,0x190 , // { { {
 72,124,124, 72, 72,0x190 , // | | |
 73,125,125, 73, 73,0x190 , // } } }
 74,126,126, 74, 74,0x190 , // ~ ~ ~
 27,127,127, 27, 27,0x4   , //      
 28,128,128, 28, 28,0x4   , //      
 29,129,129, 29, 29,0x4   , //      
 85,130,130, 85, 85,0x190 , //   
172,131,131,172,172,0x1b3 , //   
 88,132,132, 88, 88,0x190 , //   
115,133,133,115,115,0x190 , //   
112,134,134,112,112,0x190 , //   
113,135,135,113,113,0x190 , //   
 68,136,136, 68, 68,0x190 , //   
116,137,137,116,116,0x190 , //   
225,138,154,225,224,0xd3  , //   
 89,139,139, 89, 89,0x190 , //   
215,140,156,215,214,0xd3  , //   
 30,141,141, 30, 30,0x4   , //      
 31,142,142, 31, 31,0x4   , //      
 32,143,143, 32, 32,0x4   , //      
 33,144,144, 33, 33,0x4   , //      
 83,145,145, 83, 83,0x190 , //   
 84,146,146, 84, 84,0x190 , //   
 86,147,147, 86, 86,0x190 , //   
 87,148,148, 87, 87,0x190 , //   
114,149,149,114,114,0x190 , //   
 39,150,150, 39, 39,0x190 , //   
 40,151,151, 40, 40,0x190 , //   
 82,152,152, 82, 82,0x190 , //   
231,153,153,231,231,0x190 , //   
224,138,154,225,224,0xb3  , //   
 90,155,155, 90, 90,0x190 , //   
214,140,156,215,214,0xb3  , //   
 34,157,157, 34, 34,0x4   , //      
 35,158,158, 35, 35,0x4   , //      
253,159,255,253,252,0xd3  , //   
 42,160,160, 42, 42,0x280 , //   
 75,161,161, 75, 75,0x190 , //   
100,162,162,100,100,0x190 , //   
101,163,163,101,101,0x190 , //   
102,164,164,102,102,0x190 , //   
103,165,165,103,103,0x190 , //   
 76,166,166, 76, 76,0x190 , //   
104,167,167,104,104,0x190 , //   
 77,168,168, 77, 77,0x190 , //   
105,169,169,105,105,0x190 , //   
135,170,170,135,135,0x190 , //   
 96,171,171, 96, 96,0x190 , //   
106,172,172,106,106,0x190 , //   
 38,173,173, 38, 38,0x190 , //   
107,174,174,107,107,0x190 , //   
 78,175,175, 78, 78,0x190 , //   
108,176,176,108,108,0x190 , //   
 95,177,177, 95, 95,0x190 , //   
124,178,178,124,124,0x19a , //   
126,179,179,126,126,0x19a , //   
 79,180,180, 79, 79,0x190 , //   
109,181,181,109,109,0x190 , //   
110,182,182,110,110,0x190 , //   
111,183,183,111,111,0x190 , //   
 80,184,184, 80, 80,0x190 , //   
122,185,185,122,122,0x19a , //   
201,186,186,201,201,0x190 , //   
 97,187,187, 97, 97,0x190 , //   
118,188,188,118,118,0x190 , //   
119,189,189,119,119,0x190 , //   
120,190,190,120,120,0x190 , //   
 81,191,191, 81, 81,0x190 , //   
139,192,224,139,138,0xd3  , //   
137,193,225,137,136,0xd3  , //   
141,194,226,141,140,0xd3  , //   
145,195,227,145,144,0xd3  , //   
143,196,228,143,142,0xd3  , //   
147,197,229,147,146,0xd3  , //   
149,198,230,149,148,0xd3  , //   
155,199,231,155,154,0xd3  , //   
165,200,232,165,164,0xd3  , //   
163,201,233,163,162,0xd3  , //   
167,202,234,167,166,0xd3  , //   
169,203,235,169,168,0xd3  , //   
182,204,236,182,181,0xd3  , //   
180,205,237,180,179,0xd3  , //   
184,206,238,184,183,0xd3  , //   
186,207,239,186,185,0xd3  , //   
159,208,240,159,158,0xd3  , //   
198,209,241,198,197,0xd3  , //   
205,210,242,205,204,0xd3  , //   
203,211,243,203,202,0xd3  , //   
207,212,244,207,206,0xd3  , //   
211,213,245,211,210,0xd3  , //   
209,214,246,209,208,0xd3  , //   
 98,215,215, 98, 98,0x190 , //   
213,216,248,213,212,0xd3  , //   
237,217,249,237,236,0xd3  , //   
235,218,250,235,234,0xd3  , //   
239,219,251,239,238,0xd3  , //   
241,220,252,241,240,0xd3  , //   
251,221,253,251,250,0xd3  , //   
230,222,254,230,229,0xd3  , //   
226,223,223,226,226,0xb3  , //   
138,192,224,139,138,0xb3  , //   
136,193,225,137,136,0xb3  , //   
140,194,226,141,140,0xb3  , //   
144,195,227,145,144,0xb3  , //   
142,196,228,143,142,0xb3  , //   
146,197,229,147,146,0xb3  , //   
148,198,230,149,148,0xb3  , //   
154,199,231,155,154,0xb3  , //   
164,200,232,165,164,0xb3  , //   
162,201,233,163,162,0xb3  , //   
166,202,234,167,166,0xb3  , //   
168,203,235,169,168,0xb3  , //   
181,204,236,182,181,0xb3  , //   
179,205,237,180,179,0xb3  , //   
183,206,238,184,183,0xb3  , //   
185,207,239,186,185,0xb3  , //   
158,208,240,159,158,0xb3  , //   
197,209,241,198,197,0xb3  , //   
204,210,242,205,204,0xb3  , //   
202,211,243,203,202,0xb3  , //   
206,212,244,207,206,0xb3  , //   
210,213,245,211,210,0xb3  , //   
208,214,246,209,208,0xb3  , //   
 99,247,247, 99, 99,0x190 , //   
212,216,248,213,212,0xb3  , //   
236,217,249,237,236,0xb3  , //   
234,218,250,235,234,0xb3  , //   
238,219,251,239,238,0xb3  , //   
240,220,252,241,240,0xb3  , //   
250,221,253,251,250,0xb3  , //   
229,222,254,230,229,0xb3  , //   
252,159,255,253,252,0xb3  , //   


};



/*
 xstrncmp(char * s1,char * s2,int max,int flags);
;             a1         a2       a3       a4
;
; flags    input   0x10000 ignore hyphens
;          output  0x1     case mismatch

*/

static int xstrncmp(char * first,char * second,int n,int * flags)
{
 int f=0;
 int s=0;
 int code;
 int code1;
 int casematch;
 int hyphens;

 *flags=(*flags) & 0xFF0000;
 hyphens=(*flags) & 0x10000;
 casematch=0;

 while(n--)
 {
  if(hyphens)
  {
   while(1)
   {
    f=*first++;
    if(f!='-') break;
   }

   while(1)
   {
    s=*second++;
    if(s!='-') break;
   }
  }
  else
  {
   f=*first++;
   s=*second++;
  }
  code1=(chardata[f].rank-chardata[s].rank);
  if(code1)
  {
   code=(chardata[f].upperrank-chardata[s].upperrank);
   if(code) return(code1);
   if(casematch==0)
   {
    if(code1<0) casematch=0x1;
    else        casematch=0x3;
   }
  }

  if(f==0) break;
 }

 *flags=(*flags)|(casematch);

 return(0);
}




static char workstring[STRLEN];
static char * workptr;

int xgetscanstring(char * string)
{
 strcpy(string,workstring);
 return(((int)workptr)-1);
}



static int xscanword(char * string,int * flags,char * subs,char * dcspc)
{
 int    copyup;
 char * match;
 int    matchlen;
 int    capslen;
 int    dohyphen;
 int    token=0;
 char * p;
 char * q;
 char * r;
 char * w;
 int    f;
 int    s=0;
 int    code=0;


 *flags=(*flags)  & 0xFF0000;
 dohyphen=(*flags) & 0x10000;

 copyup=*dcspc++;
 match=workstring;

 XMEMCPYX(workstring,subs,copyup);
 *(workstring+copyup)=0;

 matchlen=0;
 capslen=0;
 p=workstring;
 q=string;

 if(copyup) goto startmatch;

 while(1)                   // start new word
 {
  while(copyup>matchlen)
  {                         // skip to next word
   while(1)
   {
    copyup=*dcspc++;
    if(copyup==ESCTOK) dcspc++;
    else
    if(copyup<ESCTOK) break;
   }
  }

  matchlen=copyup;
  if(capslen>matchlen) capslen=matchlen;  // make sure cap match less equal match
  p=workstring+matchlen;
  q=string+matchlen;

  if(dohyphen)
  {
    // count hyphens in workstring 
   if(matchlen>0)
   {
    r=workstring;
    while(r<p)
    {
     if((*r++)=='-') q--;
    }
   }
  }


  token=*dcspc++;
  while(1)                      // move through tokens loop
  {
   if(token==0) goto finished;
   if(token==ESCTOK)
   {
    *p=*dcspc++;
    copyup++;
    *(p+1)=0;
   }
   else
   {
    r=mfx[token];
    w=p;
    while(1)
    {
     if(*r==0) break;
     *w++=*r++;
     copyup++;
    }
    *w=0;
   }

startmatch:

   while(1)                    // match loop
   {
    f=*p++;

    if(dohyphen && f=='-')
    {
     code=0;
    }
    else
    {
     s=*q++;
     code=(chardata[f].rank-chardata[s].rank);
    }

    if(code==0)
    {
     if(capslen>=matchlen) capslen++;
     matchlen++;
    }
    else
    {
     if((chardata[f].upperrank-chardata[s].upperrank)==0)
     {
      code=0;
      matchlen++;
     }
     else
     if(code<0)
     {  // skip word

      break;
     }
     else
     { // its all over

      if(dohyphen && (matchlen>(q-string-1)))
      {
       code=-1;
       break;
      }
      else
      {
       return(0);
      }
     }
    }

    // assert code==0 here

    if(matchlen>=copyup)
    {
     token=*dcspc++;

     if(token<ESCTOK)
     {
      if(*q==0)      // a hit
      {
       // set flags and workptr
       if(capslen!=matchlen) *flags=(*flags) | 0x1;
       workptr=dcspc;

       return(1);
      }
      else           // start new word
      {
       copyup=token;
       code=-1;      // force outer loop
       break;
      }
     }
     else
     {
                    // leave compare loop and get the next token
      break;
     }
    }
   }

   if(code<0) break;
  }
 }

finished:

 return(0); // word not found
}


/*****************************************************************************/

static os_error * deletebuffer(int key,domainstr * d)
{
/* dprintf(7,"delbuff=%d",key);  */


 if(key) return(ob_delete(key,d));
 else    return(NULL);
}


static os_error * createbuffer(int * key,domainstr * d)
{
 os_error   * err;
 obufferstr * buffer;

 err=ob_create(sizeof(obufferstr),d,OBUFFER,(objptr)&buffer);
 *key=buffer->key;

 if(!err)
 {
  buffer->buffer.len=sizeof(Ovnbuffer)-4;
  buffer->buffer.maxlen=buffer->buffer.len;
  buffer->buffer.previous=0;
  buffer->buffer.goffset=buffer->buffer.len;
 }

 return(err);
}


static os_error * loadbuffer(int * key,fshandle fh,domainstr * d)
{
 os_error   * err;
 Ovnbuffer    temp;
 obufferstr * buffer;

 err=fs_read(fh,&temp,sizeof(Ovnbuffer)-4);
 if(!err)
 {
  err=ob_create(sizeof(obufferstr)-sizeof(Ovnbuffer)+temp.len,
                                                d,OBUFFER,(objptr)&buffer);
  if(!err)
  {
   *key=buffer->key;
   XMEMCPYX(&buffer->buffer,&temp,sizeof(Ovnbuffer)-4);
   err=fs_read(fh,buffer->buffer.buff,temp.len-sizeof(Ovnbuffer)+4);
  }
 }
 return(err);
}


static os_error * savebuffer(int key,fshandle fh,domainstr * d)
{
 os_error   * err;
 obufferstr * buffer;

 err=NULL;

/* dprintf(6,"save buff key=%d",key); */

 buffer=(obufferstr*)ob_find(key,d);
 if(buffer)
 {
 /* dprintf(7,"save buff len=%d",buffer->buffer.len); */

  err=fs_write(fh,&buffer->buffer,buffer->buffer.len);
 }

 return(err);
}


static os_error * setsizebuffer(int key,int size,domainstr * d)
{
 os_error   * err;
 obufferstr * buffer;

 err=NULL;

 err=ob_change(key,d,size+sizeof(obufferstr),(objptr)&buffer);

 size=size+sizeof(Ovnbuffer)-4;
 buffer->buffer.len=buffer->buffer.maxlen=buffer->buffer.goffset=size;

 return(err);
}


static os_error * alterbuffer(int key,int offset,int delta,domainstr * d)
{
 os_error   * err;
 obufferstr * buffer;
 int          len;

 err=NULL;

 if(delta>0)
 {
  buffer=(obufferstr*)ob_find(key,d);
  len=buffer->buffer.len+delta;

  err=ob_change(key,d,len+sizeof(obufferstr)-sizeof(Ovnbuffer),
                                                      (objptr)&buffer);
  if(!err)
  {
   buffer->buffer.maxlen=buffer->buffer.goffset=buffer->buffer.len=len;
   len-=sizeof(Ovnbuffer)-4;

   memmove(buffer->buffer.buff+offset+delta,buffer->buffer.buff+offset,
           len-delta-offset);
  }
 }
 else
 if(delta<0)
 {
  buffer=(obufferstr*)ob_find(key,d);
  len=buffer->buffer.len;
  len-=sizeof(Ovnbuffer)-4;

  memmove(buffer->buffer.buff+offset,buffer->buffer.buff+offset-delta,
           len-offset);

  len+=sizeof(Ovnbuffer)-4;

  len+=delta;

  err=ob_change(key,d,len+sizeof(obufferstr)-sizeof(Ovnbuffer),
                                                      (objptr)&buffer);

  buffer->buffer.maxlen=buffer->buffer.goffset=buffer->buffer.len=len;
 }

 return(err);
}


char * spcharbuffer(int key,domainstr * d,int offset)
{
 obufferstr * buffer;
 buffer=(obufferstr*)ob_find(key,d);
 return(buffer->buffer.buff+offset);
}









/* make a change to the word string space */

static os_error * changeword(int dict,domainstr * d,
                             char * code,int woffset,int newlen,int oldlen)
{
 os_error  * err;
 char      * c;
 int         i;
 dictstr     dp;

 dp=((odictstr*)ob_find(dict,d))->dict;

 err=alterbuffer(dp.words,woffset,newlen-oldlen,d);
 c=spcharbuffer(dp.words,d,woffset);
 for(i=0;i<newlen;i++) *c++=code[i];

 return(err);
}


/* insert a new index pointer at indexn */

static indexstr * insindex(int dict,int indexn,domainstr * d)
{
 dictstr     dp;
 odictstr  * dpp;

 dp=((odictstr*)ob_find(dict,d))->dict;

 alterbuffer(dp.index,indexn*sizeof(indexstr),sizeof(indexstr),d);

 dpp=(odictstr*)ob_find(dict,d);
 dpp->dict.noindex++;

 return((indexstr *)spcharbuffer(dp.index,d,indexn*sizeof(indexstr)));
}


static void delindex(int dict,int indexn,domainstr * d)
{
 dictstr     dp;
 odictstr  * dpp;

 dpp=(odictstr*)ob_find(dict,d);
 dp=dpp->dict;

 dpp->dict.noindex--;

 alterbuffer(dp.index,indexn*sizeof(indexstr),-((int)sizeof(indexstr)),d);
}


#define SPLIT 12

static int lolim[SPLIT]={31,40,46,58,91,123,39,45,48,65,97 ,192};
static int hilim[SPLIT]={39,45,49,65,97,192,40,46,58,91,123,256};

static int codeword(char * prev,char * word,char *  code)
{
 int i=0;
 int j=0;
 int k=0; /* keep compiler happy */
 int l;
 int w=0;

 while((prev[i] && word[i]) && (prev[i]==word[i]) && (i<(ESCTOK-1))) i++;

 *(code+w)=(char)i;
 w++;
 if(!word[i]) return(w);

 word+=i;

 while(1)
 {
  if(w>=STRLEN) {cprintf("code word fault");return(0);}

  for(l=0;l<SPLIT;l++)                   /* looking for end of word */
  {
   for(j=lolim[l];j<hilim[l];j++)
   {
    if(!strcmp(word,mfx[j]))
    {
     *(code+w)=(char)j;
     w++;
     return(w);
    }
   }
  }

  for(l=0;l<SPLIT;l++)                   /* looking for mid strings */
  {
   for(j=lolim[l];j<hilim[l];j++)
   {
    k=0;
    while(mfx[j][k])
     {
      if(mfx[j][k]!=word[k]) break; 
      else                   k++;
     }
    if(!mfx[j][k] && word[k]) break;
   }
   if(j<hilim[l]) break;
  }

  if(l==SPLIT)
  {
   *(code+w)=ESCTOK;
   w++;
   *(code+w)=*word++;
   w++;
   if(!*word) return(w);
   /*return(0); */
  }
  else
  {
   *(code+w)=(char)j;
   w++;
   word+=k;
  }
 }
}



static int formword(int dict,word * words,domainstr * d)
{
 char     * c;
 int        n;
 dictstr    dp;
 int        m;

 dp=((odictstr*)ob_find(dict,d))->dict;

 c=spcharbuffer(dp.words,d,words->woffset);
 n=(*c) & 0x1F;
 words->string[n]=0;

 n=0;
 while(1)
 {
  c++;
  n++;
  if((*c)<MINTOK)
  {
   if(*c==ESCTOK)
   {
    m=strlen(words->string);
    c++;
    n++;
    words->string[m++]=*c;
    words->string[m]=0;
   }
   else
   {
    break;
   }
  }
  else
  {
   strcat(words->string,mfx[*c]);
  }
 }

 words->len=n;
 return(1);
}




/* given one words structure, step to the next one */
/* return 0 if no more                             */

int nextword(int dict,word * words,domainstr * d)
{
 char   * c;
 int      n;
 int      offset;
 dictstr  dp;
 int      m;

 dp=((odictstr*)ob_find(dict,d))->dict;

 words->woffset+=words->len;

 words->wordn++;
 if(words->wordn>=dp.nowords)
 {
  words->len=0;
  strcpy(words->string,"");
  return(0);
 }

 offset=words->woffset;

 c=spcharbuffer(dp.words,d,offset);
 n=(*c) & 0x1F;
 words->string[n]=0;

 n=0;
 while(1)
 {
//		if(strlen(words->string)>31) cprintf("next word overrun %s",words->string);
  
		offset++;
  c=spcharbuffer(dp.words,d,offset);
  n++;
  if((*c)<MINTOK)
  {
   if(*c==ESCTOK)
   {
    m=strlen(words->string);
    offset++;
    n++;
    c=spcharbuffer(dp.words,d,offset);
    words->string[m++]=*c;
    words->string[m]=0;
   }
   else
   {
    break;
   }
  }
  else
  {
   strcat(words->string,mfx[*c]);
  }
 }

 words->len=n;

 return(1);
}


/***************************************************************************/

/*

void printindexs(dict *dp)
{
 int     indexn;
 indexstr * indexp;
 char    string[16];

 for(indexn=dp->noindex-1;indexn<dp->noindex;indexn++)
 {
  indexp=(index*)spcharbuffer(dp->index,indexn*sizeof(indexstr));

  strncpy(string,indexp->key,KEYLEN);
  string[KEYLEN+1]=0;
 }

}


 */


/* check if index is OK, return 1, else remove index and return 0 */

static int validindex(int dict,int indexn,word * words,domainstr * d)
{
 int    maxwordn;
 int    change=0;
 char * c;
 int    n=0; /* keep compiler happy */
 indexstr * indexp;
 dictstr    dp;

 dp=((odictstr*)ob_find(dict,d))->dict;


 indexp=(indexstr*)spcharbuffer(dp.index,d,indexn*sizeof(indexstr));

/* dprintf(2,"validindex enter %d",indexn); */


 if((indexn+1)<dp.noindex) 
   maxwordn=WORDN((indexstr*)spcharbuffer(dp.index,d,
                                               (indexn+1)*sizeof(indexstr)));
 else
  maxwordn=dp.nowords;

 while((words->wordn)<maxwordn)
 {
  c=spcharbuffer(dp.words,d,words->woffset);
  n=(*c) & 0x1F;
/*  dprintf(6,"wordns=%s n=%d copy=%d",words->string,words->wordn,n); */
  if(n<KEYLEN) break;
  change=1;
  nextword(dict,words,d);
 }

/* dprintf(1,"validindex change=%d n=%d string=%s",change,n,words->string); */


 if(n<KEYLEN && change)
 {
  SETWORDN(indexp,words->wordn);
  SETWOFF(indexp,words->woffset);
  strncpy(indexp->key,words->string,KEYLEN);
  return(1);
 }
 else
 if(change)
 {
  delindex(dict,indexn,d);
  return(0);
 }

 return(1);
}



static void setindx(int index1,indexstr ** indexp0,indexstr ** indexp1,
                               indexstr ** indexp2,int dict,domainstr * d)
{
 int index0;
 int index2;
 dictstr    dp;

 dp=((odictstr*)ob_find(dict,d))->dict;

 index0=index1-1;
 index2=index1+1;

 if(index0>=0) 
         *indexp0=(indexstr *)spcharbuffer(dp.index,d,index0*sizeof(indexstr));
 else    *indexp0=NULL;

 *indexp1=(indexstr *)spcharbuffer(dp.index,d,index1*sizeof(indexstr));

 if(index2<dp.noindex) 
         *indexp2=(indexstr *)spcharbuffer(dp.index,d,index2*sizeof(indexstr));
 else    *indexp2=NULL;

}


/* given words structure, remove from dictionary */

int remword(int dict,word * words,domainstr * d)
{
 word    nextwords;
 word    prevwords;
 int     index0;
 int     index1;
 int     index2;

 indexstr * indexp0;
 indexstr * indexp1;
 indexstr * indexp2;

 char    code[STRLEN];
 int     shift;
 int     indexn;
 int     indexc;
 indexstr * indexp;
 indexstr * f;

 int     tempwoffset;
 int     tempwordn;
 int     len;
 int     maxindex;

 int     delcurindex=0;
 int     nextindex=0;
 int     curvalid=1;

 int     wn;
 dictstr    dp;
 odictstr * dpp;


 dp=((odictstr*)ob_find(dict,d))->dict;

 maxindex=dp.noindex;

 /* accepting that due to error in findword, may get index one too small */

 while(1)
 {
  index1=words->indexn;
  index1++;
  if(index1>=maxindex) break;
  indexp1=(indexstr *)spcharbuffer(dp.index,d,index1*sizeof(indexstr));
  if(words->wordn<(int)WORDN(indexp1)) break;
  words->indexn=words->indexn+1;
 }

 index1=words->indexn;
 index0=index1-1;
 index2=index1+1;


 setindx(index1,&indexp0,&indexp1,&indexp2,dict,d);

 if(dp.nowords==1)    /* only one word in dictionary */
 {
  setsizebuffer(dp.words,0,d);
  setsizebuffer(dp.index,0,d);
  dp.nowords=0;
  dp.noindex=0;
  dpp=(odictstr*)ob_find(dict,d);
  dpp->dict.nowords=dp.nowords;
  dpp->dict.noindex=dp.noindex;
 }
 else
 if(words->wordn==(dp.nowords-1))  /* deleting last word */
 {
  if(words->wordn==(int)WORDN(indexp1)) delindex(dict,index1,d);
  changeword(dict,d,NULL,words->woffset,0,words->len);
  dp.nowords--;
  dpp=(odictstr*)ob_find(dict,d);
  dpp->dict.nowords=dp.nowords;
 }
 else
 if(!words->wordn)                  /* deleting first word */
 {
  nextwords=*words;
  nextword(dict,&nextwords,d);
  len=codeword("",nextwords.string,code);
  strncpy(indexp1->key,nextwords.string,KEYLEN);
  shift=len-words->len-nextwords.len;
  changeword(dict,d,code,words->woffset,len,words->len+nextwords.len);
  dp.nowords--;
  dpp=(odictstr*)ob_find(dict,d);
  dpp->dict.nowords=dp.nowords;

  indexn=index1;
  indexc=indexn*sizeof(indexstr);
  while(++indexn<maxindex)
  {
   indexc+=sizeof(indexstr);
   indexp=(indexstr *)spcharbuffer(dp.index,d,indexc);
   tempwoffset=WOFF(indexp)+shift;
   tempwordn=WORDN(indexp)-1;
   SETWORDN(indexp,tempwordn);
   SETWOFF(indexp,tempwoffset);
  }

 }
 else                              /* deleting word in middle */
 {
  nextwords=*words;
  nextword(dict,&nextwords,d);

  delcurindex=words->wordn==(int)WORDN(indexp1);
  nextindex=indexp2 && (nextwords.wordn==(int)WORDN(indexp2));

/*  dprintf(0,"delcurindex=%d nextindex=%d",delcurindex,nextindex); 
  dprintf(1,"wordn=%d WORDN=%d string=%s",words->wordn,WORDN(indexp1),
                                        words->string); */


  if(words->wordn>(int)WORDN(indexp1))
  {
   f=indexp1;
   prevwords.indexn=index1;
  }
  else
  {
   f=indexp0;
   prevwords.indexn=index0;
  }

  strncpy(prevwords.string,f->key,KEYLEN);
  prevwords.woffset=WOFF(f);
  prevwords.wordn=WORDN(f);
  prevwords.len=0;

  formword(dict,&prevwords,d);

  while(prevwords.wordn<(words->wordn-1)) nextword(dict,&prevwords,d);

 /* dprintf(2,"prev=%s next=%s",prevwords.string,nextwords.string);  */

  len=codeword(prevwords.string,nextwords.string,code);
  nextwords.woffset-=words->len;
  nextwords.wordn-=1;
  shift=len-words->len-nextwords.len;
  changeword(dict,d,code,words->woffset,len,words->len+nextwords.len);
  nextwords.len=len;
  dp.nowords--;
  dpp=(odictstr*)ob_find(dict,d);
  dpp->dict.nowords=dp.nowords;

  setindx(index1,&indexp0,&indexp1,&indexp2,dict,d);

  if(delcurindex)
  {
   strncpy(indexp1->key,nextwords.string,KEYLEN);
  }

  if(nextindex)
  {
   tempwoffset=WOFF(indexp2)-words->len;
   tempwordn=WORDN(indexp2)-1;
   SETWORDN(indexp2,tempwordn);
   SETWOFF(indexp2,tempwoffset);
   indexn=index2;
  }
  else
  {
   indexn=index1;
  }

  indexc=indexn*sizeof(indexstr);
  while(++indexn<maxindex)
  {
   indexc+=sizeof(indexstr);
   indexp=(indexstr *)spcharbuffer(dp.index,d,indexc);
   tempwoffset=WOFF(indexp)+shift;
   tempwordn=WORDN(indexp)-1;
   SETWORDN(indexp,tempwordn);
   SETWOFF(indexp,tempwoffset);
  }

  if(delcurindex) curvalid=validindex(dict,index1,&nextwords,d);
 }


 if(dp.nowords && curvalid && dp.noindex>1 && index1>0)
 {
  /* merge indexes */
  /* we know word has been chopped out of index1 */

  setindx(index1,&indexp0,&indexp1,&indexp2,dict,d);
 
  wn=WORDN(indexp1)-WORDN(indexp0);
  if(wn<64) 
  {
   delindex(dict,index1,d);
  }
  else
  if(index2<dp.noindex)
  {
   wn=WORDN(indexp2)-WORDN(indexp1);
   if(wn<64) delindex(dict,index1,d);
  }
  else
  {
   wn=dp.nowords-WORDN(indexp1);
   if(wn<64) delindex(dict,index1,d);
  }

 }

 return(1);
}



static void splitindex(int dict,int indexn,int count,domainstr * d)
{
 word words;
 indexstr * indexp;
 char * c;
 int    n=KEYLEN; /* probably needed */
 int    maxwordn;
 int    startn;
 dictstr    dp;

 dp=((odictstr*)ob_find(dict,d))->dict;


 indexp=(indexstr*)spcharbuffer(dp.index,d,indexn*sizeof(indexstr));

 strncpy(words.string,indexp->key,KEYLEN);
 words.woffset=WOFF(indexp);
 words.indexn=indexn;
 words.wordn=WORDN(indexp);
 words.len=0;
 formword(dict,&words,d);


 maxwordn=WORDN(indexp)+count;
 startn=WORDN(indexp)+count/2;

/* dprintf(1,"split index word=%s maxwordn=%d startn=%d",
                                   words.string,maxwordn,startn);  */


 while(words.wordn<startn) nextword(dict,&words,d);

 while(words.wordn<maxwordn)
 {
  c=spcharbuffer(dp.words,d,words.woffset);
  n=(*c) & 0x1F;
  if(n<KEYLEN) break;
  nextword(dict,&words,d);
 }

 if(n<KEYLEN)
 {
  indexp=insindex(dict,indexn+1,d);
  SETWORDN(indexp,words.wordn);
  SETWOFF(indexp,words.woffset);
  strncpy(indexp->key,words.string,KEYLEN);

 /* dprintf(2,"split index word=%s ",words.string); */
 }

}




/* add words structure to dictionary             */
/* return 1 on OK */

static int storeword(char * string,int dict,word * words,domainstr * d)
{
 char       code[STRLEN+2];    // +2 to allow for !dp.words case, dictionary initialisation
 int        len;
 int        oldnxlen;
 indexstr * indexp;
 word       nextwords;
 int        isnext;
 int        val;

 int        indexn;
 int        indexbase;
 int        indexc;
 int        maxindex;
 int        shift;

 int        count;

 int        tempwoffset;
 int        tempwordn;

 int        flags;

 int        checkvalid=0;
 dictstr    dp;
 odictstr * dpp;
 int        index1;
 indexstr * indexp1;


 dp=((odictstr*)ob_find(dict,d))->dict;

 maxindex=dp.noindex;

 cprintf("store %s",string);

 /* accepting that due to error in findword, may get index one too small */

 while(1)
 {
  index1=words->indexn;
  index1++;
  if(index1>=maxindex) break;
  indexp1=(indexstr *)spcharbuffer(dp.index,d,index1*sizeof(indexstr));
  if(words->wordn<(int)WORDN(indexp1)) break;
  words->indexn=words->indexn+1;
 }

 if(!dp.nowords)
 {
  len=codeword("",string,code);

  cprintf("code1 %d",len);

  if(!len) return(0);
  code[len++]=0;
  code[len++]=0;

  changeword(dict,d,code,0,len,0);
  indexp=insindex(dict,0,d);
  SETWOFF(indexp,0);
  SETWORDN(indexp,0);
  strncpy(indexp->key,string,KEYLEN);
 }
 else
 {
  indexbase=indexn=words->indexn;
  indexc=indexn*sizeof(indexstr);


  flags=0;
  val=xstrncmp(string,words->string,STRMAX,&flags);
  if(val==0)
  {
   if(flags & 0x2) val=1;
   else
   if(flags & 0x1) val=-1;
  }

  nextwords=*words;

  if(val>0)
  {
   len=codeword(words->string,string,code);
   cprintf("code2 %d",len);

   if(!len) return(0);
   isnext=nextword(dict,&nextwords,d);
  }
  else
  {                        /* there wasn't a smaller word - so must be first */
   len=codeword("",string,code);
   cprintf("code3 %d",len);


   if(!len) return(0);
   indexp=(indexstr *)spcharbuffer(dp.index,d,indexc);
   strncpy(indexp->key,string,KEYLEN);
   isnext=1;
  }


  changeword(dict,d,code,nextwords.woffset,len,0);
  shift=len;

  if(isnext)
  {
   nextwords.woffset+=len;
   len=codeword(string,nextwords.string,code);
   cprintf("code4 %d",len);


   changeword(dict,d,code,nextwords.woffset,len,nextwords.len);
   oldnxlen=nextwords.len;
   nextwords.len=len;

  /* dprintf(5,"nextwords->string=%s",nextwords.string);  */

   if((indexn+1)<maxindex)
   {
    indexp=(indexstr *)spcharbuffer(dp.index,d,indexc+sizeof(indexstr));

  /* dprintf(4,"WORDN(indexp)=%d word=%d",WORDN(indexp),nextwords.wordn); */

    /* this is the problem where the word after the new word is an index key */

    if((int)WORDN(indexp)==nextwords.wordn)
    {
     indexn++;
     indexc+=sizeof(indexstr);
     tempwoffset=WOFF(indexp)+shift;
     tempwordn=WORDN(indexp)+1;
     SETWORDN(indexp,tempwordn);
     SETWOFF(indexp,tempwoffset);
     checkvalid=indexn;
  /*   dprintf(0,"check valid"); */
/*     indexn++;
     indexc+=sizeof(indexstr);  */  /* because loop below preincrements */
    }
   }
   nextwords.wordn++;
   shift+=len-oldnxlen;
  }


  while(++indexn<maxindex)
  {
   indexc+=sizeof(indexstr);
   indexp=(indexstr *)spcharbuffer(dp.index,d,indexc);
   tempwoffset=WOFF(indexp)+shift;
   tempwordn=WORDN(indexp)+1;
   SETWORDN(indexp,tempwordn);
   SETWOFF(indexp,tempwoffset);
  }

  if(checkvalid) validindex(dict,checkvalid,&nextwords,d);

  indexn=indexbase;
  indexc=indexn*sizeof(indexstr);
  indexp=(indexstr *)spcharbuffer(dp.index,d,indexc);
  count=WORDN(indexp);

  if(++indexn<maxindex)
  {
   indexc+=sizeof(indexstr);
   indexp=(indexstr *)spcharbuffer(dp.index,d,indexc);
   count=WORDN(indexp)-count;
  }
  else
  {
   count=dp.nowords-count;
  }

  if(count>=128) 
  {
   splitindex(dict,indexbase,count,d);
   /* dprintf(0,"split"); */
  }
 }

 dpp=(odictstr*)ob_find(dict,d);
 dpp->dict.nowords++;

 return(1);
}







/* returns 1 if word found or 0 if not found     */
/* returns previous word structure in dictionary */
/* flags 0x10000 == ignore hyphens               */
/*       0x20000 == fast search return no data   */
/*       0x40000 == case dependent               */
/*       0xXX000000 == min before hyphen         */


int findword(char * string,int dict,word * words,int * flags,domainstr * d)
{
 int         n;
 int         lo;
 int         hi;
 int         i;
 int         loi;
 int         hii;
 int         ii;
 int         code;
 indexstr *  f;
 char     *  p;
 word        oldwords;
 dictstr     dp;
 int         sflags;
 char    *   stringp;
 char        temp[STRLEN*2];

 dp=((odictstr*)ob_find(dict,d))->dict;


 n=dp.noindex;
 hi=(n-1)*sizeof(indexstr);
 hii=n-1;
 lo=0;
 loi=0;
 ii=0;
 i=0;
 code=0; /* compiler */


 if(!dp.nowords)
 {
  words->woffset=0;
  words->indexn=0;
  strcpy(words->string,"");
  words->wordn=0;
  words->len=0;
 }
 else
 {
  p=spcharbuffer(dp.index,d,0);
  f=(indexstr *)p; /* compiler */

  sflags=*flags;
  stringp=string;
  if(sflags & 0x10000)
  {
   sflags&=~0x10000;
   code=(sflags>>24) & 0xFF;
   if(code)
   {
    stringp=temp;
    XMEMCPYX(temp,string,code);
    temp[code]='-';
    temp[code+1]=*(string+code);
    temp[code+2]=0;
   /* strcpy(temp+code+1,string+code); */
   }
  }

  while(hi>=lo)
  {
   i=(lo+hi)>>1;
   ii=loi+hii;
   if((ii & 1) && i) i-=(sizeof(indexstr)>>1);
   ii=ii>>1;

   f=(indexstr *)(p+i);

   code=xstrncmp(stringp,f->key,KEYLEN,&sflags);

   if(!code) break;
   else
   if(code>0) {lo=i+sizeof(indexstr);loi=ii+1;}
   else       {hi=i-sizeof(indexstr);hii=ii-1;}
  }

  while((code<=0) && (i>0))
  {
   i-=sizeof(indexstr);
   ii--;
   f=(indexstr *)(p+i);
   code=xstrncmp(stringp,f->key,KEYLEN,&sflags);
  }

  if(((*flags) & 0x20000))                   /* fast search */
  {
   return(xscanword(string,flags,f->key,spcharbuffer(dp.words,d,WOFF(f))));
  }
  else  
  {

   strncpy(words->string,f->key,KEYLEN);

   words->woffset=WOFF(f);
   words->indexn=ii;
   words->wordn=WORDN(f);
   words->len=0;

   formword(dict,words,d);

   oldwords=*words;

   while(1)
   {
    code=xstrncmp(string,words->string,STRMAX,flags);

    if(!code)
    {
     if(((*flags) & 0x40002)==0x40002) code=1;
     else
     if(((*flags) & 0x40001)==0x40001) code=-1;
     else                              return(1);
    }

    if(code<0) break;
    oldwords=*words;
    if(!nextword(dict,words,d)) break;
   }

   *words=oldwords;
  }
 }

 return(0);
}


/* like findword() but returns words->string */

int findwords(char * string,int dict,word * words,int * flags,domainstr * d)
{
 int      code;
 int      shift;
 dictstr  dp;


 code=findword(string,dict,words,flags,d);
 if(code)
 {
  if(((*flags) & 0x20000))
  {
   shift=xgetscanstring(words->string);
   dp=((odictstr*)ob_find(dict,d))->dict;
   shift=shift-(int)spcharbuffer(dp.words,d,0);
   words->woffset=shift;
  }
 }

 return(code);
}



int findnextword(char * string,int dict,word * words,int * flags,domainstr * d)
{
 dictstr    dp;
 int        code;
 int        shift;


 if(((*flags) & 0x20000))
 {
  dp=((odictstr*)ob_find(dict,d))->dict;
  code=xscanword(string,flags,words->string,
                                spcharbuffer(dp.words,d,words->woffset));
  shift=xgetscanstring(words->string);
  shift=shift-(int)spcharbuffer(dp.words,d,0);
  words->woffset=shift;
 }
 else
 {
  code=nextword(dict,words,d);
  if(code) code=(xstrncmp(string,words->string,STRMAX,flags)==0);
 }

 return(code);
}



int findwordabs(char * string,int dict,word * words,int * flags,domainstr * d)
{
 word oldwords;
 int  oldflags;

 if(findwords(string,dict,words,flags,d))
 {
  while((*flags) & 0x1)
  {
   oldflags=*flags;
   oldwords=*words;

   if(!findnextword(string,dict,words,flags,d))
   {
    *words=oldwords;
    *flags=oldflags;
    break;
   }
  }
  return(!((*flags) & 0x1));
 }
 return(0);
}



/*
void testdict(dict * dp)
{
 int         n=dp->noindex;
 index    *  f;
 char     *  p;
 int         i;

 for(i=0;i<n;i++)
 {
  f=(index*)spcharbuffer(dp->index,i*sizeof(indexstr));
  p=spcharbuffer(dp->words,WOFF(f));
  if(*p>30)
  {
   dprintf(0,"error index=%d f->key=%s f->woff=%d",i,f->key,WOFF(f));
  }
 }
}
*/




/* returns word structure for n'th word in dictionary */

int locword(int seekn,int dict,word * words,domainstr * d)
{
 int         n;
 int         lo;
 int         hi;
 int         i;
 int         loi;
 int         hii;
 int         ii;
 indexstr *  f;
 dictstr     dp;

 dp=((odictstr*)ob_find(dict,d))->dict;

 n=dp.noindex;
 lo=0;
 hi=(n-1)*sizeof(indexstr);
 i=0;
 loi=0;
 hii=n-1;
 ii=0;
 f=NULL; /* compiler - eek! */

 if(seekn>=dp.nowords) return(0);

 while(hi>=lo)
 {
  i=(lo+hi)>>1;
  ii=loi+hii;
  if((ii & 1) && i) i-=sizeof(indexstr)/2;
  ii=ii>>1;

  f=(indexstr *)spcharbuffer(dp.index,d,i);

  if((int)WORDN(f)==seekn) break;
  else
  if((int)WORDN(f)<seekn)  {lo=i+sizeof(indexstr);loi=ii+1;}
  else                     {hi=i-sizeof(indexstr);hii=ii-1;}
 }
        

 if((int)WORDN(f)>seekn)
 {
  i-=sizeof(indexstr);
  ii--;
  f=(indexstr *)spcharbuffer(dp.index,d,i);
 }

 strncpy(words->string,f->key,KEYLEN);
 words->woffset=WOFF(f);
 words->indexn=ii;
 words->wordn=WORDN(f);
 words->len=0;
 formword(dict,words,d);

 while(words->wordn<seekn) nextword(dict,words,d);
 return(1);
}


/****************************************************************************/

/* delete a word from a dictionary */

#ifdef NEVER

int deleteword(char * string,int dict,domainstr * d)
{
 word words;
 int  code;
 int  flags=0;

 cprintf("delword %s",string);

 code=findwordabs(string,dict,&words,&flags,d);

 cprintf("findword code %d",code);

 if(!code) return(0);             /* word was not in dictionary */
 code=remword(dict,&words,d);
 return(code);
}

#endif


/* add a word to a dictionary */
/* return 1 on OK             */

int addword(char * string,int dict,domainstr * d)
{
 word words;
 int  flags;
 int  len;
 int  code;

 len=strlen(string);
 if(!len || len>STRMAX) return(0);

 flags=0x40000; /* case dependent */

 cprintf("addword1 len %d %s",strlen(string),string);

 if(findword(string,dict,&words,&flags,d)) return(1);
 
 cprintf("addword2");

 code=storeword(string,dict,&words,d);

 cprintf("addword3");

 return(code);
}



char * wordn(int n,int dict,domainstr * d)
{
 static char string[STRLEN];
 int         code;
 word        words;

 code=locword(n,dict,&words,d);
 if(code) strcpy(string,words.string);
 else     strcpy(string,"");
 return(string);
}


int nowords(int dict,domainstr * d)
{
 odictstr * dp;
 dp=(odictstr*)ob_find(dict,d);
 return(dp->dict.nowords);
}





#ifdef NEVER

void checkdict(int dict,domainstr * d)
{
 odictstr   * dp;
 int          n;
 indexstr  *  f;
 char      *  p;
 int          i;
 obufferstr * buffer;
 char         temp[16];


 dp=ob_find(dict,d);

/* dprintf(0,"nowords=%d noindex=%d index=%d words=%d",
                dp->dict.nowords,
                dp->dict.noindex,
                dp->dict.index,
                dp->dict.words); */

 n=dp->dict.noindex;

 buffer=ob_find(dp->dict.words,d);

 dprintf(0,"words buffer len=%d",buffer->buffer.len);

 for(i=0;i<n;i++)
 {
  f=(indexstr*)spcharbuffer(dp->dict.index,d,i*sizeof(indexstr));
  p=spcharbuffer(dp->dict.words,d,WOFF(f));
  xstrncpy(temp,f->key,KEYLEN);

  dprintf(0,"index=%d f->key=%s f->woff=%d c=%d",i,temp,WOFF(f),*p); 

  if(*p>30)
  {
   dprintf(0,"error index=%d f->key=%s f->woff=%d",i,temp,WOFF(f));
   dprintf(0,"p-2=%d p-1=%d p+1=%d p+2=%d",*(p-2),*(p-1),*(p+1),*(p+2));
  }
 }

}


#endif



/*****************************************************************************/


/* clear dictionary structure */

void trashdc(int * dict,domainstr * d)
{
 dictstr dp;

 if(*dict)
 {
  dp=((odictstr*)ob_find(*dict,d))->dict;
  deletebuffer(dp.words,d);
  deletebuffer(dp.index,d);
  ob_delete(*dict,d);
  *dict=0;
 }
}




os_error * copydc(int * ddict,domainstr * d,int sdict,domainstr * s)
{
 os_error   * err;
 odictstr   * dpp;
 obufferstr * dbf;
 int          words;
 int          index;

 *ddict=0;

 dpp=(odictstr*)ob_find(sdict,s);
 words=dpp->dict.words;
 index=dpp->dict.index;

 err=ob_copy((objptr)&dpp,d,sdict,s);
 if(!err)
 {
  *ddict=dpp->key;

  err=ob_copy((objptr)&dbf,d,words,s);
  words=dbf->key;

  err=ob_copy((objptr)&dbf,d,index,s);
  index=dbf->key;

  dpp=(odictstr*)ob_find(*ddict,d);
  dpp->dict.words=words;
  dpp->dict.index=index;
 }

 return(err);
}



/* initialise dictionary structure */

os_error * createdc(int * dict,domainstr * d)
{
 os_error * err;
 odictstr * dpp;
 int        words;
 int        index=0;

          err=createbuffer(&words,d);
 if(!err) err=createbuffer(&index,d);

 if(!err)
 {
  err=ob_create(sizeof(odictstr),d,ODICT2,(objptr)&dpp);
  *dict=dpp->key;

  dpp->dict.words=words;
  dpp->dict.index=index;
  dpp->dict.nowords=0;
  dpp->dict.noindex=0;

 /* dprintf(5,"words=%d key=%d",words,*dict); */

 }

 return(err);
}



static os_error * dopen(char * name,int mode,int user,fshandle * fh)
{
 os_error * err;
 char       string[FILENAMELEN];


 strcpy(string,dcpath[user]);
 strcat(string,"\\");
 strcat(string,name);
 strcat(string,".dic");

 cprintf("dcopen %s",string);

 err=fs_open(string,mode,fh);
 if(!err && !(*fh)) err=geterror(ESP04);

 return(err);
}


/* lo level load dictionary into dictionary structure */

os_error * loaddc(char * name,int * dict,int user,domainstr * d)
{
 os_error  * err;
 fshandle    fh;
 dheader     dh;
 dictstr     dp;
 odictstr  * dpp;

 err=dopen(name,'r',user,&fh);
 if(!err)
 {
  memset(&dp,0,sizeof(dictstr));

  trashdc(dict,d);

  fs_read(fh,&dh,sizeof(dheader));

  if(strcmp(dh.mark,"1.00")<0) err=geterror(EDCOLD);
  if(dh.capabilities)          err=geterror(EDCAPS);

  fs_read(fh,&dp.nowords,4);
  fs_read(fh,&dp.noindex,4);

 /* dprintf(4,"now=%d nin=%d",dp.nowords,dp.noindex); */


           err=loadbuffer(&dp.words,fh,d);
  if(!err) err=loadbuffer(&dp.index,fh,d);

  err=fs_close(fh,err);

  if(!err)
  {
   err=ob_create(sizeof(odictstr),d,ODICT2,(objptr)&dpp);
   *dict=dpp->key;
   dpp->dict=dp;
  }

  if(err && err->errnum==EMEM) err=geterror(ESP03);
                        /* Not enough memory to load dictionaries */


 }
 return(err);
}


/* lo level save dictionary strcuture */

os_error * savedc(char * name,int dict,int user,domainstr * d)
{
 os_error * err;
 dheader    dh;
 dictstr    dp;
 fshandle   fh;

 dp=((odictstr*)ob_find(dict,d))->dict;

 memset(&dh,0,sizeof(dheader));

 strcpy(dh.name,"Ovation Dictionary");
 strcpy(dh.mark,"1.00");
 strcpy(dh.copy,"(16-Mar-2002)");
 dh.capabilities=0;


 err=dopen(name,'w',user,&fh);
 if(!err)
 {
           err=fs_write(fh,&dh,sizeof(dheader));
  if(!err) err=fs_write(fh,&dp.nowords,4);
  if(!err) err=fs_write(fh,&dp.noindex,4);
  if(!err) err=savebuffer(dp.words,fh,d);
  if(!err) err=savebuffer(dp.index,fh,d);

  err=fs_close(fh,err);
 }
 return(err);
}





/*

void dctest(void)
{
 index indi;
 int   woffset;
 int   wordn;

 while(1)
 {
  printf("\ninput:");
  scanf("%d %d",&woffset,&wordn);

  SETWOFF(&indi,woffset);
  SETWORDN(&indi,wordn);

  printf("woffset=%d wordn=%d\n",woffset,wordn);

  woffset=WOFF(&indi);
  wordn=WORDN(&indi);

  printf("woffset=%d wordn=%d\n",woffset,wordn);

  SETWOFF(&indi,WOFF(&indi)+8);
  SETWORDN(&indi,WORDN(&indi)+8);


  woffset=WOFF(&indi);
  wordn=WORDN(&indi);


  printf("woffset=%d wordn=%d\n",woffset,wordn);

  printf("indexp.woffset=%d indexp.wordn=%d indi.extra=%x\n",
             indi.woffset,indi.wordn,indi.extra);


 }

}
*/
