/*->c.find */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  
#include <ctype.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "font.h"
#include "bbc.h"
#include "werr.h"
#include "akbd.h"
#include "flex.h"
#include "alloc.h"


#include "transform.h"

#include "etc.h"
#include "err.h"
#include "wos.h"
#include "poll.h"
#include "key.h"
#include "fsx.h"
#include "timex.h"
#include "bits.h"
#include "deb.h"


#include "str.h"
#include "constants.h"
#include "codes.h"
#include "reslink.h"

#include "object.h"

#include "file.h"
#include "view.h"
#include "viewr.h"
#include "viewo.h"
#include "undo.h"
#include "macros.h"

#include "txstr.h"
#include "tx.h"
#include "vec.h"
#include "sx.h"
#include "vl.h"
#include "fx.h"
#include "style.h"
#include "fl.h"
#include "act.h"
#include "wcx.h"


#include "find.h"



static vector find0;
vector     find1;
vector     find2;
static int find3offset;        /* don't search past here */
int        findzone;



os_error * clearfind(void)
{
 findzone=0; /* this is more powerful than checkfindzone() */
             /* case of trying to find next and failing    */
             /* find1 and 2 have been moved                */

 return(NULL);
}



os_error * findreset(viewstr * view)
{
 os_error * err;
 vector     s;

 err=NULL;


 if(findzone)
 {
  unselects(0);

  s=find0;

  err=txlock(&s.textsrc,s.file);
  if(!err)
  {
   setxa(&s);
   setactive(&s);
   screenvector(&s,view);

   txunlock(&s.textsrc,s.file);
  }
 }

 return(err);
}



os_error * saveinitfind3(vector * s0,vector * s1,vector * s2)
{
 if(s0) find0=*s0;
 if(s1) find1=*s1;
 if(s2) find2=*s2;
 find3offset=find2.textsrc.offset;
 return(NULL);
}


os_error * saveinitfind1(vector * s)
{
 return(saveinitfind3(s,s,s));
}


os_error * saveinitfind(vector * s)
{
 return(saveinitfind3(NULL,s,s));
}



os_error * setupfindo(vector * s1,int offset)
{
 find0=*s1;
 find1=find0;
 find2=find0;
 find3offset=offset;
 return(NULL);
}


os_error * setupfind(vector * s1,vector * s2)
{
 return(setupfindo(s1,s2->textsrc.offset));
}


os_error * findstep(void)
{
 find1=find2;
 return(NULL);
}


os_error * findrestep(void)
{
 return(setupfindo(&find0,find3offset));
}



/* set up a zone around object that has been found */
/* returns 0 if can't get find zone on screen      */



os_error * validfindzone(vector * s,int * valid,int soffset,int eoffset)
{
 os_error * err;
 vector     v1;
 vector     v2;

 v1=*s;
 v2=v1;

 *valid=0;

          err=movevector(&v1,soffset);
 if(!err) err=movevector(&v2,eoffset);
 if(!err) err=vecinline(&v2,valid);

 if(!err && (*valid))
 {
  find1=v1;
  find2=v2;
 }

 return(err);
}



os_error * setfindzone(viewstr * view)
{
 os_error * err;

 err=unsaveact();
 setupzone(&find1,&find2);

 err=txlock(&find1.textsrc,find1.file);
 if(!err)
 {
  screenvector(&find1,view);
  txunlock(&find1.textsrc,find1.file);
  findzone=1;
 }

 return(err);
}



int checkfindzone(void)
{
/* dprintf(0,"aoffset=%d 1offset=%d zoffset=%d 2offset=%d",
          act.textsrc.offset,find1.textsrc.offset,
          zon.textsrc.offset,find2.textsrc.offset); */

 return(act.valid && 
        act.file==find1.file && 
        zone && 
        act.textsrc.offset==find1.textsrc.offset && 
        zon.textsrc.offset==find2.textsrc.offset);
}


/**************************************************************************/


#define FANY   1
#define FALPHA 11
#define FDIGIT 12
#define FWHITE 14



static os_error * fcpy(findstr * find,unsigned short * top,int tosize,char * fromp,unsigned short * found,filestr * file)
{
 os_error * err;
 unsigned short * lt;
 unsigned short * to;
 unsigned short * string;
	unsigned short * from;
	int              c;
	int              len;
	int              founderror;

 err=expandmacrostring2(fromp,&string,0);
	if(!err)				// matching 	  expandmacrostringfinit2(&string);				below
 {
	 err=txunccheckstring(string,file);
		if(!err)
		{

  	founderror=0;
 		if(found)
 		{
  		from=found;
  		while((c=*from++)!=0)
  		{
  			if(c==EOB)
     {
      founderror=FI0A;
  				break;
  			}

  			if(c==MACSEQ)
     {
      founderror=FI0B;
  				break;
  			}

  			if(c==SPACESEQ)
     {
      founderror=FI0D;
  				break;
 				}
 			}
 		}


   to=top;
   lt=to+tosize;
   from=string;


//  cprintf("fcpy %d %d %d",*string,*(string+1),*(string+2));

   if(!find->wild) xzstrncpye22(to,from,tosize);
   else
   {
    int escape=0;

    do
    {
     if(escape)
     {
      switch(*from)
      {

         case 'a':
                  *to++=FALPHA;
                  if(found) err=geterror(FI05);
                  break;

        case  'c':
                  *to++=CHAPNO;
                  break;

         case 'd':
                  *to++=FDIGIT;
                  if(found) err=geterror(FI05);
                  break;

         case 'e':
                  *to++=EOB;
                  if(found) err=geterror(FI0A);
                  break;

         case 'f':
                  *to++=EOBOX;
                  break;

        case  'g':
                  *to++=PAGENO;
                  break;

        case  'h':
                  *to++=ACTDATE;
                  break;

         case 'l':
                  *to++=CR;
                  break;

        case  'm':
                  *to++=MACSEQ;
                  if(found) err=geterror(FI0B);
                  break;

         case 'n':
                  *to++=NL;
                  break;

         case 'p':
                  *to++=EOPAGE;
                  break;


         case 's':
                  *to++=SPACESEQ;
                  if(found) err=geterror(FI0A);
                  break;

         case 't':
                  *to++=TABSEQ;
                  break;

         case 'w':
                  *to++=FWHITE;
                  if(found) err=geterror(FI05);
                  break;


         case '*':
                  *to++='\\';
                  *to++='*';
                  if(found) err=geterror(FI05);
                  break;

         case '.':
                  *to++=FANY;
                  if(found) err=geterror(FI05);
                  break;


        case '\\':
                  *to++='\\';
                  break;


         case '&':
                  if(!found) err=geterror(FI06);
                  else
																		if(founderror) err=geterror(founderror);
																		else
                  {
																			len=xstrlen2(found);
                   if((to+len)>=lt) err=geterror(FI0C);
                   else
                   {
                    xzstrncpye22(to,found,lt-to);
                    to+=len;
                   }
                  }
                  break;

          default:
                  err=geterror(FI07);
                  break;

      }
      escape=0;
     }
     else
     {
      escape=0;
      if(*from=='\\') escape=1;
      else            *to++=*from;
     }

     if(to>=lt) err=geterror(FI0C);

    } while(*from++ && !err);
   }
		}

  expandmacrostringfinit2(&string);

  if(!err)
  {
   if(*top==0 && !found) err=geterror(FI00);
  }

		cprintf("fcpy %d %d %d",*top,*(top+1),*(top+2));
 }   

 return(err);
}


/*****************************************************************************/


static os_error * fchange(filestr * file,textsrcstr * textsrc,char * p,
                                         int insert,int remove)
{
 int n;
 int offset;

 n=insert-remove;
 offset=textsrc->offset;

 if(remove) txundosourceremovex(remove,textsrc,file);
 if(insert) txundosourceinsert(p,insert,textsrc,file);

 if(offset<=find1.textsrc.offset) find1.textsrc.offset+=n;
 if(offset<=find2.textsrc.offset) find2.textsrc.offset+=n;
 if(offset<=find3offset)          find3offset+=n;
 if(offset<=find0.textsrc.offset && textsrc->source==find0.textsrc.source)
                                  find0.textsrc.offset+=n;

 return(NULL);
}




/* notice the complexities - upper case + lower case != length */

void wordstats(char * string,int * ucp,int * lcp,int * fucp)
{
 int  uc=0;
 int  lc=0;
 int  fuc;
 int  len;
 int  i;

 if(riscos_isupper(string[0])) {uc++;fuc=1;}
 else                   {lc++;fuc=0;}

 len=strlen(string);
 for(i=1;i<len;i++)
 if(riscos_isalpha(string[i]))
 {
  if(riscos_isupper(string[i])) uc++;
  else                   lc++;
 }

 *ucp=uc;
 *lcp=lc;
 *fucp=fuc;
}




static void wordstats2(unsigned short * string,int * ucp,int * lcp,int * fucp)
{
 int  uc=0;
 int  lc=0;
 int  fuc;
 int  len;
 int  i;

 if(iswupper(string[0])) {uc++;fuc=1;}
 else                    {lc++;fuc=0;}

 len=xstrlen2(string);
 for(i=1;i<len;i++)
 if(iswalpha(string[i]))
 {
  if(iswupper(string[i])) uc++;
  else                   lc++;
 }

 *ucp=uc;
 *lcp=lc;
 *fucp=fuc;
}









static void replstats(vector * v,int olen,int * inc,
                                 int * lo,int * up,int * ne,int * tot)
{
 int         c;
 int         inituc;
 int         lower;
 int         upper;
 int         neither;
 int         total;
 int         first;
 char      * p;
 sourcestr * sourcep;
 int         bits;
 int         offset;
 int         maxoffset;


 inituc=0;
 lower=0;
 upper=0;
 neither=0;
 total=0;
 first=1;

 offset=v->textsrc.offset;
 maxoffset=offset+olen;
 sourcep=(sourcestr*)fob_find(v->textsrc.source,v->file);

 /* parse original string */

 while(offset<maxoffset)
 {
  p=txptr(sourcep,offset);
  c=*p;
  bits=codex[c]; 

		if(c==UNC16)
		{
			c=(*(p+1))+((*(p+2))<<8);
		}

  if(c==TABSEQ || c>=32)
  {
   if(first) 
   {
    inituc=(iswupper((unsigned short)c)!=0);
    first=0;
   }
   total++;

   if(iswupper((unsigned short)c)) upper++;
   else
   if(iswlower((unsigned short)c)) lower++;
   else            neither++;
  }


  offset+=bits & CODELEN;
  if(bits & CODETERMINATOR) break;
 }

 *inc=inituc;
 *lo=lower;
 *up=upper;
 *ne=neither;
 *tot=total;
}




/* gets replace string into the correct format */
/* i.e. gets upper/lower case right            */

static void frstring(vector * v,int olen,unsigned short * string,int slen,unsigned short * replace,int xc)
{
 unsigned short * p;
 char           * q;
 int         c;
 int         inituc;
 int         lower;
 int         upper;
 int         neither;
 int         total;
 int         bits;
 int         offset;
 int         maxoffset;
 sourcestr * sourcep;
 int         uch;
 int         lch;
 int         fuch;




 xzstrncpye22(string,replace,slen);

	cprintf("s0 %d s1 %d s2 %d",string[0],string[1],string[2]);
	cprintf("r0 %d r1 %d r2 %d",replace[0],replace[1],replace[2]);
	cprintf("xc %d",xc);

 if(xc==1) return;                 /* NB returns here */


// there is a potential problem here, we're applying towupper() etc. to values
// that are not true unicode - there are values in the range 128..160

 replstats(v,olen,&inituc,&lower,&upper,&neither,&total);

 p=string;

	if(total==neither)
	{
		cprintf("neither clause");
	}
	else
 if(total==(upper+neither))
 {
  /* search string is all uc */
  while(*p) {*p=towupper(*p);p++;}
 }
 else
 {
  wordstats2(replace,&uch,&lch,&fuch);

  if(xc==2 || (xc==3 && uch==0))
  {
   if(total==(lower+neither))
   {
    /* search string is all lc */
    while(*p) {*p=towlower(*p);p++;}
   }
   else
   if(total==(lower+neither+inituc))   /* !=(lower+neither+inituc) */
   { 
    /* first letter is upper case */
    while(*p) {*p=towlower(*p);p++;}
    string[0]=towupper(string[0]);
   }
   else
   if(xc==2)  /* for spell check only do all lower or init uc */
   {
    offset=v->textsrc.offset;
    maxoffset=offset+olen;
    sourcep=(sourcestr*)fob_find(v->textsrc.source,v->file);

    /* it's rule 2 */

    while(offset<maxoffset && (*p))
    {
     q=txptr(sourcep,offset);
     c=*q;
     bits=codex[c]; 

   		if(c==UNC16)
   		{
		   	c=(*(p+1))+((*(p+2))<<8);
   		}

     if(c>=32)
     {
      if(iswupper((unsigned short)c)) *p=towupper(*p);
      else                            *p=towlower(*p);
      p++;
     }

     offset+=bits & CODELEN;
     if(bits & CODETERMINATOR) break;
    }
   }
  }
 }
}





/* do a replace */

os_error * freplacesub(vector * v,int olen,int * nl,unsigned short * string,int * mod)
{
 os_error  * err;
 int         xlen;
 int         nlen;
 int         modr;
 unsigned short * p;
 int         c=0;
 filestr   * file;
 vector      s;
 int         clen;
	char        buff[4];
	int         blen;
	int         cs;
	int         cv=0;
	int         csv;
	char						* q=NULL;

 err=NULL;

 modr=0;
 xlen=olen;
 nlen=0;
 p=string;

 file=v->file;
 s=*v;

 err=txlock(&s.textsrc,file);
 if(!err)
 {
  txmodvec(&s);

  while((csv=cs=*p)!=0)
  {
//			c=code16inv(cs);		// already done this
			if(cs<256)
			{
			 buff[0]=(char)cs;
			 blen=1;
			}
			else
			{
				buff[0]=UNC16;
				buff[1]=(char)(cs & 0xFF);
				buff[2]=(char)((cs >>8) & 0xFF);
				blen=UNC16LEN;
				cs=UNC16;
			}

   while(1)
   {
    q=txptr(s.textsrc.sourcep,s.textsrc.offset);
				cv=c=*q;
    if(c==SNO) 
    {
     nlen+=SNLEN;
     s.textsrc.offset+=SNLEN;
    }
    else       break;
   }

			if(c==UNC16)
			{
				cv=(*(q+1))+((*(q+2))<<8);
			}

   clen=(codex[c] & CODELEN);

			// c, cv and clen what we are removing
			// cs and blen what is new

   if(nlen<xlen)
   {
				cprintf("nlen %d xlen %d c %d cs %d cv %d csv %d blen %d",nlen,xlen,c,cs,cv,csv,blen);

    if(cs==TABSEQ && c==TABSEQ)
    {
     nlen+=TSLEN;
     s.textsrc.offset+=TSLEN;
     p++;
    }
    else
    if(cs==TABSEQ && c!=TABSEQ)
    {
     fchange(file,&s.textsrc,buff,TSLEN,clen);
     xlen+=TSLEN-clen;
     nlen+=TSLEN;
     s.textsrc.offset+=TSLEN;
     p++;
     modr=1;
    }
    else
    if(c==TABSEQ && cs!=TABSEQ)
    {
     fchange(file,&s.textsrc,buff,blen,TSLEN);
     xlen-=TSLEN-blen;
     nlen+=blen;
     s.textsrc.offset+=blen;
     p++;
     modr=1;
    }
    else
    {
     if(c!=cs || cv!=csv)
     {
      modr=1;
      fchange(file,&s.textsrc,buff,blen,clen);
      s.textsrc.offset+=blen;
      xlen-=(clen-blen);
						nlen+=blen;
     }
     else
     {
      s.textsrc.offset+=clen;
      nlen+=blen;
     }

     p++;
    }
   }
   else
   {
    modr=1;

				cprintf("cv %d csv %d blen %d",cv,csv,blen);

    if(cs==TABSEQ)
    {
     fchange(file,&s.textsrc,buff,TSLEN,0);
     nlen+=TSLEN;
     s.textsrc.offset+=TSLEN;
     p++;
    }
    else
    {
     fchange(file,&s.textsrc,buff,blen,0);
     s.textsrc.offset+=blen;
     nlen+=blen;
     p++;
    }
   }
  }

  while(nlen<xlen)
  {
   while((c=*txptr(s.textsrc.sourcep,s.textsrc.offset))==SNO) 
   {
    s.textsrc.offset+=SNLEN;
    nlen+=SNLEN;
   }

   if(nlen>=xlen) break;
   modr=1;
   clen=(codex[c] & CODELEN);

   fchange(file,&s.textsrc,NULL,0,clen);
   xlen-=clen;
  }

  txunlock(&s.textsrc,file);
 }

 *nl=nlen;
 *mod=modr;
 return(err);
}



os_error * freplaceflow(vector * v,int olen,int * nlen,int backflow)
{
 flowstr    fl;

 fl.opcode=FDATA|FSUB;
 if(backflow) fl.opcode|=FLPREV;
 fl.data.type=FLDIRTY;
 fl.data.offset=v->textsrc.offset;
 fl.data.delta=*nlen-olen;
 fl.data.length=*nlen;

 fl.opcode|=FLV0|FLV1;
 fl.roff[0]=lozon->textsrc.offset;
 fl.roff[1]=hizon->textsrc.offset+fl.data.delta;
 fl.resultv[0]=lozon;
 fl.resultv[1]=hizon;

 flow(v,&fl);

 find1=*lozon;
 find2=*hizon;

 return(NULL);
}



static os_error * getstring(vector * v,int len,unsigned short * string)
{
 os_error * err;
 int        offset;
	char     * p;
 int        c;
 int        bits;
 int        maxoffset;
 unsigned short * lt;

 lt=string+FMAXLEN-1;

 err=txlock(&v->textsrc,v->file);
 if(!err)
 {
  offset=v->textsrc.offset;
  maxoffset=offset+len;

  while(offset<maxoffset)
  {
   p=txptr(v->textsrc.sourcep,offset);
			c=*p;
   if(c>=32 || c==TABSEQ || c==EOPAGE || c==NL      || c==CR     || c==EOB
            || c==EOBOX  || c==CHAPNO || c==ACTDATE || c==MACSEQ 
            || c==PAGENO || c==SPACESEQ) *string++=(unsigned short)c;
		 else
			if(c==UNC16)
			{
				*string++=(unsigned short)((*(p+1))|((*(p+2))<<8));
			}

   bits=codex[c]; 
   offset+=bits & CODELEN;

   if(string>=lt)
   {
    err=geterror(FI0C);
    break;
   }
  }

  txunlock(&v->textsrc,v->file);
 }

 *string++=0;

 return(err);
}



os_error * freplace(findstr * find)
{
 os_error     * err;
 int            backflow;
 int            olen;
 int            nlen;
 unsigned short replacestring[FMAXLEN];
 unsigned short string[FMAXLEN];
 int            mod;

 err=NULL;

 /* find step - sets find1=find2 */

 olen=find2.textsrc.offset-find1.textsrc.offset;
 if(olen)
 {
           err=getstring(&find1,olen,string);
  if(!err) err=fcpy(find,replacestring,sizeof(replacestring)/sizeof(unsigned short),find->r,string,find1.file);
  if(!err)
  {
   frstring(&find1,olen,string,sizeof(string)/sizeof(unsigned short),replacestring,find->xcase);

   err=modfile(find1.file,find1.section);
   if(!err)
   {
    err=undostart(find1.file);
    if(!err)
    {
     backflow=1;

     uninsertfx(UINSERTS);

     err=freplacesub(&find1,olen,&nlen,string,&mod);
     if(mod) 
     {
      freplaceflow(&find1,olen,&nlen,backflow);
     }
  
     undowritefn(act.file,UINSERTF,NULL,0);

     undoend(find1.file);
    }
   }
  }
 }

 return(err);
}


/*****************************************************************************/

/* search for search string starting at soffset */
/* return 1 on success                          */

static int searchsub(vector * v,findstr * find,int maxoffset,unsigned short * searchr,
                         int whole,int lastwhole,int * soffset,int * eoffset)
{
 unsigned short * s;       /* pointer into search string                */
 int    poffset; /* pointer to base of place we are searching */
 int    qoffset; /* pointer to where we are searching         */
 int    esccheck;
 int    match;
 int    alnum;
 int    temp;
 int    c;
 int    d;
 int    bits;
 int    slen;
	char * p;


 esccheck=0;



 poffset=qoffset=*soffset;

 while(1)
 {
  qoffset=poffset;

  if(esccheck++>10240)
  {
   esccheck=0;
//   if(bbc_inkey(0)==27) return(0);
   if(akbd_pollesc()) return(0);
  }

  s=searchr;
  match=1;

  while(match)
  {
   p=txptr(v->textsrc.sourcep,qoffset);
			c=*p;
   d=*s;
   bits=codex[c];
   slen=bits & CODELEN;

   if(!d && !(lastwhole && iswalnum((unsigned short)c)))
   {            /* found it */
    *soffset=poffset; /* pb=pcheck-pn */
    *eoffset=qoffset; /* qb=qcheck-qn */
    if(c==SNO) *eoffset+=SNLEN;
    return(1);
   }

   if(qoffset>=maxoffset) return(0);

   if(c>=32 || c==TABSEQ   || c==EOPAGE || c==NL      || c==CR     || c==EOB
            || c==EOBOX    || c==CHAPNO || c==ACTDATE || c==MACSEQ
            || c==SPACESEQ || c==PAGENO || c==UNC16)
   {
    if(d==FANY || 
       (d==FALPHA && ((bits & CODETYPE)==CODEALPHA)) || 
       (d==FDIGIT && ((bits & CODETYPE)==CODEDIGIT)) ||
       (d==FWHITE && ((bits & CODETYPE)==CODEWHITE))
      )
    {
     s++;
    }
    else
    {
					if(c==UNC16)	c=(*(p+1))|((*(p+2))<<8);

     if(!find->xcase)
     {
      match=(towupper((unsigned short)d)==towupper((unsigned short)c));
     }
     else
     {
      match=(d==c);
     }
     s++;
    }
   }
   else
   if(c==EOT) return(0);

   qoffset+=slen;
  }

  alnum=1;

  while(1)
  {
   if(poffset>=maxoffset) return(0);

   c=*txptr(v->textsrc.sourcep,poffset);
   bits=codex[c];
   slen=bits & CODELEN;

   if(c==EOT) return(0);

   temp=alnum;
   alnum=iswalnum((unsigned short)c);
   if(!temp && alnum) break;
   poffset+=slen;
   if(!whole) break;
  }
 }
}


#define MAXWILD 16


static os_error * searchs(findstr * find,vector * v,int maxoffset,
                          int * found,int * soffset,int * eoffset)
{
 os_error       * err;
 unsigned short * s[MAXWILD];
 int              wild;
 int              maxwild;
 int              xsoffset;
 int              eoffsets[MAXWILD];
 int              hit;
 unsigned short   string[FMAXLEN];
 unsigned short * p;
 unsigned short * q;
 int              whole;
 int              i;


 /* parse out wild cards */

 err=NULL;
 wild=0;
 maxwild=0;
 xsoffset=v->textsrc.offset;
 *soffset=xsoffset;

 whole=find->whole;

 *found=0;

 err=fcpy(find,string,sizeof(string)/sizeof(unsigned short),find->s,NULL,v->file);
 if(!err)
 {
  s[0]=string;

  if(find->wild)
  {
   p=q=string;
   while(*p)
   {
    if(*p=='\\')
    {
     if(*(p+1)=='\\') {*q='\\';q++;p+=2;}
     else
     if(*(p+1)=='*')
     {
      if(maxwild==(MAXWILD-1))
      { 
       err=geterror(FI01); /* Too many wild cards! */
       break;
      }
      *q=0;
      q++;
      maxwild++;
      s[maxwild]=q;
      p+=2;
     }
     else 
     {
      *q++=*p++;
     }
    }
    else
    {
     *q++=*p++;
    }
   }
   *q=0;

   if(maxwild)
   {
    for(i=0;i<=maxwild;i++)
    {
     if(*s[i]) break;
    }

    if(i>maxwild) err=geterror(FI09);
   }
  }

  if(!err)
  {
   while(1)
   {
    hit=searchsub(v,find,maxoffset,s[wild],whole,
                    find->whole && wild==maxwild,soffset,eoffset);


    if(hit && wild==maxwild) /* no more sub strings, then finished */
    {
     if(wild) *soffset=xsoffset;
     *found=1;
     break;
    }
    else
    if(hit)
    {
     if(!wild) xsoffset=*soffset;
     *soffset=eoffsets[wild]=*eoffset;
     wild++;
     whole=0;
    }
    else
    {
     if(wild)
     {
      wild--;
      *soffset=eoffsets[wild];
      if(!wild) 
      {
       if(xsoffset==*soffset) break; /* prevent <*><string not found> */
                                     /* looping for ever */
       xsoffset=*soffset;
       whole=find->whole;
      }
     }
     else
     {
      break;
     }
    }
   }
  }
 }

 return(err);
}




os_error * search(findstr * find,int * found,int * soffset,int * eoffset)
{
 os_error * err;
 vector     v;

 if(!strlen(find->s)) err=geterror(FI00);
 else
 {
  v=find1;

  txlock(&v.textsrc,v.file);

  err=searchs(find,&v,find3offset,found,soffset,eoffset);

  txunlock(&v.textsrc,v.file);
 }

 return(err);
}


/*************************************************************************/

/* tagged to UFINSERTS */
/* this function is always called last in undo/redo */

os_error * unfinserts(filestr * file) 
{
 vector     s1;
 flowstr    fl;
 int        coffset;
 int        cdelta;
 int        hoffset;

 txundoend(&coffset,&hoffset,&cdelta,file);

 fl.opcode=FDATA|FSUB;

 fl.opcode|=FLPREV;

 fl.data.type=cdelta?FLDELTA:FLDIRTY;
 fl.data.offset=coffset;
 fl.data.delta=cdelta;
 fl.data.length=hoffset-coffset;

 s1=find1;

 flow(&s1,&fl);

 undowritefn(file,UFINSERTF,&find1,sizeof(vector));

 return(NULL);
}


/* tagged to UFINSERTF */
/* this function is always first in undo/redo */

os_error * unfinsertf(filestr * file)
{
 if(undoforward(file)) clearactive();

 undoread(file,&find1,sizeof(vector));
 undowritefn(file,UFINSERTS,NULL,0);

 txundostart(&find1.textsrc,file);

 return(NULL);
}




os_error * globalreplace(findstr * find,int * sum)
{
 os_error  * err;
 int         backflow;
 int         olen;
 int         nlen;
 unsigned short replacestring[FMAXLEN];
 unsigned short string[FMAXLEN];
 int         mod;
 vector      v;
 vector      v1;
 int         found=0;
 int         soffset;
 int         eoffset;
 int         foffset;
 int         delta;
 flowstr     fl;
 int         n;
 int         eof;
 vector      v2;
 sourcestr * sourcep;


 n=0;

 err=NULL;

 if(!strlen(find->s)) err=geterror(FI00);
 else
 {
  string[0]=0;  /* get rid of trivial errors now */
           err=fcpy(find,replacestring,sizeof(replacestring)/sizeof(unsigned short),find->r,string,find1.file);
  if(!err) err=modfile(find1.file,find1.section);
  if(!err)
  {
   err=undostart(find1.file);
   if(!err)
   {
    clearactive();

    backflow=1;
    foffset=-1;
    soffset=eoffset=find1.textsrc.offset;
    delta=0;

    while(1)   /* loop through all stories */
    {
     undowritefn(find1.file,UFINSERTS,NULL,0);

     while(1)
     {
      v=find1;

      err=txlock(&v.textsrc,v.file);
      if(!err)
      {
       err=searchs(find,&v,find3offset,&found,&soffset,&eoffset);
       txunlock(&v.textsrc,v.file);
      }
      if(err || !found) break;
  
      if(foffset<0)
      {
       v1=v;
       movevector(&v1,soffset);
      }

      find1.textsrc.offset=soffset;
      find2=find1;
      find2.textsrc.offset=eoffset;
      olen=eoffset-soffset;

               err=getstring(&find1,olen,string);
      if(!err) err=fcpy(find,replacestring,sizeof(replacestring)/sizeof(unsigned short),find->r,string,find1.file);
      if(!err)
      {
       frstring(&find1,olen,string,sizeof(string)/sizeof(unsigned short),replacestring,find->xcase);
       err=freplacesub(&find1,olen,&nlen,string,&mod);
       if(mod)
       {
        if(foffset<0) foffset=find1.textsrc.offset;
        delta+=nlen-olen;
       }
       n++;
      }

      find1.textsrc.offset=find2.textsrc.offset;
     }

     if(foffset>=0)
     {
      fl.opcode=FSUB;
      if(backflow) fl.opcode|=FLPREV;
      fl.data.type=FLDIRTY;
      fl.data.offset=foffset;
      fl.data.delta=delta;
      fl.data.length=eoffset;

      flow(&v1,&fl);
     }

     undowritefn(find1.file,UFINSERTF,&find1,sizeof(vector));

     if(!find->all) break;
					if(find->zone) break;
     nextstory(&v1,&eof);
     if(eof) break;

     v2=v1;
     sourcep=(sourcestr*)fob_find(v1.textsrc.source,v1.file);
     v2.textsrc.offset=sourcep->len;

     setupfind(&v1,&v2);

					foffset=-1;		// 7/2/2006 added. Otherwise corrupts flow in stories looked at but with no hits in by doing a flow on them.
    }

    undoend(find1.file);
   }
  }
 }

 *sum+=n;

 return(err);
}

