/*->c.sx */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  
#include <ctype.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "font.h"
#include "werr.h"

#include "transform.h"

#include "etc.h"
#include "err.h"
#include "wos.h"
#include "deb.h"


#include "str.h"

#include "file.h"

#include "txstr.h"
#include "tx.h"
#include "codes.h"
#include "fl.h"
#include "act.h"
#include "style.h"
#include "styleif.h"
#include "vl.h"
#include "fx.h"
#include "txchoices.h"
#include "fox.h"



#include "sx.h"


/*****************************************************************************/
/* This file contains the interface between the low level routines that      */
/* manipulate text buffers and the high level routines.                      */
/* It contains the understanding of styles.                                  */
/* This is also the interface between text and the style routines.           */
/*****************************************************************************/




/*****************************************************************************/



#ifdef NEVER

 int      to;
 int      from;
 int      offset;
 int      roffset;
 int      shift;

 int      backflow=0;
 int      firstspc;
 int      laststyle=0;
 int      pendstyle=0;
 int      wasbreak=0;
 int      terminated=0;

 int      parabreak=0;

 xstr   * src=s1->source;

 int      pendsn;
 style    pendingstyle;
 int      cursn;
 int      nextsn;
 int      prevsn;
 int      startsn;

 int      newpara;
 int      canbenewpara=0;

 vline *  line;


 if(s2->off<=s1->off) return; /* nothing to delete */

 dpending=pending=0;




 offset=s1->vloff;
 if(offset)
 {
  line=vlsrcp(src,offset-sizeof(vline));
  canbenewpara=(EOLCHAR(line)==ISNL);
  if(!canbenewpara && EOLCHAR(line)!=ISBREAK)
  {
   firstspc=getfirstspc(s1);
   if(firstspc>=s1->off) backflow=1;
  }
 }

 /* skip s1 back over any SNO's */

 prevsnox(s1);

 /* find out what the style before this was */

 canbenewpara=canbenewpara && (s1->loff==s1->off);

 startsn=prevsn=cursn=prevstylex(s1);

 if(isnewpara(s1) && s1->off==s1->loff) {newpara=1;roffset=s1->off+SNLEN;}
 else                                   {newpara=0;roffset=s1->off;}

 offset=from=s1->off;
 to=s2->off;

 while(1)
 {
  switch(*srcp(src,offset))
  {
   case EOT:
            terminated=1;
            goto finished;

   case SNO:
            nextsn=snsrc(src,offset);

            if(laststyle)
            {
             if(!parabrk(nextsn,cursn))
             {
              pendsn=cursn;
              pendingstyle=*getstyle(pendsn);
              pendstyle=1;
             }
             else
              pendstyle=0;

             delstyle(cursn,file);
            }

            cursn=nextsn;
            laststyle=1;
            offset+=SNLEN;

            if(wasbreak && startsn!=BADFONT)
            {
             parabreak|=parabrk(startsn,cursn);
            }
            wasbreak=0;
            break;

case     NL:
case  EOBOX:
case EOPAGE:
            if(offset>=to) goto finished;
            wasbreak=1;
            offset++;
            break;

case TABSEQ:
            if(offset>=to) goto finished;
            wasbreak=0;
            offset+=TSLEN;
            break;

case MACSEQ:
            if(offset>=to) goto finished;
            wasbreak=0;
            offset+=MSLEN;
            break;

    default:
            if(offset>=to) goto finished;
            wasbreak=0;
            offset++;
            break;
  }
 }


 finished:

 if(laststyle)
 {
  if(cursn!=prevsn && !(terminated && !newpara)) 
  {
   wrsnsrc(src,from,cursn);
   from+=SNLEN;
  }
  else delstyle(cursn,file);
 }

 change(src,from,from-offset,0);

 if(parabreak && cursn!=prevsn && !terminated && !canbenewpara)
 {
  shift=normaliseblock(src,from-SNLEN,startsn);
 }
 else
 {
  shift=0;
 }

 flowv(s1,s1,roffset,NULL,0,from-offset+shift,from,backflow);

 if(pendstyle)
 {
  if(pendsn!=prevsn)
   {
    pendstr=pendingstyle;
    dpending=1;
   }
 }







#endif




os_error * deletev(vector * v1,vector * v2)
{
 os_error  * err;
 flowstr     fl;
 int         stringlen;
 int         backflow;
 int         voffset;
 int         offset;
 int         firstspc;
 vlstr     * vline;
 filestr   * file;
 int         lastsn;
 int         bits;
 char      * p;
 int         c;
 int         seennl;


 backflow=0;
 seennl=0;

 file=v1->file;

 err=txlock(&v1->textsrc,file);

 txmodvec(v1);

 /* first find out if a backflow can happen */

 voffset=v1->textsrc.voffset;
 while(voffset)
 {
  vline=vlptr(v1->textsrc.vsourcep,voffset-sizeof(vlstr));
  if(!vline->line.xl)
  {
   if(vline->line.eol!=ISNL && vline->line.eol!=ISBREAK)
   {
    firstspc=getfirstspc(v1,vline->line.len);
    if(firstspc>=v1->textsrc.offset) backflow=1;
   }
   break;
  }
  voffset-=sizeof(vlstr);
 }


 /* the last sno in any deleted area must be kept */
 /* all others must be rem'd                      */

 lastsn=0;
 offset=v1->textsrc.offset;

 while(offset<v2->textsrc.offset)
 {
  p=txptr(v1->textsrc.sourcep,offset);
  c=*p;
  bits=codex[c];

  if(c==SNO)
  {
   lastsn=p[1]+(p[2]<<8)+(p[3]<<16);
  }
  else
  if(c==NL) seennl=1;

  offset+=bits & CODELEN;
 }

 stringlen=v2->textsrc.offset-v1->textsrc.offset;

/* dprintf(0,"backflow=%d stringlen=%d",backflow,stringlen); */

 err=txundosourceremovex(stringlen,&v1->textsrc,file);

 if(lastsn)
 {
  err=txundosourceinsertsn(lastsn,&v1->textsrc,file);
  stringlen-=SNLEN;
 }


 txunlock(&v1->textsrc,file);


 /* fl.opcode=FLV0|FDATA|FSUB; */

 fl.opcode=FLV0|FDATA|FLINE;
 if(backflow) fl.opcode|=FLPREV;

 fl.data.type=FLDELTA;
 fl.data.offset=v1->textsrc.offset;
 fl.data.delta=-stringlen;
 fl.data.length=0;
 fl.roff[0]=v1->textsrc.offset;
 fl.resultv[0]=v1;


 flow(v1,&fl);

 return(err);
}


/*****************************************************************************/

/*
   Assertion
   ==========

   if we are inserting something that starts with a space,
   then unless we are **past** the first space in the line, we
   may backflow

   if we are inserting something that starts with a non space
   then it cannot backflow

   if the previous line ends with a break char, then we cannot backflow

 */


 /*

    Assertion on bullets
    ====================
    Only inserted LF's can change bullet numbers
    Only LF's inserted in a style which has bulleting on and a contents
    level>0 can change bullet numbers

 */



os_error * insertv(vector * v,char * string,int stringlen,int sn,int after)
{
 os_error  * err;
 filestr   * file;
 flowstr     fl;
 int         offset;
 int         delta;
 int         coffset;
 int         voffset;
 int         backflow;
 int         firstspc;
 vlstr     * vline;
 char        ch;
 int         oldsn;
 int         cn;


 file=v->file;

 err=txlock(&v->textsrc,file);

 txmodvec(v);

 offset=v->textsrc.offset;

 voffset=v->textsrc.voffset;
 backflow=0;

 while(voffset)
 {
  vline=vlptr(v->textsrc.vsourcep,voffset-sizeof(vlstr));
  if(!vline->line.xl)
  {
   if(vline->line.eol!=ISNL && vline->line.eol!=ISBREAK)
   {
    ch=*string;
    if(
       ch==SPACE  || ch==TABSEQ || ch==NL     || ch==CR     || ch==EOBOX   || 
       ch==EOPAGE || ch==HYPHEN || ch==NBHYPH || ch==DCHYPH || ch==NBSPACE ||
       (vline->line.eol!=ISSPACE)
      )
    {
     firstspc=getfirstspc(v,vline->line.len);
     if(firstspc>=offset) backflow=1;
    }
   }
   break;
  }

  voffset-=sizeof(vlstr);
 }


 delta=0;

 /* if you are just after an sno step back in front of it        */
 /* if you are just in front of an sno insert the new code alone */
 /* else insert new code, text, old code                         */

 cn=0;
 if(sn)
 {
  getstylev(v,0,&oldsn);
  if(oldsn==sn) sn=0;
  else
  {
   cn=styleprevcode(v);
   txundosourceinsertsn(sn,&v->textsrc,file);
   delta+=SNLEN;
   v->textsrc.offset+=SNLEN;
  }
 }

 err=txundosourceinsert(string,stringlen,&v->textsrc,file);
 v->textsrc.offset+=stringlen;
 delta+=stringlen;



 coffset=v->textsrc.offset;

 if(sn)
 {
  if(cn!=SNO && (cn!=EOT || after))
  {
   txundosourceinsertsn(oldsn,&v->textsrc,file);
   delta+=SNLEN;
  }
  else
  if(!after && cn==SNO)
  {
   if(*txptr(v->textsrc.sourcep,v->textsrc.offset)==EOT)
   {
    txundosourceremovex(SNLEN,&v->textsrc,file);
   }
  }

  if(after) coffset+=SNLEN;
 }


 txunlock(&v->textsrc,file);

 fl.opcode=FLV0|FDATA|FLINE;

 if(backflow) fl.opcode|=FLPREV;

 fl.data.type=FLDELTA;
 fl.data.offset=offset;
 fl.data.delta=delta;
 fl.data.length=0;
 fl.roff[0]=coffset;

 fl.resultv[0]=v;

 flow(v,&fl);

 return(err);
}



os_error * applystylev(vector * s,vector * e,xstylestr * style,
                                                        undostylestr * uss)
{
 os_error  * err;
 int         offset;
 int         eoffset;
 int         bits;
 absstylestr rstyle;
 char      * p;
 filestr   * file;
 int         sn;
 int         c;

 file=s->file;



 err=txlock(&s->textsrc,file);
 if(!err)
 {
  offset=s->textsrc.offset;
  eoffset=e->textsrc.offset;


  while(offset<eoffset)
  {
//   cprintf("offset=%d",offset);



   p=txptr(s->textsrc.sourcep,offset);
   c=*p;
   bits=codex[c];

   if(c==SNO)
   {
    sn=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);

    undostylemapadd(file,uss,offset,sn);

    findabsstyle(file,sn,&rstyle);

    applystyle(&rstyle.style,style);

    addabsstyle(file,&rstyle,1);

/*    remabsstyle(file,sn); */

    p=txptr(s->textsrc.sourcep,offset);
    *(p+1)=(char)rstyle.style.n;
    *(p+2)=(char)(rstyle.style.n>>8);
    *(p+3)=(char)(rstyle.style.n>>16);
   }
   offset+=bits & CODELEN;
  }
  txunlock(&s->textsrc,file);
 }
 return(err);
}





os_error * addchainentry(int usn,int oldchain,int * newchain,filestr * file)
{
 int         n;
 int         chain[MAXCHAIN];
 int         i;
 int         nchain;

 *newchain=0;

 findstylechains(file,oldchain,chain+1,&n);

 for(i=0;i<n;i++)
 {
  if(chain[i+1]==usn) break;
 }

 if(i>0)
 {
  if(i<n)  /* move styles from i+1 to i */
  {
   nchain=n;
   memmove(chain+i+1,chain+i+2,(n-(i+1))*sizeof(int));
  }
  else
  {
   nchain=n+1;
  }

  chain[0]=usn;

  addstylechain(file,chain,nchain,newchain,1);
 }

 return(NULL);
}



os_error * adduserstylev(vector * s,vector * e,int usn,undostylestr * uss)
{
 os_error  * err;
 int         offset;
 int         eoffset;
 int         bits;
 absstylestr rstyle;
 char      * p;
 filestr   * file;
 int         sn;
 int         c;
 int         newchain;



 file=s->file;

 err=txlock(&s->textsrc,file);


 if(!err)
 {
  offset=s->textsrc.offset;
  eoffset=e->textsrc.offset;

  while(offset<eoffset)
  {
   p=txptr(s->textsrc.sourcep,offset);
   c=*p;
   bits=codex[c];

   if(c==SNO)
   {
    sn=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);


    findabsstyle(file,sn,&rstyle);
    addchainentry(usn,rstyle.chain,&newchain,file);


    if(newchain)
    {
     undostylemapadd(file,uss,offset,sn);

     rstyle.chain=newchain;
     fillinstyle(&rstyle,file);


     addabsstyle(file,&rstyle,1);

/*     remabsstyle(file,sn);            */


     remstylechain(file,newchain,1);


     p=txptr(s->textsrc.sourcep,offset);
     *(p+1)=(char)rstyle.style.n;
     *(p+2)=(char)(rstyle.style.n>>8);
     *(p+3)=(char)(rstyle.style.n>>16);

    }
   }
   offset+=bits & CODELEN;
  }
  txunlock(&s->textsrc,file);
 }

 return(err);
}





os_error * remchainentry(int usn,int oldchain,int * newchain,filestr * file)
{
 int         n;
 int         chain[MAXCHAIN];
 int         i;

 *newchain=0;


 findstylechains(file,oldchain,chain,&n);

 for(i=0;i<n;i++)
 {
  if(chain[i]==usn) break;
 }

 if(i<n && !(usn==BODYTEXT && i==(n-1))) /* move styles from i+1 to i */
 {
  memmove(chain+i,chain+i+1,(n-(i+1))*sizeof(int));

  if(usn==BODYTEXT)
  {
   chain[n-1]=usn;
  }
  else
  {
   n--;
  }

  addstylechain(file,chain,n,newchain,1);
 }

 return(NULL);
}




os_error * remuserstylev(vector * s,vector * e,int usn,undostylestr * uss)
{
 os_error  * err;
 int         offset;
 int         eoffset;
 int         bits;
 absstylestr rstyle;
 char      * p;
 filestr   * file;
 int         sn;
 int         c;
 int         newchain;

 file=s->file;


 err=txlock(&s->textsrc,file);
 if(!err)
 {
  offset=s->textsrc.offset;
  eoffset=e->textsrc.offset;

  while(offset<eoffset)
  {
   p=txptr(s->textsrc.sourcep,offset);
   c=*p;
   bits=codex[c];

   if(c==SNO)
   {
    sn=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);

    findabsstyle(file,sn,&rstyle);

    remchainentry(usn,rstyle.chain,&newchain,file);
    if(newchain)
    {
     undostylemapadd(file,uss,offset,sn);
     rstyle.chain=newchain;
     fillinstyle(&rstyle,file);
  
     addabsstyle(file,&rstyle,1);
/*     remabsstyle(file,sn);       */

     remstylechain(file,newchain,1);

     p=txptr(s->textsrc.sourcep,offset);
     *(p+1)=(char)rstyle.style.n;
     *(p+2)=(char)(rstyle.style.n>>8);
     *(p+3)=(char)(rstyle.style.n>>16);
    }
   }
   offset+=bits & CODELEN;
  }
  txunlock(&s->textsrc,file);
 }
 return(err);
}



os_error * stripstylev(vector * s,vector * e,undostylestr * uss,xstylestr * style)
{
 os_error  * err;
 int         offset;
 int         eoffset;
 int         bits;
 absstylestr rstyle;
 char      * p;
 filestr   * file;
 int         sn;
 int         c;


 file=s->file;

 err=txlock(&s->textsrc,file);
 if(!err)
 {
  offset=s->textsrc.offset;
  eoffset=e->textsrc.offset;

  while(offset<eoffset)
  {
   p=txptr(s->textsrc.sourcep,offset);
   c=*p;
   bits=codex[c];

   if(c==SNO)
   {
    sn=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);

    undostylemapadd(file,uss,offset,sn);

    findabsstyle(file,sn,&rstyle);
    if(style)
    {
     styleclrbits(&rstyle.style.action,&rstyle.style.action,&style->action);
    }
    else
    {
     styleclrall(&rstyle.style);
    }

    fillinstyle(&rstyle,file);
  
    addabsstyle(file,&rstyle,1);
/*    remabsstyle(file,sn);  */

    p=txptr(s->textsrc.sourcep,offset);
    *(p+1)=(char)rstyle.style.n;
    *(p+2)=(char)(rstyle.style.n>>8);
    *(p+3)=(char)(rstyle.style.n>>16);
   }
   offset+=bits & CODELEN;
  }
  txunlock(&s->textsrc,file);
 }
 return(err);
}

