/*->c.texttool */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  
#include <ctype.h>
#include <time.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "font.h"
#include "werr.h"

#include "transform.h"

#include "etc.h"
#include "err.h"
#include "wos.h"
#include "poll.h"
#include "key.h"
#include "colour.h"
#include "xmath.h"
#include "deb.h"
#include "osunits.h"
#include "dbhi.h"


#include "constants.h"
#include "str.h"

#include "object.h"

#include "codes.h"
#include "reslink.h"

#include "file.h"
#include "view.h"
#include "viewr.h"


#include "xredraw.h"
#include "mhi.h"

#include "posn.h"
#include "toolstr.h"
#include "tools.h"
#include "caret.h"
#include "pref.h"
#include "select.h"
#include "chain.h"
#include "clip.h"
#include "units.h"
#include "undo.h"
#include "geometry.h"


#include "txstr.h"
#include "tx.h"
#include "txprivate.h"
#include "vec.h"
#include "act.h"
#include "txdd.h"
#include "vl.h"
#include "text.h"
#include "styleif.h"
#include "mx.h"
#include "txptr.h"
#include "dbstyle.h"
#include "fox.h"
#include "fl.h"
#include "stylemap.h"
#include "fx.h"


#include "txchoices.h"

#include "texttool.h"



static int txpass;
static int txclaim;
static int txdrag;
static int txddrag;
static int txddsx;
static int txddsy;


static pointstr ddptr=
{
 "p_export",0,0
};



/*************************************************************************/


#define TIPBUTTONS 15


#define TIPFONTM   0
#define TIPSIZETX  1
#define TIPSIZEM   2
#define TIPNORMAL  3
#define TIPBOLD    4
#define TIPITALIC  5
#define TIPUNDER   6
#define TIPREVERSE 7
#define TIPSUPER   8
#define TIPSUBS    9
#define TIPLEFT    10
#define TIPCENTRE  11
#define TIPRIGHT   12
#define TIPJUSTIFY 13
#define TIPFONTTX  14


static int tipflags[TIPBUTTONS];


static iconmap tipmap[TIPBUTTONS+1]=
{
 21, 0,0,IP_TIPS,
 22, 0,0,IP_TIPS,
 3, 0,0,IP_TIPS,
 4, 0,0,IP_TIPS,
 5, 0,0,IP_TIPS,
 6, 0,0,IP_TIPS,
 7, 0,0,IP_TIPS,
 8, 0,0,IP_TIPS,
 9, 0,0,IP_TIPS,
 10,0,0,IP_TIPS,
 11,0,0,IP_TIPS,
 12,0,0,IP_TIPS,
 13,0,0,IP_TIPS,
 14,0,0,IP_TIPS,
 15,0,0,IP_TIPS,

 0,0,0,0,      /* terminator */
};



static void tipsetflag(int index,int flag,int handle)
{
// cprintf("index %d flag %d tipflags %d",index,flag,tipflags[index]);
 
 if(flag!=tipflags[index]) 
 {
  selectst(handle,tipmap[index].realicon,flag);
  tipflags[index]=flag;
 }
}




static os_error * tiprefresh(viewstr * view,int handle,int code)
{
 os_error  * err;
 filestr   * file;
 xstylestr   style;
 int         i;
 int         flag;
 char      * p;


 err=NULL;


 file=view->file;

 if(act.valid && act.file==file)
 {
  if(code==-1)
  {
   for(i=0;i<TIPBUTTONS;i++) tipflags[i]=-1;
  }

//  cprintf("code %x",code);


  if(code==2) style=txastyle.style;
  else        err=gettextstyle(file,&style);

  flag=(!style.data.bold && style.action.bold) &&
       (!style.data.italic && style.action.italic) &&
       (!style.data.underline && style.action.underline) &&
       (!style.data.reverse && style.action.reverse) &&
       (!style.data.supersub && style.action.supersub);

  tipsetflag(TIPNORMAL,flag,handle);
  tipsetflag(TIPBOLD,(style.data.bold && style.action.bold),handle);
  tipsetflag(TIPITALIC,
         (style.data.italic && style.action.italic),handle);
  tipsetflag(TIPUNDER,
         (style.data.underline && style.action.underline),handle);
  tipsetflag(TIPREVERSE,
         (style.data.reverse && style.action.reverse),handle);
  tipsetflag(TIPSUPER,(style.data.supersub==SUPS && 
                       style.action.supersub),handle);
  tipsetflag(TIPSUBS,(style.data.supersub==SUBS &&
                      style.action.supersub),handle);

  tipsetflag(TIPLEFT,
        (style.data.align==LEFT && style.action.align),handle);
  tipsetflag(TIPRIGHT,
        (style.data.align==RIGHT && style.action.align),handle);
  tipsetflag(TIPCENTRE,(style.data.align==CENTRE && 
                        style.action.align),handle);
  tipsetflag(TIPJUSTIFY,(style.data.align==JUSTIFY &&
                         style.action.align),handle);

  flag=style.action.size?style.data.ypts:-2;
  if(flag!=tipflags[TIPSIZETX])
  {
   if(flag<0) writeiconc(handle,tipmap[TIPSIZETX].realicon,"");
   else       writeiconc(handle,tipmap[TIPSIZETX].realicon,
                                                 unitstostring(flag,POINTS));
   tipflags[TIPSIZETX]=flag;
  }

  flag=style.action.font?style.data.font:-2;

//cprintf("flag %d tipflags %d",flag,tipflags[TIPFONTTX]);

  if(flag!=tipflags[TIPFONTTX])
  {
   p=fontlocalnamei(flag); /* NB works for flag<0 */
   if(!p) p="";

   writeiconc(handle,tipmap[TIPFONTTX].realicon,p);
   tipflags[TIPFONTTX]=flag;
  }
 }

 return(err);
}




static os_error * tipkey(int handle,int userhandle,int icon,int * key)
{
 os_error * err;
 viewstr  * view;
 char     * p;
 int        newsize;

 err=NULL;

 if(*key==13)
 {
  view=(viewstr *)userhandle;

  err=iconaddr(handle,tipmap[TIPSIZETX].realicon,&p);
  if(!err)
  {
   err=stringtounits(p,&newsize,POINTS);
   if(!err) err=txsetfontsize(newsize,view);
  }
  *key=-1;
 }

 return(err);
 USE(icon);
}





static os_error * tipclick(int handle,int userhandle,wimp_mousestr * m)
{
 os_error        * err;
 viewstr         * view;
 filestr         * file;

 err=NULL;

 view=(viewstr *)userhandle;
 file=view->file;

//  cprintf("tipclick");

 switch(m->i)
 {
  case 4:
         err=txseteffx(1,view);  /* normal */
         break;

  case 5:
//         cprintf("bold");
         err=txseteffx(2,view);  /* bold */
         break;

  case 6:
         err=txseteffx(4,view);  /* italic */
         break;

  case 7:
         err=txseteffx(8,view);  /* underline */
         break;

  case 8:
         err=txseteffx(16,view);  /* reverse */
         break;

  case 9:
         err=txseteffx(32,view);  /* super */
         break;

 case 10:
         err=txseteffx(64,view);  /* subs */
         break;

 case 11:
         err=txsetalign(LEFT,view);
         break;

 case 12:
         err=txsetalign(CENTRE,view);
         break;

 case 13:
         err=txsetalign(RIGHT,view);
         break;

 case 14:
         err=txsetalign(JUSTIFY,view);
         break;

 case  3:
         err=openmenuparent("size_menu",handle);
         break;

 case  21:
         err=txopenfontmenu(view);
         break;

 }

 return(err);

 USE(handle);
}



static ipstr tipstr=
{
 tipclick,     /* click    */
 tipkey,       /* key      */
 tipmap,       /* icon map */
 TTEXTTOOL,    /* template */
 0,            /* code     */
 tiprefresh,   /* refresh  */
};



static int textpending;

static void textpoll(int userhandle)
{
 if(textpending)
 {
  event(EVENT_TEXTUPDATE,act.valid?act.file:NULL,0);
  textpending=0;
 }

 USE(userhandle);
}



void txactchange(void)
{
 int tooln;

 tooln=toolcurrent(act.file);
 if(tooln==TL_SELECT)
 {
  ipchangepane(act.file->toolbox,IP_PANE2,act.valid?&tipstr:NULL);
 }
 textpending=1;
}


void txactstylechange(int code)
{
 int tooln;

 tooln=toolcurrent(act.file);
 if(tooln==TL_SELECT)
 {
  iprefreshpane(act.file,code,IP_PANE2);
 }
 textpending=1;
}



void txfontschanged(void)
{
 if(act.valid)
 {
  txactstylechange(0x1);
  actclearpend();
 }
}


/*************************************************************************/


typedef struct caretpaintstr
{
 filestr      * file;
 viewstr      * view;     /* view with focus, NOT view with caret */
 int            page;
 int            valid;
 int            visible;
 int            x;
 int            y;        /* baseline */
 int            h;        /* caret is from baseline-l to baseline-l+h */
 int            l;
 transformstr   tr;
 int            trtype;
 int            b;
} caretpaintstr;


static caretpaintstr   newcp;
static caretpaintstr   oldcp;
static caretshift;








/* this returns dud results if the frame has no vlines in it */

/* convert a position into a vector  */

os_error * posn2vector(posnstr * posn,vector * act,coordstr * cx)
{
 os_error     *  err;
 textboxstr   *  textp;
 filestr      *  file;
 int             offset;
 int             vloff;
 int             vlmax;
 vlstr           vline;
 vlstr           xline;
 coordstr        coord;
 int             s;
 int             minx;
 int             miny;
 int             linex;
 int             maxw;
 int             hit;
 int             newminx;
 int             newminy=0;      /* compiler */
 int             found;
 int             vshift;         /* line shift                       */
 int             vdelta;         /* increment in line shift per line */
 texsrc        * texsp;
 texsub        * texup;
 texhdr        * texhp;
 int             u;
 int             header;
 int             footer;
 int             editable;
 int             xl;
 int             xr;
 int             hof;
 int             doheader;
 int             dofooter;
 transformbitstr bits;
 int             h;
 int             bitsvalid;
 int             targets;
 int             hits;
 int             w;
 int             gw;
 int             x;


 err=NULL;

 found=0;
 bitsvalid=0;
 targets=hits=0;
 minx=miny=linex=0; /* compiler */
 act->valid=0;
 file=posn->file;


 if(posn->object && !posn->ghost)
 {
  textp=(textboxstr*)fob_find(posn->object,file);
  if(textp->type==OTEXTBOX)
  {
   coord.x=posn->x;
   coord.y=posn->y;
   tr_inverseset(&coord,1,&textp->data.transform);
   coord.x-=textp->fcurve.box.x;
   coord.y-=textp->fcurve.box.y;

   act->file=file;

   header=textp->data.header;
   footer=textp->data.footer;
   hof=(header || footer);


   u=0;
   if(hof)
   {
    texhp=(texhdr*)(((char*)textp)+sizeof(textboxstr)+3*sizeof(texsrc));
    header=texhp->header;
    footer=texhp->footer;

    dohf(textp,posn->page,&doheader,&dofooter,file);

    if(doheader || dofooter)
    {
     tr_getbits(&textp->transform,&bits);
     bitsvalid=1;

     h=ttmul(textp->fcurve.box.h,bits.yscale);

     if(coord.y<header && doheader)     u=1;
     else
     if(coord.y>(h-footer) && dofooter) u=2;
    }
   }

   if((editable=(txeditable(posn->object,posn->section,u,file)==NULL))
                                                                          ==0)
   {
    if(u) u=0;
    editable=(txeditable(posn->object,posn->section,u,file)==NULL);
   }

   if(editable)
   {
    if(u==0) settextoffset(file,textp,&vloff,&offset);
    else
    {
     vloff=offset=0;
    }

    act->textsrc.u=u;
    if(hof)
    {
     act->textsrc.usize=sizeof(textboxstr)+3*sizeof(texsrc)+sizeof(texhdr);
     if(u==0) act->textsrc.usize+=2*sizeof(texsub);
     else
     if(u==2) act->textsrc.usize+=sizeof(texsub);
    }
    else 
    {
     act->textsrc.usize=sizeof(textboxstr)+sizeof(texsrc);
    }

    if(u==1 || u==2) act->textsrc.columns=1;
    else             act->textsrc.columns=textp->data.columns;
 
    texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

    act->boffset=offset;
    act->bvoffset=vloff;
    act->textsrc.source=texsp[act->textsrc.u].source;
    act->textsrc.vsource=texsp[act->textsrc.u].vsource;
    act->textsrc.text=posn->object;
    act->textsrc.offset=offset;
    act->textsrc.loffset=offset;
    act->section=posn->section;
    act->page=posn->page;
    act->x=coord.x;
    act->y=coord.y;

    if(act->textsrc.columns>1)
    {
     if(!bitsvalid) tr_getbits(&textp->transform,&bits);
     w=txcolwidthb(textp,u,&gw,&bits);

     x=-gw/2;
     for(s=0;s<act->textsrc.columns;s++)
     {
      if(coord.x>=x && coord.x<=(x+(w+gw)))
      {
       targets=s;
       break;
      }
      x+=(w+gw);
     }
    }

    err=txlock(&act->textsrc,file);
    if(!err)
    {
     flowvalidate(act,FLVBOX);

     vloff=act->bvoffset;
     offset=act->boffset;


     for(s=0;s<act->textsrc.columns;s++)
     {
      texup=(texsub*)(((char*)act->textsrc.textp)+act->textsrc.usize);

      txgetvshifts(act->textsrc.textp,texup+s,&vshift,&vdelta);

      vlmax=vloff+texup[s].vlines;

      for(;vloff<vlmax;vloff+=sizeof(vlstr))
      {
       hit=0;
    
       getvline(&vline,act->textsrc.vsourcep,vloff);

       if(!vline.line.xl)
       {
        vline.line.yy=LY(vline.line.yy)+vshift;
        maxw=MAXWX(vline);
     
        if(coord.y>=LY(vline.line.yy) && 
                  coord.y<=(int)(LY(vline.line.yy)+vline.line.h))
        {
         if(coord.x>=(int)vline.line.x && coord.x<=(int)(vline.line.x+maxw))
         {    /* a direct hit */
          hit=2;
          minx=miny=0;
          xline=vline;
         }
         else
         {
          newminy=0;
         }
        }
        else
        if(coord.y<LY(vline.line.yy))
        {
         newminy=LY(vline.line.yy)-coord.y;
        }
        else  /* coord.y>(vline.y+vline.h) */
        {
         newminy=coord.y-(LY(vline.line.yy)+vline.line.h);
        }

        if(!hit)
        {
         if(coord.x>=(int)vline.line.x && coord.x<=(int)(vline.line.x+maxw)) newminx=0;
         else
         if(coord.x<(int)vline.line.x) newminx=coord.x-vline.line.x;  /* swopped */
         else                     newminx=coord.x-(vline.line.x+maxw);
    
         if(!found ||
            (pythag(newminx,newminy)<pythag(minx,miny)
                             && (s==targets || hits!=targets)) ||
            (s==targets && hits!=targets)
           )
         {
          miny=newminy;
          minx=newminx;
          xline=vline;
          hit=1;
          hits=s;
         }
        }

        if(hit)
        {
         act->textsrc.voffset=vloff;
         act->textsrc.loffset=offset;
         act->textsrc.offset=offset;
         act->textsrc.s=s;
         act->astyle=vline.line.style;
         found=1;
         if(hit==2) break;
        }

        offset+=vline.line.len;
        vshift+=vdelta;
       }
      }

      if(vloff<vlmax) break;
      vloff=vlmax;
     }

     if(found)
     {
      vsetcaretposn(act);
      act->valid=VVECTOR;

      if(cx)
      {
       xl=xr=0;
       maxw=MAXWX(xline);

       if(xline.line.just==RIGHT)   
       {
        xl=(maxw-xline.line.w);
        xr=maxw;
       }
       else
       if(xline.line.just==CENTRE)  
       {
        xl=(maxw-xline.line.w)>>1;
        xr=xl+xline.line.w;
       }
       else
       if(xline.line.just==JUSTIFY) xr=maxw;
       else                         xr=xline.line.w;

       if(coord.x<(int)(xline.line.x+xl)) cx->x=coord.x-(xline.line.x+xl);
       else
       if(coord.x>(int)(xline.line.x+xr)) cx->x=coord.x-(xline.line.x+xr);
       else                          cx->x=0;

       if(coord.y<LY(vline.line.yy)) cx->y=coord.y-LY(vline.line.yy);
       else
       if(coord.y>(int)(LY(vline.line.yy)+vline.line.h)) 
                                 cx->y=coord.y-(LY(vline.line.yy)+vline.line.h);
       else                      cx->y=0;
      }
     }

     txunlock(&act->textsrc,file);
    }
   }
  }
 }

 return(err);
}



void vector2posn(posnstr * posn,vector * v)
{
 posn->file=v->file;
 posn->section=v->section;
 posn->page=v->page;
}



static os_error * txtptr(toolboxstr * toolbox,posnstr * posn)
{
 if(txpass)
 {
  findbox(posn,-1);


#ifdef NEVER
  if(posn->otype==OTEXTBOX)
  {
   vector    s;
   coordstr cx;

   posn2vector(posn,&s,&cx);

   cprintf("txptr %x",s.textsrc.source);

  }
#endif


  if(act.valid && act.file==posn->file 
               && act.textsrc.text==posn->object
               && !posn->ghost) settxptr(1);
 }

 return(NULL);

 USE(toolbox);
}





static int txvinzone(vector * s)
{
 return(zone && s->valid && act.valid &&
        s->file==act.file && 
        s->textsrc.source==act.textsrc.source &&
        s->textsrc.offset>=lozon->textsrc.offset && 
        s->textsrc.offset<=hizon->textsrc.offset);
}


static os_error * txstartdd(posnstr * posn)
{
 toolschangepointer(128,USERPOINTER,&ddptr);
 toolsstartdrag(posn,TOOLDRAGTRANSFER|TOOLDRAGPTR);
 txddrag=(posn->buttons & VBSHIFT)?2:1;
 txddsx=posn->mousex;
 txddsy=posn->mousey;
 return(NULL);
}




static os_error * txclick(toolboxstr * toolbox,posnstr * posn)
{
 os_error    * err;
 vector        s;
 int           object;
 coordstr      cx;


 err=NULL;

 if(txpass)
 {
  if(posn->object && posn->otype==OTEXTBOX && !posn->handle)
  {
   if(posn->buttons==VBCLICKS || posn->buttons==VBCLICKSS) 
   {
    if(nselected(&object,posn->file)==1 && 
     (object==posn->object || objectinobject(posn->object,object,posn->file))) 
    {
     err=posn2vector(posn,&s,&cx);
     if(!err && s.valid) 
     {
     /* if(txvinzone(&s) && cx.x==0) txstartdd(posn);
      else */                        makeactive(&s);
     }
    }
   }
   else
   if(act.valid && act.file==posn->file)
   {
    if(posn->buttons==VBDRAGS) /* a drag */
    {
       /*  posn2vector(posn,&s,&cx);
           if(txvinzone(&s) && cx.x==0)
           {
            txstartdd(posn);
           }
           else */

     if(txddrag)
     {


     }
     else
     {
      actstartdrag();
      settxptr(128);
      toolsstartdrag(posn,TOOLDRAGWINDOW|TOOLDRAGPTR);
      txdrag=1;
     }
    }
    else
    if(posn->buttons==VBDBLCLICKS)
    {
     selectword(&act);/* utter faith that the previous clause has just execd */
    }
    else
    if(posn->buttons==(VBDBLCLICKS|VBSHIFT))
    {
     selectword1(&act);
    }
    else
    if(posn->buttons==VBTRIPCLICKS)
    {
     selectline(&act);
    }
    else
    if(posn->buttons==VBQUADCLICKS)
    {
     selectpara(&act);
    }
    else
    if(posn->buttons==VBPENTCLICKS)
    {
     selectall(&act);
    }
   }
  }
 }
 else
 {
  if(posn->buttons==VBLONGCLICKS || posn->buttons==(VBLONGCLICKS|VBSHIFT))
  {
   if(txddrag) txclaim=0;
  }
  else
  if(posn->buttons==VBCLICKA || posn->buttons==VBCLICKSS)
  {
   if(act.valid && act.file==posn->file)
   {
    findbox(posn,-1);  /* duplicating what comes next - never mind */
    err=posn2vector(posn,&s,&cx);

    if(!err)
    {
    // Win style shift+select outside zone marking
     if(posn->buttons==VBCLICKSS && txvinzone(&s))
     {
      txstartdd(posn);
      txclaim=0;    
     }
     else
     if(s.valid && s.textsrc.source==act.textsrc.source)
     {
      extendzone(&s,&cx,posn);
      txclaim=0;
     }
    }
   }
  }
  else
  if(posn->buttons==(VBCLICKS|VBALT) ||
     posn->buttons==(VBCLICKS|VBALT|VBSHIFT) ||
     posn->buttons==(VBDRAGS|VBALT) || 
     posn->buttons==(VBDRAGS|VBALT|VBSHIFT) ||
     posn->buttons==(VBLONGCLICKS|VBALT) ||
     posn->buttons==(VBLONGCLICKS|VBALT|VBSHIFT) ||
     posn->buttons==VBDRAGSS ||
     posn->buttons==VBCLICKS || /* this has to be here to cope with clicking */
     posn->buttons==VBCLICKSS)  /* in a zone which extends across two pages  */
  {
   /* need to take out VBCLICKS|VBALT because otherwise in the case  */
   /* where we are clicking in marked text but not on a selected box */
   /* main select tool will reselect box and start DnD               */

   if(act.valid && act.file==posn->file && zone)
   {
    findbox(posn,-1);
    err=posn2vector(posn,&s,NULL);
    if(!err)
    {
     if(txvinzone(&s))
     {
      if(posn->buttons!=(VBCLICKS|VBALT) && 
         posn->buttons!=(VBCLICKS|VBALT|VBSHIFT))
      {
       txstartdd(posn);
      }
      txclaim=0;
     }
    }
   }
  }
  else
  if(posn->buttons==(VBCLICKA|VBSHIFT))
  {
   if(act.valid && act.file==posn->file)				// so not Unicode compat problem
   {
    findbox(posn,-1);

    posn2vector(posn,&s,NULL);

    if(s.valid)
    {
     err=applypara(&s);
     txclaim=0;
    }
   }
  }
 }

 txsshiftclear();

 if(act.valid && act.file==posn->file 
              && act.textsrc.text==posn->object) settxptr(1);

 return(err);

 USE(toolbox);
}



static os_error * txselect(toolboxstr * toolbox,viewstr * view,
                                                filestr * file,int select)
{

 if(!txpass && !select && act.valid && act.file==file)
 {
  clearactive();
 }

 return(NULL);

 USE(view);
 USE(file);
 USE(select);
 USE(toolbox);
}


static os_error * txmove(toolboxstr * toolbox,posnstr * posn,int move)
{
 os_error  * err;
 vector      v;
 coordstr    cx;
 absstylestr astyle;

 if(txddrag && !txpass)
 {
  txclaim=0;

  if(move)
  {
   findbox(posn,-1);
   err=posn2vector(posn,&v,NULL);
   if(!err)
   {
    if(newcp.valid && newcp.file!=posn->file) clearcaret();

    if(v.valid)
    {
     err=txlock(&v.textsrc,v.file);
     if(!err)
     {
      vsetxy(&v);
      getcaretstyle(&v,&astyle);
      setupcaret(&v,&astyle);
      txunlock(&v.textsrc,v.file);
     }
    }
    else
    {
     clearcaret();
    }
   }
  }
 }
 else
 if(txdrag && txpass)
 {
  txclaim=0;

  if(move)
  {
   findbox(posn,-1);
   posn2vector(posn,&v,&cx);
   if(v.valid)
   {
    updatezone(&v,&cx,posn);
   }
  }
 }
 else
 if(!txpass && move)
 {
  findbox(posn,-1);

  if(act.valid && 
     act.file==posn->file && 
     act.textsrc.text==posn->object && 
     !posn->ghost)
  {
   settxptr(1);
  }
 }

 return(NULL);

 USE(toolbox);
}


static os_error * txcancel(toolboxstr * toolbox,viewstr * view,filestr * file)
{

 if(txddrag || txdrag)
 {
  if(txddrag) clearcaret();
  toolsstopdrag();
  txddrag=txdrag=0;
  txclaim=0;
 }

 return(NULL);

 USE(view);
 USE(file);
 USE(toolbox);
}



/****************************************************************************/




/*

    Font_Caret
    In:     R0 = colour to EOR onto screen
            R1 = height (units depend on R2 bit 4)
            R2 = flags:
                bits 0..3 unused
                bit 4 set => coordinates are OS units, not 1/72000"
                bit 6 set => use R6 as indicated below
                bits 5,7..31 reserved (must be 0)
            R3,R4 = start coordinates (units depend on R2 bit 4)
            R6 -> transformation matrix (if R2 bit 6 set)
                R6!0..R6!12 = fixed point multipliers
                R6!16,R6!20 = translation (units depend on R2 bit 4)
                unit matrix = [1<<16,0,0,1<<16,0,0]

    If R2 bit 6 is set, then, the caret can be transformed.  This will be
    useful for applications to allow text round a circle to be edited.


*/


#ifdef NEVER

static os_error * ospaintcaret(viewredrawstr * v,caretpaintstr * p,int f)
{
 os_error * err;
 os_regset  rx;
 coordstr   px;

 err=NULL;

 px.x=p->x;
 px.y=p->y;

 tr_transformset(&px,1,&p->tr);

/* rx.r[0]=cvdu.wimpcolnos[f] ^ getcolnumber(p->b); */

 rx.r[0]=cvdu.wimpcolnos[f] ^ cvdu.wimpcolnos[WIMPWHITE];
 rx.r[1]=osunits(p->h,v->view);
 rx.r[2]=(1<<4);
 rx.r[3]=v->ox+osunits(v->xpo+px.x,v->view);
 rx.r[4]=v->oy-osunits(v->ypo+px.y+(p->h-p->l),v->view);

// err=os_swix(Font_Caret,&rx);

 return(err);
}


#endif


/*

#define CWDTH 2000
#define CYSKW 400

if(!err) err=rtbbc_move(x-CWDTH,y-CYSKW,&p->tr,v);
if(!err) err=rtbbc_draw(x,y,&p->tr,v);
if(!err) err=rtbbc_draw(x+CWDTH,y-CYSKW,&p->tr,v);

if(!err) err=rtbbc_move(x-CWDTH,y+p->h+CYSKW,&p->tr,v);
if(!err) err=rtbbc_draw(x,y+p->h,&p->tr,v);
if(!err) err=rtbbc_draw(x+CWDTH,y+p->h+CYSKW,&p->tr,v);

*/



/*

  The caret problem....

  In 16 bit resolution mode, we do some error averaging in fxfont_paintext()
  this will add some jitter to which pixel characters land on.
  We could use the same code for calculating the caret position.

  We could change the code so that it works out the distance of each glyph
  from the start of the line, and converts back to step. This is just another
  sort of error averaging but more like what goes on with the caret position.
  (identical in fact - so not a solution)

  Another approach is to look into making the caret redraw work in the same
  units as font drawing.
  (seems more likely since 16 bit mode looks to be better than 32, and 16
   bit font rendering is in OS units, the same as the caret redraw)

  So perhaps the caret problem is a 32 bit thing.


*/



static os_error * paintcaret(viewredrawstr * v,caretpaintstr * p)
{
 os_error * err;
 int        f;
 int        x;
 int        y;
 int        h;
// int        hlt;

 err=NULL;

 if(p->visible)
 {
  if(v->view==p->view) f=WIMPRED;
  else                 f=WIMPGREY2;

  if(1 || (p->trtype & TR_ROTATE))
  {
  /* err=rseteorcolpal(p->b,f); */
   err=rseteorcol(WIMPWHITE,f);

   h=p->h;

//   hlt=ourunits(ypix2os(10),v->view);
//   if(h<hlt) h=hlt;

   x=p->x;
   y=p->y-p->l;

   if(!err) err=rtbbc_move(x,y,&p->tr,v);
   if(!err) err=rtbbc_draw(x,y+h,&p->tr,v);
  }
  else
  {
//   err=ospaintcaret(v,p,f);
  }

 }
 return(err);
}



/*****************************************************************************/


static os_error * rendercaret(viewredrawstr * v)
{
 os_error      * err;

 err=NULL;

 if(oldcp.valid) 
 {
  if(oldcp.file==v->file && oldcp.page==v->page)
  {
   err=paintcaret(v,&oldcp);
  }
 }

 if(newcp.valid)
 {
  if(newcp.file==v->file && newcp.page==v->page)
  {
   err=paintcaret(v,&newcp);
  }
 }

/* if(act.valid && act.file==v->file && zone)
 {
  err=paintzone(v);
 } */

 return(err);
}



static void czero(int userhandle)
{
 aboxstr abox;
 aboxstr cbox;

// cprintf("czero");

 if(newcp.valid)
 {
  oldcp=newcp;
  if(txflash) newcp.visible^=1;
  else        newcp.visible=1;
  caretshift=1;

  cbox.y0=newcp.y-newcp.l;
  cbox.y1=cbox.y0+newcp.h;
  cbox.x0=newcp.x-newcp.h/4;
  cbox.x1=newcp.x+newcp.h/4;

  getmaxabox(&abox,&cbox,&newcp.tr);

  viewrefresharea(newcp.file,newcp.page,&abox,VRTOOLS2|VRONELAYER);
  caretshift=0;
  oldcp.valid=0;


  if(txflash)
  {
   addscheduledevent(czero,0,newcp.visible?txperiods:txperiod-txperiods);
  }

 }

 USE(userhandle);
}




static os_error * txchoiceschanged(int eventn,int user,void * data,int data1)
{
 czero(user);
 return(NULL);
 USE(eventn);
 USE(data);
 USE(data1);
}



os_error * posncaret(filestr * file,int page,int x,int y,int h,int l,
                                             int back,transformstr * tr)
{
 oldcp=newcp;

 newcp.x=x;
 newcp.y=y;
 newcp.h=h;
 newcp.l=l;
 newcp.b=back;
 newcp.tr=*tr;
 newcp.valid=1;
 newcp.file=file;
 newcp.view=caretview;
 newcp.page=page;
 newcp.visible=1;
 newcp.trtype=tr_type(tr);

 if(txflash)
 {
  addscheduledevent(czero,0,2*txperiods);
 }

 caretshift=1;
 if(oldcp.valid && oldcp.visible && oldcp.page!=newcp.page)
 {
  viewrefresharea(file,oldcp.page,NULL,VRTOOLS2|VRONELAYER);
 }

 viewrefresharea(file,page,NULL,VRTOOLS2|VRONELAYER);
 caretshift=0;

 oldcp.valid=0;

 return(NULL);
}


os_error * clearcaret(void)
{
 if(newcp.valid)
 {
  caretshift=1;
  viewrefresharea(newcp.file,newcp.page,NULL,VRTOOLS2|VRONELAYER);
  caretshift=0;
  newcp.valid=0;
 }
 return(NULL);
}


static void trashcaret(filestr * file)
{
 if(newcp.valid && file==newcp.file)
 {
  newcp.valid=oldcp.valid=0;
 }
}


static os_error * txcaret(toolboxstr * toolbox,viewstr * view,int gain)
{
 if(newcp.valid && newcp.file==view->file)
 {
  oldcp=newcp;
  newcp.view=caretview;
  caretshift=1;
  viewrefresharea(newcp.file,newcp.page,NULL,VRTOOLS2|VRONELAYER);
  caretshift=0;
  oldcp.valid=0;
 }
 return(NULL);
 USE(gain);
 USE(toolbox);
}


static os_error * txredraw(toolboxstr * toolbox,viewredrawstr * v)
{

 if(caretshift)
 {
  rendercaret(v);
  txclaim=0;
 }
 else
 {
  if(txpass)
  {
   rendercaret(v);
  }
 }

 return(NULL);

 USE(toolbox);
}

/*****************************************************************************/


static os_error * txkey(toolboxstr * toolbox,int * key,fkeyfn * fk)
{
 os_error * err;

 err=NULL;

 if(!txpass)
 {
//    cprintf("txkey %x",*key);
  
  err=actionkey(key);
  if(*key==-1) *fk=actionkey;
  else
  {
   err=stylekey(key);
   if(*key==-1) *fk=stylekey;
   else
   {
    err=textkey(key);
    if(*key==-1) *fk=textkey;
   }
  }
 }

 return(err);
 USE(toolbox);
}






static os_error * txdragend(toolboxstr * toolbox,posnstr * posn,wimp_box * box)
{
 os_error * err;
 int        copy;
 vector     s;

 err=NULL;

 if(txddrag)
 {
  clearcaret();

  copy=(txddrag-1);

  txddrag=0;
  txclaim=0;

  if(ABS(posn->mousex-txddsx)<2*cvdu.deltax && 
     ABS(posn->mousey-txddsy)<2*cvdu.deltay)
  {
   findbox(posn,-1);
   err=posn2vector(posn,&s,NULL);
   if(!err)
   {
    if(s.valid) makeactive(&s);
    settxptr(1);
   }
  }
  else
  {
   err=txdragndrop(posn,copy,0);
  }
 }
 else
 if(txdrag)
 {
  txdrag=0;
  txclaim=0;
  if(act.valid && !zone) resetactive();
 }

 return(err);

 USE(box);
 USE(toolbox);
}




static os_error * txinitselect(filestr * file,int object)
{
 os_error   * err;
 vector       v;
 textboxstr * textp;

 err=NULL;

 textp=(textboxstr*)fob_find(object,file);
 if(textp->type==OTEXTBOX)
 {
  err=setvectorfrombox(&v,0,object,file);
  if(v.valid) makeactive2(&v);

  txclaim=0;
 }

 return(err);
}



static os_error * txmess(toolboxstr * toolbox,filestr * file,
                                      int message,void * data)
{

 if(!txpass)
 {
  if(message==TSAVEPOSN) txsaveact(file);
  else
  if(message==TACTPOINT)
  {
   if(act.valid && act.file==file)
   {
    ((toolactstr*)data)->value=zone?3:2;
    ((toolactstr*)data)->object=act.textsrc.text;
   }
  }
  else
  if(message==TSELECTOBJECT)
  {
   txinitselect(file,(int)data);
  }
  else
  if(message==TCLAIMSUB && ((int)data!=OTEXTBOX))
  {
   if(act.valid && act.file==file) clearactive();
  }
 }

 return(NULL);

 USE(toolbox);
}






static subtoolstr texttool=
{
 TL_SELECT,
 txclick,
 txmove,
 txselect,
 txtptr,
 txcancel,
 txredraw,
 txdragend,
 NULL,
 txkey,
 txcaret,
 NULL,
 txmess,
 &txpass,
 &txclaim
};



/* invitation to embed something */

static os_error * txembed(int eventn,int user,filestr * file,int * claim)
{
 os_error    * err;
 objectloc     sloc;
 objectloc     dloc;
 transformstr  tr;
 filestr     * dfile;
 filestr     * sfile;
 char          string[EOBLEN];
 int           cbtype;

 err=NULL;

 cprintf("txembed");

 if(act.valid && act.file==file && !zone)
 {
  clipboardtype(&cbtype,NULL);
  if(cbtype==CLIP_OBJECT)
  {
   cprintf("txembed2");

   dfile=act.file;
   err=clipopen(&sloc.object,&sloc.page,&sloc.section,&sfile);

// unicode compatability check
		 if(!err) err=checkcompatability(sfile,sloc.object,CHECKC_CHAIN,dfile);
   if(!err)
   {
    sloc.file=sfile;
    sloc.parent=0;
    sloc.after=0;
    sloc.chain=0;
    sloc.branch=0;
    sloc.copymode=0;

    dloc.file=dfile;
    dloc.object=0;
    dloc.page=act.page;
    dloc.section=act.section;
    dloc.parent=act.textsrc.text;
    dloc.after=0;
    dloc.chain=-1;         /* no chain */
    dloc.branch=0;
    dloc.copymode=LOCFLOWDATA;
   
    tr_setidentity(&tr);

    err=objectcopy(&sloc,&dloc,&tr);

    if(!err)
    {
     memset(string,0,sizeof(string));
     string[0]=EOB;
     string[1]=(char)dloc.object;
     string[2]=(char)(dloc.object>>8);
     string[3]=(char)(dloc.object>>16);
     string[4]=(char)(dloc.object>>24);

     err=actinstext(string,EOBLEN,sizeof(string));
    }

    *claim=1;
    clipclose(sfile);
   }
  }
 }

 return(err);

 USE(user);
 USE(eventn);
}



/* called when file is closed */

static os_error * txclose(int eventn,int user,filestr * file,int data1)
{

 txsshiftclear();
 trashcaret(file);
 if(act.valid && act.file==file) 
 {
  actclearpend();
  act.valid=0;
  zone=0;
 }

 return(NULL);

 USE(eventn);
 USE(user);
 USE(data1);
}


static os_error * txselection(int eventn,int user,filestr * file,int object)
{
 if(eventn==EVENT_OBJECTSELECTED0)
 {
  if(act.valid && file==act.file && object!=act.textsrc.text && 
                 !objectinobject(act.textsrc.text,object,file)) clearactive();
 }
 else
 if(eventn==EVENT_OBJECTDESELECTED0)
 {
  if(act.valid && file==act.file && (act.textsrc.text==object ||
                  objectinobject(act.textsrc.text,object,file))) clearactive();
 }

 return(NULL);

 USE(eventn);
 USE(user);
}




static os_error * txcon(int eventn,int user,filestr * file,char ** name)
{
 if(act.valid && file==act.file)
 {
  if((eventn==EVENT_CONTENTSELECTEDNAME && zone) || 
      eventn==EVENT_CONTENTNAME) *name="{TX03}";
  else
  if(eventn==EVENT_CONTENTMENUNAME) *name="{TX06}";
  else
  if(eventn==EVENT_CONTENTMENU) *name="text_menu";
 }

 return(NULL);

 USE(user);
}




static os_error * txconbox(int eventn,int user,filestr * file,viewstr * view)
{
 if(act.valid && file==act.file)
 {
  opentextstylebox(file,view);
 }

 return(NULL);

 USE(user);
 USE(eventn);
}




os_error * texttoolinit(void)
{
 os_error * err;

 err=subtoolregister(&texttool);
 if(!err) err=addevent(EVENT_FCLOSE,(eventfn)txclose,0);
 if(!err) err=addevent(EVENT_FSCRAP,(eventfn)txclose,0);
 if(!err) err=addevent(EVENT_OBJECTSELECTED0,(eventfn)txselection,0);
 if(!err) err=addevent(EVENT_OBJECTDESELECTED0,(eventfn)txselection,0);
 if(!err) err=addevent(EVENT_EMBED,(eventfn)txembed,0);
 if(!err) err=addevent(EVENT_CONTENTNAME,(eventfn)txcon,0);
 if(!err) err=addevent(EVENT_CONTENTMENUNAME,(eventfn)txcon,0);
 if(!err) err=addevent(EVENT_CONTENTMENU,(eventfn)txcon,0);
 if(!err) err=addevent(EVENT_CONTENTSELECTEDNAME,(eventfn)txcon,0);
 if(!err) err=addevent(EVENT_CONTENTBOX,(eventfn)txconbox,0);
 if(!err) err=addevent(EVENT_CHOICES,(eventfn)txchoiceschanged,0);
 if(!err) err=addpollexit(textpoll,0);

 if(!err) err=actinit();

 return(err);
}


