/*->c.txchoices */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "font.h"
#include "transform.h"

#include "wos.h"

#include "err.h"
#include "task.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "etc.h"
#include "bf.h"
#include "fsx.h"
#include "timex.h"
#include "bits.h"
#include "conf.h"
#include "dbhi.h"
#include "deb.h"



#include "str.h"
#include "constants.h"
#include "obj.h"

#include "units.h"
#include "reslink.h"
#include "mhi.h"
#include "object.h"
#include "view.h"
#include "viewo.h"
#include "dscript.h"
#include "macros.h"

#include "pref.h"
#include "dbpref.h"
#include "dbchoices.h"
#include "choices.h"

#include "tools.h"
#include "infopal.h"
#include "buttons.h"
#include "rulers.h"
#include "xcolour.h"


#include "txstr.h"
#include "dbstyle.h"
#include "fox.h"
#include "txprivate.h"
#include "fontmenu.h"
#include "codes.h"

#include "txchoices.h"






static int  xrencols;
static int  xpcdel;
       int  pcdel;


static int  xtxrename;
       int  txrename;

static int  xtxsmartq;
       int  txsmartq;

static int  xtxovertype;
       int  txovertype;

static int  xdandd;
       int  dandd;         /* no longer used */


static int  xunicode;
       int  txunicode;

       char ssfontname[SSNAMELEN];


static int  xssfont;

static int  xinset;

static int  xsaveignore;
       int  saveignore;

static int  xdoublewords;
       int  doublewords;

static int  xspminlength;
       int  spminlength;

static int  xfontsample;
							int  fontsample;




static os_error * chtextclose(int code)
{
 if(code==DBOK || code==DBAPPLY)
 {
  pcdel=xpcdel;
  renamecolours=xrencols;
  txrename=xtxrename;
  txsmartq=xtxsmartq;
  txovertype=xtxovertype;
  if(xssfont>=0) xzstrncpy(ssfontname,fontidentifieri(xssfont),sizeof(ssfontname));
  else           strcpy(ssfontname,"");
  deflttextdata.inset=xinset;
  saveignore=xsaveignore;
  doublewords=xdoublewords;
  spminlength=xspminlength;
  dandd=xdandd;
		fontsample=xfontsample;
//  if(!ISW9X) txunicode=xunicode;
  if(txunicode!=xunicode)
  {
   txunicode=xunicode;
   event(EVENT_TXUNICODE,NULL,0);
   choicechange(CHOICEVIEW);
  }
 }
 return(NULL);
}


static os_error * chtextsave(buffer * bf)
{
 os_error * err;

 err=bf_printfeol(bf,"textchoices(\"%s\",%d,%d,%d,%d,%d,%d,%d,%d);",
                      ssfontname,txrename,
                      txsmartq,deflttextdata.inset,txovertype,
                      pcdel,renamecolours,dandd,saveignore);

 if(!err) bf_printfeol(bf,"textchoices2(%d,%d,%d,%d);",
                            doublewords,spminlength,txunicode,!fontsample);

 return(err);
}



void textchoices(int fp)
{
 xzstrncpy(ssfontname,stringptr(stack[fp]),sizeof(ssfontname));
 txrename=stack[fp+1];
 txsmartq=stack[fp+2];
 deflttextdata.inset=stack[fp+3];
 txovertype=stack[fp+4];
 pcdel=stack[fp+5];
 renamecolours=stack[fp+6];
 dandd=stack[fp+7];
 saveignore=stack[fp+8];
}


void textchoices2(int fp)
{
 doublewords=stack[fp];
 spminlength=stack[fp+1];

// if(!ISW9X) txunicode=stack[fp+2];
 if(txunicode!=stack[fp+2])
 {
  txunicode=stack[fp+2];
  event(EVENT_TXUNICODE,NULL,0);
 }

	fontsample=!stack[fp+3];
}





/*

int textchoicesbits(void);

         bit 0 pcdel
             1 rename styles
             2 smartq
             3 overtype
             4 rename colours
             5 drag n drop
             6 save ignored words
             7 repeated words

*/



int textchoicesbits(int fp)
{
 return(pcdel |
        (txrename<<1) |
        (txsmartq<<2) |
        (txovertype<<3) |
        (renamecolours<<4) |
        (dandd<<5) |
        (saveignore<<6) |
        (doublewords<<7)|
        (txunicode<<8)		|
								(fontsample<<9)
       );

 USE(fp);
}





static os_error * chsetfont(int sfont)
{
 xssfont=fontuserfromstyle(sfont,0,0);
 return(choicechangevalue(&xssfont));
}

static os_error * chsetfont2(int font,int sub)
{
 if(sub<0) xssfont=fontuserfromstyle(font,0,0);
 else      xssfont=ifont(font)+sub;
 return(choicechangevalue(&xssfont));
}


static os_error * chgetfont(int * sfont) 
{
 *sfont=ufont(xssfont);
 return(NULL);
}


static os_error * chgetfont2(int * sfont)
{
 *sfont=xssfont-ifont(ufont(xssfont));
 return(NULL);
}



static os_error * txchoicesicon(int handle,int userhandle,wimp_mousestr * m)
{
 if(m->i==3) return(openfontmenu(chsetfont,chsetfont2,chgetfont,chgetfont2,handle));
 else        return(NULL);
 USE(handle);
 USE(userhandle);
}


static os_error * xwrfont(int value,char * string)
{
 if(value>=0) strcpy(string,fontlocalnamei(value));
 else         *string=0;
 return(NULL);
}



static os_error * outu(int value,char * string)
{
 strcpy(string,unitstostring(value,MILIMS));
 return(NULL);
}


static os_error * inu(int * value,char * string)
{
 os_error * err;
 
 err=stringtounits(string,value,MILIMS);

 return(err);
}



static os_error * outn(int value,char * string)
{
 strcpy(string,numbertostring(value));
 return(NULL);
}


static os_error * inn(int * value,char * string)
{
 return(stringtonumber(string,value));
}



static dbiconstr chtexticondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */


   52, &xssfont,    DBTEXT,   0,   0,      -1, -1, -1, -1, NULL, xwrfont,

    4, &xinset,     DBWRITE,  0,   0,      -1, -1, -1, -1,   inu,  outu,

    5, &xtxrename,  DBTOGGLE, 0,    0,      1,  F3, 0, 0,  NULL,    0,
    7, &xtxsmartq,  DBTOGGLE, 0,    0,      1,  F4, 0, 0,  NULL,    0,

    9, &xtxovertype,DBTOGGLE, 0,    0,      1,  F5, 0, 0,  NULL,    0,

//    8, &xpcdel,     DBTOGGLE, 0,    0,      1,  F1, 0, 0,  NULL,    0,
    6, &xrencols,   DBTOGGLE, 0,    0,      1,  F2, 0, 0,  NULL,    0,
/* 10, &xdandd,     DBTOGGLE, 0,    0,      1,  F6, 0, 0,  NULL,    0, */

   18, &xunicode,   DBTOGGLE, 0,    0,      1,  F6, 0, 0,  NULL,    0,

   12, &xsaveignore,DBTOGGLE, 0,    0,      1,  F7, 0, 0,  NULL,    0,

   13, &xdoublewords,DBTOGGLE,0,    0,      1,  F8, 0, 0,  NULL,    0,

   14, &xspminlength,DBWRITE, 0,   DBASSOCINC,      -1, -1, -1, -1,   inn,  outn,
   16, &xspminlength,DBDEC,   0,   0,       1, -1,  8,  1,   NULL, 0,
   17, &xspminlength,DBINC,   0,   0,       1, -1,  8,  1,   NULL, 0,
			19,	&xfontsample,DBTOGGLE,0,    0,      1,  F8, 0, 0,  NULL,    0,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static os_error * chtextopen(void)
{
 os_error      * err;

 err=NULL;

 xssfont=findxuserfont(ssfontname);
 xinset=deflttextdata.inset;

 xtxrename=txrename;
 xtxsmartq=txsmartq;
 xtxovertype=txovertype;
 xpcdel=pcdel;
 xrencols=renamecolours;
 xdandd=dandd;
	xfontsample=fontsample;
 xunicode=txunicode;
 xsaveignore=saveignore;
 xdoublewords=doublewords;
 xspminlength=spminlength;

 return(err);
}



static dboxstr chtextbox=
{
 0,
 TCHTEXT,
 DBPANE,
 0,
 NULL,
 txchoicesicon,
 NULL,
 NULL,
 chtexticondefs,
 0,
 0
};


static subchoicestr chtext=
{
 NULL,

 &chtextbox,

 "ch_text",
 "{CHT0}",

 chtextsave,
 chtextclose,
 NULL,
 chtextopen,
 NULL,
 NULL,
};


/*****************************************************************************/

static os_error * outpt(int value,char * string)
{
 strcpy(string,unitstostring(value,POINTS));
 return(NULL);
}

static os_error * inpt(int * value,char * string)
{
 return(stringtounits(string,value,prefdata.units));
}


#define BSMIN 10

static os_error * bsinpt(int * value,char * string)
{
 os_error * err;

 err=stringtounits(string,value,prefdata.units);
 if(!err)
 {
  if(*value<BSMIN) *value=BSMIN;
 }

 return(err);
}


static os_error * wrdc(int value,char * string)
{
	os_error       * err;
 unsigned short   wstring[MAXDECTABCHAR+1];
	char             temp[MAXDECTABCHAR+1];

	memcpy(temp,prefdata.decimaltab1,4);
	memcpy(temp+4,prefdata.decimaltab2,8);
	temp[MAXDECTABCHAR]=0;

 txstring12(temp,12,wstring,NITEM(wstring),NULL);

 err=stringtomacro2(wstring,string,DBWRITEMAX);

 return(err);

	USE(value);
}


static os_error * rddc(int * value,char * string)
{
	os_error       * err;
 unsigned short   wstring[MAXDECTABCHAR+1];
	char             temp[MAXDECTABCHAR+1];
	filestr        * file;

	file=preffile();

          err=macrotostring2(string,wstring,NITEM(wstring));
	if(!err)	err=txunccheckstring(wstring,file);
	if(!err)
	{
 	if(file->compatability<UNICOMPAT)
 	{
 		wstring[4]=0;
 	}

  txstring21(wstring,temp,sizeof(temp),NULL);

		memcpy(prefdata.decimaltab1,temp,4);
		memcpy(prefdata.decimaltab2,temp+4,8);
	}

	return(err);

	USE(value);
}




static os_error * wrhp(int value,char * string)
{
	os_error       * err;
 unsigned short   wstring[MAXHYPHENCHAR+1];
	char             temp[MAXHYPHENCHAR+1];


	memcpy(temp,prefdata.hyphenchar,MAXHYPHENCHAR);
	temp[MAXHYPHENCHAR]=0;

 txstring12(temp,MAXHYPHENCHAR,wstring,NITEM(wstring),NULL);

 err=stringtomacro2(wstring,string,DBWRITEMAX);

 return(err);

	USE(value);
}


static os_error * rdhp(int * value,char * string)
{
	os_error       * err;
 unsigned short   wstring[MAXHYPHENCHAR+1];
	char             temp[MAXHYPHENCHAR+1];
	filestr        * file;

	file=preffile();

          err=macrotostring2(string,wstring,NITEM(wstring));
	if(!err)	err=txunccheckstring(wstring,file);
	if(!err)
	{
 	if(file->compatability<UNICOMPAT)
 	{
 		wstring[4]=0;
 	}

  txstring21(wstring,temp,sizeof(temp),NULL);

		memcpy(prefdata.hyphenchar,temp,MAXHYPHENCHAR);
	}

	return(err);

	USE(value);
}






static os_error * textprefsave(buffer * bf)
{
 char           string1[256];
	char           string2[256];
	unsigned short wstring[16];

 XMEMCPYX(string1,defprefdata.decimaltab1,4);
 XMEMCPYX(string1+4,defprefdata.decimaltab2,8);
 string1[12]=0;

 txstring12(string1,12,wstring,NITEM(wstring),NULL);
	stringtomacro2(wstring,string1,sizeof(string1));


 XMEMCPYX(string2,defprefdata.hyphenchar,12);
 string2[12]=0;

 txstring12(string2,12,wstring,NITEM(wstring),NULL);
	stringtomacro2(wstring,string2,sizeof(string2));


 bf_printfeol(bf,"textpref(%d,%d,%d,%d,%d,0);",
                defprefdata.baselinegridspacing,
                defprefdata.baselinegridorigin,
                defprefdata.supersize,
                defprefdata.subsize,
                defprefdata.smallsize);

 bf_printfeol(bf,"textpref2(\"%s\",\"%s\",\"%s\",\"%s\");",
                string1,string2,"","");

 return(NULL);
}


void textpref(int fp)
{
 defprefdata.baselinegridspacing=stack[fp];
 defprefdata.baselinegridorigin=stack[fp+1];
 defprefdata.supersize=stack[fp+2];
 defprefdata.subsize=stack[fp+3];
 defprefdata.smallsize=stack[fp+4];
/* defprefdata.decimaltab=stack[fp+5]; */
}



void textpref2(int fp)
{
	os_error * err;
	unsigned short wstring[16];
 char string[16];

 err=macrotostring2(stringptr(stack[fp]),wstring,NITEM(wstring));
	if(!err)	err=txstring21(wstring,string,13,NULL);			// allow for trailing zero
	if(!err)
	{
  XMEMCPYX(defprefdata.decimaltab1,string,4);
  XMEMCPYX(defprefdata.decimaltab2,string+4,8);

  err=macrotostring2(stringptr(stack[fp+1]),wstring,NITEM(wstring));
  if(!err) txstring21(wstring,string,13,NULL);			// allow for trailing zero
		if(!err)
		{
   XMEMCPYX(defprefdata.hyphenchar,string,12);
		}
	}

	zreport(err);
}



static os_error * preftextchange(prefdatastr * old,
                                  prefdatastr * xnew,viewstr * view)
{
	char olddecimaltab[16];
	char newdecimaltab[16];

 XMEMCPYX(olddecimaltab,old->decimaltab1,4);
 XMEMCPYX(olddecimaltab+4,old->decimaltab2+4,8);
 XMEMCPYX(newdecimaltab,xnew->decimaltab1,4);
 XMEMCPYX(newdecimaltab+4,xnew->decimaltab2+4,8);

 if(old->baselinegridspacing!=xnew->baselinegridspacing ||
    old->baselinegridorigin!=xnew->baselinegridorigin   ||
    old->supersize!=xnew->supersize                     ||
    old->subsize!=xnew->subsize                         ||
    old->smallsize!=xnew->smallsize                     ||
    strncmp(olddecimaltab,newdecimaltab,12)             ||
    strncmp(old->hyphenchar,xnew->hyphenchar,12))
 {
  prefchanges(PREFFLOW);
 }


 if(old->baselinegridspacing!=xnew->baselinegridspacing ||
    old->baselinegridorigin!=xnew->baselinegridorigin)
 {
  prefchanges(PREFMST|PREFDOC);
 }

 return(NULL);

 USE(view);
}




static os_error * preftextdscript(buffer * bf,prefdatastr * data,
                                  filestr * file)
{
 char string[16];
 char temp[256];

 bf_printfeol(bf,"TEXTPREF={textpref");
 bf_printfeol(bf,"{baselinespace %d}",data->baselinegridspacing);
 bf_printfeol(bf,"{baselineorigin %d}",data->baselinegridorigin);
 bf_printfeol(bf,"{supersize 0x%x}",data->supersize);
 bf_printfeol(bf,"{subsize 0x%x}",data->subsize);
 bf_printfeol(bf,"{smallsize 0x%x}",data->smallsize);

 XMEMCPYX(string,data->decimaltab1,4);
 XMEMCPYX(string+4,data->decimaltab2,8);
 string[12]=0;

 bf_printfeol(bf,"{decimaltabchar %s}",dsmkunistr1(string,temp,sizeof(temp)));

 XMEMCPYX(string,data->hyphenchar,12);
 string[12]=0;

 bf_printfeol(bf,"{hyphenchar %s}",dsmkunistr1(string,temp,sizeof(temp)));

 bf_printfeoln(bf,2,"}");

 return(NULL);

 USE(file);
}



#define DSTTEXTPREF       0x1600
#define DSTBASELINESPACE  0x1601
#define DSTBASELINEORIGIN 0x1602
#define DSTSUPERSIZE      0x1603
#define DSTSUBSIZE        0x1604
#define DSTSMALLSIZE      0x1605
#define DSTDECTAB         0x1606
#define DSTHYPHEN         0x1607




static os_error * dstxpref(int fp,int argc,objectloc * loc)
{
 os_error *    err;
 int           sp;
 int           nsp;
 dsobjectstr * ds;
 dsobjectstr * ds1;
 int           type;
 filestr     * file;
 prefdatastr   data;
 char          string[16];


 err=NULL;

 dsneeddoc(loc);

 file=loc->file;

 sp=fp+2; /* skip leading type/len */

 prefread(&data,file);


 while(argc--)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  type=ds->type;
  nsp=sp+ds->len/sizeof(int);

  if(ds->len>2*sizeof(int)) ds1=(dsobjectstr*)(dsstack+sp+2);
  else                      ds1=NULL;

  switch(type)
  {

   case  DSTBASELINESPACE:
                          data.baselinegridspacing=ds1->data.integer;
                          break;

   case DSTBASELINEORIGIN:
                          data.baselinegridorigin=ds1->data.integer;
                          break;

   case      DSTSUPERSIZE:
                          data.supersize=ds1->data.integer;
                          break;

   case        DSTSUBSIZE:
                          data.subsize=ds1->data.integer;
                          break;

   case      DSTSMALLSIZE:
                          data.smallsize=ds1->data.integer;
                          break;

   case         DSTDECTAB:
																										if(ds1->type==DSTSTR)
																										{
                           memset(string,0,sizeof(string));
                           strncpy(string,ds1->data.string,sizeof(string));
                           XMEMCPYX(data.decimaltab1,string,4);
                           XMEMCPYX(data.decimaltab2,string+4,8);
																										}
																										else
																										if(ds1->type==DSTUNISTR)
																										{
                           txstring21(ds1->data.unistring,string,13,NULL);
                           XMEMCPYX(data.decimaltab1,string,4);
                           XMEMCPYX(data.decimaltab2,string+4,8);
																										}
                          break;

   case         DSTHYPHEN:
																										if(ds1->type==DSTSTR)
																										{
                           memset(string,0,sizeof(string));
                           strncpy(string,ds1->data.string,sizeof(string));
                           XMEMCPYX(data.hyphenchar,string,12);
																										}
																										else
																										if(ds1->type==DSTUNISTR)
																										{
                           txstring21(ds1->data.unistring,string,13,NULL);
                           XMEMCPYX(data.hyphenchar,string,12);
																										}
                          break;

  }

  sp=nsp;
 }

 prefwrite(&data,file);

 ds=(dsobjectstr*)(dsstack+fp);
 ds->data.integer=0;
 ds->len=3*sizeof(int);

 return(err);
}





static int dsnulllist[]={
                           DSTENDLIST
                          };



static dscreator dsdefs[]=
{
 0,0,0,0, "textpref",        dstxpref, 0, DSTTEXTPREF,       dsnulllist,

 0,0,0,0, "baselinespace",   NULL,     0, DSTBASELINESPACE,  dsnulllist,
 0,0,0,0, "baselineorigin",  NULL,     0, DSTBASELINEORIGIN, dsnulllist,
 0,0,0,0, "supersize",       NULL,     0, DSTSUPERSIZE,      dsnulllist,
 0,0,0,0, "subsize",         NULL,     0, DSTSUBSIZE,        dsnulllist,
 0,0,0,0, "smallsize",       NULL,     0, DSTSMALLSIZE,      dsnulllist,
 0,0,0,0, "decimaltabchar",  NULL,     0, DSTDECTAB,         dsnulllist,
 0,0,0,0, "hyphenchar",      NULL,     0, DSTHYPHEN,         dsnulllist,

};






static dbiconstr textpreficondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

   51, &prefdata.baselinegridspacing,DBWRITE,0,0, -1, -1, -1, -1,bsinpt,outpt,
   52, &prefdata.baselinegridorigin, DBWRITE,0,0, -1, -1, -1, -1, inpt, outpt,
    9, &prefdata.supersize,   DBWRITE, 0,   0,   -1, -1, -1, -1,readpc,writepc,
   14, &prefdata.subsize,     DBWRITE, 0,   0,   -1, -1, -1, -1,readpc,writepc,
   18, &prefdata.smallsize,   DBWRITE, 0,   0,   -1, -1, -1, -1,readpc,writepc,
    3, NULL,  DBWRITE, 0,   0,    -1, -1, -1, -1, rddc,  wrdc,
    6, NULL,  DBWRITE, 0,   0,    -1, -1, -1, -1, rdhp,  wrhp,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};




static dboxstr textprefbox=
{
 0,
 TPREFTEXT,
 DBPANE,
 0,
 NULL,
 NULL,
 NULL,
 NULL,
 textpreficondefs,
 0,
 0,

 0,NULL,
 0,
 0,

};


static subchoicestr textprefdata=
{
 NULL,

 &textprefbox,

 "ch_text",
 "{CHT0}",

 textprefsave,
 NULL,
 NULL,
 NULL,
 (choicechangefn)preftextchange,
 (choicedscriptfn)preftextdscript,
};



os_error * txchoicesinit(void)
{
 txunicode=!(ISW9X);  // problem is that this is used before choices are set


 dsaddblock(dsdefs,sizeof(dsdefs)/sizeof(dscreator));
 prefadd(&textprefdata);
 return(choicesadd(&chtext));
}


