#include <stdafx.h>

#include "commdlg.h"


#include "os.h"
#include "font.h"
#include "wimp.h"

#include "etc.h"
#include "colour.h"
#include "osglue.h"
#include "xmath.h"
#include "bits.h"


#include "deb.h"

#include "comdialogs.h"


os_error * cd_getcolour(wimp_w parent,int flags,int * rgbpal,int * result)
{
 os_error    * err;
 CHOOSECOLOR   col;
 int           code;
 static COLORREF customcolours[16];

 err=NULL;

 memset(&col,0,sizeof(CHOOSECOLOR));
 col.lStructSize=sizeof(CHOOSECOLOR);
 col.hwndOwner=(HWND)parent;
 col.rgbResult=COLREFFROMPAL(*rgbpal);
 col.Flags=CC_RGBINIT|CC_ANYCOLOR;
 col.lpCustColors=customcolours;

 *result=0;

 code=ChooseColor(&col);

 if(code)
 {
  *result|=CDGC_OK;
  *rgbpal=PALFROMCOLREF(col.rgbResult);
 }

 return(err);

 USE(flags);
}





os_error * cd_getfont(wimp_w parent,int flags,font_description * description,int * result)
{
 os_error * err;
 CHOOSEFONT cf;
 LOGFONT    font;
 int        code;

 err=NULL;

 *result=0;

 memset(&font,0,sizeof(LOGFONT));

 font.lfCharSet=(char)description->charset;
 font.lfWeight=description->weight;
 font.lfHeight=-scale(description->height,cvdu.ydpi,16*72);
 font.lfItalic=(char)description->italic;
 xzstrncpy(font.lfFaceName,description->name,sizeof(font.lfFaceName)/sizeof(TCHAR));

 memset(&cf,0,sizeof(CHOOSEFONT));
 cf.lStructSize=sizeof(CHOOSEFONT);
 cf.Flags=CF_SCREENFONTS|CF_INITTOLOGFONTSTRUCT;
 cf.lpLogFont=&font;
 cf.hwndOwner=(HWND)parent;

 code=ChooseFont(&cf);
 if(code)
 {
  *result|=CDGC_OK;
  description->weight=font.lfWeight;
  description->height=scale(-font.lfHeight,16*72,cvdu.ydpi);
  xzstrncpy(description->name,font.lfFaceName,sizeof(description->name)/sizeof(TCHAR));
  description->italic=font.lfItalic;
  description->charset=font.lfCharSet;
  description->width=0;
 }

 return(err);

 USE(flags);
}
