/*->c.mlo */

#include <stdafx.h>

#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "flex.h"

#include "osglue.h"
#include "oserr.h"

#include "err.h"
#include "alloc.h"
#include "wos.h"
#include "poll.h"

#include "key.h"
#include "fsx.h"
#include "etc.h"
#include "bits.h"

#include "deb.h"


#include "mlo.h"




static int        lastmenu;
static menulink * firstlink;





#define MAXMENU 16







menustr * menufromhandle(int n)
{
 menulink * link;
 menustr  * menus;

 if(n)
 {
  link=firstlink;
  while(link)
  {
   menus=link->menus;

   while(menus->menuno!=MLAST)
   {
//   cprintf("menufromhandle target=%d current=%d",n,menus->menuno);

    if(menus->menuno==n) return(menus);
    menus++;
   }

   link=link->next;
  }
 }

 return(NULL);
}



static menustr * getmenustack(menustr * menu,int id,int * stack)
{
 int       * p;

 p=stack+(MAXMENU-1);
 *p--=-1;
 *p=id;

 while(menu->parent)
 {
  p--;
  *p=menu->entryinparent;
  menu=menufromhandle(menu->parent);
 }

// cprintf("stack %d",*p);

 memmove(stack,p,(MAXMENU-(p-stack))*sizeof(int));

// cprintf("stack %d",*stack);

 return(menu);
}





static menustr * menufromhmenu(HMENU hmenu)
{
 menulink * link;
 menustr  * menus;

 if(hmenu)
 {
  link=firstlink;
  while(link)
  {
   menus=link->menus;

   while(menus->menuno!=MLAST)
   {
    if(menus->menuptr==(char*)hmenu) return(menus);
    menus++;
   }

   link=link->next;
  }
 }
 return(NULL);
}




static int realentry(int entry,menustr * menu)
{
 int i;

 i=0;
 if(menu && menu->map)
 {
 // count entryinparent zero bits in map
  for(;entry>=0 && i<32;i++)
  {
   if(!(menu->map & (1<<i))) entry--;
  }
 }

 return(i+entry);// because entry is -1 and i has been incremented
}



static int virtualentry(int entry,menustr * menu)
{
 int i;
 int entrycount;

 entrycount=0;

 if(menu && menu->map)
 {
  for(i=0;i<entry && i<32;i++)
  {
//   cprintf("map %x and %x",menu->map,1<<i);
   if(menu->map & (1<<i)) entrycount++;
  }
 }

// cprintf("entry %d count %d",entry,entrycount);

 return(entry-entrycount);
}




#ifdef NEVER

void mwpoint(int * menuhandle,int item,int pointer)
{
// *(menuhandle+(7+1+6*item))=pointer;
 USE(pointer);
 USE(item);
 USE(menuhandle);
}



/* return a pointer to a menu's sub menu */
// item here is an index

char * pointm(char * menuhandle,int item)
{
 return((char*)GetSubMenu((HMENU)menuhandle,item));
}



#endif




os_error * shade(char * menumemoryhandle,int item)
{
 os_error     * err;
 MENUITEMINFO   minfo;

 minfo.cbSize=sizeof(minfo);
 minfo.fMask=MIIM_STATE;

 err=XGetMenuItemInfo((HMENU)menumemoryhandle,item,FALSE,&minfo);
 if(!err)
 {
  minfo.fState|=MFS_GRAYED;
  err=XSetMenuItemInfo((HMENU)menumemoryhandle,item,FALSE,&minfo);
 }

 return(err);
}




os_error * unshade(char * menumemoryhandle,int item)
{
 os_error     * err;
 MENUITEMINFO   minfo;

 minfo.cbSize=sizeof(minfo);
 minfo.fMask=MIIM_STATE;

 err=XGetMenuItemInfo((HMENU)menumemoryhandle,item,FALSE,&minfo);
 if(!err)
 {
  minfo.fState&=~MFS_GRAYED;
  err=XSetMenuItemInfo((HMENU)menumemoryhandle,item,FALSE,&minfo);
 }

 return(err);
}




os_error * unshadest(char * menumemoryhandle,int item,int state)
{
 if(state) return(unshade(menumemoryhandle,item));
 else      return(shade(menumemoryhandle,item));
}





os_error * tick(char * menumemoryhandle,int item)
{
 os_error     * err;
 MENUITEMINFO   minfo;

 minfo.cbSize=sizeof(minfo);
 minfo.fMask=MIIM_STATE;

 err=XGetMenuItemInfo((HMENU)menumemoryhandle,item,FALSE,&minfo);
 if(!err)
 {
  minfo.fState|=MFS_CHECKED;
  err=XSetMenuItemInfo((HMENU)menumemoryhandle,item,FALSE,&minfo);
 }

 return(err);
}




os_error * untick(char * menumemoryhandle,int item)
{
 os_error      * err;
 MENUITEMINFO    minfo;

 minfo.cbSize=sizeof(minfo);
 minfo.fMask=MIIM_STATE;

 err=XGetMenuItemInfo((HMENU)menumemoryhandle,item,FALSE,&minfo);
 if(!err)
 {
  minfo.fState&=~MFS_CHECKED;
  err=XSetMenuItemInfo((HMENU)menumemoryhandle,item,FALSE,&minfo);
 }

 return(err);
}




os_error * tickst(char * menumemoryhandle,int item,int state)
{
 if(state) return(tick(menumemoryhandle,item));
 else      return(untick(menumemoryhandle,item));
}



static os_error * setsubmenu(char * childmenumemoryhandle,char * parentmenumemoryhandle,int entryinparent)
{
 MENUITEMINFO   minfo;
 os_error     * err;


	memset(&minfo,0,sizeof(minfo));

 minfo.cbSize=sizeof(minfo);
 minfo.fMask=MIIM_SUBMENU;

 minfo.hSubMenu=(HMENU)childmenumemoryhandle;

 err=XSetMenuItemInfo((HMENU)parentmenumemoryhandle,entryinparent,TRUE,&minfo);

//	cprintf("setsubmenu %x %d child %x",parentmenumemoryhandle,entryinparent,childmenumemoryhandle);


 return(err);
}



void setmenufns(int n,menudecodefn decode,menudynamicfn dynamic)
{
 menustr * menu;

 menu=menufromhandle(n);
 if(menu)
 {
  menu->decode=decode;
  menu->dynamic=dynamic;
 }
}


void menutag(int n,int tag)
{
 menustr * menu;

 menu=menufromhandle(n);
 if(menu)
 {
  menu->tag=tag;
 }
}



#ifdef NEVER

void setmenudynamic(int n,int item)
{
 menustr * menu;

 menu=menufromhandle(n);
// if(menu) dynamic(menu->menuptr,item);
}


#endif


void setmenuflags(int n,int flags)
{
 menustr * menu;

 menu=menufromhandle(n);
 if(menu) menu->flags=flags;
}


void tickmenust(int n,int item,int state)
{
 menustr * menu;

 menu=menufromhandle(n);
 if(menu) tickst(menu->menuptr,item,state);
}



void unshademenust(int n,int item,int state)
{
 menustr * menu;

 menu=menufromhandle(n);
 if(menu) unshadest(menu->menuptr,item,state);
}


// item here is an index 0..N entries

os_error * readmenu(int n,int item,int size,TCHAR * buffer)
{
 os_error      * err;
 menustr       * menu;
 MENUITEMINFO    minfo;

 err=NULL;

 menu=menufromhandle(n);

 if(menu && menu->menuptr)
 {
  item=realentry(item,menu);

  memset(&minfo,0,sizeof(minfo));
  minfo.cbSize=sizeof(minfo);
  minfo.fMask=MIIM_TYPE; // not obvious this is needed value - Superbible p261
  minfo.dwTypeData=buffer;
  minfo.cch=size;

  err=XGetMenuItemInfo((HMENU)menu->menuptr,item,TRUE,&minfo);
 }

 return(err);
}


// item here is an index 0..N entries

os_error * writemenu(int n,int item,TCHAR * buffer,int * change)
{
 os_error   * err;
 menustr    * menu;
 TCHAR        temp[256];
 MENUITEMINFO minfo;


 err=NULL;

 if(change) *change=0;

 menu=menufromhandle(n);

 if(menu && menu->menuptr)
 {
  item=realentry(item,menu);

  memset(&minfo,0,sizeof(minfo));
  minfo.cbSize=sizeof(minfo);
  minfo.fMask=MIIM_TYPE; // not obvious this is needed value - Superbible p261
  minfo.dwTypeData=temp;
  minfo.cch=sizeof(temp)/sizeof(TCHAR);

  err=XGetMenuItemInfo((HMENU)menu->menuptr,item,TRUE,&minfo);
  if(!err)
  {
   if(strcmp(temp,buffer))
   {
    err=xzstrncpye(temp,buffer,sizeof(temp)/sizeof(TCHAR));
				if(!err)
				{
     memset(&minfo,0,sizeof(minfo));
     minfo.cbSize=sizeof(minfo);
     minfo.fMask=MIIM_TYPE;
     minfo.dwTypeData=temp;
     minfo.cch=sizeof(temp)/sizeof(TCHAR);

     err=XSetMenuItemInfo((HMENU)menu->menuptr,item,TRUE,&minfo);

     if(change) *change=1;
				}
   }
  }
 }

 return(err);
}






// WM_MENUSELECT - mouse over menu item

int menuselect(HWND hwnd,WPARAM wParam,LPARAM lParam)
{
 menustr * menu;
 UINT      code;

 code=(UINT)HIWORD(wParam);
 if(code==0xFFFF && lParam==NULL)
 {
//  cprintf("menuselect close %x",LOWORD(wParam));
 }
 else
 {
  menu=menufromhmenu((HMENU)lParam);
  if(menu)
  {
   lastmenu=menu->menuno;
//   cprintf("menuselect set last %d",lastmenu);
  }
 }
 return(0);
 USE(hwnd);
}



// WM_INITMENUPOPUP

int menuinitpopup(HWND hwnd,WPARAM wParam,LPARAM lParam)
{
 os_error * err;
 HMENU     hmenuPopup;
 int       uPos;
 int       fSystemMenu;
 menustr * menu;
 int       stack[MAXMENU];
 menustr * root;
 menustr * pmenu;
 
 hmenuPopup=(HMENU)wParam;  // handle to submenu
 uPos=LOWORD(lParam);        // submenu item position 
 fSystemMenu=HIWORD(lParam); // window menu flag 

// cprintf("menu init pop up %x",hmenuPopup);

 menu=menufromhmenu(hmenuPopup);

 if(menu)
 {
  pmenu=menufromhandle(menu->parent);
  menu->entryinparent=virtualentry(uPos,pmenu);

  lastmenu=menu->menuno;

//  cprintf("setting lastmenu %d entryin parent %d",lastmenu,uPos);

  root=getmenustack(menu,-1,stack);

//		if(!root) cprintf("no root");
// possible for menuptr's to move e.g. if app extends menu table
  if(root->dynamic)
  {
   err=root->dynamic(stack,(char*)hmenuPopup,(wimp_w)hwnd);
   report(err);
  }
 }
 return(0);
}



// menu about to become active WM_INITMENU

int menuinit(HWND hwnd,WPARAM wParam,LPARAM lParam)
{
 HMENU hmenuInit;

 hmenuInit=(HMENU)wParam; // handle to menu to initialize 

// cprintf("menu init");
 
 return(0);
 USE(lParam);
 USE(hwnd);
}



// WM_COMMAND, a click on a menu item

int menucommand(HWND hwnd,WPARAM wParam,LPARAM lParam)
{
 os_error * err;
 menustr  * menu;
 int        wID;
 int        stack[MAXMENU];
 menustr  * root;

// cprintf("menucommand %d",lastmenu);

 menu=menufromhandle(lastmenu);
 if(menu)
 {
  wID=LOWORD(wParam);         
  root=getmenustack(menu,wID,stack);
//  cprintf("menucommand root %x tag %d",root,root->menuno);

  if(root->decode)
  {
//   cprintf("menucommand decode %d",stack[0]);

   err=root->decode(stack,(wimp_w)hwnd);
   report(err);
  }
 } 


 return(0);
 USE(lParam);
}




int menuhelp(HWND hwnd,int id,HMENU hmenu)
{
 os_error * err;
 menustr  * menu;
 int        stack[MAXMENU];
 menustr  * root;

 err=NULL;


 menu=menufromhandle(lastmenu);
 if(menu)
 {

  root=getmenustack(menu,id,stack);
  cprintf("help menucommand root %x tag %d s[0] %d s[1] %d ",root,root->menuno,stack[0],stack[1]);


 }

 return(0);
}




os_error * popmenu(wimp_w handle,char * menumemoryhandle,int info) 
{
 os_error * err;
 POINT      pt;

 err=XGetCursorPos(&pt);
 if(!err)
 {
  err=XTrackPopupMenuEx((HMENU)menumemoryhandle,0,pt.x,pt.y,(HWND)handle,NULL);

 }

 return(err);
 USE(info);
}



os_error * openupmenu(wimp_w window,int menuhandle)
{
 os_error * err;
 menustr  * menu;

 err=NULL;

 menu=menufromhandle(menuhandle);
 if(menu)
 {
  lastmenu=menuhandle;
  err=popmenu(window,menu->menuptr,menu->flags & MFINFO);
 }

 return(err);
}









// add a menu bar to a window, input menu tag and window handle

os_error * addwindowmenu(wimp_w handle,int menuhandle)
{
 os_error * err;
 menustr  * menu;

 err=NULL;

 menu=menufromhandle(menuhandle);
 if(menu)
 {
  err=XSetMenu((HWND)handle,(HMENU)menu->menuptr);
 }
 return(err);
}



os_error * remwindowmenu(wimp_w handle,int menuhandle)
{
 os_error * err;

 err=XSetMenu((HWND)handle,NULL);
 return(err);
 USE(menuhandle);
}





os_error * menulostart(TCHAR * path,TCHAR * leaf)
{

 return(NULL);
 USE(path);
 USE(leaf);
}




os_error * menulofinit(void)
{
 menulink * link;
 menustr  * menus;

 link=firstlink;
 while(link)
 {
  menus=link->menus;

  while(menus->menuno!=MLAST)
  {
   if(menus->menuptr && !menus->parent) XDestroyMenu((HMENU)menus->menuptr);
   // this is recursive, so might consider !menus->parent
   menus++;
  }

  link=link->next;
 }

 return(NULL);
}





os_error * addmenus(TCHAR * path,TCHAR * leaf,menustr * menutable,menulink * link)
{
 os_error * err;
 menustr  * menus;
 HMENU      hmenu;
 HRSRC      hRsrc;
 menustr  * parent;
 void     * mdata;

 err=NULL;

 link->menus=menutable;
 link->next=firstlink;
 firstlink=link;

 menus=menutable;

 while(menus->menuno!=MLAST)
 {
  if(menus->menuname)
  {
   err=XFindResource(AppInstance,menus->menuname,RT_MENU,&hRsrc);
   if(err) break;

   err=XLoadResource(AppInstance,hRsrc,(HGLOBAL*)&hmenu);
   if(err) break;

   err=XLockResource(hmenu,&mdata);
   if(err) break;

   err=XLoadMenuIndirect(mdata,(HMENU*)&menus->menuptr);
   if(err) break;
  }
  else
  {
   parent=menufromhandle(menus->parent);
   if(parent)
   {
    err=XGetSubMenu((HMENU)parent->menuptr,menus->entryinparent,(HMENU*)&menus->menuptr);
    if(err) break;
//    cprintf("menuno %d ptr %x",menus->menuno,menus->menuptr);
   }
  }
  menus++;
 }

 return(err); 
 USE(leaf);
 USE(path);
}


os_error * updatemenus(menustr * menutable,menulink * link)
{
 link->menus=menutable;
 return(NULL);
}



/***************************************************************************/


// remove any parent/entry in parent fields from sub menus of this one
// preparatory to clobbering the menuptrs's


static void clearlinks(int menuno)
{
 menulink * link;
 menustr  * menus;

 link=firstlink;
 while(link)
 {
  menus=link->menus;

  while(menus->menuno!=MLAST)
  {
   if(menus->parent==menuno)
   {
    clearlinks(menus->menuno);
    menus->parent=0;
    menus->entryinparent=0;
    menus->menuptr=NULL;
				menus->tag=0;
    menus->map=0;
   }

   menus++;
  }

  link=link->next;
 }

}





os_error * createusermenu(int n,menudecodefn decode,menudynamicfn dynamic)
{
 os_error * err;
 menustr  * menu;

 err=NULL;

 menu=menufromhandle(n);
 if(menu)
 {
  if(menu->menuptr)
  {
//			cprintf("create user delete");
   err=XDestroyMenu((HMENU)menu->menuptr);
   if(!err)
   {
    menu->menuptr=NULL;
    clearlinks(n);
   }
  }

  if(!err)
  {
 		menu->entryinparent=0;
 		menu->tag=0;
   menu->parent=0;
   menu->map=0;
   menu->dynamic=dynamic;
   menu->decode=decode;
   err=XCreatePopupMenu((HMENU*)&menu->menuptr);
//		cprintf("create popup %d %x",n,menu->menuptr);
  }
 }
 
 return(err);
}





os_error * createmainmenu(int n,menudecodefn decode,menudynamicfn dynamic)
{
 os_error * err;
 menustr  * menu;

 err=NULL;

 menu=menufromhandle(n);
 if(menu)
 {
  if(menu->menuptr)
  {
   err=XDestroyMenu((HMENU)menu->menuptr);
   clearlinks(n);
   menu->menuptr=NULL;
  }

  if(!err)
  {
 		menu->entryinparent=0;
 		menu->tag=0;
   menu->parent=0;
   menu->map=0;
   menu->dynamic=dynamic;
   menu->decode=decode;
   err=XCreateMenu((HMENU*)&menu->menuptr);
//  cprintf("create main %d %x",n,menu->menuptr);
  }
 }
 
 return(err);
}



os_error * refreshmenubar(wimp_w handle)
{
 return(XDrawMenuBar((HWND)handle));
}



#ifdef NEVER

os_error * debugosmenu(int n)
{
 os_error * err;
 int nitem;
 menustr  * menu;
 MENUITEMINFO minfo;
 int i;
 char         temp[256];

 menu=menufromhandle(n);
 if(menu)
 {
  nitem=GetMenuItemCount((HMENU)menu->menuptr);

  cprintf("debmenu %d %d ptr %x",n,nitem,menu->menuptr);

  for(i=0;i<nitem;i++)
  {
   memset(&minfo,0,sizeof(minfo));
   minfo.cbSize=sizeof(minfo);
   minfo.fMask=MIIM_TYPE|MIIM_SUBMENU; // not obvious this is needed value - Superbible p261
   minfo.dwTypeData=temp;
   minfo.cch=sizeof(temp)/sizeof(TCHAR);

   err=XGetMenuItemInfo((HMENU)menu->menuptr,i,TRUE,&minfo);
   report(err);
  
   cprintf("name %s submenu %x",temp,minfo.hSubMenu);

  }
 }

 return(NULL);
}


#endif




os_error * addusermenu(int n,TCHAR * string,int flags,int id)
{
 os_error * err;
 menustr  * menu;
 int        bits;
 int        nitem;

 err=NULL;

 menu=menufromhandle(n);
 if(menu)
 {
  bits=0;

  if(flags & MSHADE) bits|=MF_GRAYED;
  if(flags & ((int)wimp_MTICK)) bits|=MF_CHECKED;

           err=XGetMenuItemCount((HMENU)menu->menuptr,&nitem);
  if(!err) err=XAppendMenu((HMENU)menu->menuptr,MF_STRING|bits,id,string);
//  cprintf("append1 %d",nitem);

  if(!err)
  {
   if(flags & wimp_MSEPARATE)
   {
    menu->map|=(1<<(nitem+1));
    err=XAppendMenu((HMENU)menu->menuptr,MF_SEPARATOR,0,NULL);
//   cprintf("append2");
   }
  }
 }

 return(err);
}


char * completeusermenu(int n,TCHAR * title)
{
 return(NULL);
 USE(title);
 USE(n);
}




os_error * deleteusermenu(int n)
{
 os_error * err;
 menustr  * menu;

 err=NULL;

 menu=menufromhandle(n);
 if(menu)
 {
  if(menu->menuptr)
  {
   err=XDestroyMenu((HMENU)menu->menuptr);
   if(!err)
   {
    clearlinks(n);
    menu->parent=0;
    menu->entryinparent=0;
    menu->menuptr=NULL;
 			menu->tag=0;
    menu->map=0;
   }
  }
 }

 return(err);
}


os_error * deletemainmenu(int n)
{
	return(deleteusermenu(n));
}




os_error * clearmenu(int n)
{
 os_error * err;
 menustr  * menu;
 int        nitem;
 int        i;

 err=NULL;

 menu=menufromhandle(n);
 if(menu)
 {
  if(menu->menuptr)
  {
   err=XGetMenuItemCount((HMENU)menu->menuptr,&nitem);
   if(!err)
   {
    for(i=nitem-1;i>=0;i--)
    { 
     err=XDeleteMenu((HMENU)menu->menuptr,i,MF_BYPOSITION); // also deletes any sub menu
     if(err) break;
    }
    clearlinks(n);
   }
  }
  menu->map=0;
 }

 return(err);
}





os_error * linkmenu(int child,int parent,int entryinparent)
{
 os_error * err;
 menustr  * cmenu;
 menustr  * pmenu;

 err=NULL;

 cmenu=menufromhandle(child);
 if(cmenu && !parent)
 {
  cmenu->parent=parent;
  cmenu->entryinparent=entryinparent;
 }
 else
 {
  pmenu=menufromhandle(parent);
  if(pmenu)
  {
   if(cmenu->menuptr && pmenu->menuptr)
   {
    cmenu->parent=parent;
    cmenu->entryinparent=entryinparent;

    err=setsubmenu(cmenu->menuptr,pmenu->menuptr,realentry(entryinparent,pmenu));
   }
  }
 }

 return(err);
}






#ifdef NEVER


static menufn mfn;

os_error * addmenuhandler(menufn fn)
{
 mfn=fn;
 return(NULL);
}



static void decodemen(void)
{
// if(mfn) report(mfn(wimpevent.data.menu));
}

#endif

