// osglue.cpp

#include <stdafx.h>

#include <stdlib.h>

#include "os.h"
#include "wimp.h"

#include "fsx.h"

#include "deb.h"
#include "etc.h"
#include "colour.h"
#include "wos.h"

#include "osglue.h"
#include "osunits.h"
#include "oserr.h"
#include "xmath.h"
#include "transform.h"
#include "xprocess.h"

#include "osgraphics.h"

#include "ossprite.h"


hdcstr * currenthdcptr;

static hdcstr * firsthdcptr;


//static int counthdc;

os_error * graphicsnewhdc(hdcstr ** hdcptrp)
{
 hdcstr * hdcptr;

// counthdc++;

 hdcptr=(hdcstr*)malloc(sizeof(hdcstr));
 memset(hdcptr,0,sizeof(hdcstr));

 hdcptr->next=firsthdcptr;
 if(firsthdcptr) firsthdcptr->prev=hdcptr;
 firsthdcptr=hdcptr;

 *hdcptrp=hdcptr;

 return(NULL);
}



os_error * graphicsdeletehdc(hdcstr * hdcptr)
{
 hdcstr * next;
 hdcstr * prev;

// counthdc--;
// cprintf("counthdc %d",counthdc);

 next=hdcptr->next;
 prev=hdcptr->prev;
 if(next) next->prev=prev;
 if(prev) prev->next=next;
 if(firsthdcptr==hdcptr) firsthdcptr=next;

 free(hdcptr);

 return(NULL);
}





os_error * graphicssetfont2(HFONT newfont,hdcstr * hdcptr)
{
 os_error * err;
 HFONT      oldfont;

 err=NULL;

 oldfont=hdcptr->currentfont;
 hdcptr->currentfont=newfont;
 
 if(oldfont)
 {
  SelectObject(hdcptr->hdc,hdcptr->currentfont);
 }
 else
 {
  hdcptr->basefont=(HFONT)SelectObject(hdcptr->hdc,hdcptr->currentfont);
 }

 return(err);
}




os_error * graphicslosefont(HFONT font)
{
 os_error * err;
 hdcstr   * hdcptr;

 err=NULL;

 hdcptr=firsthdcptr;
 while(hdcptr)
 {
  if(font==hdcptr->currentfont)
  {
   hdcptr->currentfont=NULL;
   if(hdcptr->basefont)
   {
    SelectObject(hdcptr->hdc,hdcptr->basefont);
    hdcptr->basefont=NULL;
   }
  }

  hdcptr=hdcptr->next;
 }

 return(err);
}



os_error * graphicscreatepen2(int fnPenStyle,int nWidth,COLORREF crColor,hdcstr * hdcptr)
{
 os_error * err;
 HPEN       oldpen;

 err=NULL;

 oldpen=hdcptr->currentpen;
 hdcptr->currentpen=CreatePen(fnPenStyle,nWidth,crColor);
 
 if(oldpen)
 {
  SelectObject(hdcptr->hdc,hdcptr->currentpen);
  DeleteObject(oldpen);
 }
 else
 {
  hdcptr->basepen=(HPEN)SelectObject(hdcptr->hdc,hdcptr->currentpen);
 }

 return(err);
}



os_error * graphicscreatepenext2(DWORD dwPenStyle,DWORD dwWidth,CONST LOGBRUSH *lplb,
                                DWORD dwStyleCount,CONST DWORD *lpStyle,hdcstr * hdcptr)
{
 os_error * err;
 HPEN       oldpen;

 err=NULL;

 oldpen=hdcptr->currentpen;

 hdcptr->currentpen=ExtCreatePen(dwPenStyle,dwWidth,lplb,dwStyleCount,lpStyle);

 if(oldpen)
 {
  SelectObject(hdcptr->hdc,hdcptr->currentpen);
  DeleteObject(oldpen);
 }
 else
 {
  hdcptr->basepen=(HPEN)SelectObject(hdcptr->hdc,hdcptr->currentpen);
 }

 return(err);
}




os_error * graphicscreatesolidbrush2(COLORREF crColor,hdcstr * hdcptr)
{
 os_error * err;
 HBRUSH     oldbrush;


 err=NULL;

 oldbrush=hdcptr->currentbrush;
 hdcptr->currentbrush=CreateSolidBrush(crColor);
 
 if(oldbrush)
 {
  SelectObject(hdcptr->hdc,hdcptr->currentbrush);
  DeleteObject(oldbrush);
 }
 else
 {
  hdcptr->basebrush=(HBRUSH)SelectObject(hdcptr->hdc,hdcptr->currentbrush);
 }

 return(err);
}





// problem, selecting stuff from meta files
// treacherous thing with clearing hdc because this is often followed
// by calls to delete hdc

os_error * graphicsfinit2(hdcstr * hdcptr)
{

 if(hdcptr->basebrush)
 {
  SelectObject(hdcptr->hdc,hdcptr->basebrush);
 }

 if(hdcptr->currentbrush)
 {
  DeleteObject(hdcptr->currentbrush);
 }


 if(hdcptr->basepen)
 {
  SelectObject(hdcptr->hdc,hdcptr->basepen);
 }

 if(hdcptr->currentpen)
 {
  DeleteObject(hdcptr->currentpen);
 }

 if(hdcptr->basefont)
 {
  SelectObject(hdcptr->hdc,hdcptr->basefont);
 }

// if(currentfont) cprintf("currentfont");

// hdcptr->hdc=NULL;

 return(NULL);
}






/*

Dx = ((Lx - WOx) * VEx / WEx) + VOx 
The following variables are involved.

Dx     x value in device units 
Lx     x value in logical units (also known as page space units) 
WOx     window x origin 
VOx     viewport x origin 
WEx     window x-extent 
VEx     viewport x-extent 

*/



os_error * graphicsriscos2(hdcstr * hdcptr)
{
 os_error * err;
 int        ox;
 int        oy;
 int        xp;
 int        yp;
// int        nx;
// int        ny;


 err=NULL;

#ifdef NEVER

          err=XSetMapMode(hdcptr->hdc,MM_ANISOTROPIC,NULL);
 if(!err) err=XSetWindowExtEx(hdcptr->hdc,hdcptr->osxres,-hdcptr->osyres,NULL); 
 if(!err) err=XSetViewportExtEx(hdcptr->hdc,hdcptr->vduxres,hdcptr->vduyres,NULL); 

#endif

 if(!err)
 {
  ox=scale(hdcptr->cgox,hdcptr->osxres,OSXRES);
  oy=scale(hdcptr->cgoy,hdcptr->osyres,OSYRES);

//  cprintf("ox %d oy %d",ox,oy);

//  nx=ox/hdcptr->osxres;
//  ox-=nx*hdcptr->osxres;
//  ny=oy/hdcptr->osyres;
//  oy-=ny*hdcptr->osyres;

  hdcptr->ox=ox;
  hdcptr->oy=oy;

//  err=XSetWindowOrgEx(hdcptr->hdc,ox,oy,NULL);

// xp=scale(ox,cvdu.xdpi,hdcptr->osxres);
// yp=scale(oy,cvdu.ydpi,hdcptr->osyres);

// think that cgox,cgoy are scroll bar positions, we can guarantee that
// scx,scy converted to device units keeps step in pixels with the window
// origin

  xp=scale(hdcptr->cgox,hdcptr->vduxres,OSXRES);   // same as xos2pix()
//  xp-=nx*hdcptr->vduxres;
  yp=scale(hdcptr->cgoy,hdcptr->vduyres,OSYRES);
//  yp-=ny*hdcptr->vduyres;

//  cprintf("xp %d yp %d",xp,yp);

//  if(!err) err=XSetViewportOrgEx(hdcptr->hdc,xp,-yp,NULL);

  hdcptr->vx=xp;
  hdcptr->vy=-yp;
 }

 return(err);
}




os_error * graphicsscale2(int xres,int yres,hdcstr * hdcptr)
{
 hdcptr->osxres=xres;
 hdcptr->osyres=yres;
 return(graphicsriscos2(hdcptr));
}


os_error * graphicsscale(int xres,int yres)
{
 return(graphicsscale2(xres,yres,currenthdcptr));
}



os_error * graphicsscaleboth2(int xres,int yres,int vxres,int vyres,hdcstr * hdcptr)
{
// cprintf("xres %d vsxres %d",xres,vxres);
 
 hdcptr->osxres=xres;
 hdcptr->osyres=yres;
 hdcptr->vduxres=vxres;
 hdcptr->vduyres=vyres;
 return(graphicsriscos2(hdcptr));
}


os_error * graphicsscaleboth(int xres,int yres,int vxres,int vyres)
{
 return(graphicsscaleboth2(xres,yres,vxres,vyres,currenthdcptr));
}



#ifdef NEVER

os_error * graphicsostext2(hdcstr * hdcptr)
{
 os_error * err;

 err=NULL;

//          err=XSetMapMode(hdcptr->hdc, MM_TEXT,NULL);
// if(!err) err=XSetWindowOrgEx(hdcptr->hdc,0,0,NULL);
// if(!err) err=XSetViewportOrgEx(hdcptr->hdc,0,0,NULL);

 return(err);
}


#endif


os_error * graphicspixel(hdcstr * hdcptr)
{
 hdcptr->osxres=1;
 hdcptr->osyres=-1;
 hdcptr->vduxres=1;
 hdcptr->vduyres=1;
	hdcptr->ox=0;
 hdcptr->oy=0;
 hdcptr->vx=0;
 hdcptr->vy=0;

	return(NULL);
}




os_error * graphicsospixel(hdcstr * hdcptr)
{
 hdcptr->osxres=1;
 hdcptr->osyres=1;
 hdcptr->vduxres=1;
 hdcptr->vduyres=1;
	hdcptr->ox=0;
 hdcptr->oy=0;
 hdcptr->vx=0;
 hdcptr->vy=0;

	return(NULL);
}



os_error * grospixel(void)
{
 return(graphicsospixel(currenthdcptr));
}






os_error * graphicssave(hdcstr * hdcptr,graphicssavestr * saves)
{
 saves->osxres=hdcptr->osxres;
 saves->osyres=hdcptr->osyres;
 saves->vduxres=hdcptr->vduxres;
 saves->vduyres=hdcptr->vduyres;
	saves->ox=hdcptr->ox;
 saves->oy=hdcptr->oy;
 saves->vx=hdcptr->vx;
 saves->vy=hdcptr->vy;

	return(NULL);
}


os_error * grossave(graphicssavestr * saves)
{
	return(graphicssave(currenthdcptr,saves));
}


os_error * graphicsload(hdcstr * hdcptr,graphicssavestr * saves)
{
 hdcptr->osxres=saves->osxres;
 hdcptr->osyres=saves->osyres;
 hdcptr->vduxres=saves->vduxres;
 hdcptr->vduyres=saves->vduyres;
	hdcptr->ox=saves->ox;
 hdcptr->oy=saves->oy;
 hdcptr->vx=saves->vx;
 hdcptr->vy=saves->vy;

 graphicsriscos2(hdcptr);

	return(NULL);
}

os_error * grosload(graphicssavestr * saves)
{
	return(graphicsload(currenthdcptr,saves));
}










// worry meta files?

os_error * graphicsbaseinit2(hdcstr * hdcptr)
{

 hdcptr->currentbrush=hdcptr->basebrush=NULL;
 hdcptr->currentpen=hdcptr->basepen=NULL;
 hdcptr->currentfont=hdcptr->basefont=NULL;
 hdcptr->osxres=OSXRES;
 hdcptr->osyres=OSYRES;
 hdcptr->vduxres=cvdu.xdpi;
 hdcptr->vduyres=cvdu.ydpi;
 hdcptr->cgox=0;
 hdcptr->cgoy=0;

 
// idealpaletteselect(currenthdc);?

 return(NULL);
}



// worry meta files?

os_error * graphicsinit2(int gox,int goy,hdcstr * hdcptr)
{
 os_error * err;

 hdcptr->currentbrush=hdcptr->basebrush=NULL;
 hdcptr->currentpen=hdcptr->basepen=NULL;
 hdcptr->currentfont=hdcptr->basefont=NULL;
 hdcptr->cgox=gox;
 hdcptr->cgoy=goy;
 hdcptr->osxres=OSXRES;
 hdcptr->osyres=OSYRES;
 hdcptr->vduxres=cvdu.xdpi;
 hdcptr->vduyres=cvdu.ydpi;

          err=graphicsriscos2(hdcptr);
 if(!err) err=idealpaletteselect(hdcptr->hdc);

 return(err);
}



os_error * graphicssetcurrent(hdcstr * hdcptr)
{
#ifdef _DEBUG
// if(currenthdcptr) *(int*)0=0;
#endif
 currenthdcptr=hdcptr;
 return(NULL);
}



os_error * graphicsclearcurrent(hdcstr * hdcptr)
{
//	cprintf("graphics clear current");

 currenthdcptr=NULL;
 return(NULL);
 USE(hdcptr);
}




os_error * graphicscreatehdcptr(hdcstr ** hdcptrp)
{
 os_error * err;
 hdcstr   * hdcptr;

 err=graphicsnewhdc(hdcptrp);
 if(!err)
 {
  hdcptr=*hdcptrp;
  
  hdcptr->hdc=CreateIC(TEXT("DISPLAY"),NULL,NULL,NULL);

           err=graphicsbaseinit2(hdcptr);
  if(!err) err=graphicsriscos2(hdcptr);
 }

 return(err);
}



os_error * graphicsdeletehdcptr(hdcstr ** hdcptrp)
{
 os_error * err;
 hdcstr   * hdcptr;

 hdcptr=*hdcptrp;

 err=graphicsfinit2(hdcptr);
 DeleteDC(hdcptr->hdc);
 graphicsdeletehdc(hdcptr);
 *hdcptrp=NULL;

 return(err);
}







static int checkflag;

os_error * graphicscheck(int dc)
{
 os_error * err;
 hdcstr   * hdcptr;

 err=NULL;

 if(!currenthdcptr)
 {
  err=graphicsnewhdc(&hdcptr);
  if(!err)
  {
   if(dc) hdcptr->hdc=CreateDC(TEXT("DISPLAY"),NULL,NULL,NULL);
   else   hdcptr->hdc=CreateIC(TEXT("DISPLAY"),NULL,NULL,NULL);

            err=graphicsbaseinit2(hdcptr);
   if(!err) err=graphicsriscos2(hdcptr);
   if(!err) err=graphicssetcurrent(hdcptr);

   checkflag=1;
  }
 }
 else
 {
  if(checkflag<1) checkflag=1;
  checkflag++;
 }

 return(err);
}


os_error * graphicsclear(void)
{
 os_error * err;
 hdcstr   * hdcptr;

 
 err=NULL;

 if(checkflag)
 {
  checkflag--;
  if(checkflag==0)
  {
   hdcptr=currenthdcptr;
//   cprintf("graphicsclear");

   graphicsclearcurrent(hdcptr);
   graphicsfinit2(hdcptr);
   DeleteDC(hdcptr->hdc);
   graphicsdeletehdc(hdcptr);
  }
 }

 return(err);
}



os_error * graphicsworld(transformstr * tr,int * wmode)
{
	XFORM xf;

 if(tr)
 {
  *wmode=GetGraphicsMode(currenthdcptr->hdc);

 	xf.eDx=(float)tr->e;
 	xf.eDy=(float)tr->f;
 	xf.eM11=(float)tr->a/((float)0x10000);
 	xf.eM12=-(float)tr->b/((float)0x10000);
 	xf.eM21=-(float)tr->c/((float)0x10000);
 	xf.eM22=(float)tr->d/((float)0x10000);

  SetGraphicsMode(currenthdcptr->hdc,GM_ADVANCED);

 	SetWorldTransform(currenthdcptr->hdc,&xf);
 }
 else
 {
 	xf.eDx=0.0;
 	xf.eDy=0.0;
 	xf.eM11=1.0;
 	xf.eM12=0.0;
 	xf.eM21=0.0;
 	xf.eM22=1.0;

 	SetWorldTransform(currenthdcptr->hdc,&xf);
 
  SetGraphicsMode(currenthdcptr->hdc,*wmode);
 }

	return(NULL);
}





