
#include <stdafx.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <time.h>


#include "commctrl.h"


#include "os.h"
#include "wimpt.h"
#include "werr.h"

#include "flex.h"

#include "etc.h"
#include "err.h"
#include "wos.h"
#include "poll.h"
#include "fsx.h"
#include "timex.h"
#include "deb.h"
#include "osunits.h"
#include "colour.h"
#include "hourglass.h"
#include "key.h"
#include "sp.h"
#include "bits.h"
#include "xhelp.h"

#include "osmlo.h"
#include "osglue.h"
#include "oserr.h"
#include "ospoll.h"
#include "osdrag.h"
#include "oshelp.h"
#include "oscb.h"
#include "userdraw.h"
#include "abx.h"
#include "osdde.h"
#include "trans.h"


#include "ospoll.h"
#include "poll.h"


#include "tooltips.h"




static int cctrlsbits;


os_error * commoncontrolsinit(int bits)
{
 os_error           * err;
 INITCOMMONCONTROLSEX iccex; 

 err=NULL;

	if((cctrlsbits & bits)!=bits)
	{
  iccex.dwICC=ICC_WIN95_CLASSES;
  iccex.dwSize=sizeof(INITCOMMONCONTROLSEX);
  InitCommonControlsEx(&iccex);
		cctrlsbits|=bits;
	}

	return(err);
}




static os_error * tipsmess(MSG * msg,uservalue userhandle,int * ack,int * code,int * reverselogic)
{
	int lResult;


 lResult=SendMessage((HWND)userhandle,(UINT)TTM_RELAYEVENT,(WPARAM)0,(LPARAM)msg);


	return(NULL);

	USE(reverselogic);
	USE(ack);
	USE(code);
}



// add a tip to a window with tooltips

os_error * tooltipadd(wimp_w tipshandle,wimp_w handle,int id,wimp_box * box,TCHAR * tip,int flags)
{
 os_error * err;
 TOOLINFO   ti;

 err=NULL;

	if(tipshandle)
	{
  ti.cbSize=sizeof(TOOLINFO);
  ti.uFlags=(flags & TTIPADDSUBCLASS)?TTF_SUBCLASS:0;
  ti.hwnd=(HWND)handle;
  ti.hinst=AppInstance;
  ti.uId=id;
  ti.lpszText=tip;
  ti.rect.bottom=-yos2pix(box->y0);
  ti.rect.top=-yos2pix(box->y1);
  ti.rect.left=xos2pix(box->x0);
  ti.rect.right=xos2pix(box->x1);

// cprintf("left %d right %d top %d bot %d",ti.rect.left,ti.rect.right,ti.rect.top,ti.rect.bottom);

  SendMessage((HWND)tipshandle,(flags & TTIPREPOSN)?TTM_NEWTOOLRECT:TTM_ADDTOOL,0,(LPARAM)(LPTOOLINFO)&ti);	
	}

 return(err);
}


// rem a tip from a tooltips window

os_error * tooltiprem(wimp_w tipshandle,wimp_w handle,int id)
{
 os_error * err;
 TOOLINFO   ti;

 err=NULL;

	if(tipshandle)
	{
  ti.cbSize=sizeof(TOOLINFO);
  ti.uFlags=TTF_SUBCLASS;
  ti.hwnd=(HWND)handle;
  ti.hinst=AppInstance;
  ti.uId=id;

  SendMessage((HWND)tipshandle,TTM_DELTOOL,0,(LPARAM)(LPTOOLINFO)&ti);	
	}

 return(err);
}


// add tooltips to window+icon, use icon<0 for window

os_error * tooltipstart(wimp_w handle,int icon,wimp_w * tipshandle,int flags)
{
 os_error           * err;
 HWND                 hwndTT;
 HWND                 hwnd;

 err=NULL;

 commoncontrolsinit(ICC_WIN95_CLASSES);

	if(icon>=0) err=XGetDlgItem((HWND)handle,icon,&hwnd);
 else        hwnd=(HWND)handle;


// topmosts commented out because they seem to upset window stacks
// e.g. open print window, open screen, click on cancel and print window
// ends up behind main window

	if(!err)
	{
  err=XCreateWindowEx(0 /*WS_EX_TOPMOST*/,TOOLTIPS_CLASS,NULL,
         WS_POPUP | TTS_NOPREFIX | TTS_ALWAYSTIP,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
         hwnd,NULL,AppInstance,NULL,&hwndTT);

  if(!err) err=XSetWindowPos(hwndTT,0 /*HWND_TOPMOST*/,0,0,0,0,SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE);

		if(!err)
		{
   if(tipshandle) *tipshandle=(wimp_w)hwndTT;
   if(!(flags & TTIPADDSUBCLASS)) addwinmessage(tipsmess,-1,handle,(uservalue)hwndTT);
		}
	}

 return(err);
}


// remove tooltips using tips handle

os_error * tooltipend(wimp_w handle,wimp_w tipshandle,int flags)
{

	if(tipshandle)
	{
  if(!(flags & TTIPADDSUBCLASS)) remwinmessage(tipsmess,-1,handle,(uservalue)tipshandle);
  return(XDestroyWindow((HWND)tipshandle));
	}
	else
	{
		return(NULL);
	}
}




// add an icon to an existing tooltip control

os_error * tooltipaddicon(wimp_w handle,int icon,TCHAR * tip,wimp_w tipshandle)
{
	os_error * err;
	HWND       hwnd;
 RECT       rect;
 wimp_box   box;
 TCHAR      buffer[256];


	err=NULL;

	if(tipshandle)
	{
 	xzstrncpyu(buffer,tip,NITEM(buffer));
 	trans(buffer,NITEM(buffer));


 	if(icon>=0) err=XGetDlgItem((HWND)handle,icon,&hwnd);
  else        hwnd=(HWND)handle;

  if(!err) err=XGetClientRect(hwnd,&rect);
 	if(!err)
 	{
   box.x0=xpix2os(rect.left);
   box.x1=xpix2os(rect.right);
   box.y1=-ypix2os(rect.top);
   box.y0=-ypix2os(rect.bottom);

   err=tooltipadd(tipshandle,(wimp_w)hwnd,0,&box,buffer,TTIPADDSUBCLASS);
 	}
	}

	return(err);
}



// add a tooltip to an icon in a window
// this version creates the tooltip for the icon too
// i.e. one tooltip window per icon

os_error * tooltipicon(wimp_w handle,int icon,TCHAR * tip,wimp_w * tipshandle2)
{
 os_error * err;
 wimp_w     tipshandle;


 err=tooltipstart(handle,icon,&tipshandle,TTIPADDSUBCLASS);
 if(!err)
 {
  if(tipshandle2) *tipshandle2=tipshandle;
  err=tooltipaddicon(handle,icon,tip,tipshandle);
 }

 return(err);
}

