/*->c.wimp */

#include <stdafx.h>


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>
#include <stdarg.h>

#include "os.h"
#include "wimp.h"
#include "bbc.h"
#include "transform.h"

#include "xmath.h"
#include "osglue.h"
#include "oserr.h"
#include "osunits.h"
#include "osgraphics.h"

#include "deb.h"


#include "werr.h"
#include "colour.h"
#include "flex.h"
#include "alloc.h"
#include "abx.h"

#include "etc.h"
#include "wos.h"

#include "userdraw.h"







typedef struct windowdatastr
{
 int                    flags;
 int                    style;
 int                    scx;
 int                    scy;
 int                    ex0;
 int                    ex1;
 int                    ey0;
 int                    ey1;
 int                    accdelta;
 int                    accdeltasign;
 int                    acchorizontaldelta;
 int                    acchorizontaldeltasign;
 int                    backcolour;
 int                    vpage;
 int                    hpage;
 wimp_w                 handle;
 wimp_w                 parent;
 struct windowdatastr * next;
 struct windowdatastr * prev;

} windowdatastr;



static windowdatastr * firstwindowdata;


void wimp_check(char * string)
{
 windowdatastr * wdata;
 int             n;

 n=0;
 wdata=firstwindowdata;
 while(wdata)
 {
  n++;
  wdata=wdata->next;
 }
 cprintf("wimp check %s wdata's %d",string,n);
}


#ifdef _DEBUG

static void xcheckhandle(wimp_w handle,char * where)
{
 windowdatastr * wdata;

 wdata=firstwindowdata;
 while(wdata)
 {
  if(wdata->handle==handle) return;
  wdata=wdata->next;
 }

 cprintf("illegal window handle %x at %s",handle,where);
}

#endif


#ifdef _DEBUG

#define checkhandle(a,b) xcheckhandle((a),(b))

#else

#define checkhandle(a,b)

#endif





static os_error * getscrollinfo(windowdatastr * wdata,HWND hwnd,LPSCROLLINFO sih,LPSCROLLINFO siv)
{
 os_error * err;

 err=NULL;


 checkhandle((wimp_w)hwnd,"getscrollinfo");

 if(siv && wdata)
 {
  XZeroMemory(siv,sizeof(SCROLLINFO));
  siv->cbSize=sizeof(SCROLLINFO);
  siv->fMask=SIF_POS | SIF_PAGE | SIF_RANGE;

  if(wdata->style & WS_VSCROLL)
  {
   err=XGetScrollInfo(hwnd,SB_VERT,siv);
   if(wdata->flags & WINDOWAUTOCENTRE)
   {
    siv->nPos=wdata->scy;
   }
   if(err && (err->errnum==ERROR_NO_SCROLLBARS || err->errnum==ERROR_INVALID_PARAMETER))
   {
    XZeroMemory(siv,sizeof(SCROLLINFO));
    err=NULL;
   }
  }
  else
  {
   siv->nMax=wdata->ey1;
   siv->nMin=wdata->ey0;
   siv->nPos=wdata->scy;
   siv->nPage=wdata->vpage;
  }
 }

 if(!err)
 {
  if(sih && wdata)
  {
   XZeroMemory(sih,sizeof(SCROLLINFO));
   sih->cbSize=sizeof(SCROLLINFO);
   sih->fMask=SIF_POS | SIF_PAGE | SIF_RANGE;

   if(wdata->style & WS_HSCROLL)
   {
    err=XGetScrollInfo(hwnd,SB_HORZ,sih);
//				cprintf("getscroll info %d",sih->nPos);
    if(wdata->flags & WINDOWAUTOCENTRE)
    {
     sih->nPos=wdata->scx;
    }
    if(err && (err->errnum==ERROR_NO_SCROLLBARS || err->errnum==ERROR_INVALID_PARAMETER))
    {
     XZeroMemory(sih,sizeof(SCROLLINFO));
     err=NULL;
    }
   }
   else
   {
//				cprintf("fill scroll info %d",sih->nPos);
    sih->nMax=wdata->ex1;
    sih->nMin=wdata->ex0;
    sih->nPos=wdata->scx;
    sih->nPage=wdata->hpage;
   }
  } 
 }

 if(err)  cprintf("getscroll info returns error %s",err->errmess);

 return(err);
}



static os_error * setscrollinfo(windowdatastr * wdata,HWND hwnd,LPSCROLLINFO sih,LPSCROLLINFO siv)
{
 os_error * err;

 err=NULL;

 if(siv)
 {
  if(wdata->style & WS_VSCROLL)
  {
   if(wdata->flags & WINDOWAUTOCENTRE)
   {
    if(siv->fMask & SIF_POS)
    {
     wdata->scy=siv->nPos;
    }
   }

   XSetScrollInfo(hwnd,SB_VERT,siv,1,&siv->nPos);
  }
  else
  {
   if(siv->fMask & SIF_RANGE)
   {
    wdata->ey1=siv->nMax;
    wdata->ey0=siv->nMin;

//				cprintf("set data ey1 %d ey0 %d",wdata->ey1,wdata->ey0);

   }

   if(siv->fMask & SIF_POS)
   {
    wdata->scy=siv->nPos;
   }

   if(siv->fMask & SIF_PAGE)
   {
    wdata->vpage=siv->nPage;
   }
  }
 }

 if(!err)
 {
  if(sih)
  {
   if(wdata->style & WS_HSCROLL)
   {
    if(wdata->flags & WINDOWAUTOCENTRE)
    {
     if(sih->fMask & SIF_POS)
     {
      wdata->scx=sih->nPos;
     }
    }

    XSetScrollInfo(hwnd,SB_HORZ,sih,1,&sih->nPos);
   }
   else
   {
    if(sih->fMask & SIF_RANGE)
    {
     wdata->ex1=sih->nMax;
     wdata->ex0=sih->nMin;
    }

    if(sih->fMask & SIF_POS)
    {
     wdata->scx=sih->nPos;
    }

    if(sih->fMask & SIF_PAGE)
    {
     wdata->hpage=sih->nPage;
    }
   }
  } 
 }

 return(err);
}


#ifdef NEVER

// return 1 if we do something

int wimp_moving(HWND hwnd,LPRECT rect,int edges)
{

 return(0);

 USE(hwnd);
 USE(rect);
 USE(edges);
}


#endif


// return 1 if we do something

int wimp_systemcommand(HWND hwnd,WPARAM command,int x,int y)
{
 os_error      * err;
 windowdatastr * wdata;

 err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR*)&wdata);
 if(!err && wdata)
 {
  if(wdata->flags & WINDOWFIXED)
  {
   if((command & 0xFFF0)==SC_MOVE)
   {
    cprintf("syscommand defeat");

    return(1);
   }
  }

 }

 return(0);

 USE(x);
 USE(y);
}




#ifdef NEVER

// return TRUE if message processed

int sizecheck(HWND hwnd,int flags,RECT * rect)
{
 os_error      * err;
 windowdatastr * wdata;
 int             maxw;
 int             maxh;
 int             neww;
 int             newh;

 err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR*)&wdata);
 if(!err && wdata)
 {
  maxw=xos2pix(wdata->ex1-wdata->ex0);
  maxh=yos2pix(wdata->ey1-wdata->ey0);
  neww=rect->right-rect->left;
  newh=rect->bottom-rect->top;

  if(neww>maxw)
  {
   if(flags==WMSZ_BOTTOMRIGHT || flags==WMSZ_TOPRIGHT || flags==WMSZ_RIGHT)
   {
    rect->right-=(neww-maxw);
   }
   else
   {
    rect->left+=(neww-maxw);
   }
  }

  if(newh>maxh)
  {
   if(flags==WMSZ_BOTTOMRIGHT || flags==WMSZ_BOTTOM || flags==WMSZ_BOTTOMLEFT)
   {
    rect->bottom-=(newh-maxh);
   }
   else
   {
    rect->top+=(newh-maxh);
   }
  }

  return(1);
 }

 return(0);
}


#endif



int getminmax(HWND hwnd,LPMINMAXINFO maxmin)
{
 os_error      * err;
 windowdatastr * wdata;
 int             maxw;
 int             maxh;

 err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR *)&wdata);
 if(!err && wdata)
 {
  if(wdata->flags & WINDOWMINMAX)
  {
   maxw=xos2pix(wdata->ex1-wdata->ex0);
   maxh=yos2pix(wdata->ey1-wdata->ey0);

//   cprintf("maxw %d maxh %d",maxw,maxh);

   maxmin->ptMaxTrackSize.x=maxw;
   maxmin->ptMaxTrackSize.y=maxh;
   maxmin->ptMaxSize.x=maxw;
   maxmin->ptMaxSize.y=maxh;

   return(0);
  }
 }

 return(1);
}



int wimp_ncactivate(HWND hwnd,WPARAM state)
{
 os_error      * err;
 windowdatastr * wdata;
 HWND            parent;

 err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR *)&wdata);
 if(!err && wdata)
 {
  if(wdata->flags & WINDOWPANE)
  {
   parent=GetParent(hwnd);
   SendMessage(parent,WM_NCACTIVATE,state,0);
  }
 }
 return(0);
}







os_error * wimp_checkfocus(HWND hwnd)
{
 os_error      * err;
 windowdatastr * wdata;
 HWND            parent;
 HWND            prev;
 int             style;


 err=XGetWindowLong(hwnd,GWL_STYLE,(LONG*)&style);
 if(!err)
 {
  if(style & WS_CHILD) hwnd=GetParent(hwnd);
  
  prev=GetFocus();

  if(prev==hwnd)
  {
   err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR *)&wdata);
   if(!err && wdata)
   {
    if(wdata->flags & WINDOWPANE)
    {
     parent=GetParent(hwnd);
     XSetFocus(parent,&prev);
    }
   }
  }
 }

 return(err);
}




// return 0 if this window is a dialogue

int wimp_isdialogue(HWND hwnd)
{
 os_error      * err;
 HMENU           menu;
 windowdatastr * wdata;

	if(hwnd==NULL) return(1);

 err=XGetMenu(hwnd,&menu);
 if(menu) return(1);

 if(taskclasswindow(hwnd))
 {
  err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR *)&wdata);
  if(!err && wdata)
  {
   return(wdata->flags & WINDOWNOTDIALOGUE);
  }
 }

 return(0);
}


#ifdef NEVER

int maximizewindow(HWND hwnd)
{
 os_error      * err;
 windowdatastr * wdata;
 int             maxw;
 int             maxh;

 err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR *)&wdata);
 if(!err && wdata)
 {
  maxw=xos2pix(wdata->ex1-wdata->ex0);
  maxh=yos2pix(wdata->ey1-wdata->ey0);
  if(maxw<cvdu.screenx || maxh<cvdu.screeny)
  {
   err=XSetWindowPos(hwnd,HWND_TOP,0,0,maxw,maxh,SWP_NOZORDER|SWP_SHOWWINDOW);  

   return(1);
  }
 }

 return(0);
}

#endif



void wmfocus(HWND hwnd,int message)
{
 os_error      * err;
 windowdatastr * wdata;

 if(message==WM_KILLFOCUS)
 {
  if(taskclasswindow(hwnd))
  {
   err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR *)&wdata);
   if(!err && wdata)
   {
    wdata->accdelta=wdata->acchorizontaldelta=0;
   }
  }
 }
}



int wimp_wheelgetlines(wimp_w handle,int delta,int horizontal)
{
 os_error      * err;
 windowdatastr * wdata;
 int             lines;
 int             sign;

 lines=0;

 err=XGetWindowLongPtr((HWND)handle,GWLP_USERDATA,(LONG_PTR *)&wdata);
 if(!err && wdata)
 {
  sign=SGN(delta);

  if(horizontal)
  {
   if(sign!=wdata->acchorizontaldeltasign)
   {
    wdata->acchorizontaldelta=delta;
    wdata->acchorizontaldeltasign=sign;
   }
   else
   {
    wdata->acchorizontaldelta+=delta;
   }

   delta=wdata->acchorizontaldelta;
  }
  else
  {
   if(sign!=wdata->accdeltasign)
   {
    wdata->accdelta=delta;
    wdata->accdeltasign=sign;
   }
   else
   {
    wdata->accdelta+=delta;
   }

   delta=wdata->accdelta;
  }
  
  
  if(deltaperline!=0)
  {
   while(delta>=deltaperline)
   {
    lines++;
    delta-=deltaperline;
   }

   while(delta<=-deltaperline)
   {
    lines--;
    delta+=deltaperline;
   }
  }


  if(horizontal) wdata->acchorizontaldelta=delta;
  else           wdata->accdelta=delta;
 }

 return(lines);
}

// return 0 if process
// called on wheel mouse event

int wheelwindow(HWND hwnd,int delta,int keys)
{
 os_error      * err;
 windowdatastr * wdata;
 int             lines;

// cprintf("wheel %x delta %d",hwnd,delta);

 err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR*)&wdata);
 if(!err && wdata)
 {
  if(wdata->style & (WS_VSCROLL|WS_HSCROLL))
  {
   lines=wimp_wheelgetlines((wimp_w)hwnd,delta,0);
   if(lines>0)
   {
    while(lines-->0)
    {
     SendMessage(hwnd,WM_VSCROLL,SB_LINEUP,0);
    }
   }
   else
   if(lines<0)
   {
    while(lines++<0)
    {
     SendMessage(hwnd,WM_VSCROLL,SB_LINEDOWN,0);
    }
   }
   return(0);
  }
 }

 return(1);

 USE(keys);
}



// return true if we do something, opposite to normal wheel message

int wheelhwindow(HWND hwnd,int delta,int keys)
{
 os_error      * err;
 windowdatastr * wdata;
 int             lines;

// cprintf("H wheel %x delta %d",hwnd,delta);

 err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR *)&wdata);
 if(!err && wdata)
 {
  if(wdata->style & (WS_VSCROLL|WS_HSCROLL))
  {
   lines=wimp_wheelgetlines((wimp_w)hwnd,delta,1);
   if(lines>0)
   {
    while(lines-->0)
    {
     SendMessage(hwnd,WM_HSCROLL,SB_LINEUP,0);
    }
   }
   else
   if(lines<0)
   {
    while(lines++<0)
    {
     SendMessage(hwnd,WM_HSCROLL,SB_LINEDOWN,0);
    }
   }
   return(1);
  }
 }

 return(0);

 USE(keys);
}









// fill background if we want to, return 0 on process

int windoweraseback(HWND hwnd,HDC hdc)
{
 os_error      * err;
 RECT            rc;
 int             code;
 windowdatastr * wdata;
 HBRUSH          brush;
 int             cbits;

 code=0;

 err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR*)&wdata);
 if(!err && wdata)
 {
  cbits=wdata->backcolour & CCMASK;
  
  if(cbits!=CCNULL)
  {
   GetClientRect(hwnd,(LPRECT)&rc);

   if(cbits==CCRGB)
   {
    brush=CreateSolidBrush((wdata->backcolour>>8) & 0xFFFFFF);
    FillRect(hdc,(LPRECT)&rc,brush);
    DeleteObject(brush);
   }
   else
   if(cbits<CCSYSBASE)
   {
    if(cvdu.bpp<=8)
    {
     if(cvdu.palettesupport)
     {
      physicalpaletteselect(hdc);
      brush=CreateSolidBrush(PALETTEINDEX(cvdu.wimpcolnos[cbits-CCWIMPBASE]));
     }
     else
     {
      brush=CreateSolidBrush(COLREFFROMPAL(systempalette[cvdu.wimpcolnos[cbits-CCWIMPBASE]]));
     }
    }
    else
    {
     brush=CreateSolidBrush((cvdu.vdupal.c[cbits-CCWIMPBASE].word>>8) & 0xFFFFFF);
    }

    FillRect(hdc,(LPRECT)&rc,brush);
    DeleteObject(brush);
   }
   else
   if(cbits<CCTRANSPARENT)
   {
    FillRect(hdc,(LPRECT)&rc,(HBRUSH)GetSysColorBrush(cbits-CCSYSBASE));
   }
   else
   {

   }
    
   code=1;
  }
 }

 return(code);
}


os_error * wimp_setwindowbackground(wimp_w window,int colour)
{
 os_error      * err;
 windowdatastr * wdata;


 err=XGetWindowLongPtr((HWND)window,GWLP_USERDATA,(LONG_PTR *)&wdata);
 if(!err && wdata)
 {
  wdata->backcolour=colour;
 }

 return(err);
}




os_error * wimp_setwindowflags(wimp_w window,int orr,int bic)
{
 os_error      * err;
 windowdatastr * wdata;
	int             flags;

 checkhandle(window,"flags");

 err=XGetWindowLongPtr((HWND)window,GWLP_USERDATA,(LONG_PTR*)&wdata);
 if(!err && wdata)
 {
		flags=wdata->flags;

  wdata->flags&=~bic;
  wdata->flags|=orr;

		if((wdata->flags ^ flags) & WINDOWUNICODE)	// supposed to change unicode status of window, unproven
		{
			if(wdata->flags	& WINDOWUNICODE)
			{
		 	SetWindowLongPtrW((HWND)window,GWLP_WNDPROC,GetWindowLongPtr((HWND)window,GWLP_WNDPROC));
			}
			else
			{
    SetWindowLongPtrA((HWND)window,GWLP_WNDPROC,GetWindowLongPtr((HWND)window,GWLP_WNDPROC));
			}
		}
 }

 return(err);
}


os_error * wimp_getwindowflags(wimp_w window,int * flags)
{
 os_error      * err;
 windowdatastr * wdata;

 checkhandle(window,"get flags");

 *flags=0;

 err=XGetWindowLongPtr((HWND)window,GWLP_USERDATA,(LONG_PTR*)&wdata);
 if(!err && wdata)
 {
  *flags=wdata->flags;
 }

 return(err);
}



static os_error * setwinextentx(HWND hwnd,int ex0,int ex1)
{
 os_error      * err;
 SCROLLINFO      si;
 RECT            rect;
 windowdatastr * wdata;
 int             oldhpos;
 int             hpos;
 int             region;
 int             size;
 int             limit;


 err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR*)&wdata);

//	cprintf("set extent %x",wdata);

 if(!err && wdata)
 {
  err=XGetClientRect(hwnd,&rect);
  if(!err)
  {
   err=getscrollinfo(wdata,hwnd,&si,NULL);
   if(!err)
   {
    size=rect.right-rect.left;
    si.cbSize=sizeof(SCROLLINFO);
    si.fMask=SIF_RANGE|SIF_PAGE|SIF_POS;
    si.nMin=ex0;
    si.nMax=ex1;
    si.nPage=xpix2os(size);
    oldhpos=hpos=xos2pix(si.nPos);

    ex1=xos2pix(ex1);
    ex0=xos2pix(ex0);

    if((wdata->flags & WINDOWAUTOCENTRE) && size>(ex1-ex0))
    {
     hpos=ex0-(size-(ex1-ex0))/2;
    }
    else
    {
     limit=ex1-size;

     if(hpos>limit) hpos=limit;
     if(hpos<ex0)   hpos=ex0;
    }

    si.nPos=xpix2os(hpos);

    err=setscrollinfo(wdata,hwnd,&si,NULL);
    if(!err)
    {
//     hpos=xos2pix(si.nPos);
     if(hpos!=oldhpos)
     {
      err=wmscroll(hwnd,oldhpos-hpos,0,NULL,NULL,NULL,NULL,SW_INVALIDATE|SW_ERASE|((wdata->flags & WINDOWNOSCROLLCHILD)?0:SW_SCROLLCHILDREN),&region);
     }
    }
   }
  }
 }

 return(err);
}



static os_error * setwinextenty(HWND hwnd,int ey0,int ey1)
{
 os_error      * err;
 SCROLLINFO      si;
 RECT            rect;
 windowdatastr * wdata;
 int             oldvpos;
 int             vpos;
 int             region;
 int             size;
 int             limit;

 err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR*)&wdata);
 if(!err && wdata)
 {
  err=XGetClientRect(hwnd,&rect);
  if(!err)
  {
   err=getscrollinfo(wdata,hwnd,NULL,&si);
   if(!err)
   {
    size=rect.bottom-rect.top;
    si.cbSize=sizeof(SCROLLINFO);
    si.fMask=SIF_RANGE|SIF_PAGE|SIF_POS;
    si.nMin=ey0;
    si.nMax=ey1;
    si.nPage=ypix2os(size);
    oldvpos=vpos=yos2pix(si.nPos);


    ey1=yos2pix(ey1);
    ey0=yos2pix(ey0);


    if((wdata->flags & WINDOWAUTOCENTRE) && size>(ey1-ey0))
    {
     vpos=ey0-(size-(ey1-ey0))/2;
    }
    else
    {
     limit=ey1-size;

     if(vpos>limit) vpos=limit;
     if(vpos<ey0)   vpos=ey0;
    }

    si.nPos=ypix2os(vpos);

    err=setscrollinfo(wdata,hwnd,NULL,&si);
    if(!err)
    {
//     vpos=yos2pix(si.nPos);
     if(oldvpos!=vpos)
     {
      err=wmscroll(hwnd,0,oldvpos-vpos,NULL,NULL,NULL,NULL,SW_INVALIDATE|SW_ERASE|((wdata->flags & WINDOWNOSCROLLCHILD)?0:SW_SCROLLCHILDREN),&region);
     }
    }
   }
  }
 }

 return(err);
}




os_error * wimp_set_extent(wimp_redrawstr * wr)
{
 os_error      * err;
 int             x0;
 int             x1;
 int             y0;
 int             y1;
 windowdatastr * wdata;


 checkhandle(wr->w,"set extent");

 err=XGetWindowLongPtr((HWND)wr->w,GWLP_USERDATA,(LONG_PTR*)&wdata);
 if(!err && wdata)
 {
  wdata->ex0=x0=wr->box.x0;
  wdata->ex1=x1=wr->box.x1;
  wdata->ey0=y0=wr->box.y0;
  wdata->ey1=y1=wr->box.y1;

           err=setwinextenty((HWND)wr->w,0-y1,0-y0);
  if(!err) err=setwinextentx((HWND)wr->w,x0,x1);
 }

 return(err);
}




os_error * wimp_get_extent(wimp_redrawstr * wr)
{
 os_error      * err;
 windowdatastr * wdata;

 checkhandle(wr->w,"get extent");

 err=XGetWindowLongPtr((HWND)wr->w,GWLP_USERDATA,(LONG_PTR*)&wdata);
 if(!err && wdata)
 {
  wr->box.x0=wdata->ex0;
  wr->box.x1=wdata->ex1;
  wr->box.y0=wdata->ey0;
  wr->box.y1=wdata->ey1;
 }

 return(err);
}





// hpos in OS

os_error * scrollcheckx(HWND hwnd,int hpos)
{
 os_error      * err;
 SCROLLINFO      sih;
 RECT            rect;
 int             oldpos;
 int             ex0;
 int             ex1;
 int             limit;
 int             size;
 int             region;
 windowdatastr * wdata;


//	cprintf("scroll checkx %x",hwnd);

 err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR*)&wdata);
 if(!err && wdata)
 {
  err=XGetClientRect(hwnd,&rect);
  if(!err)
  {
   size=(rect.right-rect.left);

   err=getscrollinfo(wdata,hwnd,&sih,NULL);
   if(!err)
   {
    oldpos=sih.nPos;
    ex1=sih.nMax;
    ex0=sih.nMin;

    if(ex1>ex0)
    {
     oldpos=xos2pix(oldpos);
     ex1=xos2pix(ex1);
     ex0=xos2pix(ex0);
     hpos=xos2pix(hpos);

     if((wdata->flags & WINDOWAUTOCENTRE) && size>(ex1-ex0))
     {
      hpos=ex0-(size-(ex1-ex0))/2;
     }
     else
     {
      limit=ex1-size;

      if(hpos>limit) hpos=limit;
      if(hpos<ex0)   hpos=ex0;
     }

     if(oldpos!=hpos)
     {
      sih.cbSize=sizeof(SCROLLINFO);
      sih.fMask=SIF_POS;
      sih.nPos=xpix2os(hpos);

      err=setscrollinfo(wdata,hwnd,&sih,NULL);
      if(!err) err=wmscroll(hwnd,oldpos-hpos,0,NULL,NULL,NULL,NULL,SW_INVALIDATE|SW_ERASE|((wdata->flags & WINDOWNOSCROLLCHILD)?0:SW_SCROLLCHILDREN),&region);
     }
    }
   }
  }
 }

 return(err);
}


// vpos in OS units

os_error * scrollchecky(HWND hwnd,int vpos)
{
 os_error * err;
 SCROLLINFO siv;
 RECT       rect;
 int        oldpos;
 int        ex0;
 int        ex1;
 int        limit;
 int        size;
 int        region;
 windowdatastr * wdata;


//	cprintf("scroll checky %x vpos %d",hwnd,vpos);

 err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR*)&wdata);
 if(!err && wdata)
 {
  err=XGetClientRect(hwnd,&rect);
  if(!err)
  {
   size=(rect.bottom-rect.top);

   err=getscrollinfo(wdata,hwnd,NULL,&siv);
   if(!err)
   {
    oldpos=siv.nPos;
    ex1=siv.nMax;
    ex0=siv.nMin;
    if(ex1>ex0)
    {
     oldpos=yos2pix(oldpos);
     vpos=yos2pix(vpos);
     ex1=yos2pix(ex1);
     ex0=yos2pix(ex0);

//					cprintf("vpos2 %d size %d ex0 %d ex1 %d",vpos,size,ex0,ex1);

     if((wdata->flags & WINDOWAUTOCENTRE) && size>(ex1-ex0))
     {
//						cprintf("clause1");
      vpos=ex0-(size-(ex1-ex0))/2;
     }
     else
     {
//						cprintf("clause2");

      limit=ex1-size;

//						cprintf("limit %d",limit);

      if(vpos>limit) vpos=limit;
      if(vpos<ex0) vpos=ex0;
     }

//					cprintf("old %d new vpos %d ex1 %d ex0 %d",oldpos,vpos,ex1,ex0);

     if(oldpos!=vpos)
     {
      siv.cbSize=sizeof(SCROLLINFO);
      siv.fMask=SIF_POS;
      siv.nPos=ypix2os(vpos);

      err=setscrollinfo(wdata,hwnd,NULL,&siv);
      if(!err) err=wmscroll(hwnd,0,oldpos-vpos,NULL,NULL,NULL,NULL,SW_INVALIDATE|SW_ERASE|((wdata->flags & WINDOWNOSCROLLCHILD)?0:SW_SCROLLCHILDREN),&region);
     }
    }
   }
  }
 }

 return(err);
}


/*

 Double click on title bar, get WM_MOVE, window maximises and this
 function resets scroll extents, resetting these to max values results
 in the scroll bars vanishing, this generates WM_SHOW commands which
 make this function re-enter. Losing a vert scroll bar will change
 the size of the horiz scroll bar, so re-enter has to force recalculation

 Function stops later code by setting skip parameter, but knows about
 multiple calls and goes around a loop to recalculate.

*/


os_error * scrollcheck(wimp_w handle,int * skip)
{
 os_error * err;
 SCROLLINFO siv;
 SCROLLINFO sih;
 RECT       rect;
 int        oldhpos=0;
 int        oldvpos;
 int        hpos=0;
 int        vpos;
 int        ex0;
 int        ex1;
 int        ey0;
 int        ey1;
 int        limit;
 int        vsize;
 int        hsize;
 int        region;
 int        oldvsize;
 int        oldhsize;
 HWND       hwnd;
 windowdatastr * wdata;
 int        vshift;
 int        hshift;
 static int reenter;


 if(reenter)
 {
  reenter++;
  *skip=1;
  return(NULL);
 }
 else
 {
  *skip=0;
  reenter=1;
 }


//	cprintf("scrollcheck %x",handle);

 hwnd=(HWND)handle;
 vshift=0;
 hshift=0;
 
 err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR*)&wdata);

 // see this return an error, no wdata, during window init?

 if(!err && wdata)
 {
  while(1)
  {
   err=XGetClientRect(hwnd,&rect);
   if(!err) err=getscrollinfo(wdata,hwnd,&sih,&siv);
   if(!err)
   {
    vsize=(rect.bottom-rect.top);
    hsize=(rect.right-rect.left);

    vpos=oldvpos=yos2pix(siv.nPos);
    oldvsize=yos2pix(siv.nPage);

    ey1=yos2pix(siv.nMax);
    ey0=yos2pix(siv.nMin);

    if(ey1>ey0)
    {
     if((wdata->flags & WINDOWAUTOCENTRE) && vsize>(ey1-ey0))
     {
      vpos=ey0-(vsize-(ey1-ey0))/2;
     }
     else
     {
      limit=ey1-vsize;
 
      if(vpos>limit) vpos=limit;
      if(vpos<ey0)   vpos=ey0;
     }

     if(oldvpos!=vpos || vsize!=oldvsize)
     {
      siv.cbSize=sizeof(SCROLLINFO);
      siv.fMask=SIF_POS | SIF_PAGE;
      siv.nPos=ypix2os(vpos);
      siv.nPage=ypix2os(vsize);
      err=setscrollinfo(wdata,hwnd,NULL,&siv);
     }

     vshift+=oldvpos-vpos;
    }
 

 // now check X direction

    if(!err)
    {
     hpos=oldhpos=xos2pix(sih.nPos);
     oldhsize=xos2pix(sih.nPage);

     ex1=xos2pix(sih.nMax);
     ex0=xos2pix(sih.nMin);

     if(ex1>ex0)
     {
      if((wdata->flags & WINDOWAUTOCENTRE) && hsize>(ex1-ex0))
      {
       hpos=ex0-(hsize-(ex1-ex0))/2;
      }
      else
      {
       limit=ex1-hsize;

       if(hpos>limit) hpos=limit;
       if(hpos<ex0)   hpos=ex0;
      }

      if(oldhpos!=hpos || hsize!=oldhsize)
      {
       sih.cbSize=sizeof(SCROLLINFO);
       sih.fMask=SIF_POS | SIF_PAGE;
       sih.nPos=xpix2os(hpos);
       sih.nPage=xpix2os(hsize);
       err=setscrollinfo(wdata,hwnd,&sih,NULL);
      }

      hshift+=oldhpos-hpos;
     }
    }
   }

   if(reenter==1) break;
   reenter=1;
  }


  if(!err)
  {
   if(vshift)
   {
    err=wmscroll(hwnd,0,vshift,NULL,NULL,NULL,NULL,SW_INVALIDATE|SW_ERASE|((wdata->flags & WINDOWNOSCROLLCHILD)?0:SW_SCROLLCHILDREN),&region);
   }

   if(!err)
   {
    if(hshift)
    {
     err=wmscroll(hwnd,hshift,0,NULL,NULL,NULL,NULL,SW_INVALIDATE|SW_ERASE|((wdata->flags & WINDOWNOSCROLLCHILD)?0:SW_SCROLLCHILDREN),&region);
    }
   }
  }
 } 
  
 //	cprintf("scroll check ex");

 reenter=0;
 *skip=0;

 return(err);
}


// if we don't have this, we don't get WM_SETFONT messages...

static INT_PTR CALLBACK DialogProc(
  HWND hwndDlg,  // handle to dialog box
  UINT uMsg,     // message
  WPARAM wParam, // first message parameter
  LPARAM lParam  // second message parameter
)
{
 cprintf("dialog proc");

 return(0);
 USE(lParam);
 USE(wParam);
 USE(uMsg);
 USE(hwndDlg);
}


static wimp_w xparent;


int wmcreate(HWND hwnd)
{
 os_error      * err;
 windowdatastr * wdata;
 LONG_PTR        oldval;


	err=NULL;

// this code used to be in the create function below
// that's OK because most of the code can work with missing wdata's
// putting it here gives wdata's thougout but leads to operations
// on wdata's which are not set up.


 wdata=(windowdatastr*)malloc(sizeof(windowdatastr));
 if(wdata)
 {
   XZeroMemory(wdata,sizeof(windowdatastr));
            err=XSetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR)wdata,&oldval);
   if(!err) err=XGetWindowLong(hwnd,GWL_STYLE,(LONG *)&wdata->style);

//			cprintf("wdata style %x",wdata->style);

   wdata->handle=(wimp_w)(hwnd);
   wdata->parent=(wimp_w)xparent;
   wdata->next=firstwindowdata;
   if(firstwindowdata) firstwindowdata->prev=wdata;
   firstwindowdata=wdata;
 }

//	cprintf("wmcreate unicode %d",IsWindowUnicode(hwnd));

	report(err);

 return(0);
}



// warning template pointers can be to old or new types depending on extra flag values

os_error * wimp_create_windparent(wimp_wind * w, wimp_w * result,wimp_w parent)
{
 os_error      * err;
 HWND            hwnd;


 xparent=parent;
// cprintf("in Create Dialog %x",w);
 err=XCreateDialogIndirect(AppInstance,(LPCDLGTEMPLATE)w,(HWND)parent,DialogProc,&hwnd);
// cprintf("ex Create Dialog");

 if(!err)
 {
//  cprintf("create %x",hwnd);
  *result=(wimp_w)hwnd;

 }

 return(err);
}








/***************************************************************************/

#define WDSTACK 16

static windowdatastr ** wdpointer[WDSTACK];



static void lockwdata(windowdatastr ** pointer)
{
 int i;

 for(i=0;i<WDSTACK;i++)
 {
  if(wdpointer[i]==NULL) 
  {
   wdpointer[i]=pointer;
   break;
  }
 }
}


static void unlockwdata(windowdatastr ** pointer)
{
 int i;

 for(i=0;i<WDSTACK;i++)
 {
  if(wdpointer[i]==pointer) 
  {
   wdpointer[i]=NULL;
   break;
  }
 }
}




static void maplockwdata(windowdatastr * wdata)
{
 int i;

 for(i=0;i<WDSTACK;i++)
 {
  if(wdpointer[i] && (*wdpointer[i])==wdata) 
  {
   *wdpointer[i]=wdata->next;
  }
 }
}





static os_error * scrapwdata(windowdatastr * wdata)
{
 windowdatastr  * prev;
 windowdatastr  * next;

 maplockwdata(wdata);

 prev=wdata->prev;
 next=wdata->next;
 if(prev) prev->next=next;
 if(next) next->prev=prev;
 if(wdata==firstwindowdata) firstwindowdata=next;

 free(wdata); 


 return(NULL);
}



// assertion child windows will always appear first in chain

os_error * wimp_delete_wind(wimp_w w)
{
 os_error       * err;
 windowdatastr  * wdata;
 windowdatastr  * next;
 windowdatastr  * target;
 windowdatastr  * targetp;
 LONG_PTR         oldval;


 checkhandle(w,"delete");

 polldeletewindow(w);

// cprintf("delete %x",w);

 err=XGetWindowLongPtr((HWND)w,GWLP_USERDATA,(LONG_PTR *)&wdata);
 if(!err)
 {
  if(wdata)
  {
   next=firstwindowdata;
   while(next)
   {
    target=targetp=next;
    next=next->next;
    if(w==target->parent)
    {
     lockwdata(&next);
     lockwdata(&target);
     polldeletechild(target->handle);
//     cprintf("delete child %x",target->handle);
     unlockwdata(&target);
     unlockwdata(&next);
     if(target==targetp)
     {
// problem here is that we're trashing wdata but we might call functions
// that depend on it via handle
      XSetWindowLongPtr((HWND)target->handle,GWLP_USERDATA,NULL,&oldval);
      scrapwdata(target);
     }
    }
   }

   scrapwdata(wdata);
  }
 }

 return(XDestroyWindow((HWND)w));
}




os_error * wimp_create_wind(wimp_wind * w, wimp_w * result)
{
 return(wimp_create_windparent(w,result,NULL));
}





os_error * wimp_open_wind(wimp_openstr * o)
{
 os_error      * err;
 HWND            hwnd;
 RECT            recto;
 RECT            rect;
 int             newx;
 int             newy;
 int             newwidth;
 int             newheight;
 int             openx;
 int             openy;
 int             openh;
 int             openw;
 POINT           pt;
 int             style;
 HWND            parent;
 HWND            after;
 int             flags;
 windowdatastr * wdata;


 checkhandle(o->w,"open");

 hwnd=(HWND)o->w;

          err=XGetWindowRect(hwnd,&recto);
 if(!err) err=XGetClientRect(hwnd,&rect);

//	cprintf("rect x %d y %d w %d h %d",rect.left,rect.top,rect.right,rect.bottom);

 pt.x=pt.y=0;
 if(!err) err=XClientToScreen(hwnd,&pt);

 if(!err)
 {
  openx=xcoordos2pix(o->box.x0);
  openy=ycoordos2pix(o->box.y1);
  openw=xcoordos2pix(o->box.x1)-xcoordos2pix(o->box.x0);
  openh=ycoordos2pix(o->box.y0)-ycoordos2pix(o->box.y1);

  newx=(recto.left-pt.x)+openx;
  newwidth=(recto.right-recto.left)+openw-(rect.right-rect.left);
  newy=(recto.top-pt.y)+openy;
  newheight=(recto.bottom-recto.top)+openh-(rect.bottom-rect.top);

  XGetWindowLong(hwnd,GWL_STYLE,(LONG*)&style);
  if(style & WS_CHILD)
  {
   err=XGetParent(hwnd,&parent);
   if(!err)
   {
    pt.x=pt.y=0;
    err=XClientToScreen(parent,&pt);
    newx-=pt.x;
    newy-=pt.y;
   }
  }
  else
  {
   parent=NULL;
  }

  if(o->behind==(wimp_w)wimp_HIDDEN)
  {
   flags=SWP_HIDEWINDOW |SWP_NOACTIVATE | SWP_NOZORDER;
   after=hwnd;
  }
  else
  {
   flags=SWP_SHOWWINDOW |SWP_NOACTIVATE; // it is said SHOWWINDOW incompatible with moving window
   if(o->behind==(wimp_w)wimp_NOCHANGE)
   {
    flags|=SWP_NOZORDER;
    after=hwnd;
   }
   else
   if(o->behind==(wimp_w)wimp_TOP) after=HWND_TOP;
   else
   if(o->behind==(wimp_w)wimp_BOTTOM) after=HWND_BOTTOM;
   else
   if(o->behind==(wimp_w)wimp_TOPMOST) after=HWND_TOPMOST;
   else
   if(o->behind==(wimp_w)wimp_NOTOPMOST) after=HWND_NOTOPMOST;
   else
   {
    if(o->behind==(wimp_w)hwnd)
    {
     flags|=SWP_NOZORDER;
     after=hwnd;
    }
    else
    {
     after=(HWND)o->behind;
     if(after==hwnd) flags|=SWP_NOZORDER;

#ifdef NEVER    
    after=GetWindow((HWND)o->behind,GW_HWNDNEXT);
    if(after==NULL) after=HWND_BOTTOM;
    else
    if(after==hwnd) flags|=SWP_NOZORDER;
    else
    {
/*     XGetParent(after,&parent2);
     if(parent2==hwnd) flags|=SWP_NOZORDER; */
    }
#endif
    }
   }
  }

  if(parent && after==parent) // can't open a true child window after its parent - probably scan child windows, doesn't find it and fails
  {
   after=HWND_BOTTOM;
  }


//  cprintf("behind=%d after=%d parent %d",o->behind,after,parent);


  err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR*)&wdata);
  if(err)
  {
   wdata=NULL;
   err=NULL;
  }

  if(wdata) wdata->flags|=WINDOWBEINGOPENED;

  if(!err) err=XSetWindowPos(hwnd,after,newx,newy,newwidth,newheight,flags);

  if(wdata) wdata->flags&=~WINDOWBEINGOPENED;

  if(!err) err=scrollcheckx((HWND)o->w,o->x);
  if(!err) err=scrollchecky((HWND)o->w,-o->y);
		// still need a scrollcheck() which comes from the open event above

 }
 return(err);
}


// o struct contains outer of window to be opened

os_error * wimp_open_wind_ex(wimp_openstr * o)
{
 os_error      * err;
 HWND            hwnd;
 RECT            recto;
 RECT            rect;
 int             newx;
 int             newy;
 int             newwidth;
 int             newheight;
 int             openx;
 int             openy;
 int             openh;
 int             openw;
 POINT           pt;
 int             style;
 HWND            parent;
 HWND            after;
 int             flags;
 windowdatastr * wdata;


 checkhandle(o->w,"open ex");

 hwnd=(HWND)o->w;

          err=XGetWindowRect(hwnd,&recto);
 if(!err) err=XGetClientRect(hwnd,&rect);
 pt.x=pt.y=0;
 XClientToScreen(hwnd,&pt);

 if(!err)
 {
  openx=xcoordos2pix(o->box.x0);
  openy=ycoordos2pix(o->box.y1);
  openw=xcoordos2pix(o->box.x1)-xcoordos2pix(o->box.x0);
  openh=ycoordos2pix(o->box.y0)-ycoordos2pix(o->box.y1);

  newx=openx;
  newwidth=openw;
  newy=openy;
  newheight=openh;

  XGetWindowLong(hwnd,GWL_STYLE,(LONG*)&style);
  if(style & WS_CHILD)
  {
   XGetParent(hwnd,&parent);
   pt.x=pt.y=0;
   XClientToScreen(parent,&pt);
   newx-=pt.x;
   newy-=pt.y;
  }
  else
  {
   parent=NULL;
  }

  flags=SWP_SHOWWINDOW|SWP_NOACTIVATE; // it is said SHOWWINDOW incompatible with moving window
  if(o->behind==(wimp_w)-3)
  {
   flags|=SWP_NOZORDER;
   after=hwnd;
  }
  else
  if(o->behind==(wimp_w)-1) after=HWND_TOP;
  else
  if(o->behind==(wimp_w)-2) after=HWND_BOTTOM;
  else
  if(o->behind==(wimp_w)-4) after=HWND_TOPMOST;
  else
  if(o->behind==(wimp_w)-5) after=HWND_NOTOPMOST;
		else
  {
   if(o->behind==(wimp_w)hwnd)
   {
    flags|=SWP_NOZORDER;
    after=hwnd;
   }
   else
   {
    after=(HWND)o->behind;
    if(after==hwnd) flags|=SWP_NOZORDER;

#ifdef NEVER    
    after=GetWindow((HWND)o->behind,GW_HWNDNEXT);
    if(after==NULL) after=HWND_BOTTOM;
    else
    if(after==hwnd) flags|=SWP_NOZORDER;
#endif
   }
  }

  if(parent && after==parent) // can't open a true child window after its parent - probably scan child windows, doesn't find it and fails
  {
   after=HWND_BOTTOM;
  }

  err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR *)&wdata);
  if(err)
  {
   wdata=NULL;
   err=NULL;
  }

  if(wdata) wdata->flags|=WINDOWBEINGOPENED;

  err=XSetWindowPos(hwnd,after,newx,newy,newwidth,newheight,flags);

  if(wdata) wdata->flags&=~WINDOWBEINGOPENED;

// cprintf("hwnd=%x after=%x flags=%x",hwnd,after,flags);

// still need a scrollcheck() which comes from the open event above

  scrollcheckx((HWND)o->w,o->x);
  scrollchecky((HWND)o->w,-o->y);
 }
 return(err);
}



os_error * wimp_move_icon(wimp_w handle,int icon,wimp_icon * i,int flags)
{
 os_error * err;
 HWND       child;
 int        newx;
 int        newy;
 int        newwidth;
 int        newheight;

 checkhandle(handle,"move icon");

 err=XGetDlgItem((HWND)handle,icon,&child);
 if(!err)
 {
  newx=xos2pix(i->box.x0);
  newy=-yos2pix(i->box.y1);
  newwidth=xos2pix(i->box.x1)-xos2pix(i->box.x0);
  newheight=yos2pix(i->box.y1)-yos2pix(i->box.y0);

// cprintf("height %d width %d",newheight,newwidth);

  err=XSetWindowPos(child,HWND_TOP,newx,newy,newwidth,newheight,SWP_NOZORDER|SWP_SHOWWINDOW|((flags & WMOVEICONSIZE)?0:SWP_NOSIZE));

 }

 return(err);
}




#ifdef NEVER

os_error * wimp_get_os_wind_state(wimp_w w, wimp_wstate * result)
{
 os_error      * err;
 RECT            rect;
 POINT           pt;
 HWND            bhandle;
 WINDOWPLACEMENT placement;


 result->o.w=w;
 result->o.behind=0;
 result->flags=(wimp_wflags)0;

 err=XGetClientRect((HWND)w,&rect);
 pt.x=pt.y=0;
 if(!err) err=XClientToScreen((HWND)w,&pt);

 if(!err)
 {
  result->o.box.x0=xcoordpix2os(pt.x+rect.left);
  result->o.box.y0=ycoordpix2os(pt.y+rect.bottom);
  result->o.box.x1=xcoordpix2os(pt.x+rect.right);
  result->o.box.y1=ycoordpix2os(pt.y+rect.top);
 }

 if(!err)
 {
  if(!err)
  {

   bhandle=GetWindow((HWND)w,GW_HWNDPREV);
   if(bhandle) result->o.behind=(wimp_w)bhandle;
   else        result->o.behind=(wimp_w)-1;

   placement.length=sizeof(WINDOWPLACEMENT);

   GetWindowPlacement((HWND)w,&placement);

   result->flags=wimp_EXISTS;

//   cprintf("showCmd %x",placement.showCmd);


   if(placement.showCmd!=SW_HIDE) result->flags=(wimp_wflags)((int)result->flags+(int)wimp_WOPEN);

   if(placement.showCmd==SW_SHOWMAXIMIZED) result->flags=(wimp_wflags)((int)result->flags+(int)wimp_WFULL);
   if(placement.showCmd==SW_SHOWMINIMIZED) result->flags=(wimp_wflags)((int)result->flags+(int)wimp_MINIMISED);
  }
 }

 return(err);
}


#endif





os_error * wimp_get_wind_state(wimp_w w, wimp_wstate * result)
{
 os_error      * err;
 RECT            rect;
 SCROLLINFO      siv;
 SCROLLINFO      sih;
 POINT           pt;
 HWND            bhandle;
 windowdatastr * wdata;
 WINDOWPLACEMENT placement;


 checkhandle(w,"state");

 wdata=NULL;

 if(taskclasswindow((HWND)w))
 {
  err=XGetWindowLongPtr((HWND)w,GWLP_USERDATA,(LONG_PTR *)&wdata);
  if(err)
  {
   report(err);
   err=NULL;
  }
 }


 result->o.w=w;
 result->o.behind=0;
 result->flags=(wimp_wflags)0;

 err=XGetClientRect((HWND)w,&rect);
 pt.x=pt.y=0;
 if(!err) err=XClientToScreen((HWND)w,&pt);

 if(!err)
 {
  result->o.box.x0=xcoordpix2os(pt.x+rect.left);
  result->o.box.y0=ycoordpix2os(pt.y+rect.bottom);
  result->o.box.x1=xcoordpix2os(pt.x+rect.right);
  result->o.box.y1=ycoordpix2os(pt.y+rect.top);
 }

 if(!err)
 {
  if(wdata)
  {
   err=getscrollinfo(wdata,(HWND)w,&sih,&siv);
   if(!err)
   {
    result->o.x=sih.nPos;
    result->o.y=-siv.nPos;
   }
  }
/*
		cprintf("scx %d",result->o.x);
		cprintf("scx %d",result->o.y);
		cprintf("box.x0 %d",result->o.box.x0);
		cprintf("box.x1 %d",result->o.box.x1);
		cprintf("box.y0 %d",result->o.box.y0);
		cprintf("box.y1 %d",result->o.box.y1);
	*/


  if(!err)
  {
   bhandle=GetWindow((HWND)w,GW_HWNDPREV);
   if(bhandle) result->o.behind=(wimp_w)bhandle;
   else        result->o.behind=(wimp_w)-1;

   placement.length=sizeof(WINDOWPLACEMENT);

   GetWindowPlacement((HWND)w,&placement);

   result->flags=wimp_EXISTS;

//   cprintf("showCmd %x",placement.showCmd);


   if(placement.showCmd!=SW_HIDE) result->flags=(wimp_wflags)((int)result->flags+(int)wimp_WOPEN);

   if(placement.showCmd==SW_SHOWMAXIMIZED) result->flags=(wimp_wflags)((int)result->flags+(int)wimp_WFULL);
   if(placement.showCmd==SW_SHOWMINIMIZED) result->flags=(wimp_wflags)((int)result->flags+(int)wimp_MINIMISED);

   if(wdata && (wdata->flags & WINDOWBEINGOPENED))  result->flags=(wimp_wflags)((int)result->flags+(int)wimp_OPENING);
  }
 }

 return(err);
}







os_error * wimp_close_wind(wimp_w w)
{
 windowdatastr * next;
 windowdatastr * target;

// return(XCloseWindow((HWND)w));  // this minimizes the window 

 checkhandle(w,"close");

 pollclosewindow(w);
 ShowWindow((HWND)w,SW_HIDE);

 next=firstwindowdata;
 while(next)
 {
  target=next;
  next=next->next;
  lockwdata(&next);
  if(w==target->parent)
  {
   pollclosechild(target->handle);
  }
  unlockwdata(&next);
 }

 return(NULL);
}






os_error * wimp_force_redraw(wimp_redrawstr * r)
{
 os_error      * err;
 RECT            rect;
 SCROLLINFO      siv;
 SCROLLINFO      sih;
 int             scx;
 int             scy;
 windowdatastr * wdata;

 checkhandle(r->w,"force redraw");

// cprintf("force redraw1 %d",r->w);

 err=NULL;

// if(r->w<=0)   // special effects on RISC OS but window handles can be -ve on Windows...
// {
//
// }
// else
 {
  err=XGetWindowLongPtr((HWND)r->w,GWLP_USERDATA,(LONG_PTR *)&wdata);
  if(!err && wdata)
  {
//    cprintf("force redraw2");

   err=getscrollinfo(wdata,(HWND)r->w,&sih,&siv);
   scx=sih.nPos;
   scy=siv.nPos;

   rect.bottom=-yos2pix(r->box.y0+scy);
   rect.top=-yos2pix(r->box.y1+scy);
   rect.left=xos2pix(r->box.x0-scx);
   rect.right=xos2pix(r->box.x1-scx);

//   cprintf("force redraw x0=%d x1=%d y0=%d y1=%d",rect.left,rect.right,rect.top,rect.bottom);

   InvalidateRect((HWND)r->w,&rect,1);
  }
 }

 return(err);
}




os_error * wimp_update_wind(wimp_redrawstr * wr,int * result)
{
 os_error      * err;
 RECT            rect;
 RECT            clipbox;
 SCROLLINFO      siv;
 SCROLLINFO      sih;
 int             scx;
 int             scy;
 int             x0;
 int             x1;
 int             y0;
 int             y1;
 int             x0px;
 int             x1px;
 int             y0px;
 int             y1px;
 windowdatastr * wdata;
 hdcstr        * hdcptr;
	int             code;

 checkhandle(wr->w,"update");

 *result=0;

// cprintf("update");

//	if(currenthdcptr) return(NULL);	// should this be in? At least why go through the code below if it is not re-entrant

 err=XGetWindowLongPtr((HWND)wr->w,GWLP_USERDATA,(LONG_PTR*)&wdata);
 if(!err && wdata)
 {
  err=getscrollinfo(wdata,(HWND)wr->w,&sih,&siv);
		if(!err)
		{
   scx=sih.nPos;
   scy=siv.nPos;

   err=graphicsnewhdc(&hdcptr);
			if(!err)
			{
    hdcptr->hdc=GetDC((HWND)wr->w);
    hdcptr->flags|=WRHDCUPDATE;


   // can't change scaling until stuff below has gone on
   // e.g. graphicsinit()

    x0=wr->box.x0-scx;
    x1=wr->box.x1-scx;
    y0=wr->box.y0+scy;
    y1=wr->box.y1+scy;

    x0px=xos2pix(x0);
    x1px=xos2pix(x1);
    y0px=yos2pix(y0);
    y1px=yos2pix(y1);

    hdcptr->x0=x0px;
    hdcptr->x1=x1px;
    hdcptr->y0=-y0px;
    hdcptr->y1=-y1px;

    err=XGetClientRect((HWND)wr->w,&rect);

				if(!(x1px<rect.left || x0px>rect.right || (-y0px)<rect.top || (-y1px)>rect.bottom))
				{
//     		cprintf("update x0 %d x1 %d y0 %d y1 %d",x0px,x1px,y0px,y1px);
//       cprintf("update px1 x0 %d x1 %d y0 %d y1 %d",x0,x1,y0,y1);

     err=XIntersectClipRect(hdcptr->hdc,x0px,-y1px,x1px,-y0px,&code);	// code value doesn't seem to be trustworthy
 	 	 if(!err)
	  	 {
      code=GetClipBox(hdcptr->hdc,&clipbox);
	  			if(code!=NULLREGION)
	  			{
       x0px=clipbox.left;      // set cliparea to what it actually is, may be smaller than Intersect
       x1px=clipbox.right;
       y1px=-clipbox.top;
       y0px=-clipbox.bottom;
	  	  	
       if(!err)
	  	  	{
        drageffectpaint(wr->w,hdcptr->hdc,0);

                 err=graphicsinit2(-scx,scy,hdcptr);
        if(!err) err=graphicssetcurrent(hdcptr);
        

        wr->g.x0=x0px;
        wr->g.x1=x1px;
        wr->g.y0=-y0px;
        wr->g.y1=-y1px;

        // problem here is ensuring that a bbc_gwindow() on the wr->g values
        // would end up with the same clip area and not a smaller one
        // because bbc_gwindow uses the graphics transform use the inverse
        // problem doesn't appear in window paint because that is given
        // values deliberately too large

        grpix2osr(&wr->g.x0,&wr->g.y0);   // use currenthdcptr
        grpix2osr(&wr->g.x1,&wr->g.y1);

//       cprintf("update px2 x0 %d x1 %d y0 %d y1 %d",wr->g.x0,wr->g.x1,wr->g.y0,wr->g.y1);
//       cprintf("scx %d scy %d",scx,scy);


        wr->box.x0=xpix2os(rect.left);
        wr->box.x1=xpix2os(rect.right);
        wr->box.y1=ypix2os(rect.top-rect.top);						// need - signs if using grpix2os below
        wr->box.y0=ypix2os(rect.top-rect.bottom);

//        cprintf("update x0 %d x1 %d y0 %d y1 %d",wr->box.x0,wr->box.x1,wr->box.y0,wr->box.y1);

//        grpix2osr(&wr->box.x0,&wr->box.y0);   // use currenthdcptr
//        grpix2osr(&wr->box.x1,&wr->box.y1);			// can only use this here if use it in redraw below

        wr->scx=scx;
        wr->scy=-scy; 
        wr->hdcptr=(oshdc)hdcptr;

        *result=2;
		 				}
		 			}
		 		}
				}


				if(err || *result==0)
				{
     ReleaseDC((HWND)wr->w,hdcptr->hdc);
					graphicsdeletehdc(hdcptr);
				}
 		}
		}
 }

 return(err);
}



os_error *wimp_get_rectangle(wimp_redrawstr * r,BOOL * more)
{
 hdcstr * hdcptr;

 hdcptr=(hdcstr*)r->hdcptr;

//	cprintf("wimp get rect *more=%d",*more);
 
 if(*more==2)       // update
 {
  graphicsclearcurrent(hdcptr);
  graphicsfinit2(hdcptr);
  drageffectpaint(r->w,hdcptr->hdc,1);
  ReleaseDC((HWND)r->w,hdcptr->hdc);
  graphicsdeletehdc(hdcptr);
  bbc_gflush();
 }
	else
 if(*more==1)       // paint
 {
  graphicsclearcurrent(hdcptr);
  graphicsfinit2(hdcptr);
  drageffectpaint(r->w,hdcptr->hdc,1);
  EndPaint((HWND)r->w,&hdcptr->paintstruct);
  graphicsdeletehdc(hdcptr);
  bbc_gflush();
 }
	
 *more=0;

 return(NULL);
}



// only to be used in response to WM_PAINT

os_error * wimp_redraw_wind(wimp_redrawstr * wr, int * result)
{
 os_error      * err;
 HWND            hwnd;
 HDC             hdc;
 RECT            rect;
 SCROLLINFO      siv;
 SCROLLINFO      sih;
 int             scx;
 int             scy;
 windowdatastr * wdata;
 hdcstr        * hdcptr;

 checkhandle(wr->w,"wimp redraw in");

//	cprintf("wimp redraw in");

 hwnd=(HWND)wr->w;
 
 if(GetUpdateRect(hwnd,NULL,FALSE))
 {
  err=XGetWindowLongPtr(hwnd,GWLP_USERDATA,(LONG_PTR*)&wdata);

  getscrollinfo(wdata,hwnd,&sih,&siv);
  scx=sih.nPos;
  scy=siv.nPos; //-siv.nMin;
//  cprintf("pos %d min %d",siv.nPos,siv.nMin);


  err=graphicsnewhdc(&hdcptr);
  hdc=hdcptr->hdc=BeginPaint(hwnd,&hdcptr->paintstruct);
  graphicsinit2(-scx,scy,hdcptr);
//  graphicsinit2(-scx,-scy,hdcptr);

  graphicssetcurrent(hdcptr);

  XGetClientRect(hwnd,&rect);

  wr->box.x0=xpix2os(rect.left);
  wr->box.x1=xpix2os(rect.right);
  wr->box.y1=ypix2os(rect.top-rect.top);
  wr->box.y0=ypix2os(rect.top-rect.bottom);
  wr->scx=scx;
  wr->scy=-scy; 
  wr->g.x0=xpix2os(hdcptr->paintstruct.rcPaint.left)-1; 
  wr->g.x1=xpix2os(hdcptr->paintstruct.rcPaint.right)+1;
  wr->g.y0=ypix2os(rect.top-hdcptr->paintstruct.rcPaint.bottom)-1;
  wr->g.y1=ypix2os(rect.top-hdcptr->paintstruct.rcPaint.top)+1;
//  cprintf("bottom %d top %d",wr->g.y0,wr->g.y1);
  
  wr->hdcptr=(oshdc)hdcptr;

/*
  wr->box.x0=xpix2os(rect.left)+scx;
  wr->box.x1=xpix2os(rect.right)+scx;
  wr->box.y1=ypix2os(rect.top-rect.top)-scy;
  wr->box.y0=ypix2os(rect.top-rect.bottom)-scy;
  wr->scx=scx;
  wr->scy=-scy; 
  wr->g.x0=xpix2os(hdcptr->paintstruct.rcPaint.left)-1+scx; 
  wr->g.x1=xpix2os(hdcptr->paintstruct.rcPaint.right)+1+scx;
  wr->g.y0=ypix2os(rect.top-hdcptr->paintstruct.rcPaint.bottom)-1-scy;
  wr->g.y1=ypix2os(rect.top-hdcptr->paintstruct.rcPaint.top)+1-scy;
  wr->hdcptr=(int)hdcptr;
*/
//  cprintf("redraw scx=%x scy=%x",scx,scy);

  *result=1;
 }
 else
 {
  *result=0;
 }
 
 return(NULL);
}




os_error * wimp_get_icon_info(wimp_w w, wimp_i i, wimp_icon * result)
{
 os_error      * err;
 RECT            rect;
 HWND            child;
 static char     classname[32];
 static char     buffer[256];
 windowdatastr * wdata;
 SCROLLINFO      siv;
 SCROLLINFO      sih;


          err=XGetDlgItem((HWND)w,i,&child);
 if(!err) err=XGetClientRect(child,&rect);
 if(!err)
 {
  MapWindowPoints(child,(HWND)w,(LPPOINT)&rect,2);
 
  result->box.x0=xpix2os(rect.left);
  result->box.y0=-ypix2os(rect.bottom);
  result->box.x1=xpix2os(rect.right);
  result->box.y1=-ypix2os(rect.top);

  err=XGetWindowLongPtr((HWND)w,GWLP_USERDATA,(LONG_PTR*)&wdata);

  getscrollinfo(wdata,(HWND)w,&sih,&siv);

  result->box.x0+=sih.nPos;
  result->box.x1+=sih.nPos;
  result->box.y0-=siv.nPos;
  result->box.y1-=siv.nPos;

//  cprintf("geticon %d %d",result->box.x0,result->box.x1);

  result->flags=(wimp_iconflags)0;
  result->data.indirecttext.buffer=buffer;   // window name
  result->data.indirecttext.bufflen=0;
  result->data.indirecttext.validstring=classname;   // registered class name

  GetClassName(child,classname,sizeof(classname));
  if(strcmp(classname,"abx")==0)
  {
   abxread(child,buffer,sizeof(buffer));
  }
  else
  {
   GetWindowText(child,buffer,sizeof(buffer));
  }
 }

 return(err);
}



os_error * wimp_copy_icon_info(wimp_icon ** dest,wimp_icon * src)
{
 os_error * err;
 int        len;
 int        len1;
 char     * p;

 err=NULL;


 len=sizeof(wimp_icon);
 len1=0;
 
 if(src->data.indirecttext.buffer)
 {
  len+=len1=(strlen(src->data.indirecttext.buffer)+1+3) & (~0x3);
 }

 if(src->data.indirecttext.validstring)
 {
  len+=(strlen(src->data.indirecttext.validstring)+1+3) & (~0x3);
 }

 err=salloc((flex_ptr)dest,len);
 if(!err)
 {
  *(*dest)=*src;
  p=((char*)(*dest))+sizeof(wimp_icon);

  if(src->data.indirecttext.buffer)
  {
   (*dest)->data.indirecttext.buffer=p;
   strcpy(p,src->data.indirecttext.buffer);
  }

  p+=len1;

  if(src->data.indirecttext.validstring)
  {
   (*dest)->data.indirecttext.validstring=p;
   strcpy(p,src->data.indirecttext.validstring);
  }
 }
 
 return(err);
}



os_error * wimp_lose_icon_info(wimp_icon ** icon)
{
 os_error * err;

 err=sfree((flex_ptr)icon);

 return(err);
}







os_error *wimp_getwindowoutline(wimp_redrawstr *re)
{
 os_error   * err;
 RECT         rect;


 err=XGetWindowRect((HWND)re->w,&rect);

 if(!err)
 {
  re->box.x0=xcoordpix2os(rect.left);
  re->box.y0=ycoordpix2os(rect.bottom);
  re->box.x1=xcoordpix2os(rect.right);
  re->box.y1=ycoordpix2os(rect.top);
 }

 return(err);
}


/* Set icon's flags as (old_state & ~mask) ^ value */

os_error * wimp_set_icon_state(wimp_w w, wimp_i i, 
     wimp_iconflags value, wimp_iconflags mask)
{
 os_error     * err;
 wimp_icon      istate;
 wimp_redrawstr r;
 HWND           child;
 LRESULT        newvalue;

// cprintf("set icon state");



 err=XGetDlgItem((HWND)w,i,&child);


 if((value & wimp_INOSELECT) || (mask & wimp_INOSELECT))
 {
  newvalue=IsWindowEnabled(child)?0:wimp_INOSELECT;
  newvalue&=~mask;
  newvalue^=value;

  EnableWindow(child,(newvalue & wimp_INOSELECT)?FALSE:TRUE);
 }

 if((value & wimp_ISELECTED) || (mask & wimp_ISELECTED))
 {
  newvalue=SendMessage(child,BM_GETCHECK,0,0);
  newvalue=(newvalue==BST_CHECKED)?wimp_ISELECTED:0;
  newvalue&=~mask;
  newvalue^=value;

  SendMessage(child,BM_SETCHECK,(newvalue & wimp_ISELECTED)?BST_CHECKED:BST_UNCHECKED,0);
 }


 err=wimp_get_icon_info(w,i,&istate);

 r.w=w;
 r.box=istate.box;
 
 wimp_force_redraw(&r);
 
 return(NULL);
}



os_error * wimp_set_icon_colour(wimp_w w,wimp_i i,int fcol,int bcol)
{
 os_error * err;
 HWND       hwnd;

          err=XGetDlgItem((HWND)w,i,&hwnd);
 if(!err) err=abxsetcolours(hwnd,fcol,bcol);

 return(err);
}




os_error * wimp_slice_icon(wimp_w w,wimp_i i,int ctype,char * newparam)
{
 os_error * err;

 err=abxsliceicon(w,i,ctype,newparam);

 return(err);
}




os_error * wimp_read_slice(wimp_w w,wimp_i i,int itype,int  * present,char * buffer,int * buffsize)
{
 os_error * err;

 err=abxgetsliceicon(w,i,buffer,buffsize,itype,present);
 
 return(err);
}



os_error * wimp_getfont(wimp_w hwnd,font * fh)
{

// *fh=SendMessage(hwnd,WM_GETFONT,0,0);
 *fh=(font)GetWindowLongPtr((HWND)hwnd,DWLP_USER);

 return(NULL);
}


os_error * wimp_setfont(wimp_w hwnd,font fh)
{
	
 SendMessage((HWND)hwnd,WM_SETFONT,(WPARAM)fh,0);
 return(NULL);
}



os_error * wimp_ploticon(wimp_w hwnd,wimp_icon * icon,sprite_area * spa)
{
 HFONT hfont;
 RECT  rect;
 int   flags;


 rect.left=GRXPIX(icon->box.x0);
 rect.top=GRYPIX(icon->box.y1);
 rect.right=GRXPIX(icon->box.x1);
 rect.bottom=GRYPIX(icon->box.y0);

// LPtoDP(currenthdcptr->hdc,(POINT*)&rect,2);
// graphicsostext2(currenthdcptr);

 hfont=(HFONT)GetWindowLongPtr((HWND)hwnd,DWLP_USER);

// cprintf("plotfont=%x",hfont);

// IntersectClipRect(currenthdc,rect.left,rect.top,rect.right,rect.bottom);

 flags=0;
 if(icon->flags & wimp_ISELECTED)flags|=USDSELECTED;
 drawabxeraseback(icon->data.indirecttext.buffer,currenthdcptr->hdc,&rect,flags);
 drawabx2(icon->data.indirecttext.buffer,currenthdcptr->hdc,hfont,&rect,flags,spa);

// SelectClipRgn(currenthdc,NULL);

 graphicsriscos2(currenthdcptr);

 return(NULL);
}



os_error * wimp_create_icon(wimp_icreate * i, wimp_i * result)
{
 os_error * err;
 HWND       hwnd;
 font       fh;

 err=XCreateWindowEx(
                0,      // extended window style
                i->i.data.indirecttext.validstring,  // registered class name
                i->i.data.indirecttext.buffer, // window name
                WS_CHILD|WS_VISIBLE,        // window style
                xos2pix(i->i.box.x0),                // horizontal position of window
                -yos2pix(i->i.box.y1),                // vertical position of window
                xos2pix(i->i.box.x1-i->i.box.x0),    // window width
                yos2pix(i->i.box.y1-i->i.box.y0),          // window height
                (HWND)i->w,      // handle to parent or owner window
                (HMENU)(*result),          // menu handle or child identifier
                AppInstance,  // handle to application instance
                NULL,        // window-creation data
                &hwnd
               );

// cprintf("create icon %x",hwnd);

 wimp_getfont(i->w,&fh);
 wimp_setfont((wimp_w)hwnd,fh);

// cprintf("setfont %d",fh);

 if(i->i.flags & wimp_ISELECTED) select(i->w,*result);

 return(err);
}



os_error * wimp_set_caret_pos(wimp_caretstr * c)
{
 os_error * err;
 HWND       prev;
 HWND       child;
 HWND       cfocus;
 TCHAR      classname[32];

 if(c->i!=-1)
 {
  err=XGetDlgItem((HWND)c->w,c->i,&child);
  cfocus=GetFocus();
  if(cfocus!=child) XSetFocus(child,&prev);

  GetClassName(child,classname,NITEM(classname));

  if(!strcmp(classname,"Edit"))
  {
   SendMessage(child,EM_SETSEL,c->startindex,c->endindex);
		}
		else
  if(!strcmp(classname,"ComboBox"))
  {
   SendMessage(child,CB_SETEDITSEL,0,MAKELONG(c->startindex,c->endindex));
  }


 }
 else
 {
  err=XSetFocus((HWND)c->w,&prev);
 }

 
 return(err);
}



os_error * wimp_get_caret_pos(wimp_caretstr * c)
{
 HWND  child;
 HWND  hwnd;
 int   id;
 TCHAR classname[32];
	HWND  parent;

 c->w=(wimp_w)(-1);
 c->i=-1;
 c->startindex=c->endindex=-1;

 child=GetFocus();
 if(child)
 {
  hwnd=getcontrolparentwindow(child);
  c->w=(wimp_w)hwnd;
  
  if(hwnd!=child)
  {
   XGetDlgCtrlID(child,&id);

   c->i=id;

   GetClassName(child,classname,NITEM(classname));
   if(!strcmp(classname,"Edit"))
   {
				XGetParent(child,&parent);
				if(parent!=hwnd)
				{
     GetClassName(parent,classname,NITEM(classname));

//					cprintf("classname %s",classname);

					if(!strcmp(classname,"ComboBox"))
					{
      XGetDlgCtrlID(parent,&id);

      c->i=id;

      SendMessage(parent,CB_GETEDITSEL,(WPARAM)&c->startindex,(LPARAM)&c->endindex);
					}
					else
					{
      SendMessage(child,EM_GETSEL,(WPARAM)&c->startindex,(LPARAM)&c->endindex);
					}
				}
				else
				{
     SendMessage(child,EM_GETSEL,(WPARAM)&c->startindex,(LPARAM)&c->endindex);
				}
   }
			else
   if(!strcmp(classname,"ComboBox"))
   {
    SendMessage(child,CB_GETEDITSEL,(WPARAM)&c->startindex,(LPARAM)&c->endindex);
   }
  }
 }

 return(NULL);
}





os_error * wimp_delete_icon(wimp_w w, wimp_i i)
{
 os_error * err;
 HWND       hwnd;

          err=XGetDlgItem((HWND)w,i,&hwnd);
 if(!err) err=XDestroyWindow(hwnd);

 return(err);
}







os_error * wimp_mouseitem(HWND hwnd,int x,int y,int * hitcode)
{
 LONG code;

 XDefWindowProc(hwnd,WM_NCHITTEST,(WPARAM)0,(LPARAM)MAKELPARAM(x,y),(LRESULT*)&code);

 *hitcode=(int)code;

 return(NULL);
}

