/*->c.wmflib */


#include "stdafx.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "os.h"
#include "bbc.h"
#include "sprite.h"
#include "wimp.h"
#include "font.h"

#include "transform.h"
#include "process.h"
#include "xmath.h"
#include "colour.h"
#include "wmf.h"
#include "deb.h"
#include "osglue.h"
#include "osgraphics.h"


#include "wmflib.h"



#ifdef NEVER					// in wmf.h

typedef struct _PlaceableMetaHeader
{
  DWORD Key;           /* Magic number (always 9AC6CDD7h) */
  WORD  Handle;        /* Metafile HANDLE number (always 0) */
  SHORT Left;          /* Left coordinate in metafile units */
  SHORT Top;           /* Top coordinate in metafile units */
  SHORT Right;         /* Right coordinate in metafile units */
  SHORT Bottom;        /* Bottom coordinate in metafile units */
  WORD  Inch;          /* Number of metafile units per inch */
  DWORD Reserved;      /* Reserved (always 0) */
  WORD  Checksum;      /* Checksum value for previous 10 WORDs */
} PLACEABLEMETAHEADER;

#endif


#define PLACEABLEMAGIC 0x9AC6CDD7
#define PLACEABLESIZE  22





/*

Dx = ((Lx - WOx) * VEx / WEx) + VOx 
The following variables are involved.

Dx     x value in device units 
Lx     x value in logical units (also known as page space units) 
WOx     window x origin 
VOx     viewport x origin 
WEx     window x-extent 
VEx     viewport x-extent 

*/

static int VEx;
static int VOx;
static int WEx;
static int WOx;

static int VEy;
static int VOy;
static int WEy;
static int WOy;

static int windingrule;
static int textalign;
static int textcolour;
static int backcolour;

static int fillstyle;
static int fillcolour;


static os_error * wmfscan(void * data,transformstr * tr,wmfboxstr * abox,processstr * pr)
{
 PMETAHEADER           hdr;
 PMETARECORD           record;
 PMETARECORD           record2;
 PMETARECORD           lt;
 PLACEABLEMETAHEADER * phdr;
 PMETARECORD         * object;
 PMETARECORD           objectstack[8];
 int                   i;

 int x0,x1,y0,y1;
 int inch;
 int x,y;
 coordstr cx[4];


 phdr=(PLACEABLEMETAHEADER*)data;
 if(phdr->Key==PLACEABLEMAGIC)
 {

  hdr=(METAHEADER*)(((char*)data)+PLACEABLESIZE);

  x0=scale(phdr->Left,180*256,phdr->Inch);
  x1=scale(phdr->Right,180*256,phdr->Inch);
  y0=scale(-phdr->Bottom,180*256,phdr->Inch);
  y1=scale(-phdr->Top,180*256,phdr->Inch);

  inch=phdr->Inch;

  cprintf("inch %d x0=%d x1=%d y0=%d y1=%d",inch,x0,x1,y0,y1);
 }
 else
 {
  hdr=(METAHEADER*)data;

 }

 setgcol(0) ;

 cprintf("mtype %d\n",hdr->mtType); 
 cprintf("header size %d\n",hdr->mtHeaderSize); 
 cprintf("Version %x\n",hdr->mtVersion); 
 cprintf("file size %d\n",hdr->mtSize); 
 cprintf("no objects %d\n",hdr->mtNoObjects); 
 cprintf("max records %d\n",hdr->mtMaxRecord); 
 cprintf("no parameters %d\n",hdr->mtNoParameters); 


 record=(PMETARECORD)(((char*)hdr)+sizeof(WORD)*hdr->mtHeaderSize);
 lt=(PMETARECORD)(((char*)hdr)+sizeof(WORD)*hdr->mtSize);

 object=objectstack;
 for(i=0;i<hdr->mtNoObjects;i++) object[i]=NULL;

 while(record<lt)
 {
  switch(record->rdFunction)
  {
               case META_SETBKCOLOR:
                                    backcolour=PALFROMCOLREF((record->rdParm[0]));
                                    break;

                case META_SETBKMODE:

                                    break;

               case META_SETMAPMODE:
                  case META_SETROP2:
                case META_SETRELABS:
                                    break;

          case META_SETPOLYFILLMODE:
                                    if(record->rdParm[0]==1) windingrule=0x40;
                                    else                     windingrule=0x0;
                                    break;

        case META_SETSTRETCHBLTMODE:
         case META_SETTEXTCHAREXTRA:
                                    break;

             case META_SETTEXTCOLOR:
                                    textcolour=PALFROMCOLREF((record->rdParm[0]));
                                    break;

     case META_SETTEXTJUSTIFICATION:
                                    break;

             case META_SETWINDOWORG:
                                    WOy=(int)((signed short)record->rdParm[0]);
                                    WOx=(int)((signed short)record->rdParm[1]);
                                    break;

             case META_SETWINDOWEXT:
                                    WEy=(int)((signed short)record->rdParm[0]);
                                    WEx=(int)((signed short)record->rdParm[1]);
                                    break;

           case META_SETVIEWPORTORG:
                                    VOy=(int)((signed short)record->rdParm[0]);
                                    VOx=(int)((signed short)record->rdParm[1]);
                                    break;

           case META_SETVIEWPORTEXT:
                                    VEy=(int)((signed short)record->rdParm[0]);
                                    VEx=(int)((signed short)record->rdParm[1]);
                                    break;

          case META_OFFSETWINDOWORG:
                                    WOy+=(int)((signed short)record->rdParm[0]);
                                    WOx+=(int)((signed short)record->rdParm[1]);
                                    break;

           case META_SCALEWINDOWEXT:
                                    break;

        case META_OFFSETVIEWPORTORG:
                                    VOy=+(int)((signed short)record->rdParm[0]);
                                    VOx=+(int)((signed short)record->rdParm[1]);
                                    break;

         case META_SCALEVIEWPORTEXT:
                                    break;

                   case META_LINETO:
                                    y=(int)((signed short)record->rdParm[0]);
                                    x=(int)((signed short)record->rdParm[1]);

                                    cprintf("lineto %d %d",x,y);


                                    cx[0].x=(x*180*256)/inch;
                                    cx[0].y=-(y*180*256)/inch;
                                    tr_transformset(cx,1,tr);
                                    bbc_draw(cx[0].x/256,cx[0].y/256);
                                    break;

                   case META_MOVETO:
                                    y=(int)((signed short)record->rdParm[0]);
                                    x=(int)((signed short)record->rdParm[1]);

                                    cprintf("moveto %d %d",x,y);

                                    
                                    cx[0].x=(x*180*256)/inch;
                                    cx[0].y=-(y*180*256)/inch;
                                    tr_transformset(cx,1,tr);
                                    bbc_move(cx[0].x/256,cx[0].y/256);
                                    break;

          case META_EXCLUDECLIPRECT:
        case META_INTERSECTCLIPRECT:
                                    break;

                      case META_ARC:
                                    break;

                  case META_ELLIPSE:
                                    break;

                case META_FLOODFILL:
                      case META_PIE:
                                    break;

                case META_RECTANGLE:
                                    y=(int)((signed short)record->rdParm[0]);
                                    x=(int)((signed short)record->rdParm[1]);

                                    cx[0].x=(x*180*256)/inch;
                                    cx[0].y=-(y*180*256)/inch;

                                    y=(int)((signed short)record->rdParm[2]);
                                    x=(int)((signed short)record->rdParm[3]);

                                    cx[1].x=(x*180*256)/inch;
                                    cx[1].y=-(y*180*256)/inch;

                                    tr_transformset(cx,2,tr);

                                    setgcol(fillcolour);
                                    bbc_rectanglefilli(cx[0].x/256,cx[0].y/256,(cx[1].x-cx[0].x)/256,(cx[1].y-cx[0].y)/256);

                                    cprintf("x0=%d x1=%d y0=%d y1=%d",cx[0].x/256,cx[1].x/256,cx[0].y/256,cx[1].y/256);

                                    break;

                case META_ROUNDRECT:
                                    break;

                   case META_PATBLT:
                   case META_SAVEDC:
                 case META_SETPIXEL:
            case META_OFFSETCLIPRGN:
                  case META_TEXTOUT:
                   case META_BITBLT:
               case META_STRETCHBLT:
                                    break;

                  case META_POLYGON:
                                    break;

                 case META_POLYLINE:
                                    break;

                   case META_ESCAPE:
                case META_RESTOREDC:
               case META_FILLREGION:
              case META_FRAMEREGION:
             case META_INVERTREGION:
              case META_PAINTREGION:
         case META_SELECTCLIPREGION:
                                    break;

             case META_SELECTOBJECT:
                                    record2=object[record->rdParm[0]];
                                    switch(record2->rdFunction)
                                    {
                                       case META_CREATEPENINDIRECT:
                                                                   break;

                                      case META_CREATEFONTINDIRECT:
                                                                   break;

                                     case META_CREATEBRUSHINDIRECT:
                                                                   fillstyle=record2->rdParm[0];
                                                                   fillcolour=PALFROMCOLREF(record2->rdParm[1]|(record2->rdParm[2]<<16));
                                                                   break;

                                    }
                                    break;

             case META_SETTEXTALIGN:
                                    textalign=(record->rdParm[0]);
                                    break;

                    case META_CHORD:
           case META_SETMAPPERFLAGS:
               case META_EXTTEXTOUT:
              case META_SETDIBTODEV:
            case META_SELECTPALETTE:
           case META_REALIZEPALETTE:
           case META_ANIMATEPALETTE:
            case META_SETPALENTRIES:
                                    break;

              case META_POLYPOLYGON:
                                    break;

            case META_RESIZEPALETTE:
                case META_DIBBITBLT:
            case META_DIBSTRETCHBLT:
    case META_DIBCREATEPATTERNBRUSH:
               case META_STRETCHDIB:
                                    break;

             case META_EXTFLOODFILL:
                                    break;

             case META_DELETEOBJECT:
                                    object[record->rdParm[0]]=NULL;
                                    break;

            case META_CREATEPALETTE:
       case META_CREATEPATTERNBRUSH:
                                    break;

        case META_CREATEPENINDIRECT:   // these fall through
       case META_CREATEFONTINDIRECT:
      case META_CREATEBRUSHINDIRECT:
                                    for(i=0;i<hdr->mtNoObjects;i++) if(object[i]==NULL) break;
                                    object[i]=record;
                                    break;

             case META_CREATEREGION:
                                    break;


  }

  record=(PMETARECORD)(((char*)record)+sizeof(WORD)*record->rdSize);
 }

 


 return(NULL);
}






os_error * wmfinit(void * data,wmfboxstr * abox)
{
 os_error           * err;
 PMETAHEADER           hdr;
 PLACEABLEMETAHEADER * phdr;

 err=NULL;


 phdr=(PLACEABLEMETAHEADER*)data;
 if(phdr->Key==PLACEABLEMAGIC)
 {
  hdr=(METAHEADER*)(((char*)data)+PLACEABLESIZE);

  abox->x0=scale(phdr->Left,180*256,phdr->Inch);
  abox->x1=scale(phdr->Right,180*256,phdr->Inch);
  abox->y0=scale(-phdr->Bottom,180*256,phdr->Inch);
  abox->y1=scale(-phdr->Top,180*256,phdr->Inch);
 }
 else
 {
  hdr=(METAHEADER*)data;

  abox->x0=0;
  abox->x1=180*256;
  abox->y0=-180*256;
  abox->y1=0;
 }


 return(err);
}


#ifdef NEVER


os_error * wmfrender1(void * data,transformstr * tr,wmfboxstr * abox,processstr * pr)
{
 os_error * err;
 PMETAHEADER           hdr;
 PLACEABLEMETAHEADER * phdr;

 int x0,x1,y0,y1;
 int inch;
 int x,y;
 coordstr cx[4];


 phdr=(PLACEABLEMETAHEADER*)data;
 if(phdr->Key==PLACEABLEMAGIC)
 {
  hdr=(METAHEADER*)(((char*)data)+PLACEABLESIZE);
 }
 else
 {
  hdr=(METAHEADER*)data;
 }



 err=NULL;


 HMETAFILE hmeta;
 POINT     pt;
 SIZE      size;
 transformbitstr bits;
 int width;
 int height;

 hmeta=SetMetaFileBitsEx(sizeof(WORD)*hdr->mtSize,(unsigned char*)hdr);


 tr_getbits(tr,&bits);

 x=scale(abox->x0,bits.xscale,0x10000);
 x=scale(abox->y1,bits.yscale,0x10000);

 cprintf("e %d x %d f %d y %d",tr->e,tr->f,x,y);

 x=GRDXPIX(tr->e+x);
 y=GRDYPIX(tr->f+y);



 width=abox->x1-abox->x0;
 height=abox->y1-abox->y0;

 width=scale(width,bits.xscale,0x10000);
 height=scale(height,bits.yscale,0x10000);

 width=scale(width,currenthdcptr->vduxres,256*currenthdcptr->osxres);
 height=scale(height,currenthdcptr->vduxres,256*currenthdcptr->osxres);

 SetViewportOrgEx(currenthdcptr->hdc,x,y,&pt);
 SetViewportExtEx(currenthdcptr->hdc,width,height,&size);

// cprintf("wmf x %d y %d hm %x",x,y,hmeta);
 cprintf("w %d h %d",width,height);

 PlayMetaFile(currenthdcptr->hdc,hmeta);

 SetViewportOrgEx(currenthdcptr->hdc,pt.x,pt.y,NULL);

 DeleteMetaFile(hmeta);

 return(err);
}


#endif



os_error * wmfrender(void * data,transformstr * tr,wmfboxstr * abox,processstr * pr)
{
 os_error            * err;
 PMETAHEADER           hdr;
 PLACEABLEMETAHEADER * phdr;
 HENHMETAFILE          hmeta;
 coordstr              cx[2];
 transformstr          xtr;
 int                   grmode;
 RECT                  rect;
 METAFILEPICT          mfp;
 METAFILEPICT        * mfpp;


 phdr=(PLACEABLEMETAHEADER*)data;
 if(phdr->Key==PLACEABLEMAGIC)
 {
  hdr=(METAHEADER*)(((char*)data)+PLACEABLESIZE);

  mfpp=&mfp;

  mfp.mm=MM_ANISOTROPIC;             // units 0.01 mm HIMETRIC
  mfp.xExt=scale(phdr->Right-phdr->Left,254,phdr->Inch);
  mfp.yExt=scale(phdr->Bottom-phdr->Top,254,phdr->Inch);

//  cprintf("xExt %d yExt %d",mfp.xExt,mfp.yExt);
 }
 else
 {
  hdr=(METAHEADER*)data;
  mfpp=NULL;
 }

 err=NULL;




 hmeta=SetWinMetaFileBits(sizeof(WORD)*hdr->mtSize,(unsigned char*)hdr,NULL,mfpp);


 cx[0].x=abox->x0;
 cx[0].y=abox->y0;
 cx[1].x=abox->x1;
 cx[1].y=abox->y1;


 cprintf("bbox %d %d %d %d",abox->x0,abox->x1,abox->y0,abox->y1);


 if((GetVersion() & 0x80000000))        // Windows 98
 {
  tr_transformset(cx,2,tr);

  rect.top=GRDYPIX(cx[1].y);
  rect.bottom=GRDYPIX(cx[0].y);
  rect.left=GRDXPIX(cx[0].x);
  rect.right=GRDXPIX(cx[1].x);

  PlayEnhMetaFile(currenthdcptr->hdc,hmeta,&rect); 
 }
 else
 {
  rect.top=GRDYPIX(cx[1].y);
  rect.bottom=GRDYPIX(cx[0].y);
  rect.left=GRDXPIX(cx[0].x);
  rect.right=GRDXPIX(cx[1].x);

  xtr=*tr;
  xtr.e=GRDXPIX(xtr.e);
  xtr.f=GRDXPIX(-xtr.f);

  graphicsworld(&xtr,&grmode);

  PlayEnhMetaFile(currenthdcptr->hdc,hmeta,&rect); 

  graphicsworld(NULL,&grmode);
 }


 DeleteEnhMetaFile(hmeta); 

 return(err);
}










os_error * emfinit(void * data,wmfboxstr * abox)
{
 PENHMETAHEADER  hdr;

 hdr=(PENHMETAHEADER)data;

 abox->x0=scale(hdr->rclFrame.left,9*256,127);
 abox->x1=scale(hdr->rclFrame.right,9*256,127);
 abox->y0=-scale(hdr->rclFrame.bottom,9*256,127);
 abox->y1=-scale(hdr->rclFrame.top,9*256,127);


#ifdef NEVER

 cprintf("pixels %d mm %d",hdr->szlDevice,hdr->szlMillimeters);

 cprintf("bounds x0 %d x1 %d y0 %d y1 %d",hdr->rclBounds.left,hdr->rclBounds.right,
                                   hdr->rclBounds.top,hdr->rclBounds.bottom);

 cprintf("frame x0 %d x1 %d y0 %d y1 %d",hdr->rclFrame.left,hdr->rclFrame.right,
                                   hdr->rclFrame.top,hdr->rclFrame.bottom);


 cprintf("x0 %d x1 %d y0 %d y1 %d",abox->x0,abox->x1,abox->y0,abox->y1);

// this may be a better way of getting bounding box
 
 abox->x0=scale(hdr->rclBounds.left,hdr->szlMillimeters.cx*9*100*256,hdr->szlDevice.cx*127);
 abox->x1=scale(hdr->rclBounds.right,hdr->szlMillimeters.cx*9*100*256,hdr->szlDevice.cx*127);
 abox->y0=-scale(hdr->rclBounds.bottom,hdr->szlMillimeters.cy*9*100*256,hdr->szlDevice.cy*127);
 abox->y1=-scale(hdr->rclBounds.top,hdr->szlMillimeters.cy*9*100*256,hdr->szlDevice.cy*127);

 cprintf("x0 %d x1 %d y0 %d y1 %d",abox->x0,abox->x1,abox->y0,abox->y1);

#endif

 return(NULL);
}





os_error * emfrender(void * data,transformstr * tr,wmfboxstr * abox,processstr * pr)
{
 os_error         * err;
 PENHMETAHEADER     hdr;
 HENHMETAFILE       hmeta;
 coordstr           cx[2];
 transformstr       xtr;
 int                grmode;
 RECT               rect;


 err=NULL;

 hdr=(PENHMETAHEADER)data;
 

 hmeta=SetEnhMetaFileBits(hdr->nBytes,(unsigned char*)hdr);


 cx[0].x=abox->x0;
 cx[0].y=abox->y0;
 cx[1].x=abox->x1;
 cx[1].y=abox->y1;


 if((GetVersion() & 0x80000000))        // Windows 98
 {
  tr_transformset(cx,2,tr);

  rect.top=GRDYPIX(cx[1].y);
  rect.bottom=GRDYPIX(cx[0].y);
  rect.left=GRDXPIX(cx[0].x);
  rect.right=GRDXPIX(cx[1].x);

  PlayEnhMetaFile(currenthdcptr->hdc,hmeta,&rect); 
 }
 else
 {
  rect.top=GRDYPIX(cx[1].y);
  rect.bottom=GRDYPIX(cx[0].y);
  rect.left=GRDXPIX(cx[0].x);
  rect.right=GRDXPIX(cx[1].x);

  xtr=*tr;
  xtr.e=GRDXPIX(xtr.e);
  xtr.f=GRDXPIX(-xtr.f);

  graphicsworld(&xtr,&grmode);

  PlayEnhMetaFile(currenthdcptr->hdc,hmeta,&rect); 

  graphicsworld(NULL,&grmode);
 }


 DeleteEnhMetaFile(hmeta); 
 
 
#ifdef NEVER 
 tr_getbits(tr,&bits);
 tr_setbits(&xtr,&bits,TR_ROTATE|TR_SKEW);
 tr_setbits(&gtr,&bits,TR_XSHIFT|TR_YSHIFT);

// tr_transformset(cx,2,&gtr);


// x=scale(abox->x0,bits.xscale,0x10000);
// y=scale(abox->y0,bits.yscale,0x10000);

// cprintf("e %d x %d f %d y %d",tr->e,x,tr->f,y);

// x=GRDXPIX(tr->e+x);
// y=GRDYPIX(tr->f+y);

// x=GRDXPIX(cx.x);
// y=GRDYPIX(cx.y);


 width=abox->x1-abox->x0;
 height=abox->y1-abox->y0;

 width=scale(width,bits.xscale,0x10000);
 height=scale(height,bits.yscale,0x10000);

 width=scale(width,currenthdcptr->vduxres,256*currenthdcptr->osxres);
 height=scale(height,currenthdcptr->vduxres,256*currenthdcptr->osxres);

// SetViewportOrgEx(currenthdcptr->hdc,x,y,&pt);
// SetViewportExtEx(currenthdcptr->hdc,width,height,&size);

// cprintf("wmf x %d y %d hm %x",x,y,hmeta);
 cprintf("x %d y %d w %d h %d",x,y,width,height);

 RECT rect;

 rect.top=GRDYPIX(cx[1].y);
 rect.bottom=GRDYPIX(cx[0].y);
 rect.left=GRDXPIX(cx[0].x);
 rect.right=GRDXPIX(cx[1].x);

 xtr=*tr;
 xtr.e=GRDXPIX(xtr.e);
 xtr.f=GRDXPIX(-xtr.f);

 graphicsworld(&xtr,&grmode);

 PlayEnhMetaFile(currenthdcptr->hdc,hmeta,&rect);

// SetViewportOrgEx(currenthdcptr->hdc,pt.x,pt.y,NULL);

 graphicsworld(NULL,&grmode);

 DeleteEnhMetaFile(hmeta);

#endif

 return(err);
}

